/*
 * MosP - Mind Open Source Project         http://www.mosp.jp/
 * Copyright (C) 1987-2009 MIND Co., Ltd.  http://www.e-mind.co.jp/
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package jp.mosp.payroll.report.dto;

import java.sql.SQLException;
import java.util.Date;
import java.util.List;
import java.util.Map;


import jp.mosp.common.common.BaseDto;
import jp.mosp.common.common.MospUtility;
import jp.mosp.human.dto.MKihonDto;
import jp.mosp.human.dto.MKojinDto;
import jp.mosp.payroll.base.CalculateAction;
import jp.mosp.payroll.base.PayrollConst;
import jp.mosp.payroll.bonus.dao.PdBonAllowanceDao;
import jp.mosp.payroll.bonus.dao.PdBonDeductionDao;
import jp.mosp.payroll.bonus.dao.PdBonSumDao;
import jp.mosp.payroll.bonus.dto.PhBounsDto;
import jp.mosp.payroll.bonus.dto.PmDetailBaDto;
import jp.mosp.payroll.bonus.dto.PmDetailBdDto;
import jp.mosp.payroll.bonus.dto.PmDetailBsDto;
import jp.mosp.payroll.dao.PdPayAllowanceDao;
import jp.mosp.payroll.dao.PdPayDeductionDao;
import jp.mosp.payroll.dao.PdPaySumDao;
import jp.mosp.payroll.dao.PdPayTimeDao;
import jp.mosp.payroll.dto.CdAdjustmentDto;
import jp.mosp.payroll.dto.CmCompanyDto;
import jp.mosp.payroll.dto.CmIncomeTaxDto;
import jp.mosp.payroll.dto.CmSocInsuranceDto;
import jp.mosp.payroll.dto.DetailMoneyDto;
import jp.mosp.payroll.dto.DetailPaDto;
import jp.mosp.payroll.dto.DetailPdDto;
import jp.mosp.payroll.dto.DetailTimeDto;
import jp.mosp.payroll.dto.PhPaymentDto;

public class PaymentLedgerDto extends BaseDto {
	private static final long serialVersionUID = 2613587750422757053L;
	// tB[h
	protected String titlePayAllowance_01 ;	// ^x01^Cg
	protected String titlePayAllowance_02 ;	// ^x02^Cg
	protected String titlePayAllowance_03 ;	// ^x03^Cg
	protected String titlePayAllowance_04 ;	// ^x04^Cg
	protected String titlePayAllowance_05 ;	// ^x05^Cg
	protected String titlePayAllowance_06 ;	// ^x06^Cg
	protected String titlePayAllowance_07 ;	// ^x07^Cg
	protected String titlePayAllowance_08 ;	// ^x08^Cg
	protected String titlePayAllowance_09 ;	// ^x09^Cg
	protected String titlePayAllowance_10 ;	// ^x10^Cg
	protected String titlePayAllowance_11 ;	// ^x11^Cg
	protected String titlePayAllowance_12 ;	// ^x12^Cg
	protected String titlePayAllowance_13 ;	// ^x13^Cg
	protected String titlePayAllowance_14 ;	// ^x14^Cg
	protected String titlePayAllowance_15 ;	// ^x15^Cg
	protected String titlePayAllowance_16 ;	// ^x16^Cg
	protected String titlePayAllowance_17 ;	// ^x17^Cg
	protected String titlePayAllowance_18 ;	// ^x18^Cg
	protected String titlePayAllowance_19 ;	// ^x19^Cg
	protected String titlePayAllowance_20 ;	// ^x20^Cg
	protected String titlePayAllowance_21 ;	// ^x21^Cg
	protected String titlePayAllowance_22 ;	// ^x22^Cg
	protected String titlePayAllowance_23 ;	// ^x23^Cg
	protected String titlePayAllowance_24 ;	// ^x24^Cg
	protected String titlePayAllowance_25 ;	// ^x25^Cg
	protected String titlePayAllowance_26 ;	// ^x26^Cg
	protected String titlePayAllowance_27 ;	// ^x27^Cg
	protected String titlePayAllowance_28 ;	// ^x28^Cg
	protected String titlePayAllowance_29 ;	// ^x29^Cg
	protected String titlePayAllowance_30 ;	// ^x30^Cg
	
	protected String titlePayDeduction_01 ;	// ^T01^Cg
	protected String titlePayDeduction_02 ;	// ^T02^Cg
	protected String titlePayDeduction_03 ;	// ^T03^Cg
	protected String titlePayDeduction_04 ;	// ^T04^Cg
	protected String titlePayDeduction_05 ;	// ^T05^Cg
	protected String titlePayDeduction_06 ;	// ^T06^Cg
	protected String titlePayDeduction_07 ;	// ^T07^Cg
	protected String titlePayDeduction_08 ;	// ^T08^Cg
	protected String titlePayDeduction_09 ;	// ^T09^Cg
	protected String titlePayDeduction_10 ;	// ^T10^Cg
	protected String titlePayDeduction_11 ;	// ^T11^Cg
	protected String titlePayDeduction_12 ;	// ^T12^Cg
	protected String titlePayDeduction_13 ;	// ^T13^Cg
	protected String titlePayDeduction_14 ;	// ^T14^Cg
	protected String titlePayDeduction_15 ;	// ^T15^Cg
	protected String titlePayDeduction_16 ;	// ^T16^Cg
	protected String titlePayDeduction_17 ;	// ^T17^Cg
	protected String titlePayDeduction_18 ;	// ^T18^Cg
	protected String titlePayDeduction_19 ;	// ^T19^Cg
	protected String titlePayDeduction_20 ;	// ^T20^Cg
	protected String titlePayDeduction_21 ;	// ^T21^Cg
	protected String titlePayDeduction_22 ;	// ^T22^Cg
	protected String titlePayDeduction_23 ;	// ^T23^Cg
	protected String titlePayDeduction_24 ;	// ^T24^Cg
	protected String titlePayDeduction_25 ;	// ^T25^Cg
	protected String titlePayDeduction_26 ;	// ^T26^Cg
	protected String titlePayDeduction_27 ;	// ^T27^Cg
	
	protected String titleAttendance_01 ;	// ΑӍ01^Cg
	protected String titleAttendance_02 ;	// ΑӍ02^Cg
	protected String titleAttendance_03 ;	// ΑӍ03^Cg
	protected String titleAttendance_04 ;	// ΑӍ04^Cg
	protected String titleAttendance_05 ;	// ΑӍ05^Cg
	protected String titleAttendance_06 ;	// ΑӍ06^Cg
	protected String titleAttendance_07 ;	// ΑӍ07^Cg
	protected String titleAttendance_08 ;	// ΑӍ08^Cg
	protected String titleAttendance_09 ;	// ΑӍ09^Cg
	protected String titleAttendance_10 ;	// ΑӍ10^Cg
	protected String titleAttendance_11 ;	// ΑӍ11^Cg
	protected String titleAttendance_12 ;	// ΑӍ12^Cg
	protected String titleAttendance_13 ;	// ΑӍ13^Cg
	protected String titleAttendance_14 ;	// ΑӍ14^Cg
	
	protected String titleBonAllowance_01 ;	// ܗ^x01^Cg
	protected String titleBonAllowance_02 ;	// ܗ^x02^Cg
	protected String titleBonAllowance_03 ;	// ܗ^x03^Cg
	protected String titleBonAllowance_04 ;	// ܗ^x04^Cg
	protected String titleBonAllowance_05 ;	// ܗ^x05^Cg
	protected String titleBonAllowance_06 ;	// ܗ^x06^Cg
	protected String titleBonAllowance_07 ;	// ܗ^x07^Cg
	protected String titleBonAllowance_08 ;	// ܗ^x08^Cg
	protected String titleBonAllowance_09 ;	// ܗ^x09^Cg
	protected String titleBonAllowance_10 ;	// ܗ^x10^Cg
	
	protected String titleBonDeduction_01 ;	// ܗ^T01^Cg
	protected String titleBonDeduction_02 ;	// ܗ^T02^Cg
	protected String titleBonDeduction_03 ;	// ܗ^T03^Cg
	protected String titleBonDeduction_04 ;	// ܗ^T04^Cg
	protected String titleBonDeduction_05 ;	// ܗ^T05^Cg
	protected String titleBonDeduction_06 ;	// ܗ^T06^Cg
	protected String titleBonDeduction_07 ;	// ܗ^T07^Cg
	protected String titleBonDeduction_08 ;	// ܗ^T08^Cg
	protected String titleBonDeduction_09 ;	// ܗ^T09^Cg
	protected String titleBonDeduction_10 ;	// ܗ^T10^Cg
	protected String titleBonDeduction_11 ;	// ܗ^T11^Cg
	protected String titleBonDeduction_12 ;	// ܗ^T12^Cg
	protected String titleBonDeduction_13 ;	// ܗ^T13^Cg
	protected String titleBonDeduction_14 ;	// ܗ^T14^Cg
	protected String titleBonDeduction_15 ;	// ܗ^T15^Cg
	protected String titleBonDeduction_16 ;	// ܗ^T16^Cg
	protected String titleBonDeduction_17 ;	// ܗ^T17^Cg

	protected String titleIncomeTaxType    ;	// ېŋ敪
	protected String titleAdjustmentType   ;	// N敪
	protected String titleSelfWidowType    ;	// {lǕw敪
	protected String titleSelfHandicapType ;	// {lQ敪
	protected String titleSelfStudentType  ;	// {lw敪
	protected String titleSpouseIntendType ;	// zҋ敪
	protected String titleGeneralDependent ;	// ʕ}{e
	protected String titleSpecificDependent;	// }{e
	protected String titleElderlyDependent ;	// Vl}{e
	protected String titleLiveWithEldRel   ;	// Ve
	protected String titleLiveWithHandiGe  ;	// 
	protected String titleLiveWithHandiSp  ;	// 
	protected String titleLiveWithHandiEl  ;	// Vl
	protected String titleLiveWithHandiEr  ;	// Ve
	protected String titleGeneralHandicap  ;	// ʏQ
	protected String titleSpecificHandicap ;	// ʏQ
	protected String titleStationCode      ;	// R[h
	protected String titleGender           ;	// 
	protected String titleAddress          ;	// Z
	protected String titlePositionCode     ;	// E
	protected String titleBirthDate        ;	// N
	protected String titleKCode            ;	// ЈR[h
	protected String titleEntranceDate     ;	// Г
	protected String titleKName            ;	// Ј
	protected String titleRetirementDate   ;	// ގГ
	protected String titlePhoneNumber      ;	// dbԍ
	protected String titleHealthNo         ;	// Nیԍ
	protected String titleFundNo           ;	// Nԍ
	protected String titlePensionNo        ;	// Nԍ
	protected String titleUnemployNo       ;	// ٗpیԍ
	
	protected String titlePayday        ;	// x
	protected String titleAllowanceItem ;	// x
	protected String titleAllowanceTotal;	// xz
	protected String titleDeductionItem ;	// x
	protected String titleDeductionTotal;	// Tz
	protected String titlePaymentTotal  ;	// xz
	protected String titleBank1PayAmount;	// s1Uz
	protected String titleBank2PayAmount;	// s2Uz
	protected String titleCashPayAmount ;	// xz

	

	protected String companyName       ;	// Ж
	protected String outputYear        ;	// 䒠o͔N(a)
	protected String outputDate        ;	// o͓

	
	protected String payPayday_01        ;	// ^x_01
	protected String payPayday_02        ;	// ^x_02
	protected String payPayday_03        ;	// ^x_03
	protected String payPayday_04        ;	// ^x_04
	protected String payPayday_05        ;	// ^x_05
	protected String payPayday_06        ;	// ^x_06
	protected String payPayday_07        ;	// ^x_07
	protected String payPayday_08        ;	// ^x_08
	protected String payPayday_09        ;	// ^x_09
	protected String payPayday_10        ;	// ^x_10
	protected String payPayday_11        ;	// ^x_11
	protected String payPayday_12        ;	// ^x_12
	protected String bonPayday_01        ;	// ܗ^x_01
	protected String bonPayday_02        ;	// ܗ^x_02
	protected String bonPayday_03        ;	// ܗ^x_03
	protected String bonPayday_04        ;	// ܗ^x_04
	protected String bonPayday_05        ;	// ܗ^x_05
	protected String bonPayday_06        ;	// ܗ^x_06
	
	protected Integer payAllowanceTotal_01;	// ^xz_01
	protected Integer payDeductionTotal_01;	// ^Tz_01
	protected Integer payPaymentTotal_01  ;	// ^xz_01
	protected Integer payBank1PayAmount_01;	// ^s1Uz_01
	protected Integer payBank2PayAmount_01;	// ^s2Uz_01
	protected Integer payCashPayAmount_01 ;	// ^xz_01
	protected Integer payAllowanceTotal_02;	// ^xz_02
	protected Integer payDeductionTotal_02;	// ^Tz_02
	protected Integer payPaymentTotal_02  ;	// ^xz_02
	protected Integer payBank1PayAmount_02;	// ^s1Uz_02
	protected Integer payBank2PayAmount_02;	// ^s2Uz_02
	protected Integer payCashPayAmount_02 ;	// ^xz_02
	protected Integer payAllowanceTotal_03;	// ^xz_03
	protected Integer payDeductionTotal_03;	// ^Tz_03
	protected Integer payPaymentTotal_03  ;	// ^xz_03
	protected Integer payBank1PayAmount_03;	// ^s1Uz_03
	protected Integer payBank2PayAmount_03;	// ^s2Uz_03
	protected Integer payCashPayAmount_03 ;	// ^xz_03
	protected Integer payAllowanceTotal_04;	// ^xz_04
	protected Integer payDeductionTotal_04;	// ^Tz_04
	protected Integer payPaymentTotal_04  ;	// ^xz_04
	protected Integer payBank1PayAmount_04;	// ^s1Uz_04
	protected Integer payBank2PayAmount_04;	// ^s2Uz_04
	protected Integer payCashPayAmount_04 ;	// ^xz_04
	protected Integer payAllowanceTotal_05;	// ^xz_05
	protected Integer payDeductionTotal_05;	// ^Tz_05
	protected Integer payPaymentTotal_05  ;	// ^xz_05
	protected Integer payBank1PayAmount_05;	// ^s1Uz_05
	protected Integer payBank2PayAmount_05;	// ^s2Uz_05
	protected Integer payCashPayAmount_05 ;	// ^xz_05
	protected Integer payAllowanceTotal_06;	// ^xz_06
	protected Integer payDeductionTotal_06;	// ^Tz_06
	protected Integer payPaymentTotal_06  ;	// ^xz_06
	protected Integer payBank1PayAmount_06;	// ^s1Uz_06
	protected Integer payBank2PayAmount_06;	// ^s2Uz_06
	protected Integer payCashPayAmount_06 ;	// ^xz_06
	protected Integer payAllowanceTotal_07;	// ^xz_07
	protected Integer payDeductionTotal_07;	// ^Tz_07
	protected Integer payPaymentTotal_07  ;	// ^xz_07
	protected Integer payBank1PayAmount_07;	// ^s1Uz_07
	protected Integer payBank2PayAmount_07;	// ^s2Uz_07
	protected Integer payCashPayAmount_07 ;	// ^xz_07
	protected Integer payAllowanceTotal_08;	// ^xz_08
	protected Integer payDeductionTotal_08;	// ^Tz_08
	protected Integer payPaymentTotal_08  ;	// ^xz_08
	protected Integer payBank1PayAmount_08;	// ^s1Uz_08
	protected Integer payBank2PayAmount_08;	// ^s2Uz_08
	protected Integer payCashPayAmount_08 ;	// ^xz_08
	protected Integer payAllowanceTotal_09;	// ^xz_09
	protected Integer payDeductionTotal_09;	// ^Tz_09
	protected Integer payPaymentTotal_09  ;	// ^xz_09
	protected Integer payBank1PayAmount_09;	// ^s1Uz_09
	protected Integer payBank2PayAmount_09;	// ^s2Uz_09
	protected Integer payCashPayAmount_09 ;	// ^xz_09
	protected Integer payAllowanceTotal_10;	// ^xz_10
	protected Integer payDeductionTotal_10;	// ^Tz_10
	protected Integer payPaymentTotal_10  ;	// ^xz_10
	protected Integer payBank1PayAmount_10;	// ^s1Uz_10
	protected Integer payBank2PayAmount_10;	// ^s2Uz_10
	protected Integer payCashPayAmount_10 ;	// ^xz_10
	protected Integer payAllowanceTotal_11;	// ^xz_11
	protected Integer payDeductionTotal_11;	// ^Tz_11
	protected Integer payPaymentTotal_11  ;	// ^xz_11
	protected Integer payBank1PayAmount_11;	// ^s1Uz_11
	protected Integer payBank2PayAmount_11;	// ^s2Uz_11
	protected Integer payCashPayAmount_11 ;	// ^xz_11
	protected Integer payAllowanceTotal_12;	// ^xz_12
	protected Integer payDeductionTotal_12;	// ^Tz_12
	protected Integer payPaymentTotal_12  ;	// ^xz_12
	protected Integer payBank1PayAmount_12;	// ^s1Uz_12
	protected Integer payBank2PayAmount_12;	// ^s2Uz_12
	protected Integer payCashPayAmount_12 ;	// ^xz_12

	protected Integer payTotalAllowanceTotal;	// ^xz(v)
	protected Integer payTotalDeductionTotal;	// ^Tz(v)
	protected Integer payTotalPaymentTotal  ;	// ^xz(v)
	protected Integer payTotalBank1PayAmount;	// ^s1Uz(v)
	protected Integer payTotalBank2PayAmount;	// ^s2Uz(v)
	protected Integer payTotalCashPayAmount ;	// ^xz(v)

	protected Integer bonTotalAllowanceTotal;	// ܗ^xz(v)
	protected Integer bonTotalDeductionTotal;	// ܗ^Tz(v)
	protected Integer bonTotalPaymentTotal  ;	// ܗ^xz(v)
	protected Integer bonTotalBank1PayAmount;	// ܗ^s1Uz(v)
	protected Integer bonTotalBank2PayAmount;	// ܗ^s2Uz(v)
	protected Integer bonTotalCashPayAmount ;	// ܗ^xz(v)

	protected Integer bonAllowanceTotal_01;	// ܗ^xz_01
	protected Integer bonDeductionTotal_01;	// ܗ^Tz_01
	protected Integer bonPaymentTotal_01  ;	// ܗ^xz_01
	protected Integer bonBank1PayAmount_01;	// ܗ^s1Uz_01
	protected Integer bonBank2PayAmount_01;	// ܗ^s2Uz_01
	protected Integer bonCashPayAmount_01 ;	// ܗ^xz_01
	protected Integer bonAllowanceTotal_02;	// ܗ^xz_02
	protected Integer bonDeductionTotal_02;	// ܗ^Tz_02
	protected Integer bonPaymentTotal_02  ;	// ܗ^xz_02
	protected Integer bonBank1PayAmount_02;	// ܗ^s1Uz_02
	protected Integer bonBank2PayAmount_02;	// ܗ^s2Uz_02
	protected Integer bonCashPayAmount_02 ;	// ܗ^xz_02
	protected Integer bonAllowanceTotal_03;	// ܗ^xz_03
	protected Integer bonDeductionTotal_03;	// ܗ^Tz_03
	protected Integer bonPaymentTotal_03  ;	// ܗ^xz_03
	protected Integer bonBank1PayAmount_03;	// ܗ^s1Uz_03
	protected Integer bonBank2PayAmount_03;	// ܗ^s2Uz_03
	protected Integer bonCashPayAmount_03 ;	// ܗ^xz_03
	protected Integer bonAllowanceTotal_04;	// ܗ^xz_04
	protected Integer bonDeductionTotal_04;	// ܗ^Tz_04
	protected Integer bonPaymentTotal_04  ;	// ܗ^xz_04
	protected Integer bonBank1PayAmount_04;	// ܗ^s1Uz_04
	protected Integer bonBank2PayAmount_04;	// ܗ^s2Uz_04
	protected Integer bonCashPayAmount_04 ;	// ܗ^xz_04
	protected Integer bonAllowanceTotal_05;	// ܗ^xz_05
	protected Integer bonDeductionTotal_05;	// ܗ^Tz_05
	protected Integer bonPaymentTotal_05  ;	// ܗ^xz_05
	protected Integer bonBank1PayAmount_05;	// ܗ^s1Uz_05
	protected Integer bonBank2PayAmount_05;	// ܗ^s2Uz_05
	protected Integer bonCashPayAmount_05 ;	// ܗ^xz_05
	protected Integer bonAllowanceTotal_06;	// ܗ^xz_06
	protected Integer bonDeductionTotal_06;	// ܗ^Tz_06
	protected Integer bonPaymentTotal_06  ;	// ܗ^xz_06
	protected Integer bonBank1PayAmount_06;	// ܗ^s1Uz_06
	protected Integer bonBank2PayAmount_06;	// ܗ^s2Uz_06
	protected Integer bonCashPayAmount_06 ;	// ܗ^xz_06

	protected Integer payTotalAllowance_01;	// ^x01(v)
	protected Integer payTotalAllowance_02;	// ^x02(v)
	protected Integer payTotalAllowance_03;	// ^x03(v)
	protected Integer payTotalAllowance_04;	// ^x04(v)
	protected Integer payTotalAllowance_05;	// ^x05(v)
	protected Integer payTotalAllowance_06;	// ^x06(v)
	protected Integer payTotalAllowance_07;	// ^x07(v)
	protected Integer payTotalAllowance_08;	// ^x08(v)
	protected Integer payTotalAllowance_09;	// ^x09(v)
	protected Integer payTotalAllowance_10;	// ^x10(v)
	protected Integer payTotalAllowance_11;	// ^x11(v)
	protected Integer payTotalAllowance_12;	// ^x12(v)
	protected Integer payTotalAllowance_13;	// ^x13(v)
	protected Integer payTotalAllowance_14;	// ^x14(v)
	protected Integer payTotalAllowance_15;	// ^x15(v)
	protected Integer payTotalAllowance_16;	// ^x16(v)
	protected Integer payTotalAllowance_17;	// ^x17(v)
	protected Integer payTotalAllowance_18;	// ^x18(v)
	protected Integer payTotalAllowance_19;	// ^x19(v)
	protected Integer payTotalAllowance_20;	// ^x20(v)
	protected Integer payTotalAllowance_21;	// ^x21(v)
	protected Integer payTotalAllowance_22;	// ^x22(v)
	protected Integer payTotalAllowance_23;	// ^x23(v)
	protected Integer payTotalAllowance_24;	// ^x24(v)
	protected Integer payTotalAllowance_25;	// ^x25(v)
	protected Integer payTotalAllowance_26;	// ^x26(v)
	protected Integer payTotalAllowance_27;	// ^x27(v)
	protected Integer payTotalAllowance_28;	// ^x28(v)
	protected Integer payTotalAllowance_29;	// ^x29(v)
	protected Integer payTotalAllowance_30;	// ^x30(v)
	protected Integer payTotalDeduction_01;	// ^T01(v)
	protected Integer payTotalDeduction_02;	// ^T02(v)
	protected Integer payTotalDeduction_03;	// ^T03(v)
	protected Integer payTotalDeduction_04;	// ^T04(v)
	protected Integer payTotalDeduction_05;	// ^T05(v)
	protected Integer payTotalDeduction_06;	// ^T06(v)
	protected Integer payTotalDeduction_07;	// ^T07(v)
	protected Integer payTotalDeduction_08;	// ^T08(v)
	protected Integer payTotalDeduction_09;	// ^T09(v)
	protected Integer payTotalDeduction_10;	// ^T10(v)
	protected Integer payTotalDeduction_11;	// ^T11(v)
	protected Integer payTotalDeduction_12;	// ^T12(v)
	protected Integer payTotalDeduction_13;	// ^T13(v)
	protected Integer payTotalDeduction_14;	// ^T14(v)
	protected Integer payTotalDeduction_15;	// ^T15(v)
	protected Integer payTotalDeduction_16;	// ^T16(v)
	protected Integer payTotalDeduction_17;	// ^T17(v)
	protected Integer payTotalDeduction_18;	// ^T18(v)
	protected Integer payTotalDeduction_19;	// ^T19(v)
	protected Integer payTotalDeduction_20;	// ^T20(v)
	protected Integer payTotalDeduction_21;	// ^T21(v)
	protected Integer payTotalDeduction_22;	// ^T22(v)
	protected Integer payTotalDeduction_23;	// ^T23(v)
	protected Integer payTotalDeduction_24;	// ^T24(v)
	protected Integer payTotalDeduction_25;	// ^T25(v)
	protected Integer payTotalDeduction_26;	// ^T26(v)
	protected Integer payTotalDeduction_27;	// ^T27(v)
	protected Float totalAttendance_01;	// ΑӍ01(v)
	protected Float totalAttendance_02;	// ΑӍ02(v)
	protected Float totalAttendance_03;	// ΑӍ03(v)
	protected Float totalAttendance_04;	// ΑӍ04(v)
	protected Float totalAttendance_05;	// ΑӍ05(v)
	protected Integer totalAttendance_06;	// ΑӍ06(v)
	protected Integer totalAttendance_07;	// ΑӍ07(v)
	protected Float totalAttendance_08;	// ΑӍ08(v)
	protected Float totalAttendance_09;	// ΑӍ09(v)
	protected Float totalAttendance_10;	// ΑӍ10(v)
	protected Float totalAttendance_11;	// ΑӍ11(v)
	protected Float totalAttendance_12;	// ΑӍ12(v)
	protected Integer totalAttendance_13;	// ΑӍ13(v)
	protected Integer totalAttendance_14;	// ΑӍ14(v)
	protected Integer bonTotalAllowance_01;	// ܗ^x01(v)
	protected Integer bonTotalAllowance_02;	// ܗ^x02(v)
	protected Integer bonTotalAllowance_03;	// ܗ^x03(v)
	protected Integer bonTotalAllowance_04;	// ܗ^x04(v)
	protected Integer bonTotalAllowance_05;	// ܗ^x05(v)
	protected Integer bonTotalAllowance_06;	// ܗ^x06(v)
	protected Integer bonTotalAllowance_07;	// ܗ^x07(v)
	protected Integer bonTotalAllowance_08;	// ܗ^x08(v)
	protected Integer bonTotalAllowance_09;	// ܗ^x09(v)
	protected Integer bonTotalAllowance_10;	// ܗ^x10(v)
	protected Integer bonTotalDeduction_01;	// ܗ^T01(v)
	protected Integer bonTotalDeduction_02;	// ܗ^T02(v)
	protected Integer bonTotalDeduction_03;	// ܗ^T03(v)
	protected Integer bonTotalDeduction_04;	// ܗ^T04(v)
	protected Integer bonTotalDeduction_05;	// ܗ^T05(v)
	protected Integer bonTotalDeduction_06;	// ܗ^T06(v)
	protected Integer bonTotalDeduction_07;	// ܗ^T07(v)
	protected Integer bonTotalDeduction_08;	// ܗ^T08(v)
	protected Integer bonTotalDeduction_09;	// ܗ^T09(v)
	protected Integer bonTotalDeduction_10;	// ܗ^T10(v)
	protected Integer bonTotalDeduction_11;	// ܗ^T11(v)
	protected Integer bonTotalDeduction_12;	// ܗ^T12(v)
	protected Integer bonTotalDeduction_13;	// ܗ^T13(v)
	protected Integer bonTotalDeduction_14;	// ܗ^T14(v)
	protected Integer bonTotalDeduction_15;	// ܗ^T15(v)
	protected Integer bonTotalDeduction_16;	// ܗ^T16(v)
	protected Integer bonTotalDeduction_17;	// ܗ^T17(v)

	protected Integer payAllowance_01_01;		// ^x01_01
	protected Integer payAllowance_02_01;		// ^x02_01
	protected Integer payAllowance_03_01;		// ^x03_01
	protected Integer payAllowance_04_01;		// ^x04_01
	protected Integer payAllowance_05_01;		// ^x05_01
	protected Integer payAllowance_06_01;		// ^x06_01
	protected Integer payAllowance_07_01;		// ^x07_01
	protected Integer payAllowance_08_01;		// ^x08_01
	protected Integer payAllowance_09_01;		// ^x09_01
	protected Integer payAllowance_10_01;		// ^x10_01
	protected Integer payAllowance_11_01;		// ^x11_01
	protected Integer payAllowance_12_01;		// ^x12_01
	protected Integer payAllowance_13_01;		// ^x13_01
	protected Integer payAllowance_14_01;		// ^x14_01
	protected Integer payAllowance_15_01;		// ^x15_01
	protected Integer payAllowance_16_01;		// ^x16_01
	protected Integer payAllowance_17_01;		// ^x17_01
	protected Integer payAllowance_18_01;		// ^x18_01
	protected Integer payAllowance_19_01;		// ^x19_01
	protected Integer payAllowance_20_01;		// ^x20_01
	protected Integer payAllowance_21_01;		// ^x21_01
	protected Integer payAllowance_22_01;		// ^x22_01
	protected Integer payAllowance_23_01;		// ^x23_01
	protected Integer payAllowance_24_01;		// ^x24_01
	protected Integer payAllowance_25_01;		// ^x25_01
	protected Integer payAllowance_26_01;		// ^x26_01
	protected Integer payAllowance_27_01;		// ^x27_01
	protected Integer payAllowance_28_01;		// ^x28_01
	protected Integer payAllowance_29_01;		// ^x29_01
	protected Integer payAllowance_30_01;		// ^x30_01
	protected Integer payDeduction_01_01;		// ^T01_01
	protected Integer payDeduction_02_01;		// ^T02_01
	protected Integer payDeduction_03_01;		// ^T03_01
	protected Integer payDeduction_04_01;		// ^T04_01
	protected Integer payDeduction_05_01;		// ^T05_01
	protected Integer payDeduction_06_01;		// ^T06_01
	protected Integer payDeduction_07_01;		// ^T07_01
	protected Integer payDeduction_08_01;		// ^T08_01
	protected Integer payDeduction_09_01;		// ^T09_01
	protected Integer payDeduction_10_01;		// ^T10_01
	protected Integer payDeduction_11_01;		// ^T11_01
	protected Integer payDeduction_12_01;		// ^T12_01
	protected Integer payDeduction_13_01;		// ^T13_01
	protected Integer payDeduction_14_01;		// ^T14_01
	protected Integer payDeduction_15_01;		// ^T15_01
	protected Integer payDeduction_16_01;		// ^T16_01
	protected Integer payDeduction_17_01;		// ^T17_01
	protected Integer payDeduction_18_01;		// ^T18_01
	protected Integer payDeduction_19_01;		// ^T19_01
	protected Integer payDeduction_20_01;		// ^T20_01
	protected Integer payDeduction_21_01;		// ^T21_01
	protected Integer payDeduction_22_01;		// ^T22_01
	protected Integer payDeduction_23_01;		// ^T23_01
	protected Integer payDeduction_24_01;		// ^T24_01
	protected Integer payDeduction_25_01;		// ^T25_01
	protected Integer payDeduction_26_01;		// ^T26_01
	protected Integer payDeduction_27_01;		// ^T27_01
	protected Float attendance_01_01;			// ΑӍ01_01
	protected Float attendance_02_01;			// ΑӍ02_01
	protected Float attendance_03_01;			// ΑӍ03_01
	protected Float attendance_04_01;			// ΑӍ04_01
	protected Float attendance_05_01;			// ΑӍ05_01
	protected Integer attendance_06_01;		// ΑӍ06_01
	protected Integer attendance_07_01;		// ΑӍ07_01
	protected Float attendance_08_01;			// ΑӍ08_01
	protected Float attendance_09_01;			// ΑӍ09_01
	protected Float attendance_10_01;			// ΑӍ10_01
	protected Float attendance_11_01;			// ΑӍ11_01
	protected Float attendance_12_01;			// ΑӍ12_01
	protected Integer attendance_13_01;		// ΑӍ13_01
	protected Integer attendance_14_01;		// ΑӍ14_01
	protected Integer bonAllowance_01_01;		// ܗ^x01_01
	protected Integer bonAllowance_02_01;		// ܗ^x02_01
	protected Integer bonAllowance_03_01;		// ܗ^x03_01
	protected Integer bonAllowance_04_01;		// ܗ^x04_01
	protected Integer bonAllowance_05_01;		// ܗ^x05_01
	protected Integer bonAllowance_06_01;		// ܗ^x06_01
	protected Integer bonAllowance_07_01;		// ܗ^x07_01
	protected Integer bonAllowance_08_01;		// ܗ^x08_01
	protected Integer bonAllowance_09_01;		// ܗ^x09_01
	protected Integer bonAllowance_10_01;		// ܗ^x10_01
	protected Integer bonDeduction_01_01;		// ܗ^T01_01
	protected Integer bonDeduction_02_01;		// ܗ^T02_01
	protected Integer bonDeduction_03_01;		// ܗ^T03_01
	protected Integer bonDeduction_04_01;		// ܗ^T04_01
	protected Integer bonDeduction_05_01;		// ܗ^T05_01
	protected Integer bonDeduction_06_01;		// ܗ^T06_01
	protected Integer bonDeduction_07_01;		// ܗ^T07_01
	protected Integer bonDeduction_08_01;		// ܗ^T08_01
	protected Integer bonDeduction_09_01;		// ܗ^T09_01
	protected Integer bonDeduction_10_01;		// ܗ^T10_01
	protected Integer bonDeduction_11_01;		// ܗ^T11_01
	protected Integer bonDeduction_12_01;		// ܗ^T12_01
	protected Integer bonDeduction_13_01;		// ܗ^T13_01
	protected Integer bonDeduction_14_01;		// ܗ^T14_01
	protected Integer bonDeduction_15_01;		// ܗ^T15_01
	protected Integer bonDeduction_16_01;		// ܗ^T16_01
	protected Integer bonDeduction_17_01;		// ܗ^T17_01

	protected Integer payAllowance_01_02;		// ^x01_02
	protected Integer payAllowance_02_02;		// ^x02_02
	protected Integer payAllowance_03_02;		// ^x03_02
	protected Integer payAllowance_04_02;		// ^x04_02
	protected Integer payAllowance_05_02;		// ^x05_02
	protected Integer payAllowance_06_02;		// ^x06_02
	protected Integer payAllowance_07_02;		// ^x07_02
	protected Integer payAllowance_08_02;		// ^x08_02
	protected Integer payAllowance_09_02;		// ^x09_02
	protected Integer payAllowance_10_02;		// ^x10_02
	protected Integer payAllowance_11_02;		// ^x11_02
	protected Integer payAllowance_12_02;		// ^x12_02
	protected Integer payAllowance_13_02;		// ^x13_02
	protected Integer payAllowance_14_02;		// ^x14_02
	protected Integer payAllowance_15_02;		// ^x15_02
	protected Integer payAllowance_16_02;		// ^x16_02
	protected Integer payAllowance_17_02;		// ^x17_02
	protected Integer payAllowance_18_02;		// ^x18_02
	protected Integer payAllowance_19_02;		// ^x19_02
	protected Integer payAllowance_20_02;		// ^x20_02
	protected Integer payAllowance_21_02;		// ^x21_02
	protected Integer payAllowance_22_02;		// ^x22_02
	protected Integer payAllowance_23_02;		// ^x23_02
	protected Integer payAllowance_24_02;		// ^x24_02
	protected Integer payAllowance_25_02;		// ^x25_02
	protected Integer payAllowance_26_02;		// ^x26_02
	protected Integer payAllowance_27_02;		// ^x27_02
	protected Integer payAllowance_28_02;		// ^x28_02
	protected Integer payAllowance_29_02;		// ^x29_02
	protected Integer payAllowance_30_02;		// ^x30_02
	protected Integer payDeduction_01_02;		// ^T01_02
	protected Integer payDeduction_02_02;		// ^T02_02
	protected Integer payDeduction_03_02;		// ^T03_02
	protected Integer payDeduction_04_02;		// ^T04_02
	protected Integer payDeduction_05_02;		// ^T05_02
	protected Integer payDeduction_06_02;		// ^T06_02
	protected Integer payDeduction_07_02;		// ^T07_02
	protected Integer payDeduction_08_02;		// ^T08_02
	protected Integer payDeduction_09_02;		// ^T09_02
	protected Integer payDeduction_10_02;		// ^T10_02
	protected Integer payDeduction_11_02;		// ^T11_02
	protected Integer payDeduction_12_02;		// ^T12_02
	protected Integer payDeduction_13_02;		// ^T13_02
	protected Integer payDeduction_14_02;		// ^T14_02
	protected Integer payDeduction_15_02;		// ^T15_02
	protected Integer payDeduction_16_02;		// ^T16_02
	protected Integer payDeduction_17_02;		// ^T17_02
	protected Integer payDeduction_18_02;		// ^T18_02
	protected Integer payDeduction_19_02;		// ^T19_02
	protected Integer payDeduction_20_02;		// ^T20_02
	protected Integer payDeduction_21_02;		// ^T21_02
	protected Integer payDeduction_22_02;		// ^T22_02
	protected Integer payDeduction_23_02;		// ^T23_02
	protected Integer payDeduction_24_02;		// ^T24_02
	protected Integer payDeduction_25_02;		// ^T25_02
	protected Integer payDeduction_26_02;		// ^T26_02
	protected Integer payDeduction_27_02;		// ^T27_02
	protected Float attendance_01_02;			// ΑӍ01_02
	protected Float attendance_02_02;			// 	ΑӍ02_02
	protected Float attendance_03_02;			// ΑӍ03_02
	protected Float attendance_04_02;			// ΑӍ04_02
	protected Float attendance_05_02;			// ΑӍ05_02
	protected Integer attendance_06_02;		// ΑӍ06_02
	protected Integer attendance_07_02;		// ΑӍ07_02
	protected Float attendance_08_02;			// ΑӍ08_02
	protected Float attendance_09_02;			// ΑӍ09_02
	protected Float attendance_10_02;			// ΑӍ10_02
	protected Float attendance_11_02;			// ΑӍ11_02
	protected Float attendance_12_02;			// ΑӍ12_02
	protected Integer attendance_13_02;		// ΑӍ13_02
	protected Integer attendance_14_02;		// ΑӍ14_02
	protected Integer bonAllowance_01_02;		// ܗ^x01_02
	protected Integer bonAllowance_02_02;		// ܗ^x02_02
	protected Integer bonAllowance_03_02;		// ܗ^x03_02
	protected Integer bonAllowance_04_02;		// ܗ^x04_02
	protected Integer bonAllowance_05_02;		// ܗ^x05_02
	protected Integer bonAllowance_06_02;		// ܗ^x06_02
	protected Integer bonAllowance_07_02;		// ܗ^x07_02
	protected Integer bonAllowance_08_02;		// ܗ^x08_02
	protected Integer bonAllowance_09_02;		// ܗ^x09_02
	protected Integer bonAllowance_10_02;		// ܗ^x10_02
	protected Integer bonDeduction_01_02;		// ܗ^T01_02
	protected Integer bonDeduction_02_02;		// ܗ^T02_02
	protected Integer bonDeduction_03_02;		// ܗ^T03_02
	protected Integer bonDeduction_04_02;		// ܗ^T04_02
	protected Integer bonDeduction_05_02;		// ܗ^T05_02
	protected Integer bonDeduction_06_02;		// ܗ^T06_02
	protected Integer bonDeduction_07_02;		// ܗ^T07_02
	protected Integer bonDeduction_08_02;		// ܗ^T08_02
	protected Integer bonDeduction_09_02;		// ܗ^T09_02
	protected Integer bonDeduction_10_02;		// ܗ^T10_02
	protected Integer bonDeduction_11_02;		// ܗ^T11_02
	protected Integer bonDeduction_12_02;		// ܗ^T12_02
	protected Integer bonDeduction_13_02;		// ܗ^T13_02
	protected Integer bonDeduction_14_02;		// ܗ^T14_02
	protected Integer bonDeduction_15_02;		// ܗ^T15_02
	protected Integer bonDeduction_16_02;		// ܗ^T16_02
	protected Integer bonDeduction_17_02;		// ܗ^T17_02
	protected Integer payAllowance_01_03;		// ^x01_03
	protected Integer payAllowance_02_03;		// ^x02_03
	protected Integer payAllowance_03_03;		// ^x03_03
	protected Integer payAllowance_04_03;		// ^x04_03
	protected Integer payAllowance_05_03;		// ^x05_03
	protected Integer payAllowance_06_03;		// ^x06_03
	protected Integer payAllowance_07_03;		// ^x07_03
	protected Integer payAllowance_08_03;		// ^x08_03
	protected Integer payAllowance_09_03;		// ^x09_03
	protected Integer payAllowance_10_03;		// ^x10_03
	protected Integer payAllowance_11_03;		// ^x11_03
	protected Integer payAllowance_12_03;		// ^x12_03
	protected Integer payAllowance_13_03;		// ^x13_03
	protected Integer payAllowance_14_03;		// ^x14_03
	protected Integer payAllowance_15_03;		// ^x15_03
	protected Integer payAllowance_16_03;		// ^x16_03
	protected Integer payAllowance_17_03;		// ^x17_03
	protected Integer payAllowance_18_03;		// ^x18_03
	protected Integer payAllowance_19_03;		// ^x19_03
	protected Integer payAllowance_20_03;		// ^x20_03
	protected Integer payAllowance_21_03;		// ^x21_03
	protected Integer payAllowance_22_03;		// ^x22_03
	protected Integer payAllowance_23_03;		// ^x23_03
	protected Integer payAllowance_24_03;		// ^x24_03
	protected Integer payAllowance_25_03;		// ^x25_03
	protected Integer payAllowance_26_03;		// ^x26_03
	protected Integer payAllowance_27_03;		// ^x27_03
	protected Integer payAllowance_28_03;		// ^x28_03
	protected Integer payAllowance_29_03;		// ^x29_03
	protected Integer payAllowance_30_03;		// ^x30_03
	protected Integer payDeduction_01_03;		// ^T01_03
	protected Integer payDeduction_02_03;		// ^T02_03
	protected Integer payDeduction_03_03;		// ^T03_03
	protected Integer payDeduction_04_03;		// ^T04_03
	protected Integer payDeduction_05_03;		// ^T05_03
	protected Integer payDeduction_06_03;		// ^T06_03
	protected Integer payDeduction_07_03;		// ^T07_03
	protected Integer payDeduction_08_03;		// ^T08_03
	protected Integer payDeduction_09_03;		// ^T09_03
	protected Integer payDeduction_10_03;		// ^T10_03
	protected Integer payDeduction_11_03;		// ^T11_03
	protected Integer payDeduction_12_03;		// ^T12_03
	protected Integer payDeduction_13_03;		// ^T13_03
	protected Integer payDeduction_14_03;		// ^T14_03
	protected Integer payDeduction_15_03;		// ^T15_03
	protected Integer payDeduction_16_03;		// ^T16_03
	protected Integer payDeduction_17_03;		// ^T17_03
	protected Integer payDeduction_18_03;		// ^T18_03
	protected Integer payDeduction_19_03;		// ^T19_03
	protected Integer payDeduction_20_03;		// ^T20_03
	protected Integer payDeduction_21_03;		// ^T21_03
	protected Integer payDeduction_22_03;		// ^T22_03
	protected Integer payDeduction_23_03;		// ^T23_03
	protected Integer payDeduction_24_03;		// ^T24_03
	protected Integer payDeduction_25_03;		// ^T25_03
	protected Integer payDeduction_26_03;		// ^T26_03
	protected Integer payDeduction_27_03;		// ^T27_03
	protected Float attendance_01_03;			// ΑӍ01_03
	protected Float attendance_02_03;			// ΑӍ02_03
	protected Float attendance_03_03;			// ΑӍ03_03
	protected Float attendance_04_03;			// ΑӍ04_03
	protected Float attendance_05_03;			// ΑӍ05_03
	protected Integer attendance_06_03;		// ΑӍ06_03
	protected Integer attendance_07_03;		// ΑӍ07_03
	protected Float attendance_08_03;			// ΑӍ08_03
	protected Float attendance_09_03;			// ΑӍ09_03
	protected Float attendance_10_03;			// ΑӍ10_03
	protected Float attendance_11_03;			// ΑӍ11_03
	protected Float attendance_12_03;			// ΑӍ12_03
	protected Integer attendance_13_03;		// ΑӍ13_03
	protected Integer attendance_14_03;		// ΑӍ14_03
	protected Integer bonAllowance_01_03;		// ܗ^x01_03
	protected Integer bonAllowance_02_03;		// ܗ^x02_03
	protected Integer bonAllowance_03_03;		// ܗ^x03_03
	protected Integer bonAllowance_04_03;		// ܗ^x04_03
	protected Integer bonAllowance_05_03;		// ܗ^x05_03
	protected Integer bonAllowance_06_03;		// ܗ^x06_03
	protected Integer bonAllowance_07_03;		// ܗ^x07_03
	protected Integer bonAllowance_08_03;		// ܗ^x08_03
	protected Integer bonAllowance_09_03;		// ܗ^x09_03
	protected Integer bonAllowance_10_03;		// ܗ^x10_03
	protected Integer bonDeduction_01_03;		// ܗ^T01_03
	protected Integer bonDeduction_02_03;		// ܗ^T02_03
	protected Integer bonDeduction_03_03;		// ܗ^T03_03
	protected Integer bonDeduction_04_03;		// ܗ^T04_03
	protected Integer bonDeduction_05_03;		// ܗ^T05_03
	protected Integer bonDeduction_06_03;		// ܗ^T06_03
	protected Integer bonDeduction_07_03;		// ܗ^T07_03
	protected Integer bonDeduction_08_03;		// ܗ^T08_03
	protected Integer bonDeduction_09_03;		// ܗ^T09_03
	protected Integer bonDeduction_10_03;		// ܗ^T10_03
	protected Integer bonDeduction_11_03;		// ܗ^T11_03
	protected Integer bonDeduction_12_03;		// ܗ^T12_03
	protected Integer bonDeduction_13_03;		// ܗ^T13_03
	protected Integer bonDeduction_14_03;		// ܗ^T14_03
	protected Integer bonDeduction_15_03;		// ܗ^T15_03
	protected Integer bonDeduction_16_03;		// ܗ^T16_03
	protected Integer bonDeduction_17_03;		// ܗ^T17_03
	protected Integer payAllowance_01_04;		// ^x01_04
	protected Integer payAllowance_02_04;		// ^x02_04
	protected Integer payAllowance_03_04;		// ^x03_04
	protected Integer payAllowance_04_04;		// ^x04_04
	protected Integer payAllowance_05_04;		// ^x05_04
	protected Integer payAllowance_06_04;		// ^x06_04
	protected Integer payAllowance_07_04;		// ^x07_04
	protected Integer payAllowance_08_04;		// ^x08_04
	protected Integer payAllowance_09_04;		// ^x09_04
	protected Integer payAllowance_10_04;		// ^x10_04
	protected Integer payAllowance_11_04;		// ^x11_04
	protected Integer payAllowance_12_04;		// ^x12_04
	protected Integer payAllowance_13_04;		// ^x13_04
	protected Integer payAllowance_14_04;		// ^x14_04
	protected Integer payAllowance_15_04;		// ^x15_04
	protected Integer payAllowance_16_04;		// ^x16_04
	protected Integer payAllowance_17_04;		// ^x17_04
	protected Integer payAllowance_18_04;		// ^x18_04
	protected Integer payAllowance_19_04;		// ^x19_04
	protected Integer payAllowance_20_04;		// ^x20_04
	protected Integer payAllowance_21_04;		// ^x21_04
	protected Integer payAllowance_22_04;		// ^x22_04
	protected Integer payAllowance_23_04;		// ^x23_04
	protected Integer payAllowance_24_04;		// ^x24_04
	protected Integer payAllowance_25_04;		// ^x25_04
	protected Integer payAllowance_26_04;		// ^x26_04
	protected Integer payAllowance_27_04;		// ^x27_04
	protected Integer payAllowance_28_04;		// ^x28_04
	protected Integer payAllowance_29_04;		// ^x29_04
	protected Integer payAllowance_30_04;		// ^x30_04
	protected Integer payDeduction_01_04;		// ^T01_04
	protected Integer payDeduction_02_04;		// ^T02_04
	protected Integer payDeduction_03_04;		// ^T03_04
	protected Integer payDeduction_04_04;		// ^T04_04
	protected Integer payDeduction_05_04;		// ^T05_04
	protected Integer payDeduction_06_04;		// ^T06_04
	protected Integer payDeduction_07_04;		// ^T07_04
	protected Integer payDeduction_08_04;		// ^T08_04
	protected Integer payDeduction_09_04;		// ^T09_04
	protected Integer payDeduction_10_04;		// ^T10_04
	protected Integer payDeduction_11_04;		// ^T11_04
	protected Integer payDeduction_12_04;		// ^T12_04
	protected Integer payDeduction_13_04;		// ^T13_04
	protected Integer payDeduction_14_04;		// ^T14_04
	protected Integer payDeduction_15_04;		// ^T15_04
	protected Integer payDeduction_16_04;		// ^T16_04
	protected Integer payDeduction_17_04;		// ^T17_04
	protected Integer payDeduction_18_04;		// ^T18_04
	protected Integer payDeduction_19_04;		// ^T19_04
	protected Integer payDeduction_20_04;		// ^T20_04
	protected Integer payDeduction_21_04;		// ^T21_04
	protected Integer payDeduction_22_04;		// ^T22_04
	protected Integer payDeduction_23_04;		// ^T23_04
	protected Integer payDeduction_24_04;		// ^T24_04
	protected Integer payDeduction_25_04;		// ^T25_04
	protected Integer payDeduction_26_04;		// ^T26_04
	protected Integer payDeduction_27_04;		// ^T27_04
	protected Float attendance_01_04;			// ΑӍ01_04
	protected Float attendance_02_04;			// ΑӍ02_04
	protected Float attendance_03_04;			// ΑӍ03_04
	protected Float attendance_04_04;			// ΑӍ04_04
	protected Float attendance_05_04;			// ΑӍ05_04
	protected Integer attendance_06_04;		// ΑӍ06_04
	protected Integer attendance_07_04;		// ΑӍ07_04
	protected Float attendance_08_04;			// ΑӍ08_04
	protected Float attendance_09_04;			// ΑӍ09_04
	protected Float attendance_10_04;			// ΑӍ10_04
	protected Float attendance_11_04;			// ΑӍ11_04
	protected Float attendance_12_04;			// ΑӍ12_04
	protected Integer attendance_13_04;	// ΑӍ13_04
	protected Integer attendance_14_04;	// ΑӍ14_04
	protected Integer bonAllowance_01_04;	// ܗ^x01_04
	protected Integer bonAllowance_02_04;	// ܗ^x02_04
	protected Integer bonAllowance_03_04;	// ܗ^x03_04
	protected Integer bonAllowance_04_04;	// ܗ^x04_04
	protected Integer bonAllowance_05_04;	// ܗ^x05_04
	protected Integer bonAllowance_06_04;	// ܗ^x06_04
	protected Integer bonAllowance_07_04;	// ܗ^x07_04
	protected Integer bonAllowance_08_04;	// ܗ^x08_04
	protected Integer bonAllowance_09_04;	// ܗ^x09_04
	protected Integer bonAllowance_10_04;	// ܗ^x10_04
	protected Integer bonDeduction_01_04;	// ܗ^T01_04
	protected Integer bonDeduction_02_04;	// ܗ^T02_04
	protected Integer bonDeduction_03_04;	// ܗ^T03_04
	protected Integer bonDeduction_04_04;	// ܗ^T04_04
	protected Integer bonDeduction_05_04;	// ܗ^T05_04
	protected Integer bonDeduction_06_04;	// ܗ^T06_04
	protected Integer bonDeduction_07_04;	// ܗ^T07_04
	protected Integer bonDeduction_08_04;	// ܗ^T08_04
	protected Integer bonDeduction_09_04;	// ܗ^T09_04
	protected Integer bonDeduction_10_04;	// ܗ^T10_04
	protected Integer bonDeduction_11_04;	// ܗ^T11_04
	protected Integer bonDeduction_12_04;	// ܗ^T12_04
	protected Integer bonDeduction_13_04;	// ܗ^T13_04
	protected Integer bonDeduction_14_04;	// ܗ^T14_04
	protected Integer bonDeduction_15_04;	// ܗ^T15_04
	protected Integer bonDeduction_16_04;	// ܗ^T16_04
	protected Integer bonDeduction_17_04;	// ܗ^T17_04
	
	protected Integer payAllowance_01_05;	// ^x01_05
	protected Integer payAllowance_02_05;	// ^x02_05
	protected Integer payAllowance_03_05;	// ^x03_05
	protected Integer payAllowance_04_05;	// ^x04_05
	protected Integer payAllowance_05_05;	// ^x05_05
	protected Integer payAllowance_06_05;	// ^x06_05
	protected Integer payAllowance_07_05;	// ^x07_05
	protected Integer payAllowance_08_05;	// ^x08_05
	protected Integer payAllowance_09_05;	// ^x09_05
	protected Integer payAllowance_10_05;	// ^x10_05
	protected Integer payAllowance_11_05;	// ^x11_05
	protected Integer payAllowance_12_05;	// ^x12_05
	protected Integer payAllowance_13_05;	// ^x13_05
	protected Integer payAllowance_14_05;	// ^x14_05
	protected Integer payAllowance_15_05;	// ^x15_05
	protected Integer payAllowance_16_05;	// ^x16_05
	protected Integer payAllowance_17_05;	// ^x17_05
	protected Integer payAllowance_18_05;	// ^x18_05
	protected Integer payAllowance_19_05;	// ^x19_05
	protected Integer payAllowance_20_05;	// ^x20_05
	protected Integer payAllowance_21_05;	// ^x21_05
	protected Integer payAllowance_22_05;	// ^x22_05
	protected Integer payAllowance_23_05;	// ^x23_05
	protected Integer payAllowance_24_05;	// ^x24_05
	protected Integer payAllowance_25_05;	// ^x25_05
	protected Integer payAllowance_26_05;	// ^x26_05
	protected Integer payAllowance_27_05;	// ^x27_05
	protected Integer payAllowance_28_05;	// ^x28_05
	protected Integer payAllowance_29_05;	// ^x29_05
	protected Integer payAllowance_30_05;	// ^x30_05
	protected Integer payDeduction_01_05;	// ^T01_05
	protected Integer payDeduction_02_05;	// ^T02_05
	protected Integer payDeduction_03_05;	// ^T03_05
	protected Integer payDeduction_04_05;	// ^T04_05
	protected Integer payDeduction_05_05;	// ^T05_05
	protected Integer payDeduction_06_05;	// ^T06_05
	protected Integer payDeduction_07_05;	// ^T07_05
	protected Integer payDeduction_08_05;	// ^T08_05
	protected Integer payDeduction_09_05;	// ^T09_05
	protected Integer payDeduction_10_05;	// ^T10_05
	protected Integer payDeduction_11_05;	// ^T11_05
	protected Integer payDeduction_12_05;	// ^T12_05
	protected Integer payDeduction_13_05;	// ^T13_05
	protected Integer payDeduction_14_05;	// ^T14_05
	protected Integer payDeduction_15_05;	// ^T15_05
	protected Integer payDeduction_16_05;	// ^T16_05
	protected Integer payDeduction_17_05;	// ^T17_05
	protected Integer payDeduction_18_05;	// ^T18_05
	protected Integer payDeduction_19_05;	// ^T19_05
	protected Integer payDeduction_20_05;	// ^T20_05
	protected Integer payDeduction_21_05;	// ^T21_05
	protected Integer payDeduction_22_05;	// ^T22_05
	protected Integer payDeduction_23_05;	// ^T23_05
	protected Integer payDeduction_24_05;	// ^T24_05
	protected Integer payDeduction_25_05;	// ^T25_05
	protected Integer payDeduction_26_05;	// ^T26_05
	protected Integer payDeduction_27_05;	// ^T27_05
	protected Float attendance_01_05;	// ΑӍ01_05
	protected Float attendance_02_05;	// ΑӍ02_05
	protected Float attendance_03_05;	// ΑӍ03_05
	protected Float attendance_04_05;	// ΑӍ04_05
	protected Float attendance_05_05;	// ΑӍ05_05
	protected Integer attendance_06_05;	// ΑӍ06_05
	protected Integer attendance_07_05;	// ΑӍ07_05
	protected Float attendance_08_05;	// ΑӍ08_05
	protected Float attendance_09_05;	// ΑӍ09_05
	protected Float attendance_10_05;	// ΑӍ10_05
	protected Float attendance_11_05;	// ΑӍ11_05
	protected Float attendance_12_05;	// ΑӍ12_05
	protected Integer attendance_13_05;	// ΑӍ13_05
	protected Integer attendance_14_05;	// ΑӍ14_05
	
	protected Integer bonAllowance_01_05;	// ܗ^x01_05
	protected Integer bonAllowance_02_05;	// ܗ^x02_05
	protected Integer bonAllowance_03_05;	// ܗ^x03_05
	protected Integer bonAllowance_04_05;	// ܗ^x04_05
	protected Integer bonAllowance_05_05;	// ܗ^x05_05
	protected Integer bonAllowance_06_05;	// ܗ^x06_05
	protected Integer bonAllowance_07_05;	// ܗ^x07_05
	protected Integer bonAllowance_08_05;	// ܗ^x08_05
	protected Integer bonAllowance_09_05;	// ܗ^x09_05
	protected Integer bonAllowance_10_05;	// ܗ^x10_05
	protected Integer bonDeduction_01_05;	// ܗ^T01_05
	protected Integer bonDeduction_02_05;	// ܗ^T02_05
	protected Integer bonDeduction_03_05;	// ܗ^T03_05
	protected Integer bonDeduction_04_05;	// ܗ^T04_05
	protected Integer bonDeduction_05_05;	// ܗ^T05_05
	protected Integer bonDeduction_06_05;	// ܗ^T06_05
	protected Integer bonDeduction_07_05;	// ܗ^T07_05
	protected Integer bonDeduction_08_05;	// ܗ^T08_05
	protected Integer bonDeduction_09_05;	// ܗ^T09_05
	protected Integer bonDeduction_10_05;	// ܗ^T10_05
	protected Integer bonDeduction_11_05;	// ܗ^T11_05
	protected Integer bonDeduction_12_05;	// ܗ^T12_05
	protected Integer bonDeduction_13_05;	// ܗ^T13_05
	protected Integer bonDeduction_14_05;	// ܗ^T14_05
	protected Integer bonDeduction_15_05;	// ܗ^T15_05
	protected Integer bonDeduction_16_05;	// ܗ^T16_05
	protected Integer bonDeduction_17_05;	// ܗ^T17_05

	protected Integer payAllowance_01_06;	// ^x01_06
	protected Integer payAllowance_02_06;	// ^x02_06
	protected Integer payAllowance_03_06;	// ^x03_06
	protected Integer payAllowance_04_06;	// ^x04_06
	protected Integer payAllowance_05_06;	// ^x05_06
	protected Integer payAllowance_06_06;	// ^x06_06
	protected Integer payAllowance_07_06;	// ^x07_06
	protected Integer payAllowance_08_06;	// ^x08_06
	protected Integer payAllowance_09_06;	// ^x09_06
	protected Integer payAllowance_10_06;	// ^x10_06
	protected Integer payAllowance_11_06;	// ^x11_06
	protected Integer payAllowance_12_06;	// ^x12_06
	protected Integer payAllowance_13_06;	// ^x13_06
	protected Integer payAllowance_14_06;	// ^x14_06
	protected Integer payAllowance_15_06;	// ^x15_06
	protected Integer payAllowance_16_06;	// ^x16_06
	protected Integer payAllowance_17_06;	// ^x17_06
	protected Integer payAllowance_18_06;	// ^x18_06
	protected Integer payAllowance_19_06;	// ^x19_06
	protected Integer payAllowance_20_06;	// ^x20_06
	protected Integer payAllowance_21_06;	// ^x21_06
	protected Integer payAllowance_22_06;	// ^x22_06
	protected Integer payAllowance_23_06;	// ^x23_06
	protected Integer payAllowance_24_06;	// ^x24_06
	protected Integer payAllowance_25_06;	// ^x25_06
	protected Integer payAllowance_26_06;	// ^x26_06
	protected Integer payAllowance_27_06;	// ^x27_06
	protected Integer payAllowance_28_06;	// ^x28_06
	protected Integer payAllowance_29_06;	// ^x29_06
	protected Integer payAllowance_30_06;	// ^x30_06
	protected Integer payDeduction_01_06;	// ^T01_06
	protected Integer payDeduction_02_06;	// ^T02_06
	protected Integer payDeduction_03_06;	// ^T03_06
	protected Integer payDeduction_04_06;	// ^T04_06
	protected Integer payDeduction_05_06;	// ^T05_06
	protected Integer payDeduction_06_06;	// ^T06_06
	protected Integer payDeduction_07_06;	// ^T07_06
	protected Integer payDeduction_08_06;	// ^T08_06
	protected Integer payDeduction_09_06;	// ^T09_06
	protected Integer payDeduction_10_06;	// ^T10_06
	protected Integer payDeduction_11_06;	// ^T11_06
	protected Integer payDeduction_12_06;	// ^T12_06
	protected Integer payDeduction_13_06;	// ^T13_06
	protected Integer payDeduction_14_06;	// ^T14_06
	protected Integer payDeduction_15_06;	// ^T15_06
	protected Integer payDeduction_16_06;	// ^T16_06
	protected Integer payDeduction_17_06;	// ^T17_06
	protected Integer payDeduction_18_06;	// ^T18_06
	protected Integer payDeduction_19_06;	// ^T19_06
	protected Integer payDeduction_20_06;	// ^T20_06
	protected Integer payDeduction_21_06;	// ^T21_06
	protected Integer payDeduction_22_06;	// ^T22_06
	protected Integer payDeduction_23_06;	// ^T23_06
	protected Integer payDeduction_24_06;	// ^T24_06
	protected Integer payDeduction_25_06;	// ^T25_06
	protected Integer payDeduction_26_06;	// ^T26_06
	protected Integer payDeduction_27_06;	// ^T27_06
	protected Float attendance_01_06;	// ΑӍ01_06
	protected Float attendance_02_06;	// ΑӍ02_06
	protected Float attendance_03_06;	// ΑӍ03_06
	protected Float attendance_04_06;	// ΑӍ04_06
	protected Float attendance_05_06;	// ΑӍ05_06
	protected Integer attendance_06_06;	// ΑӍ06_06
	protected Integer attendance_07_06;	// ΑӍ07_06
	protected Float attendance_08_06;	// ΑӍ08_06
	protected Float attendance_09_06;	// ΑӍ09_06
	protected Float attendance_10_06;	// ΑӍ10_06
	protected Float attendance_11_06;	// ΑӍ11_06
	protected Float attendance_12_06;	// ΑӍ12_06
	protected Integer attendance_13_06;	// ΑӍ13_06
	protected Integer attendance_14_06;	// ΑӍ14_06
	protected Integer bonAllowance_01_06;	// ܗ^x01_06
	protected Integer bonAllowance_02_06;	// ܗ^x02_06
	protected Integer bonAllowance_03_06;	// ܗ^x03_06
	protected Integer bonAllowance_04_06;	// ܗ^x04_06
	protected Integer bonAllowance_05_06;	// ܗ^x05_06
	protected Integer bonAllowance_06_06;	// ܗ^x06_06
	protected Integer bonAllowance_07_06;	// ܗ^x07_06
	protected Integer bonAllowance_08_06;	// ܗ^x08_06
	protected Integer bonAllowance_09_06;	// ܗ^x09_06
	protected Integer bonAllowance_10_06;	// ܗ^x10_06
	protected Integer bonDeduction_01_06;	// ܗ^T01_06
	protected Integer bonDeduction_02_06;	// ܗ^T02_06
	protected Integer bonDeduction_03_06;	// ܗ^T03_06
	protected Integer bonDeduction_04_06;	// ܗ^T04_06
	protected Integer bonDeduction_05_06;	// ܗ^T05_06
	protected Integer bonDeduction_06_06;	// ܗ^T06_06
	protected Integer bonDeduction_07_06;	// ܗ^T07_06
	protected Integer bonDeduction_08_06;	// ܗ^T08_06
	protected Integer bonDeduction_09_06;	// ܗ^T09_06
	protected Integer bonDeduction_10_06;	// ܗ^T10_06
	protected Integer bonDeduction_11_06;	// ܗ^T11_06
	protected Integer bonDeduction_12_06;	// ܗ^T12_06
	protected Integer bonDeduction_13_06;	// ܗ^T13_06
	protected Integer bonDeduction_14_06;	// ܗ^T14_06
	protected Integer bonDeduction_15_06;	// ܗ^T15_06
	protected Integer bonDeduction_16_06;	// ܗ^T16_06
	protected Integer bonDeduction_17_06;	// ܗ^T17_06

	protected Integer payAllowance_01_07;	// ^x01_07
	protected Integer payAllowance_02_07;	// ^x02_07
	protected Integer payAllowance_03_07;	// ^x03_07
	protected Integer payAllowance_04_07;	// ^x04_07
	protected Integer payAllowance_05_07;	// ^x05_07
	protected Integer payAllowance_06_07;	// ^x06_07
	protected Integer payAllowance_07_07;	// ^x07_07
	protected Integer payAllowance_08_07;	// ^x08_07
	protected Integer payAllowance_09_07;	// ^x09_07
	protected Integer payAllowance_10_07;	// ^x10_07
	protected Integer payAllowance_11_07;	// ^x11_07
	protected Integer payAllowance_12_07;	// ^x12_07
	protected Integer payAllowance_13_07;	// ^x13_07
	protected Integer payAllowance_14_07;	// ^x14_07
	protected Integer payAllowance_15_07;	// ^x15_07
	protected Integer payAllowance_16_07;	// ^x16_07
	protected Integer payAllowance_17_07;	// ^x17_07
	protected Integer payAllowance_18_07;	// ^x18_07
	protected Integer payAllowance_19_07;	// ^x19_07
	protected Integer payAllowance_20_07;	// ^x20_07
	protected Integer payAllowance_21_07;	// ^x21_07
	protected Integer payAllowance_22_07;	// ^x22_07
	protected Integer payAllowance_23_07;	// ^x23_07
	protected Integer payAllowance_24_07;	// ^x24_07
	protected Integer payAllowance_25_07;	// ^x25_07
	protected Integer payAllowance_26_07;	// ^x26_07
	protected Integer payAllowance_27_07;	// ^x27_07
	protected Integer payAllowance_28_07;	// ^x28_07
	protected Integer payAllowance_29_07;	// ^x29_07
	protected Integer payAllowance_30_07;	// ^x30_07
	protected Integer payDeduction_01_07;	// ^T01_07
	protected Integer payDeduction_02_07;	// ^T02_07
	protected Integer payDeduction_03_07;	// ^T03_07
	protected Integer payDeduction_04_07;	// ^T04_07
	protected Integer payDeduction_05_07;	// ^T05_07
	protected Integer payDeduction_06_07;	// ^T06_07
	protected Integer payDeduction_07_07;	// ^T07_07
	protected Integer payDeduction_08_07;	// ^T08_07
	protected Integer payDeduction_09_07;	// ^T09_07
	protected Integer payDeduction_10_07;	// ^T10_07
	protected Integer payDeduction_11_07;	// ^T11_07
	protected Integer payDeduction_12_07;	// ^T12_07
	protected Integer payDeduction_13_07;	// ^T13_07
	protected Integer payDeduction_14_07;	// ^T14_07
	protected Integer payDeduction_15_07;	// ^T15_07
	protected Integer payDeduction_16_07;	// ^T16_07
	protected Integer payDeduction_17_07;	// ^T17_07
	protected Integer payDeduction_18_07;	// ^T18_07
	protected Integer payDeduction_19_07;	// ^T19_07
	protected Integer payDeduction_20_07;	// ^T20_07
	protected Integer payDeduction_21_07;	// ^T21_07
	protected Integer payDeduction_22_07;	// ^T22_07
	protected Integer payDeduction_23_07;	// ^T23_07
	protected Integer payDeduction_24_07;	// ^T24_07
	protected Integer payDeduction_25_07;	// ^T25_07
	protected Integer payDeduction_26_07;	// ^T26_07
	protected Integer payDeduction_27_07;	// ^T27_07
	protected Float attendance_01_07;	// ΑӍ01_07
	protected Float attendance_02_07;	// ΑӍ02_07
	protected Float attendance_03_07;	// ΑӍ03_07
	protected Float attendance_04_07;	// ΑӍ04_07
	protected Float attendance_05_07;	// ΑӍ05_07
	protected Integer attendance_06_07;	// ΑӍ06_07
	protected Integer attendance_07_07;	// ΑӍ07_07
	protected Float attendance_08_07;	// ΑӍ08_07
	protected Float attendance_09_07;	// ΑӍ09_07
	protected Float attendance_10_07;	// ΑӍ10_07
	protected Float attendance_11_07;	// ΑӍ11_07
	protected Float attendance_12_07;	// ΑӍ12_07
	protected Integer attendance_13_07;	// ΑӍ13_07
	protected Integer attendance_14_07;	// ΑӍ14_07

	protected Integer payAllowance_01_08;	// ^x01_08
	protected Integer payAllowance_02_08;	// ^x02_08
	protected Integer payAllowance_03_08;	// ^x03_08
	protected Integer payAllowance_04_08;	// ^x04_08
	protected Integer payAllowance_05_08;	// ^x05_08
	protected Integer payAllowance_06_08;	// ^x06_08
	protected Integer payAllowance_07_08;	// ^x07_08
	protected Integer payAllowance_08_08;	// ^x08_08
	protected Integer payAllowance_09_08;	// ^x09_08
	protected Integer payAllowance_10_08;	// ^x10_08
	protected Integer payAllowance_11_08;	// ^x11_08
	protected Integer payAllowance_12_08;	// ^x12_08
	protected Integer payAllowance_13_08;	// ^x13_08
	protected Integer payAllowance_14_08;	// ^x14_08
	protected Integer payAllowance_15_08;	// ^x15_08
	protected Integer payAllowance_16_08;	// ^x16_08
	protected Integer payAllowance_17_08;	// ^x17_08
	protected Integer payAllowance_18_08;	// ^x18_08
	protected Integer payAllowance_19_08;	// ^x19_08
	protected Integer payAllowance_20_08;	// ^x20_08
	protected Integer payAllowance_21_08;	// ^x21_08
	protected Integer payAllowance_22_08;	// ^x22_08
	protected Integer payAllowance_23_08;	// ^x23_08
	protected Integer payAllowance_24_08;	// ^x24_08
	protected Integer payAllowance_25_08;	// ^x25_08
	protected Integer payAllowance_26_08;	// ^x26_08
	protected Integer payAllowance_27_08;	// ^x27_08
	protected Integer payAllowance_28_08;	// ^x28_08
	protected Integer payAllowance_29_08;	// ^x29_08
	protected Integer payAllowance_30_08;	// ^x30_08
	protected Integer payDeduction_01_08;	// ^T01_08
	protected Integer payDeduction_02_08;	// ^T02_08
	protected Integer payDeduction_03_08;	// ^T03_08
	protected Integer payDeduction_04_08;	// ^T04_08
	protected Integer payDeduction_05_08;	// ^T05_08
	protected Integer payDeduction_06_08;	// ^T06_08
	protected Integer payDeduction_07_08;	// ^T07_08
	protected Integer payDeduction_08_08;	// ^T08_08
	protected Integer payDeduction_09_08;	// ^T09_08
	protected Integer payDeduction_10_08;	// ^T10_08
	protected Integer payDeduction_11_08;	// ^T11_08
	protected Integer payDeduction_12_08;	// ^T12_08
	protected Integer payDeduction_13_08;	// ^T13_08
	protected Integer payDeduction_14_08;	// ^T14_08
	protected Integer payDeduction_15_08;	// ^T15_08
	protected Integer payDeduction_16_08;	// ^T16_08
	protected Integer payDeduction_17_08;	// ^T17_08
	protected Integer payDeduction_18_08;	// ^T18_08
	protected Integer payDeduction_19_08;	// ^T19_08
	protected Integer payDeduction_20_08;	// ^T20_08
	protected Integer payDeduction_21_08;	// ^T21_08
	protected Integer payDeduction_22_08;	// ^T22_08
	protected Integer payDeduction_23_08;	// ^T23_08
	protected Integer payDeduction_24_08;	// ^T24_08
	protected Integer payDeduction_25_08;	// ^T25_08
	protected Integer payDeduction_26_08;	// ^T26_08
	protected Integer payDeduction_27_08;	// ^T27_08
	protected Float attendance_01_08;	// ΑӍ01_08
	protected Float attendance_02_08;	// ΑӍ02_08
	protected Float attendance_03_08;	// ΑӍ03_08
	protected Float attendance_04_08;	// ΑӍ04_08
	protected Float attendance_05_08;	// ΑӍ05_08
	protected Integer attendance_06_08;	// ΑӍ06_08
	protected Integer attendance_07_08;	// ΑӍ07_08
	protected Float attendance_08_08;	// ΑӍ08_08
	protected Float attendance_09_08;	// ΑӍ09_08
	protected Float attendance_10_08;	// ΑӍ10_08
	protected Float attendance_11_08;	// ΑӍ11_08
	protected Float attendance_12_08;	// ΑӍ12_08
	protected Integer attendance_13_08;	// ΑӍ13_08
	protected Integer attendance_14_08;	// ΑӍ14_08

	protected Integer payAllowance_01_09;	// ^x01_09
	protected Integer payAllowance_02_09;	// ^x02_09
	protected Integer payAllowance_03_09;	// ^x03_09
	protected Integer payAllowance_04_09;	// ^x04_09
	protected Integer payAllowance_05_09;	// ^x05_09
	protected Integer payAllowance_06_09;	// ^x06_09
	protected Integer payAllowance_07_09;	// ^x07_09
	protected Integer payAllowance_08_09;	// ^x08_09
	protected Integer payAllowance_09_09;	// ^x09_09
	protected Integer payAllowance_10_09;	// ^x10_09
	protected Integer payAllowance_11_09;	// ^x11_09
	protected Integer payAllowance_12_09;	// ^x12_09
	protected Integer payAllowance_13_09;	// ^x13_09
	protected Integer payAllowance_14_09;	// ^x14_09
	protected Integer payAllowance_15_09;	// ^x15_09
	protected Integer payAllowance_16_09;	// ^x16_09
	protected Integer payAllowance_17_09;	// ^x17_09
	protected Integer payAllowance_18_09;	// ^x18_09
	protected Integer payAllowance_19_09;	// ^x19_09
	protected Integer payAllowance_20_09;	// ^x20_09
	protected Integer payAllowance_21_09;	// ^x21_09
	protected Integer payAllowance_22_09;	// ^x22_09
	protected Integer payAllowance_23_09;	// ^x23_09
	protected Integer payAllowance_24_09;	// ^x24_09
	protected Integer payAllowance_25_09;	// ^x25_09
	protected Integer payAllowance_26_09;	// ^x26_09
	protected Integer payAllowance_27_09;	// ^x27_09
	protected Integer payAllowance_28_09;	// ^x28_09
	protected Integer payAllowance_29_09;	// ^x29_09
	protected Integer payAllowance_30_09;	// ^x30_09
	protected Integer payDeduction_01_09;	// ^T01_09
	protected Integer payDeduction_02_09;	// ^T02_09
	protected Integer payDeduction_03_09;	// ^T03_09
	protected Integer payDeduction_04_09;	// ^T04_09
	protected Integer payDeduction_05_09;	// ^T05_09
	protected Integer payDeduction_06_09;	// ^T06_09
	protected Integer payDeduction_07_09;	// ^T07_09
	protected Integer payDeduction_08_09;	// ^T08_09
	protected Integer payDeduction_09_09;	// ^T09_09
	protected Integer payDeduction_10_09;	// ^T10_09
	protected Integer payDeduction_11_09;	// ^T11_09
	protected Integer payDeduction_12_09;	// ^T12_09
	protected Integer payDeduction_13_09;	// ^T13_09
	protected Integer payDeduction_14_09;	// ^T14_09
	protected Integer payDeduction_15_09;	// ^T15_09
	protected Integer payDeduction_16_09;	// ^T16_09
	protected Integer payDeduction_17_09;	// ^T17_09
	protected Integer payDeduction_18_09;	// ^T18_09
	protected Integer payDeduction_19_09;	// ^T19_09
	protected Integer payDeduction_20_09;	// ^T20_09
	protected Integer payDeduction_21_09;	// ^T21_09
	protected Integer payDeduction_22_09;	// ^T22_09
	protected Integer payDeduction_23_09;	// ^T23_09
	protected Integer payDeduction_24_09;	// ^T24_09
	protected Integer payDeduction_25_09;	// ^T25_09
	protected Integer payDeduction_26_09;	// ^T26_09
	protected Integer payDeduction_27_09;	// ^T27_09
	protected Float attendance_01_09;	// ΑӍ01_09
	protected Float attendance_02_09;	// ΑӍ02_09
	protected Float attendance_03_09;	// ΑӍ03_09
	protected Float attendance_04_09;	// ΑӍ04_09
	protected Float attendance_05_09;	// ΑӍ05_09
	protected Integer attendance_06_09;	// ΑӍ06_09
	protected Integer attendance_07_09;	// ΑӍ07_09
	protected Float attendance_08_09;	// ΑӍ08_09
	protected Float attendance_09_09;	// ΑӍ09_09
	protected Float attendance_10_09;	// ΑӍ10_09
	protected Float attendance_11_09;	// ΑӍ11_09
	protected Float attendance_12_09;	// ΑӍ12_09
	protected Integer attendance_13_09;	// ΑӍ13_09
	protected Integer attendance_14_09;	// ΑӍ14_09

	protected Integer payAllowance_01_10;	// ^x01_10
	protected Integer payAllowance_02_10;	// ^x02_10
	protected Integer payAllowance_03_10;	// ^x03_10
	protected Integer payAllowance_04_10;	// ^x04_10
	protected Integer payAllowance_05_10;	// ^x05_10
	protected Integer payAllowance_06_10;	// ^x06_10
	protected Integer payAllowance_07_10;	// ^x07_10
	protected Integer payAllowance_08_10;	// ^x08_10
	protected Integer payAllowance_09_10;	// ^x09_10
	protected Integer payAllowance_10_10;	// ^x10_10
	protected Integer payAllowance_11_10;	// ^x11_10
	protected Integer payAllowance_12_10;	// ^x12_10
	protected Integer payAllowance_13_10;	// ^x13_10
	protected Integer payAllowance_14_10;	// ^x14_10
	protected Integer payAllowance_15_10;	// ^x15_10
	protected Integer payAllowance_16_10;	// ^x16_10
	protected Integer payAllowance_17_10;	// ^x17_10
	protected Integer payAllowance_18_10;	// ^x18_10
	protected Integer payAllowance_19_10;	// ^x19_10
	protected Integer payAllowance_20_10;	// ^x20_10
	protected Integer payAllowance_21_10;	// ^x21_10
	protected Integer payAllowance_22_10;	// ^x22_10
	protected Integer payAllowance_23_10;	// ^x23_10
	protected Integer payAllowance_24_10;	// ^x24_10
	protected Integer payAllowance_25_10;	// ^x25_10
	protected Integer payAllowance_26_10;	// ^x26_10
	protected Integer payAllowance_27_10;	// ^x27_10
	protected Integer payAllowance_28_10;	// ^x28_10
	protected Integer payAllowance_29_10;	// ^x29_10
	protected Integer payAllowance_30_10;	// ^x30_10
	protected Integer payDeduction_01_10;	// ^T01_10
	protected Integer payDeduction_02_10;	// ^T02_10
	protected Integer payDeduction_03_10;	// ^T03_10
	protected Integer payDeduction_04_10;	// ^T04_10
	protected Integer payDeduction_05_10;	// ^T05_10
	protected Integer payDeduction_06_10;	// ^T06_10
	protected Integer payDeduction_07_10;	// ^T07_10
	protected Integer payDeduction_08_10;	// ^T08_10
	protected Integer payDeduction_09_10;	// ^T09_10
	protected Integer payDeduction_10_10;	// ^T10_10
	protected Integer payDeduction_11_10;	// ^T11_10
	protected Integer payDeduction_12_10;	// ^T12_10
	protected Integer payDeduction_13_10;	// ^T13_10
	protected Integer payDeduction_14_10;	// ^T14_10
	protected Integer payDeduction_15_10;	// ^T15_10
	protected Integer payDeduction_16_10;	// ^T16_10
	protected Integer payDeduction_17_10;	// ^T17_10
	protected Integer payDeduction_18_10;	// ^T18_10
	protected Integer payDeduction_19_10;	// ^T19_10
	protected Integer payDeduction_20_10;	// ^T20_10
	protected Integer payDeduction_21_10;	// ^T21_10
	protected Integer payDeduction_22_10;	// ^T22_10
	protected Integer payDeduction_23_10;	// ^T23_10
	protected Integer payDeduction_24_10;	// ^T24_10
	protected Integer payDeduction_25_10;	// ^T25_10
	protected Integer payDeduction_26_10;	// ^T26_10
	protected Integer payDeduction_27_10;	// ^T27_10
	protected Float attendance_01_10;	// ΑӍ01_10
	protected Float attendance_02_10;	// ΑӍ02_10
	protected Float attendance_03_10;	// ΑӍ03_10
	protected Float attendance_04_10;	// ΑӍ04_10
	protected Float attendance_05_10;	// ΑӍ05_10
	protected Integer attendance_06_10;	// ΑӍ06_10
	protected Integer attendance_07_10;	// ΑӍ07_10
	protected Float attendance_08_10;	// ΑӍ08_10
	protected Float attendance_09_10;	// ΑӍ09_10
	protected Float attendance_10_10;	// ΑӍ10_10
	protected Float attendance_11_10;	// ΑӍ11_10
	protected Float attendance_12_10;	// ΑӍ12_10
	protected Integer attendance_13_10;	// ΑӍ13_10
	protected Integer attendance_14_10;	// ΑӍ14_10

	protected Integer payAllowance_01_11;	// ^x01_11
	protected Integer payAllowance_02_11;	// ^x02_11
	protected Integer payAllowance_03_11;	// ^x03_11
	protected Integer payAllowance_04_11;	// ^x04_11
	protected Integer payAllowance_05_11;	// ^x05_11
	protected Integer payAllowance_06_11;	// ^x06_11
	protected Integer payAllowance_07_11;	// ^x07_11
	protected Integer payAllowance_08_11;	// ^x08_11
	protected Integer payAllowance_09_11;	// ^x09_11
	protected Integer payAllowance_10_11;	// ^x10_11
	protected Integer payAllowance_11_11;	// ^x11_11
	protected Integer payAllowance_12_11;	// ^x12_11
	protected Integer payAllowance_13_11;	// ^x13_11
	protected Integer payAllowance_14_11;	// ^x14_11
	protected Integer payAllowance_15_11;	// ^x15_11
	protected Integer payAllowance_16_11;	// ^x16_11
	protected Integer payAllowance_17_11;	// ^x17_11
	protected Integer payAllowance_18_11;	// ^x18_11
	protected Integer payAllowance_19_11;	// ^x19_11
	protected Integer payAllowance_20_11;	// ^x20_11
	protected Integer payAllowance_21_11;	// ^x21_11
	protected Integer payAllowance_22_11;	// ^x22_11
	protected Integer payAllowance_23_11;	// ^x23_11
	protected Integer payAllowance_24_11;	// ^x24_11
	protected Integer payAllowance_25_11;	// ^x25_11
	protected Integer payAllowance_26_11;	// ^x26_11
	protected Integer payAllowance_27_11;	// ^x27_11
	protected Integer payAllowance_28_11;	// ^x28_11
	protected Integer payAllowance_29_11;	// ^x29_11
	protected Integer payAllowance_30_11;	// ^x30_11
	protected Integer payDeduction_01_11;	// ^T01_11
	protected Integer payDeduction_02_11;	// ^T02_11
	protected Integer payDeduction_03_11;	// ^T03_11
	protected Integer payDeduction_04_11;	// ^T04_11
	protected Integer payDeduction_05_11;	// ^T05_11
	protected Integer payDeduction_06_11;	// ^T06_11
	protected Integer payDeduction_07_11;	// ^T07_11
	protected Integer payDeduction_08_11;	// ^T08_11
	protected Integer payDeduction_09_11;	// ^T09_11
	protected Integer payDeduction_10_11;	// ^T10_11
	protected Integer payDeduction_11_11;	// ^T11_11
	protected Integer payDeduction_12_11;	// ^T12_11
	protected Integer payDeduction_13_11;	// ^T13_11
	protected Integer payDeduction_14_11;	// ^T14_11
	protected Integer payDeduction_15_11;	// ^T15_11
	protected Integer payDeduction_16_11;	// ^T16_11
	protected Integer payDeduction_17_11;	// ^T17_11
	protected Integer payDeduction_18_11;	// ^T18_11
	protected Integer payDeduction_19_11;	// ^T19_11
	protected Integer payDeduction_20_11;	// ^T20_11
	protected Integer payDeduction_21_11;	// ^T21_11
	protected Integer payDeduction_22_11;	// ^T22_11
	protected Integer payDeduction_23_11;	// ^T23_11
	protected Integer payDeduction_24_11;	// ^T24_11
	protected Integer payDeduction_25_11;	// ^T25_11
	protected Integer payDeduction_26_11;	// ^T26_11
	protected Integer payDeduction_27_11;	// ^T27_11
	protected Float attendance_01_11;	// ΑӍ01_11
	protected Float attendance_02_11;	// ΑӍ02_11
	protected Float attendance_03_11;	// ΑӍ03_11
	protected Float attendance_04_11;	// ΑӍ04_11
	protected Float attendance_05_11;	// ΑӍ05_11
	protected Integer attendance_06_11;	// ΑӍ06_11
	protected Integer attendance_07_11;	// ΑӍ07_11
	protected Float attendance_08_11;	// ΑӍ08_11
	protected Float attendance_09_11;	// ΑӍ09_11
	protected Float attendance_10_11;	// ΑӍ10_11
	protected Float attendance_11_11;	// ΑӍ11_11
	protected Float attendance_12_11;	// ΑӍ12_11
	protected Integer attendance_13_11;	// ΑӍ13_11
	protected Integer attendance_14_11;	// ΑӍ14_11
	protected Integer bonAllowance_01_11;	// ܗ^x01_11
	protected Integer bonAllowance_02_11;	// ܗ^x02_11
	protected Integer bonAllowance_03_11;	// ܗ^x03_11
	protected Integer bonAllowance_04_11;	// ܗ^x04_11
	protected Integer bonAllowance_05_11;	// ܗ^x05_11
	protected Integer bonAllowance_06_11;	// ܗ^x06_11
	protected Integer bonAllowance_07_11;	// ܗ^x07_11
	protected Integer bonAllowance_08_11;	// ܗ^x08_11
	protected Integer bonAllowance_09_11;	// ܗ^x09_11
	protected Integer bonAllowance_10_11;	// ܗ^x10_11
	protected Integer bonDeduction_01_11;	// ܗ^T01_11
	protected Integer bonDeduction_02_11;	// ܗ^T02_11
	protected Integer bonDeduction_03_11;	// ܗ^T03_11
	protected Integer bonDeduction_04_11;	// ܗ^T04_11
	protected Integer bonDeduction_05_11;	// ܗ^T05_11
	protected Integer bonDeduction_06_11;	// ܗ^T06_11
	protected Integer bonDeduction_07_11;	// ܗ^T07_11
	protected Integer bonDeduction_08_11;	// ܗ^T08_11
	protected Integer bonDeduction_09_11;	// ܗ^T09_11
	protected Integer bonDeduction_10_11;	// ܗ^T10_11
	protected Integer bonDeduction_11_11;	// ܗ^T11_11
	protected Integer bonDeduction_12_11;	// ܗ^T12_11
	protected Integer bonDeduction_13_11;	// ܗ^T13_11
	protected Integer bonDeduction_14_11;	// ܗ^T14_11
	protected Integer bonDeduction_15_11;	// ܗ^T15_11
	protected Integer bonDeduction_16_11;	// ܗ^T16_11
	protected Integer bonDeduction_17_11;	// ܗ^T17_11

	protected Integer payAllowance_01_12;	// ^x01_12
	protected Integer payAllowance_02_12;	// ^x02_12
	protected Integer payAllowance_03_12;	// ^x03_12
	protected Integer payAllowance_04_12;	// ^x04_12
	protected Integer payAllowance_05_12;	// ^x05_12
	protected Integer payAllowance_06_12;	// ^x06_12
	protected Integer payAllowance_07_12;	// ^x07_12
	protected Integer payAllowance_08_12;	// ^x08_12
	protected Integer payAllowance_09_12;	// ^x09_12
	protected Integer payAllowance_10_12;	// ^x10_12
	protected Integer payAllowance_11_12;	// ^x11_12
	protected Integer payAllowance_12_12;	// ^x12_12
	protected Integer payAllowance_13_12;	// ^x13_12
	protected Integer payAllowance_14_12;	// ^x14_12
	protected Integer payAllowance_15_12;	// ^x15_12
	protected Integer payAllowance_16_12;	// ^x16_12
	protected Integer payAllowance_17_12;	// ^x17_12
	protected Integer payAllowance_18_12;	// ^x18_12
	protected Integer payAllowance_19_12;	// ^x19_12
	protected Integer payAllowance_20_12;	// ^x20_12
	protected Integer payAllowance_21_12;	// ^x21_12
	protected Integer payAllowance_22_12;	// ^x22_12
	protected Integer payAllowance_23_12;	// ^x23_12
	protected Integer payAllowance_24_12;	// ^x24_12
	protected Integer payAllowance_25_12;	// ^x25_12
	protected Integer payAllowance_26_12;	// ^x26_12
	protected Integer payAllowance_27_12;	// ^x27_12
	protected Integer payAllowance_28_12;	// ^x28_12
	protected Integer payAllowance_29_12;	// ^x29_12
	protected Integer payAllowance_30_12;	// ^x30_12
	protected Integer payDeduction_01_12;	// ^T01_12
	protected Integer payDeduction_02_12;	// ^T02_12
	protected Integer payDeduction_03_12;	// ^T03_12
	protected Integer payDeduction_04_12;	// ^T04_12
	protected Integer payDeduction_05_12;	// ^T05_12
	protected Integer payDeduction_06_12;	// ^T06_12
	protected Integer payDeduction_07_12;	// ^T07_12
	protected Integer payDeduction_08_12;	// ^T08_12
	protected Integer payDeduction_09_12;	// ^T09_12
	protected Integer payDeduction_10_12;	// ^T10_12
	protected Integer payDeduction_11_12;	// ^T11_12
	protected Integer payDeduction_12_12;	// ^T12_12
	protected Integer payDeduction_13_12;	// ^T13_12
	protected Integer payDeduction_14_12;	// ^T14_12
	protected Integer payDeduction_15_12;	// ^T15_12
	protected Integer payDeduction_16_12;	// ^T16_12
	protected Integer payDeduction_17_12;	// ^T17_12
	protected Integer payDeduction_18_12;	// ^T18_12
	protected Integer payDeduction_19_12;	// ^T19_12
	protected Integer payDeduction_20_12;	// ^T20_12
	protected Integer payDeduction_21_12;	// ^T21_12
	protected Integer payDeduction_22_12;	// ^T22_12
	protected Integer payDeduction_23_12;	// ^T23_12
	protected Integer payDeduction_24_12;	// ^T24_12
	protected Integer payDeduction_25_12;	// ^T25_12
	protected Integer payDeduction_26_12;	// ^T26_12
	protected Integer payDeduction_27_12;	// ^T27_12
	protected Float attendance_01_12;	// ΑӍ01_12
	protected Float attendance_02_12;	// ΑӍ02_12
	protected Float attendance_03_12;	// ΑӍ03_12
	protected Float attendance_04_12;	// ΑӍ04_12
	protected Float attendance_05_12;	// ΑӍ05_12
	protected Integer attendance_06_12;	// ΑӍ06_12
	protected Integer attendance_07_12;	// ΑӍ07_12
	protected Float attendance_08_12;	// ΑӍ08_12
	protected Float attendance_09_12;	// ΑӍ09_12
	protected Float attendance_10_12;	// ΑӍ10_12
	protected Float attendance_11_12;	// ΑӍ11_12
	protected Float attendance_12_12;	// ΑӍ12_12
	protected Integer attendance_13_12;	// ΑӍ13_12
	protected Integer attendance_14_12;	// ΑӍ14_12

	protected String incomeTaxType    ;	// ېŋ敪
	protected String adjustmentType   ;	// N敪
	protected String selfWidowType    ;	// {lǕw敪
	protected String selfHandicapType ;	// {lQ敪
	protected String selfStudentType  ;	// {lw敪
	protected String spouseIntendType ;	// zҋ敪
	protected String generalDependent ;	// ʕ}{e
	protected String specificDependent;	// }{e
	protected String elderlyDependent ;	// Vl}{e
	protected String liveWithEldRel   ;	// Ve
	protected String liveWithHandiGe  ;	// 
	protected String liveWithHandiSp  ;	// 
	protected String liveWithHandiEl  ;	// Vl
	protected String liveWithHandiEr  ;	// Ve
	protected String generalHandicap  ;	// ʏQ
	protected String specificHandicap ;	// ʏQ
	protected String stationCode      ;	// R[h
	protected String gender           ;	// 
	protected String postalCode       ;	// X֔ԍ
	protected String address          ;	// Z
	protected String positionCode     ;	// E
	protected String birthDate        ;	// N
	protected String kCode            ;	// ЈR[h
	protected String entranceDate     ;	// Г
	protected String kName            ;	// Ј
	protected String retirementDate   ;	// ގГ
	protected String phoneNumber      ;	// dbԍ
	protected String healthNo         ;	// Nیԍ
	protected String fundNo           ;	// Nԍ
	protected String pensionNo        ;	// Nԍ
	protected String unemployNo       ;	// ٗpیԍ
	
	/**
	 * RXgN^
	 */
	public PaymentLedgerDto(){
		super();
	}
	
	/**
	 * RXgN^
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	public PaymentLedgerDto(
			Map<String, DetailPaDto>		listDetail_Pa,
			Map<String, DetailPdDto>		listDetail_Pd,
			Map<String, DetailMoneyDto>	listDetail_Ps,
			Map<String, DetailTimeDto>		listDetail_Pt,
			Map<String, PmDetailBaDto> 		listDetail_Ba,
			Map<String, PmDetailBdDto>		listDetail_Bd,
			Map<String, PmDetailBsDto> 		listDetail_Bs,
			CmIncomeTaxDto					cmIncomeTaxDto,
			MKojinDto						mKojinDto,
			MKihonDto						mKihonDto,
			CmSocInsuranceDto				cmSocInsuranceDto,
			CmCompanyDto					cmCompanyDto,
			CdAdjustmentDto					cdAdjustmentDto,
			List<PhPaymentDto>				listPaymentData,
			List<PhBounsDto>				listBonusData,
			PdPayAllowanceDao				pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao				pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao						pdPaySumDao,		// ^׍v
			PdPayTimeDao					pdPayTimeDao,
			PdBonAllowanceDao				pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao				pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao						pBonSumDao			// ܗ^׍v
	) throws SQLException, NoSuchFieldException, IllegalAccessException{
		super();
		// vl
		initTotalItem();
		// ^Aܗ^ʖ̐ݒ
		setCommonItemName();
		// ^x̐ݒ
		setPayAllowanceName(listDetail_Pa);
		// ^T̐ݒ
		setPayDeductionName(listDetail_Pd);

		// ΑӍږ̐ݒ
		setAttendanceName();
		// ܗ^x̐ݒ

		setBonAllowanceName(listDetail_Ba);
		// ܗ^T̐ݒ
		setBonDeductionName(listDetail_Bd);

		// }{T\֌W̐ݒ
		setDependDeductionName();
		// l񖼏̐ݒ
		setIndividualName();

		// ^f[^ݒ(xATAΑӁAv)
		setPayAllowanceValue(listPaymentData, pdPayAllowanceDao,pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
		
		// ܗ^f[^ݒ(xATAv)
		setBonusDataValue(listBonusData, pdBonAllowanceDao, pdBonDeductionDao, pBonSumDao);

		// }{f[^ݒ
		setDependDeductionValue(cmIncomeTaxDto);
		// llݒ
		setIndividualValue(mKojinDto, mKihonDto, cmSocInsuranceDto);
		// ̑lݒ
		setOtherValue(cmCompanyDto, cdAdjustmentDto);
		
	}
	
	private void initTotalItem() {
		payTotalAllowance_01= null;	// ^x01(v)
		payTotalAllowance_02= null;	// ^x02(v)
		payTotalAllowance_03= null;	// ^x03(v)
		payTotalAllowance_04= null;	// ^x04(v)
		payTotalAllowance_05= null;	// ^x05(v)
		payTotalAllowance_06= null;	// ^x06(v)
		payTotalAllowance_07= null;	// ^x07(v)
		payTotalAllowance_08= null;	// ^x08(v)
		payTotalAllowance_09= null;	// ^x09(v)
		payTotalAllowance_10= null;	// ^x10(v)
		payTotalAllowance_11= null;	// ^x11(v)
		payTotalAllowance_12= null;	// ^x12(v)
		payTotalAllowance_13= null;	// ^x13(v)
		payTotalAllowance_14= null;	// ^x14(v)
		payTotalAllowance_15= null;	// ^x15(v)
		payTotalAllowance_16= null;	// ^x16(v)
		payTotalAllowance_17= null;	// ^x17(v)
		payTotalAllowance_18= null;	// ^x18(v)
		payTotalAllowance_19= null;	// ^x19(v)
		payTotalAllowance_20= null;	// ^x20(v)
		payTotalAllowance_21= null;	// ^x21(v)
		payTotalAllowance_22= null;	// ^x22(v)
		payTotalAllowance_23= null;	// ^x23(v)
		payTotalAllowance_24= null;	// ^x24(v)
		payTotalAllowance_25= null;	// ^x25(v)
		payTotalAllowance_26= null;	// ^x26(v)
		payTotalAllowance_27= null;	// ^x27(v)
		payTotalAllowance_28= null;	// ^x28(v)
		payTotalAllowance_29= null;	// ^x29(v)
		payTotalAllowance_30= null;	// ^x30(v)
		payTotalDeduction_01= null;	// ^T01(v)
		payTotalDeduction_02= null;	// ^T02(v)
		payTotalDeduction_03= null;	// ^T03(v)
		payTotalDeduction_04= null;	// ^T04(v)
		payTotalDeduction_05= null;	// ^T05(v)
		payTotalDeduction_06= null;	// ^T06(v)
		payTotalDeduction_07= null;	// ^T07(v)
		payTotalDeduction_08= null;	// ^T08(v)
		payTotalDeduction_09= null;	// ^T09(v)
		payTotalDeduction_10= null;	// ^T10(v)
		payTotalDeduction_11= null;	// ^T11(v)
		payTotalDeduction_12= null;	// ^T12(v)
		payTotalDeduction_13= null;	// ^T13(v)
		payTotalDeduction_14= null;	// ^T14(v)
		payTotalDeduction_15= null;	// ^T15(v)
		payTotalDeduction_16= null;	// ^T16(v)
		payTotalDeduction_17= null;	// ^T17(v)
		payTotalDeduction_18= null;	// ^T18(v)
		payTotalDeduction_19= null;	// ^T19(v)
		payTotalDeduction_20= null;	// ^T20(v)
		payTotalDeduction_21= null;	// ^T21(v)
		payTotalDeduction_22= null;	// ^T22(v)
		payTotalDeduction_23= null;	// ^T23(v)
		payTotalDeduction_24= null;	// ^T24(v)
		payTotalDeduction_25= null;	// ^T25(v)
		payTotalDeduction_26= null;	// ^T26(v)
		payTotalDeduction_27= null;	// ^T27(v)
		totalAttendance_01= null;	// ΑӍ01(v)
		totalAttendance_02= null;	// ΑӍ02(v)
		totalAttendance_03= null;	// ΑӍ03(v)
		totalAttendance_04= null;	// ΑӍ04(v)
		totalAttendance_05= null;	// ΑӍ05(v)
		totalAttendance_06= null;	// ΑӍ06(v)
		totalAttendance_07= null;	// ΑӍ07(v)
		totalAttendance_08= null;	// ΑӍ08(v)
		totalAttendance_09= null;	// ΑӍ09(v)
		totalAttendance_10= null;	// ΑӍ10(v)
		totalAttendance_11= null;	// ΑӍ11(v)
		totalAttendance_12= null;	// ΑӍ12(v)
		totalAttendance_13= null;	// ΑӍ13(v)
		totalAttendance_14= null;	// ΑӍ14(v)
		bonTotalAllowance_01= null;	// ܗ^x01(v)
		bonTotalAllowance_02= null;	// ܗ^x02(v)
		bonTotalAllowance_03= null;	// ܗ^x03(v)
		bonTotalAllowance_04= null;	// ܗ^x04(v)
		bonTotalAllowance_05= null;	// ܗ^x05(v)
		bonTotalAllowance_06= null;	// ܗ^x06(v)
		bonTotalAllowance_07= null;	// ܗ^x07(v)
		bonTotalAllowance_08= null;	// ܗ^x08(v)
		bonTotalAllowance_09= null;	// ܗ^x09(v)
		bonTotalAllowance_10= null;	// ܗ^x10(v)
		bonTotalDeduction_01= null;	// ܗ^T01(v)
		bonTotalDeduction_02= null;	// ܗ^T02(v)
		bonTotalDeduction_03= null;	// ܗ^T03(v)
		bonTotalDeduction_04= null;	// ܗ^T04(v)
		bonTotalDeduction_05= null;	// ܗ^T05(v)
		bonTotalDeduction_06= null;	// ܗ^T06(v)
		bonTotalDeduction_07= null;	// ܗ^T07(v)
		bonTotalDeduction_08= null;	// ܗ^T08(v)
		bonTotalDeduction_09= null;	// ܗ^T09(v)
		bonTotalDeduction_10= null;	// ܗ^T10(v)
		bonTotalDeduction_11= null;	// ܗ^T11(v)
		bonTotalDeduction_12= null;	// ܗ^T12(v)
		bonTotalDeduction_13= null;	// ܗ^T13(v)
		bonTotalDeduction_14= null;	// ܗ^T14(v)
		bonTotalDeduction_15= null;	// ܗ^T15(v)
		bonTotalDeduction_16= null;	// ܗ^T16(v)
		bonTotalDeduction_17= null;	// ܗ^T17(v)

	}
	
	/**
	 * ^Aܗ^ʖ̐ݒ
	 */
	private void setCommonItemName() {
		titlePayday         = "<" + PayrollConst.NAM_PAY_DAY  + ">" ;	// x
		titleAllowanceItem  = "" + PayrollConst.NAM_ALLOWANCE_ITEM  + ""  ;	// x
		titleAllowanceTotal = PayrollConst.ADJ_APPLICABLE +PayrollConst.ADJ_APPLICABLE
							+ PayrollConst.NAM_ALLOWANCE_TOTAL
							+ PayrollConst.ADJ_APPLICABLE + PayrollConst.ADJ_APPLICABLE 	;	// xz
		titleDeductionItem  = PayrollConst.NAM_DEDUCTION_ITEM  ;	// T
		titleDeductionTotal = PayrollConst.ADJ_APPLICABLE +PayrollConst.ADJ_APPLICABLE
							+ PayrollConst.NAM_DEDUCTION_TOTAL 	// Tz
							+ PayrollConst.ADJ_APPLICABLE +PayrollConst.ADJ_APPLICABLE;
		titlePaymentTotal   = PayrollConst.ADJ_APPLICABLE +PayrollConst.ADJ_APPLICABLE 
							+ PayrollConst.NAM_PAYMENT_TOTAL
							+ PayrollConst.ADJ_APPLICABLE +PayrollConst.ADJ_APPLICABLE;	// xz
		titleBank1PayAmount = PayrollConst.ADJ_APPLICABLE + PayrollConst.NAM_BANK1_PAY_AMOUNT + PayrollConst.ADJ_APPLICABLE;	// s1Uz
		titleBank2PayAmount = PayrollConst.ADJ_APPLICABLE + PayrollConst.NAM_BANK2_PAY_AMOUNT +PayrollConst.ADJ_APPLICABLE;	// s2Uz
		titleCashPayAmount  =  PayrollConst.ADJ_APPLICABLE + PayrollConst.NAM_CASH_PAY_AMOUNT + PayrollConst.ADJ_APPLICABLE;	// xz
	}
	
	/**
	 * ^x̐ݒ
	 * @param listDetail_Pa
	 */
	private void setPayAllowanceName( Map<String, DetailPaDto> listDetail_Pa ) {
		titlePayAllowance_01  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_01 ));
		titlePayAllowance_02  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_02 ));
		titlePayAllowance_03  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_03 ));
		titlePayAllowance_04  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_04 ));
		titlePayAllowance_05  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_05 ));
		titlePayAllowance_06  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_06 ));
		titlePayAllowance_07  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_07 ));
		titlePayAllowance_08  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_08 ));
		titlePayAllowance_09  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_09 ));
		titlePayAllowance_10  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_10 ));
		titlePayAllowance_11  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_11 ));
		titlePayAllowance_12  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_12 ));
		titlePayAllowance_13  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_13 ));
		titlePayAllowance_14  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_14 ));
		titlePayAllowance_15  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_15 ));
		titlePayAllowance_16  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_16 ));
		titlePayAllowance_17  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_17 ));
		titlePayAllowance_18  = getDetailName_Pa(getDetail_pa(listDetail_Pa, PayrollConst.DTL_PAY_ALLOWANCE_18 ));
		titlePayAllowance_19  = PayrollConst.NAM_ALLOWANCE_03;
		titlePayAllowance_20  = PayrollConst.NAM_ALLOWANCE_04;
		titlePayAllowance_21  = PayrollConst.NAM_ALLOWANCE_05;
		titlePayAllowance_22  = PayrollConst.NAM_ALLOWANCE_06;
		titlePayAllowance_23  = PayrollConst.NAM_ALLOWANCE_07;
		titlePayAllowance_24  = PayrollConst.NAM_ALLOWANCE_08;
		titlePayAllowance_25  = PayrollConst.NAM_ALLOWANCE_09;
		titlePayAllowance_26  = PayrollConst.NAM_ALLOWANCE_10;
		titlePayAllowance_27  = PayrollConst.NAM_ALLOWANCE_11;
		titlePayAllowance_28  = PayrollConst.NAM_ALLOWANCE_12;
		titlePayAllowance_29  = PayrollConst.NAM_ALLOWANCE_13;
		titlePayAllowance_30  = PayrollConst.NAM_ALLOWANCE_14;
		
	}
	
	
	/**
	 * ^T̐ݒ
	 * @param listDetail_Pd
	 */
	private void setPayDeductionName( Map<String, DetailPdDto> listDetail_Pd ) {
		titlePayDeduction_01  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_01 ));
		titlePayDeduction_02  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_07 ));
		titlePayDeduction_03  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_02 ));
		titlePayDeduction_04  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_03 ));
		
		titlePayDeduction_05  = PayrollConst.NAM_DEDUCTION_14;
		titlePayDeduction_06  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_04));
		titlePayDeduction_07  = PayrollConst.NAM_DEDUCTION_15;
		titlePayDeduction_08  = PayrollConst.NAM_DEDUCTION_16;
		titlePayDeduction_09  = PayrollConst.NAM_DEDUCTION_17;
		titlePayDeduction_10  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_05 ));
		titlePayDeduction_11  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_06 ));
		titlePayDeduction_12  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_08 ));
		titlePayDeduction_13  = "";
		titlePayDeduction_14  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_09 ));
		titlePayDeduction_15  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_10 ));
		titlePayDeduction_16  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_11 ));
		titlePayDeduction_17  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_12 ));
		titlePayDeduction_18  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_13 ));
		titlePayDeduction_19  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_14 ));
		titlePayDeduction_20  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_15 ));
		titlePayDeduction_21  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_16 ));
		titlePayDeduction_22  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_17 ));
		titlePayDeduction_23  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_18 ));
		titlePayDeduction_24  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_19 ));
		titlePayDeduction_25  = getDetailName_Pd(getDetail_Pd(listDetail_Pd, PayrollConst.DTL_PAY_DEDUCTION_20 ));
		titlePayDeduction_26  = PayrollConst.NAM_DEDUCTION_18;
		titlePayDeduction_27  = PayrollConst.NAM_DEDUCTION_19;
	}
	
	private void setAttendanceName() {
		titleAttendance_01 = PayrollConst.NAM_PRESENCE + PayrollConst.NAM_COMMON_DAY;
		titleAttendance_02 = PayrollConst.NAM_WORK_ON_HOLIDAY + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_03 = PayrollConst.NAM_PARTICULAR_HOLIDAY + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_04 = PayrollConst.NAM_ABB_PAID_HOLIDAY;
		titleAttendance_05 = PayrollConst.NAM_OUT_ABSENCE;
		titleAttendance_06 = PayrollConst.NAM_PAID_HOLIDAY_REST;
		titleAttendance_07 = PayrollConst.NAM_PRESENCE + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_08 = PayrollConst.NAM_OUT_LATE_EARLY + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_09 = PayrollConst.NAM_OVERTIME + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_10 = PayrollConst.NAM_LATE_NIGHT + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_11 = PayrollConst.NAM_OUT_HOLIDAY + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_12 = PayrollConst.NAM_OUT_WORK  + PayrollConst.NAM_COMMON_DAY + PayrollConst.NAM_COMMON_TIME;
		titleAttendance_13 = PayrollConst.NAM_COMMON_ALLO;
		titleAttendance_14 = PayrollConst.NAM_OUT_CHANG_WORK  + PayrollConst.NAM_COMMON_DAY + PayrollConst.NAM_COMMON_TIME;
		
	}

	
	/**
	 * ܗ^x̐ݒ
	 * @param listDetail_Ba
	 */
	private void setBonAllowanceName(Map<String, PmDetailBaDto> listDetail_Ba) {
		titleBonAllowance_01  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_01 ));
		titleBonAllowance_02  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_02 ));
		titleBonAllowance_03  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_03 ));
		titleBonAllowance_04  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_04 ));
		titleBonAllowance_05  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_05 ));
		titleBonAllowance_06  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_06 ));
		titleBonAllowance_07  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_07 ));
		titleBonAllowance_08  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_08 ));
		titleBonAllowance_09  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_09 ));
		titleBonAllowance_10  = getDetailName_Ba(getDetail_Ba(listDetail_Ba, PayrollConst.DTL_BON_ALLOWANCE_10 ));
		
	}
	
	
	/**
	 * ܗ^T̐ݒ
	 * @param listDetail_Bd
	 */
	private void setBonDeductionName( Map<String, PmDetailBdDto> listDetail_Bd ) {
		titleBonDeduction_01  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_01 ));
		titleBonDeduction_02  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_05 ));
		titleBonDeduction_03  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_02 ));

		titleBonDeduction_04  = PayrollConst.NAM_INSURANCE_FUND;
		titleBonDeduction_05  = PayrollConst.NAM_OUT_UNEMPLOY_BASIS;
		
		titleBonDeduction_06  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_03));
		
		titleBonDeduction_07  = PayrollConst.NAM_OUT_TOTAL_SOC_INS;
		titleBonDeduction_08  = PayrollConst.NAM_OUT_TOTAL_TAX_FREE;
		titleBonDeduction_09  = PayrollConst.NAM_OUT_TAXATION;
		
		titleBonDeduction_10  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_04 ));
		titleBonDeduction_11  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_06 ));
		titleBonDeduction_12  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_07 ));
		titleBonDeduction_13  = "";
		titleBonDeduction_14  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_08 ));
		titleBonDeduction_15  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_09 ));
		titleBonDeduction_16  = getDetailName_Bd(getDetail_Bd(listDetail_Bd, PayrollConst.DTL_BON_DEDUCTION_10 ));
		titleBonDeduction_17  = PayrollConst.NAM_OUT_INCOME_RATE;
	}
	
	/**
	 * }{T\֌W̐ݒ
	 * @param mapDetail
	 */
	private void setDependDeductionName() {
		titleIncomeTaxType     = PayrollConst.NAM_INCOME_TAX_TYPE    ;	// ېŋ敪
		titleAdjustmentType    = PayrollConst.NAM_ADJUSTMENT_TYPE    ;	// N敪
		titleSelfWidowType     = PayrollConst.NAM_SELF_WIDOW_TYPE    ;	// {lǕw敪
		titleSelfHandicapType  = PayrollConst.NAM_SELF_HANDICAP_TYPE ;	// {lQ敪
		titleSelfStudentType   = PayrollConst.NAM_SELF_STUDENT_TYPE  ;	// {lw敪
		titleSpouseIntendType  = PayrollConst.NAM_SPOUSE_INTEND_TYPE ;	// zҋ敪
		titleGeneralDependent  = PayrollConst.NAM_GENERAL_DEPENDENT  ;	// ʕ}{e
		titleSpecificDependent = PayrollConst.NAM_SPECIFIC_DEPENDENT ;	// }{e
		titleElderlyDependent  = PayrollConst.NAM_ELDERLY_DEPENDENT  ;	// Vl}{e
		titleLiveWithEldRel    = PayrollConst.NAM_LIVE_WITH_ELD_REL  ;	// Ve
		titleLiveWithHandiGe   = PayrollConst.NAM_LIVE_WITH_HANDI_GE ;	// 
		titleLiveWithHandiSp   = PayrollConst.NAM_LIVE_WITH_HANDI_SP ;	// 
		titleLiveWithHandiEl   = PayrollConst.NAM_LIVE_WITH_HANDI_EL ;	// Vl
		titleLiveWithHandiEr   = PayrollConst.NAM_LIVE_WITH_HANDI_ER ;	// Ve
		titleGeneralHandicap   = PayrollConst.NAM_GENERAL_HANDICAP   ;	// ʏQ
		titleSpecificHandicap  = PayrollConst.NAM_SPECIFIC_HANDICAP  ;	// ʏQ
	}
	
	/**
	 * ^f[^ݒ
	 * @param listPaymentData
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private void setPayAllowanceValue(
			List<PhPaymentDto> listPaymentData,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,
			PdPayTimeDao pdPayTimeDao
	) throws SQLException, NoSuchFieldException, IllegalAccessException {
		for (int i = 0; i < PayrollConst.CNT_ADJ_PAYMENT_MONTH; i++) {
			for (int j = 0; j < listPaymentData.size(); j++) {
				// DTOɐݒ
				PhPaymentDto phPaymentDto =	listPaymentData.get(j);
				if (i + 1 == MospUtility.getMonth(phPaymentDto.getPayDate())) {
					// e̋^f[^ݒ
					setPaymentData(i, true, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
					break;
				}
				if (j == listPaymentData.size() -1 ) {
					// e̋^f[^ɋݒ
					setPaymentData(i, false, null, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				}
			}
		}
		if (listPaymentData.size() != 0) {
			// xzvݒ
			calcTotalPayAllownceTotal();
			// Tzvݒ
			calcPayTotalDeductionTotal();
			// xzvݒ
			calcPayTotalPaymentTotal();
			// s1Uzvݒ
			calcPayTotalBank1PayAmount();
			// s2Uzvݒ
			calcPayTotalBank2PayAmount();
			// xzvݒ
			calcPayTotalCashPayAmount();
		}
	}
	
	/**
	 * ܗ^f[^ݒ
	 * @param listBonusData
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private void setBonusDataValue (
			List<PhBounsDto> listBonusData,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao pdBonSumDao
	) throws SQLException, NoSuchFieldException, IllegalAccessException {
		for (int i = 0; i < PayrollConst.CNT_OUT_BONUS_MONTH; i++) {
			if (i < listBonusData.size()) {
				// DTOjݒ
				PhBounsDto udBonusDto =	listBonusData.get(i);
				// ȅܗ^f[^ݒ
				setBonusData(i, true, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
			} else {
				// ȅܗ^f[^ɋݒ
				setBonusData(i, false, null, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
			}
		}
		if (listBonusData.size() != 0 ) {
			// xzvݒ
			calcBonTotalAllowanceTotal();
			// Tzvݒ
			calcBonTotalDeductionTotal();
			// xzvݒ
			calcBonTotalPaymentTotal();
			// s1Uzvݒ
			calcTotalBonBank1PayAmount();
			// s2Uzvݒ
			calcBonTotalBank2PayAmount();
			// xzvݒ
			calcBonTotalCashPayAmount();
		}
	}
	
	/**
	 * e^f[^U
	 * @param idx
	 * @param isSetData
	 * @param phPaymentDto
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private void setPaymentData(
			int idx, boolean isSetData,PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
		) throws SQLException, NoSuchFieldException, IllegalAccessException {
		switch (idx) {
			case 0:	
				setPaymentData01(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 1:	
				setPaymentData02(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 2:	
				setPaymentData03(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 3:	
				setPaymentData04(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 4:	
				setPaymentData05(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 5:	
				setPaymentData06(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 6:	
				setPaymentData07(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 7:	
				setPaymentData08(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 8:	
				setPaymentData09(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 9:	
				setPaymentData10(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 10:	
				setPaymentData11(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
				break;
			case 11:	
				setPaymentData12(isSetData, phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao, pdPaySumDao, pdPayTimeDao);
		}
	}
	
	/**
	 * eܗ^f[^U
	 * @param idx
	 * @param isSetData
	 * @param udBonusDto
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private void setBonusData(
			int idx, boolean isSetData,PhBounsDto udBonusDto ,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao pdBonSumDao
		) throws SQLException, NoSuchFieldException, IllegalAccessException {
		switch (idx) {
			case 0:	
				setBonusData01(isSetData, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
				break;
			case 1:	
				setBonusData02(isSetData, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
				break;
			case 2:	
				setBonusData03(isSetData, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
				break;
			case 3:	
				setBonusData04(isSetData, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
				break;
			case 4:	
				setBonusData05(isSetData, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
				break;
			case 5:	
				setBonusData06(isSetData, udBonusDto, pdBonAllowanceDao, pdBonDeductionDao, pdBonSumDao);
				break;
		}
	}
	                         
	/**							
	 * ܗ^f[^ݒ01							
	 * @param isSetData							
	 * @param udBonusDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setBonusData01(
			boolean isSetData, PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao         pdBonSumDao
	) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// ܗ^x					
			setBonPayday01(udBonusDto);					
			// ܗ^x					
			setBonAllowanceData01(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^exڍv					
			setBonTotalAllowance(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^T					
			setBonDeduction01(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// Teڍv					
			setBonTotalDeduction(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// z					
			setTotalBonus01(udBonusDto, pdBonSumDao);					
		} else {						
			// ܗ^󍀖ڐݒ					
			setBonusSpace01();					
		}						
	}							
	/**							
	 * ܗ^f[^ݒ02							
	 * @param isSetData							
	 * @param udBonusDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setBonusData02(
			boolean isSetData, PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao         pdBonSumDao
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// ܗ^x					
			setBonPayday02(udBonusDto);					
			// ܗ^x					
			setBonAllowanceData02(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^exڍv					
			setBonTotalAllowance(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^T					
			setBonDeduction02(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// Teڍv					
			setBonTotalDeduction(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// z					
			setTotalBonus02(udBonusDto, pdBonSumDao);					
		} else {						
			// ܗ^󍀖ڐݒ					
			setBonusSpace02();					
		}						
	}							
	/**							
	 * ܗ^f[^ݒ03							
	 * @param isSetData							
	 * @param udBonusDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setBonusData03(
			boolean isSetData, PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao          pdBonSumDao
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// ܗ^x					
			setBonPayday03(udBonusDto);				
			// ܗ^x					
			setBonAllowanceData03(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^exڍv					
			setBonTotalAllowance(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^T					
			setBonDeduction03(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// Teڍv					
			setBonTotalDeduction(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// z					
			setTotalBonus03(udBonusDto, pdBonSumDao);					
		} else {						
			// ܗ^󍀖ڐݒ					
			setBonusSpace03();					
		}						
	}							
	/**							
	 * ܗ^f[^ݒ04							
	 * @param isSetData							
	 * @param udBonusDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setBonusData04(
			boolean isSetData, PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao          pdBonSumDao
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// ܗ^x					
			setBonPayday04(udBonusDto);					
			// ܗ^x					
			setBonAllowanceData04(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^exڍv					
			setBonTotalAllowance(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^T					
			setBonDeduction04(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// Teڍv					
			setBonTotalDeduction(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// z					
			setTotalBonus04(udBonusDto, pdBonSumDao);					
		} else {						
			// ܗ^󍀖ڐݒ					
			setBonusSpace04();					
		}						
	}							
	/**							
	 * ܗ^f[^ݒ05							
	 * @param isSetData							
	 * @param udBonusDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setBonusData05(
			boolean isSetData, PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao          pdBonSumDao
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// ܗ^x					
			setBonPayday05(udBonusDto);					
			// ܗ^x					
			setBonAllowanceData05(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^exڍv					
			setBonTotalAllowance(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^T					
			setBonDeduction05(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// Teڍv					
			setBonTotalDeduction(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// z					
			setTotalBonus05(udBonusDto, pdBonSumDao);					
		} else {						
			// ܗ^󍀖ڐݒ					
			setBonusSpace05();					
		}						
	}							
	/**							
	 * ܗ^f[^ݒ06							
	 * @param isSetData							
	 * @param udBonusDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setBonusData06(
			boolean isSetData, PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao,	// ܗ^x׃f[^
			PdBonSumDao          pdBonSumDao
	) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// ܗ^x					
			setBonPayday06(udBonusDto);					
			// ܗ^x					
			setBonAllowanceData06(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^exڍv					
			setBonTotalAllowance(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// ܗ^T					
			setBonDeduction06(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);					
			// Teڍv					
			setBonTotalDeduction(udBonusDto, pdBonAllowanceDao, pdBonDeductionDao);
			// z					
			setTotalBonus06(udBonusDto,pdBonSumDao);					
		} else {						
			// ܗ^󍀖ڐݒ					
			setBonusSpace06();					
		}						
	}							
	
	/**							
	 * ^f[^ݒ01							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData01(
			boolean isSetData, PhPaymentDto phPaymentDto, 
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday01(phPaymentDto);					
			// ^x					
			setPayAllowanceData01(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction01(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment01(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance01(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace01();					
		}						
	}							
	/**							
	 * ^f[^ݒ02							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData02(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday02(phPaymentDto);					
			// ^x					
			setPayAllowanceData02(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction02(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment02(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance02(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace02();					
		}						
	}							
	/**							
	 * ^f[^ݒ03							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData03(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday03(phPaymentDto);					
			// ^x					
			setPayAllowanceData03(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction03(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment03(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance03(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace03();					
		}						
	}							
	/**							
	 * ^f[^ݒ04							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData04(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday04(phPaymentDto);					
			// ^x					
			setPayAllowanceData04(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction04(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment04(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance04(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace04();					
		}						
	}							
	/**							
	 * ^f[^ݒ05							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData05(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
		) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday05(phPaymentDto);					
			// ^x					
			setPayAllowanceData05(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction05(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment05(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance05(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace05();					
		}						
	}							
	/**							
	 * ^f[^ݒ06							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData06(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday06(phPaymentDto);					
			// ^x					
			setPayAllowanceData06(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction06(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment06(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance06(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace06();					
		}						
	}							
	/**							
	 * ^f[^ݒ07							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData07(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday07(phPaymentDto);					
			// ^x					
			setPayAllowanceData07(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction07(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment07(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance07(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace07();					
		}						
	}							
	/**							
	 * ^f[^ݒ08							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData08(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday08(phPaymentDto);					
			// ^x					
			setPayAllowanceData08(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction08(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment08(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance08(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace08();					
		}						
	}							
	/**							
	 * ^f[^ݒ09							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData09(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday09(phPaymentDto);					
			// ^x					
			setPayAllowanceData09(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction09(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment09(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance09(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace09();					
		}						
	}							
	/**							
	 * ^f[^ݒ10							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData10(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday10(phPaymentDto);					
			// ^x					
			setPayAllowanceData10(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction10(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment10(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance10(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace10();					
		}						
	}							
	/**							
	 * ^f[^ݒ11							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData11(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,				// ^xvf[^
			PdPayTimeDao pdPayTimeDao				// ^ΑӃf[^@
			) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday11(phPaymentDto);					
			// ^x					
			setPayAllowanceData11(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction11(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment11(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance11(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace11();					
		}						
	}							
	/**							
	 * ^f[^ݒ12							
	 * @param isSetData							
	 * @param phPaymentDto							
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */							
	private void setPaymentData12(
			boolean isSetData, PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao,	// ^x׃f[^
			PdPaySumDao pdPaySumDao,
			PdPayTimeDao pdPayTimeDao
	) throws SQLException, NoSuchFieldException, IllegalAccessException {							
		if (isSetData) {						
			// xݒ					
			setPayPayday12(phPaymentDto);					
			// ^x					
			setPayAllowanceData12(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^exڍv					
			setPayTotalAllowance(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// ^T					
			setPayDeduction12(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// Teڍv					
			setTotalDeduction(phPaymentDto, pdPayAllowanceDao, pdPayDeductionDao);					
			// z					
			setTotalPayment12(phPaymentDto, pdPaySumDao);					
			// Α					
			setAttendance12(phPaymentDto, pdPayTimeDao);					
			// Αӊeڍv					
			setTotalAttendance(phPaymentDto, pdPayTimeDao);					
		} else {						
			// ^󍀖ڐݒ					
			setPaymentSpace12();					
		}						
	}							
	
	private void	setPayPayday01(PhPaymentDto phPaymentDto) {			
		payPayday_01 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday02(PhPaymentDto phPaymentDto) {			
		payPayday_02 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday03(PhPaymentDto phPaymentDto) {			
		payPayday_03 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday04(PhPaymentDto phPaymentDto) {			
		payPayday_04 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday05(PhPaymentDto phPaymentDto) {			
		payPayday_05 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday06(PhPaymentDto phPaymentDto) {			
		payPayday_06 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday07(PhPaymentDto phPaymentDto) {			
		payPayday_07 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday08(PhPaymentDto phPaymentDto) {			
		payPayday_08 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday09(PhPaymentDto phPaymentDto) {			
		payPayday_09 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday10(PhPaymentDto phPaymentDto) {			
		payPayday_10 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday11(PhPaymentDto phPaymentDto) {			
		payPayday_11 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setPayPayday12(PhPaymentDto phPaymentDto) {			
		payPayday_12 = MospUtility.getMonth(phPaymentDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(phPaymentDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				

	
	private void	setBonPayday01(PhBounsDto udBonusDto) {			
		bonPayday_01 = MospUtility.getMonth(udBonusDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(udBonusDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setBonPayday02(PhBounsDto udBonusDto) {			
		bonPayday_02 = MospUtility.getMonth(udBonusDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(udBonusDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setBonPayday03(PhBounsDto udBonusDto) {			
		bonPayday_03 = MospUtility.getMonth(udBonusDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(udBonusDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setBonPayday04(PhBounsDto udBonusDto) {			
		bonPayday_04 = MospUtility.getMonth(udBonusDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(udBonusDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setBonPayday05(PhBounsDto udBonusDto) {			
		bonPayday_05 = MospUtility.getMonth(udBonusDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(udBonusDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	private void	setBonPayday06(PhBounsDto udBonusDto) {			
		bonPayday_06 = MospUtility.getMonth(udBonusDto.getPayDate())			
					+ PayrollConst.NAM_MONTH + MospUtility.getDay(udBonusDto.getPayDate()) + PayrollConst.NAM_DAY;
					
	}				
	
	

	private void setPayAllowanceData01(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
	) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_01 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData02(
				PhPaymentDto phPaymentDto,
				PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
				PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_02 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData03(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_03 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData04(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_04 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData05(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_01_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_05 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData06(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_06 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData07(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_07 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData08(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_08 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData09(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_09 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData10(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_10 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData11(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_11 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setPayAllowanceData12(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowance_01_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01);	// {
		payAllowance_02_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02);	// E\1
		payAllowance_03_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03);	// E\2
		payAllowance_04_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04);	// c[x蓖
		payAllowance_05_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05);	// 蓖1
		payAllowance_06_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06);	// 蓖2
		payAllowance_07_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07);	// FΎ蓖
		payAllowance_08_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08);	// H蓖
		payAllowance_09_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09);	// 1蓖
		payAllowance_10_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10);	// 2蓖
		payAllowance_11_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11);	// 3蓖
		payAllowance_12_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12);	// Ζ蓖1
		payAllowance_13_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13);	// Ζ蓖2
		payAllowance_14_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14);	// Ζ蓖3
		payAllowance_15_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15);	// Ζ蓖4
		payAllowance_16_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16);	// Ζ蓖5
		payAllowance_17_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17);	// \蓖
		payAllowance_18_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18);	// ʋΎ蓖
		payAllowance_19_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖3
		payAllowance_20_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖4
		payAllowance_21_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖5
		payAllowance_22_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖6
		payAllowance_23_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖7
		payAllowance_24_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖8
		payAllowance_25_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖9
		payAllowance_26_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖10
		payAllowance_27_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖11
		payAllowance_28_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖12
		payAllowance_29_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖13
		payAllowance_30_12 = setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, "");	// 蓖14
	}

	private void setBonAllowanceData01(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowance_01_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01);	// {ܗ^
		bonAllowance_02_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02);	// ʏܗ^@
		bonAllowance_03_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03);	// ʏܗ^A
		bonAllowance_04_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04);	// 蓖@
		bonAllowance_05_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05);	// 蓖A
		bonAllowance_06_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06);	// 蓖B
		bonAllowance_07_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07);	// \蓖7
		bonAllowance_08_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08);	// \蓖8
		bonAllowance_09_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09);	// \蓖9
		bonAllowance_10_01 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10);	// \蓖10
	}

	private void setBonAllowanceData02(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowance_01_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01);	// {ܗ^
		bonAllowance_02_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02);	// ʏܗ^@
		bonAllowance_03_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03);	// ʏܗ^A
		bonAllowance_04_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04);	// 蓖@
		bonAllowance_05_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05);	// 蓖A
		bonAllowance_06_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06);	// 蓖B
		bonAllowance_07_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07);	// \蓖7
		bonAllowance_08_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08);	// \蓖8
		bonAllowance_09_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09);	// \蓖9
		bonAllowance_10_02 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10);	// \蓖10
	}

	private void setBonAllowanceData03(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowance_01_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01);	// {ܗ^
		bonAllowance_02_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02);	// ʏܗ^@
		bonAllowance_03_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03);	// ʏܗ^A
		bonAllowance_04_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04);	// 蓖@
		bonAllowance_05_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05);	// 蓖A
		bonAllowance_06_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06);	// 蓖B
		bonAllowance_07_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07);	// \蓖7
		bonAllowance_08_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08);	// \蓖8
		bonAllowance_09_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09);	// \蓖9
		bonAllowance_10_03 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10);	// \蓖10
	}

	private void setBonAllowanceData04(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowance_01_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01);	// {ܗ^
		bonAllowance_02_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02);	// ʏܗ^@
		bonAllowance_03_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03);	// ʏܗ^A
		bonAllowance_04_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04);	// 蓖@
		bonAllowance_05_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05);	// 蓖A
		bonAllowance_06_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06);	// 蓖B
		bonAllowance_07_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07);	// \蓖7
		bonAllowance_08_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08);	// \蓖8
		bonAllowance_09_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09);	// \蓖9
		bonAllowance_10_04 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10);	// \蓖10
	}
	
	private void setBonAllowanceData05(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowance_01_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01);	// {ܗ^
		bonAllowance_02_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02);	// ʏܗ^@
		bonAllowance_03_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03);	// ʏܗ^A
		bonAllowance_04_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04);	// 蓖@
		bonAllowance_05_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05);	// 蓖A
		bonAllowance_06_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06);	// 蓖B
		bonAllowance_07_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07);	// \蓖7
		bonAllowance_08_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08);	// \蓖8
		bonAllowance_09_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09);	// \蓖9
		bonAllowance_10_05 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10);	// \蓖10
	}
	private void setBonAllowanceData06(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowance_01_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01);	// {ܗ^
		bonAllowance_02_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02);	// ʏܗ^@
		bonAllowance_03_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03);	// ʏܗ^A
		bonAllowance_04_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04);	// 蓖@
		bonAllowance_05_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05);	// 蓖A
		bonAllowance_06_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06);	// 蓖B
		bonAllowance_07_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07);	// \蓖7
		bonAllowance_08_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08);	// \蓖8
		bonAllowance_09_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09);	// \蓖9
		bonAllowance_10_06 = setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10);	// \蓖10
	}
	

	
	
	private void setPayTotalAllowance(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payTotalAllowance_01 = setChangeValue(setChangeValue(payTotalAllowance_01) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_01));	// {
		payTotalAllowance_02 = setChangeValue(setChangeValue(payTotalAllowance_02) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_02));	// E\1
		payTotalAllowance_03 = setChangeValue(setChangeValue(payTotalAllowance_03) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_03));	// E\2
		payTotalAllowance_04 = setChangeValue(setChangeValue(payTotalAllowance_04) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_04));	// c[x蓖
		payTotalAllowance_05 = setChangeValue(setChangeValue(payTotalAllowance_05) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_05));	// 蓖1
		payTotalAllowance_06 = setChangeValue(setChangeValue(payTotalAllowance_06) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_06));	// 蓖2
		payTotalAllowance_07 = setChangeValue(setChangeValue(payTotalAllowance_07) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_07));	// FΎ蓖
		payTotalAllowance_08 = setChangeValue(setChangeValue(payTotalAllowance_08) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_08));	// H蓖
		payTotalAllowance_09 = setChangeValue(setChangeValue(payTotalAllowance_09) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_09));	// 1蓖
		payTotalAllowance_10 = setChangeValue(setChangeValue(payTotalAllowance_10) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_10));	// 2蓖
		payTotalAllowance_11 = setChangeValue(setChangeValue(payTotalAllowance_11) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_11));	// 3蓖
		payTotalAllowance_12 = setChangeValue(setChangeValue(payTotalAllowance_12) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_12));	// Ζ蓖1
		payTotalAllowance_13 = setChangeValue(setChangeValue(payTotalAllowance_13) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_13));	// Ζ蓖2
		payTotalAllowance_14 = setChangeValue(setChangeValue(payTotalAllowance_14) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_14));	// Ζ蓖3
		payTotalAllowance_15 = setChangeValue(setChangeValue(payTotalAllowance_15) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_15));	// Ζ蓖4
		payTotalAllowance_16 = setChangeValue(setChangeValue(payTotalAllowance_16) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_16));	// Ζ蓖5
		payTotalAllowance_17 = setChangeValue(setChangeValue(payTotalAllowance_17) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_17));	// \蓖
		payTotalAllowance_18 = setChangeValue(setChangeValue(payTotalAllowance_18) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_18));	// ʋΎ蓖
		payTotalAllowance_19 = setChangeValue(setChangeValue(payTotalAllowance_18) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_19));	// 蓖3
		payTotalAllowance_20 = setChangeValue(setChangeValue(payTotalAllowance_20) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_20));	// 蓖4
		payTotalAllowance_21 = setChangeValue(setChangeValue(payTotalAllowance_21) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_21));	// \蓖21
		payTotalAllowance_22 = setChangeValue(setChangeValue(payTotalAllowance_22) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_22));	// \蓖22
		payTotalAllowance_23 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_23));	// \蓖23
		payTotalAllowance_24 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_24));	// \蓖24
		payTotalAllowance_25 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_25));	// \蓖25
		payTotalAllowance_26 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_26));	// \蓖26
		payTotalAllowance_27 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_27));	// \蓖27
		payTotalAllowance_28 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_28));	// \蓖28
		payTotalAllowance_29 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_29));	// \蓖29
		payTotalAllowance_30 = setChangeValue(setChangeValue(payTotalAllowance_23) + setChangeValue_Pa( pdPayAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_PAY_ALLOWANCE_30));	// \蓖30

	}
	
	private void setBonTotalAllowance(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonTotalAllowance_01 = setChangeValue(setChangeValue(bonTotalAllowance_01) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_01));	// {ܗ^
		bonTotalAllowance_02 = setChangeValue(setChangeValue(bonTotalAllowance_02) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_02));	// ʏܗ^@
		bonTotalAllowance_03 = setChangeValue(setChangeValue(bonTotalAllowance_03) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_03));	// ʏܗ^A
		bonTotalAllowance_04 = setChangeValue(setChangeValue(bonTotalAllowance_04) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_04));	// 蓖@
		bonTotalAllowance_05 = setChangeValue(setChangeValue(bonTotalAllowance_05) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_05));	// 蓖A
		bonTotalAllowance_06 = setChangeValue(setChangeValue(bonTotalAllowance_06) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_06));	// 蓖B
		bonTotalAllowance_07 = setChangeValue(setChangeValue(bonTotalAllowance_07) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_07));	// \蓖7
		bonTotalAllowance_08 = setChangeValue(setChangeValue(bonTotalAllowance_08) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_08));	// \蓖8
		bonTotalAllowance_09 = setChangeValue(setChangeValue(bonTotalAllowance_09) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_09));	// \蓖9
		bonTotalAllowance_10 = setChangeValue(setChangeValue(bonTotalAllowance_10) + setChangeValue_Ba( pdBonAllowanceDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_10));	// \蓖10
		
	}
	
	private void setPayDeduction01(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();
		
		payDeduction_01_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_01 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz
		
		
	}
	



	private void setPayDeduction02(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_02 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction03(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_03 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}

	private void setPayDeduction04(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_04 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}

	private void setPayDeduction05(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_05 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction06(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_06 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction07(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_07 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction08(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_08 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction09(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_09 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction10(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_10 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction11(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_11 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}


	private void setPayDeduction12(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payDeduction_01_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01);	// Nی
		payDeduction_02_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07);	// Z
		payDeduction_03_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02);	// ی
		payDeduction_04_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03);	// NN
		payDeduction_05_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ٕۑΏۊ
		payDeduction_06_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04);	// N{
		payDeduction_07_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Еۍvz
		payDeduction_08_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_09_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// ېőΏۊz
		payDeduction_10_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05);	// ٗpی
		payDeduction_11_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06);	// 
		payDeduction_12_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08);	// T1
		payDeduction_13_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	//
		payDeduction_14_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09);	// T2
		payDeduction_15_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10);	// T3
		payDeduction_16_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11);	// T4
		payDeduction_17_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12);	// T5
		payDeduction_18_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13);	// T6
		payDeduction_19_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14);	// T7
		payDeduction_20_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15);	// T8
		payDeduction_21_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16);	// T9
		payDeduction_22_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17);	// T10
		payDeduction_23_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18);	// T11
		payDeduction_24_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19);	// T12
		payDeduction_25_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20);	// T13
		payDeduction_26_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// OJzz
		payDeduction_27_12 = setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, "");	// Jzz

	}
	
	private void setBonDeduction01(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();
		
		bonDeduction_01_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01);	// Nی
		bonDeduction_02_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05);	// ٗpی
		bonDeduction_03_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02);	// ی
		bonDeduction_04_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_05_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_06_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03);	// N
		bonDeduction_07_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_08_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_09_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_10_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04);	// N
		bonDeduction_11_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06);	// 
		bonDeduction_12_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07);	// T1
		bonDeduction_13_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_14_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08);	// T2
		bonDeduction_15_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09);	// T3
		bonDeduction_16_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10);	// T4
		bonDeduction_17_01 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17);	// 
	}

	private void setBonDeduction02(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonDeduction_01_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01);	// Nی
		bonDeduction_02_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05);	// ٗpی
		bonDeduction_03_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02);	// ی
		bonDeduction_04_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_05_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_06_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03);	// N
		bonDeduction_07_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_08_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_09_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_10_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04);	// N
		bonDeduction_11_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06);	// 
		bonDeduction_12_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07);	// T1
		bonDeduction_13_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_14_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08);	// T2
		bonDeduction_15_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09);	// T3
		bonDeduction_16_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10);	// T4
		bonDeduction_17_02 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17);	// 
	}

	private void setBonDeduction03(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonDeduction_01_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01);	// Nی
		bonDeduction_02_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05);	// ٗpی
		bonDeduction_03_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02);	// ی
		bonDeduction_04_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_05_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_06_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03);	// N
		bonDeduction_07_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_08_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_09_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_10_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04);	// N
		bonDeduction_11_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06);	// 
		bonDeduction_12_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07);	// T1
		bonDeduction_13_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_14_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08);	// T2
		bonDeduction_15_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09);	// T3
		bonDeduction_16_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10);	// T4
		bonDeduction_17_03 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17);	// 
	}

	private void setBonDeduction04(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonDeduction_01_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01);	// Nی
		bonDeduction_02_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05);	// ٗpی
		bonDeduction_03_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02);	// ی
		bonDeduction_04_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_05_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_06_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03);	// N
		bonDeduction_07_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_08_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_09_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_10_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04);	// N
		bonDeduction_11_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06);	// 
		bonDeduction_12_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07);	// T1
		bonDeduction_13_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_14_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08);	// T2
		bonDeduction_15_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09);	// T3
		bonDeduction_16_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10);	// T4
		bonDeduction_17_04 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17);	// 
	}
	
	private void setBonDeduction05(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonDeduction_01_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01);	// Nی
		bonDeduction_02_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05);	// ٗpی
		bonDeduction_03_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02);	// ی
		bonDeduction_04_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_05_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_06_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03);	// N
		bonDeduction_07_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_08_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_09_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_10_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04);	// N
		bonDeduction_11_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06);	// 
		bonDeduction_12_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07);	// T1
		bonDeduction_13_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_14_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08);	// T2
		bonDeduction_15_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09);	// T3
		bonDeduction_16_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10);	// T4
		bonDeduction_17_05 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17);	// 
	}
	
	private void setBonDeduction06(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonDeduction_01_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01);	// Nی
		bonDeduction_02_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05);	// ٗpی
		bonDeduction_03_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02);	// ی
		bonDeduction_04_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_05_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_06_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03);	// N
		bonDeduction_07_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_08_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_09_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_10_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04);	// N
		bonDeduction_11_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06);	// 
		bonDeduction_12_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07);	// T1
		bonDeduction_13_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, "");	// 
		bonDeduction_14_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08);	// T2
		bonDeduction_15_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09);	// T3
		bonDeduction_16_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10);	// T4
		bonDeduction_17_06 = setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17);	// 
	}

	
	private void setTotalDeduction(
			PhPaymentDto phPaymentDto,
			PdPayAllowanceDao	pdPayAllowanceDao,	// ^T׃f[^
			PdPayDeductionDao	pdPayDeductionDao	// ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payTotalDeduction_01 = setChangeValue(setChangeValue(payTotalDeduction_01) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_01));	// Nی
		payTotalDeduction_02 = setChangeValue(setChangeValue(payTotalDeduction_02) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_07));	// Z
		payTotalDeduction_03 = setChangeValue(setChangeValue(payTotalDeduction_03) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_02));	// ی
		payTotalDeduction_04 = setChangeValue(setChangeValue(payTotalDeduction_04) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_03));	// NN
		payTotalDeduction_05 = setChangeValue(setChangeValue(payTotalDeduction_05) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	// ٕۑΏۊ
		payTotalDeduction_06 = setChangeValue(setChangeValue(payTotalDeduction_06) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_04));	// N{
		payTotalDeduction_07 = setChangeValue(setChangeValue(payTotalDeduction_07) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	// Еۍvz
		payTotalDeduction_08 = setChangeValue(setChangeValue(payTotalDeduction_08) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	// ېőΏۊz
		payTotalDeduction_09 = setChangeValue(setChangeValue(payTotalDeduction_09) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	// ېőΏۊz
		payTotalDeduction_10 = setChangeValue(setChangeValue(payTotalDeduction_10) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_05));	// ٗpی
		payTotalDeduction_11 = setChangeValue(setChangeValue(payTotalDeduction_11) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_06));	// 
		payTotalDeduction_12 = setChangeValue(setChangeValue(payTotalDeduction_12) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_08));	// T1
		payTotalDeduction_13 = setChangeValue(setChangeValue(payTotalDeduction_13) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	//
		payTotalDeduction_14 = setChangeValue(setChangeValue(payTotalDeduction_14) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_09));	// T2
		payTotalDeduction_15 = setChangeValue(setChangeValue(payTotalDeduction_15) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_10));	// T3
		payTotalDeduction_16 = setChangeValue(setChangeValue(payTotalDeduction_16) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_11));	// T4
		payTotalDeduction_17 = setChangeValue(setChangeValue(payTotalDeduction_17) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_12));	// T5
		payTotalDeduction_18 = setChangeValue(setChangeValue(payTotalDeduction_18) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_13));	// T6
		payTotalDeduction_19 = setChangeValue(setChangeValue(payTotalDeduction_19) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_14));	// T7
		payTotalDeduction_20 = setChangeValue(setChangeValue(payTotalDeduction_20) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_15));	// T8
		payTotalDeduction_21 = setChangeValue(setChangeValue(payTotalDeduction_21) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_16));	// T9
		payTotalDeduction_22 = setChangeValue(setChangeValue(payTotalDeduction_22) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_17));	// T10
		payTotalDeduction_23 = setChangeValue(setChangeValue(payTotalDeduction_23) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_18));	// T11
		payTotalDeduction_24 = setChangeValue(setChangeValue(payTotalDeduction_24) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_19));	// T12
		payTotalDeduction_25 = setChangeValue(setChangeValue(payTotalDeduction_25) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, PayrollConst.DTL_PAY_DEDUCTION_20));	// T13
		payTotalDeduction_26 = setChangeValue(setChangeValue(payTotalDeduction_26) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	// OJzz
		payTotalDeduction_27 = setChangeValue(setChangeValue(payTotalDeduction_27) + setChangeValue_Pd( pdPayDeductionDao, GetKcode, calcDate, ""));	// Jzz		
	}
	
	private void setBonTotalDeduction(
			PhBounsDto udBonusDto,
			PdBonAllowanceDao	pdBonAllowanceDao,	// ܗ^T׃f[^
			PdBonDeductionDao	pdBonDeductionDao	// ܗ^x׃f[^
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonTotalDeduction_01 = setChangeValue(setChangeValue(bonTotalDeduction_01) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_01));	// Nی
		bonTotalDeduction_02 = setChangeValue(setChangeValue(bonTotalDeduction_02) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_05));	// ٗpی
		bonTotalDeduction_03 = setChangeValue(setChangeValue(bonTotalDeduction_03) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_02));	// ی
		bonTotalDeduction_04 = setChangeValue(setChangeValue(bonTotalDeduction_04) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, ""));	// 
		bonTotalDeduction_05 = setChangeValue(setChangeValue(bonTotalDeduction_05) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, ""));	// 
		bonTotalDeduction_06 = setChangeValue(setChangeValue(bonTotalDeduction_06) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_03));	// N
		bonTotalDeduction_07 = setChangeValue(setChangeValue(bonTotalDeduction_07) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, ""));	// 
		bonTotalDeduction_08 = setChangeValue(setChangeValue(bonTotalDeduction_08) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, ""));	// 
		bonTotalDeduction_09 = setChangeValue(setChangeValue(bonTotalDeduction_09) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, ""));	// 
		bonTotalDeduction_10 = setChangeValue(setChangeValue(bonTotalDeduction_10) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_04));	// N
		bonTotalDeduction_11 = setChangeValue(setChangeValue(bonTotalDeduction_11) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_06));	// 
		bonTotalDeduction_12 = setChangeValue(setChangeValue(bonTotalDeduction_12) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_07));	// T1
		bonTotalDeduction_13 = setChangeValue(setChangeValue(bonTotalDeduction_13) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, ""));	// 
		bonTotalDeduction_14 = setChangeValue(setChangeValue(bonTotalDeduction_14) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_08));	// T2
		bonTotalDeduction_15 = setChangeValue(setChangeValue(bonTotalDeduction_15) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_09));	// T3
		bonTotalDeduction_16 = setChangeValue(setChangeValue(bonTotalDeduction_16) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_DEDUCTION_10));	// T4
		bonTotalDeduction_17 = setChangeValue(setChangeValue(bonTotalDeduction_17) + setChangeValue_Bd( pdBonDeductionDao, GetKcode, calcDate, PayrollConst.DTL_BON_ALLOWANCE_17));	// 
	}
	
	private void setTotalPayment01(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
	) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_01 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_01 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_01   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_01 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_01 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_01  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment02(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_02 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_02 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_02   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_02 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_02 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_02  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment03(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_03 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_03 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_03   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_03 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_03 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_03  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment04(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_04 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_04 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_04   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_04 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_04 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_04  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment05(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_05 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_05 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_05   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_05 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_05 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_05  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment06(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_06 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_06 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_06   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_06 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_06 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_06  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment07(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_07 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_07 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_07   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_07 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_07 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_07  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment08(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_08 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_08 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_08   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_08 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_08 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_08  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment09(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_09 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_09 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_09   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_09 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_09 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_09  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment10(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_10 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_10 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_10   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_10 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_10 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_10  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment11(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_11 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_11 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_11   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_11 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_11 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_11  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}

	private void setTotalPayment12(
			PhPaymentDto phPaymentDto,
			PdPaySumDao pdPaySumDao			// ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		payAllowanceTotal_12 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_01);// xz
		payDeductionTotal_12 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_02);// Tz
		payPaymentTotal_12   = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_03);// xz
		payBank1PayAmount_12 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_11);// s1Uz
		payBank2PayAmount_12 = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_12);// s2Uz
		payCashPayAmount_12  = setChangeValue_Ps( pdPaySumDao, GetKcode, calcDate, PayrollConst.DTL_PAY_SUM_13);// xz
	}
	

	
	private void setTotalBonus01(
			PhBounsDto udBonusDto,
			PdBonSumDao pdBonSumDao			// ܗ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowanceTotal_01 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_01);// xz
		bonDeductionTotal_01 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_02);// Tz
		bonPaymentTotal_01   = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_03);// xz
		bonBank1PayAmount_01 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_11);// s1Uz
		bonBank2PayAmount_01 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_12);// s2Uz
		bonCashPayAmount_01  = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_13);// xz
	}

	private void setTotalBonus02(
			PhBounsDto udBonusDto,
			PdBonSumDao pdBonSumDao			// ܗ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowanceTotal_02 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_01);// xz
		bonDeductionTotal_02 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_02);// Tz
		bonPaymentTotal_02   = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_03);// xz
		bonBank1PayAmount_02 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_11);// s1Uz
		bonBank2PayAmount_02 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_12);// s2Uz
		bonCashPayAmount_02  = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_13);// xz
	}

	private void setTotalBonus03(
			PhBounsDto udBonusDto,
			PdBonSumDao pdBonSumDao			// ܗ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowanceTotal_03 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_01);// xz
		bonDeductionTotal_03 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_02);// Tz
		bonPaymentTotal_03   = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_03);// xz
		bonBank1PayAmount_03 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_11);// s1Uz
		bonBank2PayAmount_03 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_12);// s2Uz
		bonCashPayAmount_03  = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_13);// xz
	}

	private void setTotalBonus04(
			PhBounsDto udBonusDto,
			PdBonSumDao pdBonSumDao			// ܗ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowanceTotal_04 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_01);// xz
		bonDeductionTotal_04 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_02);// Tz
		bonPaymentTotal_04   = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_03);// xz
		bonBank1PayAmount_04 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_11);// s1Uz
		bonBank2PayAmount_04 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_12);// s2Uz
		bonCashPayAmount_04  = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_13);// xz
	}
	
	private void setTotalBonus05(
			PhBounsDto udBonusDto,
			PdBonSumDao pdBonSumDao			// ܗ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowanceTotal_05 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_01);// xz
		bonDeductionTotal_05 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_02);// Tz
		bonPaymentTotal_05   = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_03);// xz
		bonBank1PayAmount_05 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_11);// s1Uz
		bonBank2PayAmount_05 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_12);// s2Uz
		bonCashPayAmount_05  = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_13);// xz
	}
	
	private void setTotalBonus06(
			PhBounsDto udBonusDto,
			PdBonSumDao pdBonSumDao			// ܗ^׍v
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = udBonusDto.getKCode();
		Date calcDate   = udBonusDto.getPayDate();

		bonAllowanceTotal_06 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_01);// xz
		bonDeductionTotal_06 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_02);// Tz
		bonPaymentTotal_06   = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_03);// xz
		bonBank1PayAmount_06 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_11);// s1Uz
		bonBank2PayAmount_06 = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_12);// s2Uz
		bonCashPayAmount_06  = setChangeValue_Bs( pdBonSumDao, GetKcode, calcDate, PayrollConst.DTL_BON_SUM_13);// xz
	}

	private void calcTotalPayAllownceTotal() {
		payTotalAllowanceTotal =
			setChangeValue(
			setChangeValue(payAllowanceTotal_01)
			+ setChangeValue(payAllowanceTotal_02)
			+ setChangeValue(payAllowanceTotal_03)
			+ setChangeValue(payAllowanceTotal_04)
			+ setChangeValue(payAllowanceTotal_05)
			+ setChangeValue(payAllowanceTotal_06)
			+ setChangeValue(payAllowanceTotal_07)
			+ setChangeValue(payAllowanceTotal_08)
			+ setChangeValue(payAllowanceTotal_09)
			+ setChangeValue(payAllowanceTotal_10)
			+ setChangeValue(payAllowanceTotal_11)
			+ setChangeValue(payAllowanceTotal_12)
		);
	}

	private void calcPayTotalDeductionTotal() {
		payTotalDeductionTotal =
			setChangeValue(
			  setChangeValue(payDeductionTotal_01)
			+ setChangeValue(payDeductionTotal_02)
			+ setChangeValue(payDeductionTotal_03)
			+ setChangeValue(payDeductionTotal_04)
			+ setChangeValue(payDeductionTotal_05)
			+ setChangeValue(payDeductionTotal_06)
			+ setChangeValue(payDeductionTotal_07)
			+ setChangeValue(payDeductionTotal_08)
			+ setChangeValue(payDeductionTotal_09)
			+ setChangeValue(payDeductionTotal_10)
			+ setChangeValue(payDeductionTotal_11)
			+ setChangeValue(payDeductionTotal_12)
		);
	}
	private void calcPayTotalPaymentTotal() {
		payTotalPaymentTotal =
			setChangeValue(
			  setChangeValue(payPaymentTotal_01)
			+ setChangeValue(payPaymentTotal_02)
			+ setChangeValue(payPaymentTotal_03)
			+ setChangeValue(payPaymentTotal_04)
			+ setChangeValue(payPaymentTotal_05)
			+ setChangeValue(payPaymentTotal_06)
			+ setChangeValue(payPaymentTotal_07)
			+ setChangeValue(payPaymentTotal_08)
			+ setChangeValue(payPaymentTotal_09)
			+ setChangeValue(payPaymentTotal_10)
			+ setChangeValue(payPaymentTotal_11)
			+ setChangeValue(payPaymentTotal_12)
		);
	}
	private void calcPayTotalBank1PayAmount() {
		payTotalBank1PayAmount =
			setChangeValue(
			  setChangeValue(payBank1PayAmount_01)
			+ setChangeValue(payBank1PayAmount_02)
			+ setChangeValue(payBank1PayAmount_03)
			+ setChangeValue(payBank1PayAmount_04)
			+ setChangeValue(payBank1PayAmount_05)
			+ setChangeValue(payBank1PayAmount_06)
			+ setChangeValue(payBank1PayAmount_07)
			+ setChangeValue(payBank1PayAmount_08)
			+ setChangeValue(payBank1PayAmount_09)
			+ setChangeValue(payBank1PayAmount_10)
			+ setChangeValue(payBank1PayAmount_11)
			+ setChangeValue(payBank1PayAmount_12)
		);
	}

	private void calcPayTotalBank2PayAmount() {
		payTotalBank2PayAmount =
			setChangeValue(
			  setChangeValue(payBank2PayAmount_01)
			+ setChangeValue(payBank2PayAmount_02)
			+ setChangeValue(payBank2PayAmount_03)
			+ setChangeValue(payBank2PayAmount_04)
			+ setChangeValue(payBank2PayAmount_05)
			+ setChangeValue(payBank2PayAmount_06)
			+ setChangeValue(payBank2PayAmount_07)
			+ setChangeValue(payBank2PayAmount_08)
			+ setChangeValue(payBank2PayAmount_09)
			+ setChangeValue(payBank2PayAmount_10)
			+ setChangeValue(payBank2PayAmount_11)
			+ setChangeValue(payBank2PayAmount_12)
		);
	}

	private void calcPayTotalCashPayAmount() {
		payTotalCashPayAmount =
			setChangeValue(
			  setChangeValue(payCashPayAmount_01)
			+ setChangeValue(payCashPayAmount_02)
			+ setChangeValue(payCashPayAmount_03)
			+ setChangeValue(payCashPayAmount_04)
			+ setChangeValue(payCashPayAmount_05)
			+ setChangeValue(payCashPayAmount_06)
			+ setChangeValue(payCashPayAmount_07)
			+ setChangeValue(payCashPayAmount_08)
			+ setChangeValue(payCashPayAmount_09)
			+ setChangeValue(payCashPayAmount_10)
			+ setChangeValue(payCashPayAmount_11)
			+ setChangeValue(payCashPayAmount_12)
		);                   
	}

	private void calcBonTotalAllowanceTotal() {
		bonTotalAllowanceTotal =
			setChangeValue(
			setChangeValue(bonAllowanceTotal_01)
			+ setChangeValue(bonAllowanceTotal_02)
			+ setChangeValue(bonAllowanceTotal_03)
			+ setChangeValue(bonAllowanceTotal_04)
			+ setChangeValue(bonAllowanceTotal_05)
			+ setChangeValue(bonAllowanceTotal_06)
		);
	}

	private void calcBonTotalDeductionTotal() {
		bonTotalDeductionTotal =
			setChangeValue(
			  setChangeValue(bonDeductionTotal_01)
			+ setChangeValue(bonDeductionTotal_02)
			+ setChangeValue(bonDeductionTotal_03)
			+ setChangeValue(bonDeductionTotal_04)
			+ setChangeValue(bonDeductionTotal_05)
			+ setChangeValue(bonDeductionTotal_06)
		);
	}

	private void calcBonTotalPaymentTotal() {
		bonTotalPaymentTotal =
			setChangeValue(
			  setChangeValue(bonPaymentTotal_01)
			+ setChangeValue(bonPaymentTotal_02)
			+ setChangeValue(bonPaymentTotal_03)
			+ setChangeValue(bonPaymentTotal_04)
			+ setChangeValue(bonPaymentTotal_05)
			+ setChangeValue(bonPaymentTotal_06)
		);
	}
	private void calcTotalBonBank1PayAmount() {
		bonTotalBank1PayAmount =
			setChangeValue(
			  setChangeValue(bonBank1PayAmount_01)
			+ setChangeValue(bonBank1PayAmount_02)
			+ setChangeValue(bonBank1PayAmount_03)
			+ setChangeValue(bonBank1PayAmount_04)
			+ setChangeValue(bonBank1PayAmount_05)
			+ setChangeValue(bonBank1PayAmount_06)
		);
	}

	private void calcBonTotalBank2PayAmount() {
		bonTotalBank2PayAmount =
			setChangeValue(
			  setChangeValue(bonBank2PayAmount_01)
			+ setChangeValue(bonBank2PayAmount_02)
			+ setChangeValue(bonBank2PayAmount_03)
			+ setChangeValue(bonBank2PayAmount_04)
			+ setChangeValue(bonBank2PayAmount_05)
			+ setChangeValue(bonBank2PayAmount_06)
		);
	}

	private void calcBonTotalCashPayAmount() {
		bonTotalCashPayAmount =
			setChangeValue(
			  setChangeValue(bonCashPayAmount_01)
			+ setChangeValue(bonCashPayAmount_02)
			+ setChangeValue(bonCashPayAmount_03)
			+ setChangeValue(bonCashPayAmount_04)
			+ setChangeValue(bonCashPayAmount_05)
			+ setChangeValue(bonCashPayAmount_06)
		);                   
	}
	
	private void setAttendance01(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode  = phPaymentDto.getKCode();
		Date calcDate    = phPaymentDto.getCalcMonth();

		attendance_01_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_01 = new Integer(0);	// Lc
		attendance_07_01 = new Integer(0);	// oΎ
		attendance_08_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_01 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance02(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_02 = new Integer(0);	// Lc
		attendance_07_02 = new Integer(0);	// oΎ
		attendance_08_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_02 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance03(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_03 = new Integer(0);	// Lc
		attendance_07_03 = new Integer(0);	// oΎ
		attendance_08_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_03 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance04(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_04 = new Integer(0);	// Lc
		attendance_07_04 = new Integer(0);	// oΎ
		attendance_08_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_04 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance05(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_05 = new Integer(0);	// Lc
		attendance_07_05 = new Integer(0);	// oΎ
		attendance_08_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_05 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance06(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_06 = new Integer(0);	// Lc
		attendance_07_06 = new Integer(0);	// oΎ
		attendance_08_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_06 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance07(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_07 = new Integer(0);	// Lc
		attendance_07_07 = new Integer(0);	// oΎ
		attendance_08_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_07 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance08(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_08 = new Integer(0);	// Lc
		attendance_07_08 = new Integer(0);	// oΎ
		attendance_08_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_08 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance09(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_09 = new Integer(0);	// Lc
		attendance_07_09 = new Integer(0);	// oΎ
		attendance_08_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_09 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance10(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_10 = new Integer(0);	// Lc
		attendance_07_10 = new Integer(0);	// oΎ
		attendance_08_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_10 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance11(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_11 = new Integer(0);	// Lc
		attendance_07_11 = new Integer(0);	// oΎ
		attendance_08_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_11 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	private void setAttendance12(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		attendance_01_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01);	// oΓ
		attendance_02_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06);	// x
		attendance_03_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10);	// ʋxɎ
		attendance_04_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09);	// L
		attendance_05_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12);	// 
		attendance_06_12 = new Integer(0);	// Lc
		attendance_07_12 = new Integer(0);	// oΎ
		attendance_08_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07);	// x
		attendance_09_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04);	// cƎ
		attendance_10_12 = setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05);	// [鎞

	}

	
	private void setTotalAttendance(
			PhPaymentDto phPaymentDto,
			PdPayTimeDao pdPayTimeDao	// ^׋Αӕ
			) throws SQLException, NoSuchFieldException, IllegalAccessException {
		String GetKcode = phPaymentDto.getKCode();
		Date calcDate   = phPaymentDto.getCalcMonth();

		totalAttendance_01 = setChangeValue(setChangeValue(totalAttendance_01) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_01));	// oΓ
		totalAttendance_02 = setChangeValue(setChangeValue(totalAttendance_02) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_06));	// xoΓ
		totalAttendance_03 = setChangeValue(setChangeValue(totalAttendance_03) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_10));	// ʋxɓ
		totalAttendance_04 = setChangeValue(setChangeValue(totalAttendance_04) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_09));	// Lxɓ
		totalAttendance_05 = setChangeValue(setChangeValue(totalAttendance_05) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_12));	// Γ
		totalAttendance_06 = new Integer(0);	// Lc
		totalAttendance_07 = new Integer(0);	// 
		totalAttendance_08 = setChangeValue(setChangeValue(totalAttendance_08) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_07));	// x
		totalAttendance_09 = setChangeValue(setChangeValue(totalAttendance_09) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_04));	// ʁAcƎ
		totalAttendance_10 = setChangeValue(setChangeValue(totalAttendance_10) + setChangeValue_Pt( pdPayTimeDao, GetKcode, calcDate, PayrollConst.DTL_PAY_TIME_05));	// [鎞

	}
	
	/**
	 * ^ΑӍڃt[glݒ
	 * @param Dao ^ΑӍږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate vZN
	 * @param Item_value oΏۂ̋^ΑӍږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Float setChangeValue_Pt (PdPayTimeDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		DetailTimeDto Dto = Dao.find_detailCode(GetKcode, calcDate, Item_value);
		 float get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// z̎擾
		 }

		 if (get_amount == 0) {
			return new Float(0);
		}
		return new Float(get_amount);
	}
	

	
	/**
	 * t[glݒ
	 * @param value
	 * @return
	 */
	private Float setChangeValue (float value) {
		if (value == 0) {
			return new Float(0);
		}
		
		return new Float(value);
	}
	
	/**
	 * t[glݒ
	 * @param value
	 * @return
	 */
	private float setChangeValue (Float value) {
		if (value == null) {
			return 0;
		}
		
		return value.floatValue();
	}
	
	
	/**
	 * ^xڃt[glݒ
	 * @param Dao ^xږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate vZN
	 * @param Item_value oΏۂ̋^xږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Integer setChangeValue_Pa (PdPayAllowanceDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		 DetailMoneyDto Dto = Dao.find_detailCode(GetKcode, calcDate, Item_value);
		 int get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// {
		 }

		 if (get_amount == 0) {
			return new Integer(0);
		}
		
		return new Integer(get_amount);
	}

	/**
	 * ܗ^xڃt[glݒ
	 * @param Dao ܗ^xږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate xN
	 * @param Item_value oΏۂ̏ܗ^xږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Integer setChangeValue_Ba (PdBonAllowanceDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		PmDetailBsDto Dto = Dao.find_detailCode(GetKcode, calcDate, Item_value);
		 int get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// z̎擾
		 }

		 if (get_amount == 0) {
			return new Integer(0);
		}
		
		return new Integer(get_amount);
	}

	/**
	 * ^Tڃt[glݒ
	 * @param Dao ^TږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate vZN
	 * @param Item_value oΏۂ̋^Tږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Integer setChangeValue_Pd (PdPayDeductionDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		DetailMoneyDto Dto = Dao.findForDetail(GetKcode, calcDate, Item_value);
		 int get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// z̎擾
		 }

		 if (get_amount == 0) {
			return new Integer(0);
		}
		
		return new Integer(get_amount);
	}
	

	/**
	 * ܗ^Tڃt[glݒ
	 * @param Dao ܗ^TږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate vZN
	 * @param Item_value oΏۂ̏ܗ^Tږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Integer setChangeValue_Bd (PdBonDeductionDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		PmDetailBsDto Dto = Dao.find_detailCode(GetKcode, calcDate, Item_value);
		 int get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// z̎擾
		 }

		 if (get_amount == 0) {
			return new Integer(0);
		}
		
		return new Integer(get_amount);
	}
	
	/**
	 * ^vڃt[glݒ
	 * @param Dao ^vږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate vZN
	 * @param Item_value oΏۂ̋^vږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Integer setChangeValue_Ps (PdPaySumDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		DetailMoneyDto Dto = Dao.find_detailCode(GetKcode, calcDate, Item_value);
		 int get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// z̎擾
		 }

		 if (get_amount == 0) {
			return new Integer(0);
		}
		
		return new Integer(get_amount);
	}

	/**
	 * ܗ^vڃt[glݒ
	 * @param Dao ܗ^vږDAO
	 * @param GetKcode ЈR[h
	 * @param calcDate vZN
	 * @param Item_value oΏۂ̏ܗ^vږ
	 * @return
	 * @throws IllegalAccessException 
	 * @throws NoSuchFieldException 
	 * @throws SQLException 
	 */
	private Integer setChangeValue_Bs (PdBonSumDao Dao, String GetKcode, Date calcDate, String Item_value) throws SQLException, NoSuchFieldException, IllegalAccessException {
		PmDetailBsDto Dto = Dao.find_detailCode(GetKcode, calcDate, Item_value);
		 int get_amount = 0;
		 if(null != Dto){
			 get_amount = Dto.getAmount();	// z̎擾
		 }

		 if (get_amount == 0) {
			return new Integer(0);
		}
		
		return new Integer(get_amount);
	}
	
	
	/**
	 * t[glݒ
	 * @param value
	 * @return
	 */
	private Integer setChangeValue (int value) {
		if (value == 0) {
			return new Integer(0);
		}
		
		return new Integer(value);
	}
	
	/**
	 * t[glݒ
	 * @param value
	 * @return
	 */
	private int setChangeValue (Integer value) {
		if (value == null) {
			return 0;
		}
		
		return value.intValue();
	}


	
	
	private void setPaymentSpace01() {
		payAllowance_01_01 =null;
		payAllowance_02_01 =null;
		payAllowance_03_01 =null;
		payAllowance_04_01 =null;
		payAllowance_05_01 =null;
		payAllowance_06_01 =null;
		payAllowance_07_01 =null;
		payAllowance_08_01 =null;
		payAllowance_09_01 =null;
		payAllowance_10_01 =null;
		payAllowance_11_01 =null;
		payAllowance_12_01 =null;
		payAllowance_13_01 =null;
		payAllowance_14_01 =null;
		payAllowance_15_01 =null;
		payAllowance_16_01 =null;
		payAllowance_17_01 =null;
		payAllowance_18_01 =null;
		payAllowance_19_01 =null;
		payAllowance_20_01 =null;
		payAllowance_21_01 =null;
		payAllowance_22_01 =null;
		payAllowance_23_01 =null;
		payAllowance_24_01 =null;
		payAllowance_25_01 =null;
		payAllowance_26_01 =null;
		payAllowance_27_01 =null;
		payAllowance_28_01 =null;
		payAllowance_29_01 =null;
		payAllowance_30_01 =null;

		payDeduction_01_01 =null;
		payDeduction_02_01 =null;
		payDeduction_03_01 =null;
		payDeduction_04_01 =null;
		payDeduction_05_01 =null;
		payDeduction_06_01 =null;
		payDeduction_07_01 =null;
		payDeduction_08_01 =null;
		payDeduction_09_01 =null;
		payDeduction_10_01 =null;
		payDeduction_11_01 =null;
		payDeduction_12_01 =null;
		payDeduction_13_01 =null;
		payDeduction_14_01 =null;
		payDeduction_15_01 =null;
		payDeduction_16_01 =null;
		payDeduction_17_01 =null;
		payDeduction_18_01 =null;
		payDeduction_19_01 =null;
		payDeduction_20_01 =null;
		payDeduction_21_01 =null;
		payDeduction_22_01 =null;
		payDeduction_23_01 =null;
		payDeduction_24_01 =null;
		payDeduction_25_01 =null;
		payDeduction_26_01 =null;
		payDeduction_27_01 =null;
		payAllowanceTotal_01 =null;
		payDeductionTotal_01 =null;
		payPaymentTotal_01   =null;
		payBank1PayAmount_01 =null;
		payBank2PayAmount_01 =null;
		payCashPayAmount_01  =null;
		attendance_01_01 =null;
		attendance_02_01 =null;
		attendance_03_01 =null;
		attendance_04_01 =null;
		attendance_05_01 =null;
		attendance_06_01 =null;
		attendance_07_01 =null;
		attendance_08_01 =null;
		attendance_09_01 =null;
		attendance_10_01 =null;
		attendance_11_01 =null;
		attendance_12_01 =null;
		attendance_13_01 =null;
		attendance_14_01 =null;

	}

	private void setPaymentSpace02() {
		payAllowance_01_02 =null;
		payAllowance_02_02 =null;
		payAllowance_03_02=null;
		payAllowance_04_02=null;
		payAllowance_05_02=null;
		payAllowance_06_02=null;
		payAllowance_07_02=null;
		payAllowance_08_02=null;
		payAllowance_09_02=null;
		payAllowance_10_02=null;
		payAllowance_11_02=null;
		payAllowance_12_02=null;
		payAllowance_13_02=null;
		payAllowance_14_02=null;
		payAllowance_15_02=null;
		payAllowance_16_02=null;
		payAllowance_17_02=null;
		payAllowance_18_02=null;
		payAllowance_19_02=null;
		payAllowance_20_02=null;
		payAllowance_21_02=null;
		payAllowance_22_02=null;
		payAllowance_23_02=null;
		payAllowance_24_02=null;
		payAllowance_25_02=null;
		payAllowance_26_02=null;
		payAllowance_27_02=null;
		payAllowance_28_02=null;
		payAllowance_29_02=null;
		payAllowance_30_02=null;

		payDeduction_01_02=null;
		payDeduction_02_02=null;
		payDeduction_03_02=null;
		payDeduction_04_02=null;
		payDeduction_05_02=null;
		payDeduction_06_02=null;
		payDeduction_07_02=null;
		payDeduction_08_02=null;
		payDeduction_09_02=null;
		payDeduction_10_02=null;
		payDeduction_11_02=null;
		payDeduction_12_02=null;
		payDeduction_13_02=null;
		payDeduction_14_02=null;
		payDeduction_15_02=null;
		payDeduction_16_02=null;
		payDeduction_17_02=null;
		payDeduction_18_02=null;
		payDeduction_19_02=null;
		payDeduction_20_02=null;
		payDeduction_21_02=null;
		payDeduction_22_02=null;
		payDeduction_23_02=null;
		payDeduction_24_02=null;
		payDeduction_25_02=null;
		payDeduction_26_02=null;
		payDeduction_27_02=null;
		payAllowanceTotal_02=null;
		payDeductionTotal_02=null;
		payPaymentTotal_02=null;
		payBank1PayAmount_02=null;
		payBank2PayAmount_02=null;
		payCashPayAmount_02=null;
		attendance_01_02=null;
		attendance_02_02=null;
		attendance_03_02=null;
		attendance_04_02=null;
		attendance_05_02=null;
		attendance_06_02=null;
		attendance_07_02=null;
		attendance_08_02=null;
		attendance_09_02=null;
		attendance_10_02=null;
		attendance_11_02=null;
		attendance_12_02=null;
		attendance_13_02=null;
		attendance_14_02=null;

	}

	private void setPaymentSpace03() {
		payAllowance_01_03 =null;
		payAllowance_02_03 =null;
		payAllowance_03_03=null;
		payAllowance_04_03=null;
		payAllowance_05_03=null;
		payAllowance_06_03=null;
		payAllowance_07_03=null;
		payAllowance_08_03=null;
		payAllowance_09_03=null;
		payAllowance_10_03=null;
		payAllowance_11_03=null;
		payAllowance_12_03=null;
		payAllowance_13_03=null;
		payAllowance_14_03=null;
		payAllowance_15_03=null;
		payAllowance_16_03=null;
		payAllowance_17_03=null;
		payAllowance_18_03=null;
		payAllowance_19_03=null;
		payAllowance_20_03=null;
		payAllowance_21_03=null;
		payAllowance_22_03=null;
		payAllowance_23_03=null;
		payAllowance_24_03=null;
		payAllowance_25_03=null;
		payAllowance_26_03=null;
		payAllowance_27_03=null;
		payAllowance_28_03=null;
		payAllowance_29_03=null;
		payAllowance_30_03=null;

		payDeduction_01_03=null;
		payDeduction_02_03=null;
		payDeduction_03_03=null;
		payDeduction_04_03=null;
		payDeduction_05_03=null;
		payDeduction_06_03=null;
		payDeduction_07_03=null;
		payDeduction_08_03=null;
		payDeduction_09_03=null;
		payDeduction_10_03=null;
		payDeduction_11_03=null;
		payDeduction_12_03=null;
		payDeduction_13_03=null;
		payDeduction_14_03=null;
		payDeduction_15_03=null;
		payDeduction_16_03=null;
		payDeduction_17_03=null;
		payDeduction_18_03=null;
		payDeduction_19_03=null;
		payDeduction_20_03=null;
		payDeduction_21_03=null;
		payDeduction_22_03=null;
		payDeduction_23_03=null;
		payDeduction_24_03=null;
		payDeduction_25_03=null;
		payDeduction_26_03=null;
		payDeduction_27_03=null;
		payAllowanceTotal_03=null;
		payDeductionTotal_03=null;
		payPaymentTotal_03=null;
		payBank1PayAmount_03=null;
		payBank2PayAmount_03=null;
		payCashPayAmount_03=null;
		attendance_01_03=null;
		attendance_02_03=null;
		attendance_03_03=null;
		attendance_04_03=null;
		attendance_05_03=null;
		attendance_06_03=null;
		attendance_07_03=null;
		attendance_08_03=null;
		attendance_09_03=null;
		attendance_10_03=null;
		attendance_11_03=null;
		attendance_12_03=null;
		attendance_13_03=null;
		attendance_14_03=null;

	}

	private void setPaymentSpace04() {
		payAllowance_01_04 =null;
		payAllowance_02_04 =null;
		payAllowance_03_04=null;
		payAllowance_04_04=null;
		payAllowance_05_04=null;
		payAllowance_06_04=null;
		payAllowance_07_04=null;
		payAllowance_08_04=null;
		payAllowance_09_04=null;
		payAllowance_10_04=null;
		payAllowance_11_04=null;
		payAllowance_12_04=null;
		payAllowance_13_04=null;
		payAllowance_14_04=null;
		payAllowance_15_04=null;
		payAllowance_16_04=null;
		payAllowance_17_04=null;
		payAllowance_18_04=null;
		payAllowance_19_04=null;
		payAllowance_20_04=null;
		payAllowance_21_04=null;
		payAllowance_22_04=null;
		payAllowance_23_04=null;
		payAllowance_24_04=null;
		payAllowance_25_04=null;
		payAllowance_26_04=null;
		payAllowance_27_04=null;
		payAllowance_28_04=null;
		payAllowance_29_04=null;
		payAllowance_30_04=null;

		payDeduction_01_04 =null;
		payDeduction_02_04 =null;
		payDeduction_03_04=null;
		payDeduction_04_04=null;
		payDeduction_05_04=null;
		payDeduction_06_04=null;
		payDeduction_07_04=null;
		payDeduction_08_04=null;
		payDeduction_09_04=null;
		payDeduction_10_04=null;
		payDeduction_11_04=null;
		payDeduction_12_04=null;
		payDeduction_13_04=null;
		payDeduction_14_04=null;
		payDeduction_15_04=null;
		payDeduction_16_04=null;
		payDeduction_17_04=null;
		payDeduction_18_04=null;
		payDeduction_19_04=null;
		payDeduction_20_04=null;
		payDeduction_21_04=null;
		payDeduction_22_04=null;
		payDeduction_23_04=null;
		payDeduction_24_04=null;
		payDeduction_25_04=null;
		payDeduction_26_04=null;
		payDeduction_27_04=null;
		payAllowanceTotal_04=null;
		payDeductionTotal_04=null;
		payPaymentTotal_04=null;
		payBank1PayAmount_04=null;
		payBank2PayAmount_04=null;
		payCashPayAmount_04=null;
		attendance_01_04=null;
		attendance_02_04=null;
		attendance_03_04=null;
		attendance_04_04=null;
		attendance_05_04=null;
		attendance_06_04=null;
		attendance_07_04=null;
		attendance_08_04=null;
		attendance_09_04=null;
		attendance_10_04=null;
		attendance_11_04=null;
		attendance_12_04=null;
		attendance_13_04=null;
		attendance_14_04=null;

	}

	private void setPaymentSpace05() {
		payAllowance_01_05 =null;
		payAllowance_02_05 =null;
		payAllowance_03_05=null;
		payAllowance_04_05=null;
		payAllowance_05_05=null;
		payAllowance_06_05=null;
		payAllowance_07_05=null;
		payAllowance_08_05=null;
		payAllowance_09_05=null;
		payAllowance_10_05=null;
		payAllowance_11_05=null;
		payAllowance_12_05=null;
		payAllowance_13_05=null;
		payAllowance_14_05=null;
		payAllowance_15_05=null;
		payAllowance_16_05=null;
		payAllowance_17_05=null;
		payAllowance_18_05=null;
		payAllowance_19_05=null;
		payAllowance_20_05=null;
		payAllowance_21_05=null;
		payAllowance_22_05=null;
		payAllowance_23_05=null;
		payAllowance_24_05=null;
		payAllowance_25_05=null;
		payAllowance_26_05=null;
		payAllowance_27_05=null;
		payAllowance_28_05=null;
		payAllowance_29_05=null;
		payAllowance_30_05=null;

		payDeduction_01_05=null;
		payDeduction_02_05=null;
		payDeduction_03_05=null;
		payDeduction_04_05=null;
		payDeduction_05_05=null;
		payDeduction_06_05=null;
		payDeduction_07_05=null;
		payDeduction_08_05=null;
		payDeduction_09_05=null;
		payDeduction_10_05=null;
		payDeduction_11_05=null;
		payDeduction_12_05=null;
		payDeduction_13_05=null;
		payDeduction_14_05=null;
		payDeduction_15_05=null;
		payDeduction_16_05=null;
		payDeduction_17_05=null;
		payDeduction_18_05=null;
		payDeduction_19_05=null;
		payDeduction_20_05=null;
		payDeduction_21_05=null;
		payDeduction_22_05=null;
		payDeduction_23_05=null;
		payDeduction_24_05=null;
		payDeduction_25_05=null;
		payDeduction_26_05=null;
		payDeduction_27_05=null;
		payAllowanceTotal_05=null;
		payDeductionTotal_05=null;
		payPaymentTotal_05=null;
		payBank1PayAmount_05=null;
		payBank2PayAmount_05=null;
		payCashPayAmount_05=null;
		attendance_01_05=null;
		attendance_02_05=null;
		attendance_03_05=null;
		attendance_04_05=null;
		attendance_05_05=null;
		attendance_06_05=null;
		attendance_07_05=null;
		attendance_08_05=null;
		attendance_09_05=null;
		attendance_10_05=null;
		attendance_11_05=null;
		attendance_12_05=null;
		attendance_13_05=null;
		attendance_14_05=null;

	}

	private void setPaymentSpace06() {
		payAllowance_01_06 =null;
		payAllowance_02_06 =null;
		payAllowance_03_06=null;
		payAllowance_04_06=null;
		payAllowance_05_06=null;
		payAllowance_06_06=null;
		payAllowance_07_06=null;
		payAllowance_08_06=null;
		payAllowance_09_06=null;
		payAllowance_10_06=null;
		payAllowance_11_06=null;
		payAllowance_12_06=null;
		payAllowance_13_06=null;
		payAllowance_14_06=null;
		payAllowance_15_06=null;
		payAllowance_16_06=null;
		payAllowance_17_06=null;
		payAllowance_18_06=null;
		payAllowance_19_06=null;
		payAllowance_20_06=null;
		payAllowance_21_06=null;
		payAllowance_22_06=null;
		payAllowance_23_06=null;
		payAllowance_24_06=null;
		payAllowance_25_06=null;
		payAllowance_26_06=null;
		payAllowance_27_06=null;
		payAllowance_28_06=null;
		payAllowance_29_06=null;
		payAllowance_30_06=null;

		payDeduction_01_06=null;
		payDeduction_02_06=null;
		payDeduction_03_06=null;
		payDeduction_04_06=null;
		payDeduction_05_06=null;
		payDeduction_06_06=null;
		payDeduction_07_06=null;
		payDeduction_08_06=null;
		payDeduction_09_06=null;
		payDeduction_10_06=null;
		payDeduction_11_06=null;
		payDeduction_12_06=null;
		payDeduction_13_06=null;
		payDeduction_14_06=null;
		payDeduction_15_06=null;
		payDeduction_16_06=null;
		payDeduction_17_06=null;
		payDeduction_18_06=null;
		payDeduction_19_06=null;
		payDeduction_20_06=null;
		payDeduction_21_06=null;
		payDeduction_22_06=null;
		payDeduction_23_06=null;
		payDeduction_24_06=null;
		payDeduction_25_06=null;
		payDeduction_26_06=null;
		payDeduction_27_06=null;
		payAllowanceTotal_06=null;
		payDeductionTotal_06=null;
		payPaymentTotal_06=null;
		payBank1PayAmount_06=null;
		payBank2PayAmount_06=null;
		payCashPayAmount_06=null;
		attendance_01_06=null;
		attendance_02_06=null;
		attendance_03_06=null;
		attendance_04_06=null;
		attendance_05_06=null;
		attendance_06_06=null;
		attendance_07_06=null;
		attendance_08_06=null;
		attendance_09_06=null;
		attendance_10_06=null;
		attendance_11_06=null;
		attendance_12_06=null;
		attendance_13_06=null;
		attendance_14_06=null;

	}

	private void setPaymentSpace07() {
		payAllowance_01_07 =null;
		payAllowance_02_07 =null;
		payAllowance_03_07=null;
		payAllowance_04_07=null;
		payAllowance_05_07=null;
		payAllowance_06_07=null;
		payAllowance_07_07=null;
		payAllowance_08_07=null;
		payAllowance_09_07=null;
		payAllowance_10_07=null;
		payAllowance_11_07=null;
		payAllowance_12_07=null;
		payAllowance_13_07=null;
		payAllowance_14_07=null;
		payAllowance_15_07=null;
		payAllowance_16_07=null;
		payAllowance_17_07=null;
		payAllowance_18_07=null;
		payAllowance_19_07=null;
		payAllowance_20_07=null;
		payAllowance_21_07=null;
		payAllowance_22_07=null;
		payAllowance_23_07=null;
		payAllowance_24_07=null;
		payAllowance_25_07=null;
		payAllowance_26_07=null;
		payAllowance_27_07=null;
		payAllowance_28_07=null;
		payAllowance_29_07=null;
		payAllowance_30_07=null;

		payDeduction_01_07=null;
		payDeduction_02_07=null;
		payDeduction_03_07=null;
		payDeduction_04_07=null;
		payDeduction_05_07=null;
		payDeduction_06_07=null;
		payDeduction_07_07=null;
		payDeduction_08_07=null;
		payDeduction_09_07=null;
		payDeduction_10_07=null;
		payDeduction_11_07=null;
		payDeduction_12_07=null;
		payDeduction_13_07=null;
		payDeduction_14_07=null;
		payDeduction_15_07=null;
		payDeduction_16_07=null;
		payDeduction_17_07=null;
		payDeduction_18_07=null;
		payDeduction_19_07=null;
		payDeduction_20_07=null;
		payDeduction_21_07=null;
		payDeduction_22_07=null;
		payDeduction_23_07=null;
		payDeduction_24_07=null;
		payDeduction_25_07=null;
		payDeduction_26_07=null;
		payDeduction_27_07=null;
		payAllowanceTotal_07=null;
		payDeductionTotal_07=null;
		payPaymentTotal_07=null;
		payBank1PayAmount_07=null;
		payBank2PayAmount_07=null;
		payCashPayAmount_07=null;
		attendance_01_07=null;
		attendance_02_07=null;
		attendance_03_07=null;
		attendance_04_07=null;
		attendance_05_07=null;
		attendance_06_07=null;
		attendance_07_07=null;
		attendance_08_07=null;
		attendance_09_07=null;
		attendance_10_07=null;
		attendance_11_07=null;
		attendance_12_07=null;
		attendance_13_07=null;
		attendance_14_07=null;

	}

	private void setPaymentSpace08() {
		payAllowance_01_08 =null;
		payAllowance_02_08 =null;
		payAllowance_03_08=null;
		payAllowance_04_08=null;
		payAllowance_05_08=null;
		payAllowance_06_08=null;
		payAllowance_07_08=null;
		payAllowance_08_08=null;
		payAllowance_09_08=null;
		payAllowance_10_08=null;
		payAllowance_11_08=null;
		payAllowance_12_08=null;
		payAllowance_13_08=null;
		payAllowance_14_08=null;
		payAllowance_15_08=null;
		payAllowance_16_08=null;
		payAllowance_17_08=null;
		payAllowance_18_08=null;
		payAllowance_19_08=null;
		payAllowance_20_08=null;
		payAllowance_21_08=null;
		payAllowance_22_08=null;
		payAllowance_23_08=null;
		payAllowance_24_08=null;
		payAllowance_25_08=null;
		payAllowance_26_08=null;
		payAllowance_27_08=null;
		payAllowance_28_08=null;
		payAllowance_29_08=null;
		payAllowance_30_08=null;

		payDeduction_01_08=null;
		payDeduction_02_08=null;
		payDeduction_03_08=null;
		payDeduction_04_08=null;
		payDeduction_05_08=null;
		payDeduction_06_08=null;
		payDeduction_07_08=null;
		payDeduction_08_08=null;
		payDeduction_09_08=null;
		payDeduction_10_08=null;
		payDeduction_11_08=null;
		payDeduction_12_08=null;
		payDeduction_13_08=null;
		payDeduction_14_08=null;
		payDeduction_15_08=null;
		payDeduction_16_08=null;
		payDeduction_17_08=null;
		payDeduction_18_08=null;
		payDeduction_19_08=null;
		payDeduction_20_08=null;
		payDeduction_21_08=null;
		payDeduction_22_08=null;
		payDeduction_23_08=null;
		payDeduction_24_08=null;
		payDeduction_25_08=null;
		payDeduction_26_08=null;
		payDeduction_27_08=null;
		payAllowanceTotal_08=null;
		payDeductionTotal_08=null;
		payPaymentTotal_08=null;
		payBank1PayAmount_08=null;
		payBank2PayAmount_08=null;
		payCashPayAmount_08=null;
		attendance_01_08=null;
		attendance_02_08=null;
		attendance_03_08=null;
		attendance_04_08=null;
		attendance_05_08=null;
		attendance_06_08=null;
		attendance_07_08=null;
		attendance_08_08=null;
		attendance_09_08=null;
		attendance_10_08=null;
		attendance_11_08=null;
		attendance_12_08=null;
		attendance_13_08=null;
		attendance_14_08=null;

	}

	private void setPaymentSpace09() {
		payAllowance_01_09 =null;
		payAllowance_02_09 =null;
		payAllowance_03_09=null;
		payAllowance_04_09=null;
		payAllowance_05_09=null;
		payAllowance_06_09=null;
		payAllowance_07_09=null;
		payAllowance_08_09=null;
		payAllowance_09_09=null;
		payAllowance_10_09=null;
		payAllowance_11_09=null;
		payAllowance_12_09=null;
		payAllowance_13_09=null;
		payAllowance_14_09=null;
		payAllowance_15_09=null;
		payAllowance_16_09=null;
		payAllowance_17_09=null;
		payAllowance_18_09=null;
		payAllowance_19_09=null;
		payAllowance_20_09=null;
		payAllowance_21_09=null;
		payAllowance_22_09=null;
		payAllowance_23_09=null;
		payAllowance_24_09=null;
		payAllowance_25_09=null;
		payAllowance_26_09=null;
		payAllowance_27_09=null;
		payAllowance_28_09=null;
		payAllowance_29_09=null;
		payAllowance_30_09=null;

		payDeduction_01_09=null;
		payDeduction_02_09=null;
		payDeduction_03_09=null;
		payDeduction_04_09=null;
		payDeduction_05_09=null;
		payDeduction_06_09=null;
		payDeduction_07_09=null;
		payDeduction_08_09=null;
		payDeduction_09_09=null;
		payDeduction_10_09=null;
		payDeduction_11_09=null;
		payDeduction_12_09=null;
		payDeduction_13_09=null;
		payDeduction_14_09=null;
		payDeduction_15_09=null;
		payDeduction_16_09=null;
		payDeduction_17_09=null;
		payDeduction_18_09=null;
		payDeduction_19_09=null;
		payDeduction_20_09=null;
		payDeduction_21_09=null;
		payDeduction_22_09=null;
		payDeduction_23_09=null;
		payDeduction_24_09=null;
		payDeduction_25_09=null;
		payDeduction_26_09=null;
		payDeduction_27_09=null;
		payAllowanceTotal_09=null;
		payDeductionTotal_09=null;
		payPaymentTotal_09=null;
		payBank1PayAmount_09=null;
		payBank2PayAmount_09=null;
		payCashPayAmount_09=null;
		attendance_01_09=null;
		attendance_02_09=null;
		attendance_03_09=null;
		attendance_04_09=null;
		attendance_05_09=null;
		attendance_06_09=null;
		attendance_07_09=null;
		attendance_08_09=null;
		attendance_09_09=null;
		attendance_10_09=null;
		attendance_11_09=null;
		attendance_12_09=null;
		attendance_13_09=null;
		attendance_14_09=null;

	}

	private void setPaymentSpace10() {
		payAllowance_01_10 =null;
		payAllowance_02_10 =null;
		payAllowance_03_10=null;
		payAllowance_04_10=null;
		payAllowance_05_10=null;
		payAllowance_06_10=null;
		payAllowance_07_10=null;
		payAllowance_08_10=null;
		payAllowance_09_10=null;
		payAllowance_10_10=null;
		payAllowance_11_10=null;
		payAllowance_12_10=null;
		payAllowance_13_10=null;
		payAllowance_14_10=null;
		payAllowance_15_10=null;
		payAllowance_16_10=null;
		payAllowance_17_10=null;
		payAllowance_18_10=null;
		payAllowance_19_10=null;
		payAllowance_20_10=null;
		payAllowance_21_10=null;
		payAllowance_22_10=null;
		payAllowance_23_10=null;
		payAllowance_24_10=null;
		payAllowance_25_10=null;
		payAllowance_26_10=null;
		payAllowance_27_10=null;
		payAllowance_28_10=null;
		payAllowance_29_10=null;
		payAllowance_30_10=null;

		payDeduction_01_10=null;
		payDeduction_02_10=null;
		payDeduction_03_10=null;
		payDeduction_04_10=null;
		payDeduction_05_10=null;
		payDeduction_06_10=null;
		payDeduction_07_10=null;
		payDeduction_08_10=null;
		payDeduction_09_10=null;
		payDeduction_10_10=null;
		payDeduction_11_10=null;
		payDeduction_12_10=null;
		payDeduction_13_10=null;
		payDeduction_14_10=null;
		payDeduction_15_10=null;
		payDeduction_16_10=null;
		payDeduction_17_10=null;
		payDeduction_18_10=null;
		payDeduction_19_10=null;
		payDeduction_20_10=null;
		payDeduction_21_10=null;
		payDeduction_22_10=null;
		payDeduction_23_10=null;
		payDeduction_24_10=null;
		payDeduction_25_10=null;
		payDeduction_26_10=null;
		payDeduction_27_10=null;
		payAllowanceTotal_10=null;
		payDeductionTotal_10=null;
		payPaymentTotal_10=null;
		payBank1PayAmount_10=null;
		payBank2PayAmount_10=null;
		payCashPayAmount_10=null;
		attendance_01_10=null;
		attendance_02_10=null;
		attendance_03_10=null;
		attendance_04_10=null;
		attendance_05_10=null;
		attendance_06_10=null;
		attendance_07_10=null;
		attendance_08_10=null;
		attendance_09_10=null;
		attendance_10_10=null;
		attendance_11_10=null;
		attendance_12_10=null;
		attendance_13_10=null;
		attendance_14_10=null;

	}

	private void setPaymentSpace11() {
		payAllowance_01_11=null;
		payAllowance_02_11=null;
		payAllowance_03_11=null;
		payAllowance_04_11=null;
		payAllowance_05_11=null;
		payAllowance_06_11=null;
		payAllowance_07_11=null;
		payAllowance_08_11=null;
		payAllowance_09_11=null;
		payAllowance_10_11=null;
		payAllowance_11_11=null;
		payAllowance_12_11=null;
		payAllowance_13_11=null;
		payAllowance_14_11=null;
		payAllowance_15_11=null;
		payAllowance_16_11=null;
		payAllowance_17_11=null;
		payAllowance_18_11=null;
		payAllowance_19_11=null;
		payAllowance_20_11=null;
		payAllowance_21_11=null;
		payAllowance_22_11=null;
		payAllowance_23_11=null;
		payAllowance_24_11=null;
		payAllowance_25_11=null;
		payAllowance_26_11=null;
		payAllowance_27_11=null;
		payAllowance_28_11=null;
		payAllowance_29_11=null;
		payAllowance_30_11=null;

		payDeduction_01_11=null;
		payDeduction_02_11=null;
		payDeduction_03_11=null;
		payDeduction_04_11=null;
		payDeduction_05_11=null;
		payDeduction_06_11=null;
		payDeduction_07_11=null;
		payDeduction_08_11=null;
		payDeduction_09_11=null;
		payDeduction_10_11=null;
		payDeduction_11_11=null;
		payDeduction_12_11=null;
		payDeduction_13_11=null;
		payDeduction_14_11=null;
		payDeduction_15_11=null;
		payDeduction_16_11=null;
		payDeduction_17_11=null;
		payDeduction_18_11=null;
		payDeduction_19_11=null;
		payDeduction_20_11=null;
		payDeduction_21_11=null;
		payDeduction_22_11=null;
		payDeduction_23_11=null;
		payDeduction_24_11=null;
		payDeduction_25_11=null;
		payDeduction_26_11=null;
		payDeduction_27_11=null;
		payAllowanceTotal_11=null;
		payDeductionTotal_11=null;
		payPaymentTotal_11=null;
		payBank1PayAmount_11=null;
		payBank2PayAmount_11=null;
		payCashPayAmount_11=null;
		attendance_01_11=null;
		attendance_02_11=null;
		attendance_03_11=null;
		attendance_04_11=null;
		attendance_05_11=null;
		attendance_06_11=null;
		attendance_07_11=null;
		attendance_08_11=null;
		attendance_09_11=null;
		attendance_10_11=null;
		attendance_11_11=null;
		attendance_12_11=null;
		attendance_13_11=null;
		attendance_14_11=null;

	}

	private void setPaymentSpace12() {
		payAllowance_01_12 =null;
		payAllowance_02_12 =null;
		payAllowance_03_12=null;
		payAllowance_04_12=null;
		payAllowance_05_12=null;
		payAllowance_06_12=null;
		payAllowance_07_12=null;
		payAllowance_08_12=null;
		payAllowance_09_12=null;
		payAllowance_10_12=null;
		payAllowance_11_12=null;
		payAllowance_12_12=null;
		payAllowance_13_12=null;
		payAllowance_14_12=null;
		payAllowance_15_12=null;
		payAllowance_16_12=null;
		payAllowance_17_12=null;
		payAllowance_18_12=null;
		payAllowance_19_12=null;
		payAllowance_20_12=null;
		payAllowance_21_12=null;
		payAllowance_22_12=null;
		payAllowance_23_12=null;
		payAllowance_24_12=null;
		payAllowance_25_12=null;
		payAllowance_26_12=null;
		payAllowance_27_12=null;
		payAllowance_28_12=null;
		payAllowance_29_12=null;
		payAllowance_30_12=null;

		payDeduction_01_12=null;
		payDeduction_02_12=null;
		payDeduction_03_12=null;
		payDeduction_04_12=null;
		payDeduction_05_12=null;
		payDeduction_06_12=null;
		payDeduction_07_12=null;
		payDeduction_08_12=null;
		payDeduction_09_12=null;
		payDeduction_10_12=null;
		payDeduction_11_12=null;
		payDeduction_12_12=null;
		payDeduction_13_12=null;
		payDeduction_14_12=null;
		payDeduction_15_12=null;
		payDeduction_16_12=null;
		payDeduction_17_12=null;
		payDeduction_18_12=null;
		payDeduction_19_12=null;
		payDeduction_20_12=null;
		payDeduction_21_12=null;
		payDeduction_22_12=null;
		payDeduction_23_12=null;
		payDeduction_24_12=null;
		payDeduction_25_12=null;
		payDeduction_26_12=null;
		payDeduction_27_12=null;
		payAllowanceTotal_12=null;
		payDeductionTotal_12=null;
		payPaymentTotal_12=null;
		payBank1PayAmount_12=null;
		payBank2PayAmount_12=null;
		payCashPayAmount_12=null;
		attendance_01_12=null;
		attendance_02_12=null;
		attendance_03_12=null;
		attendance_04_12=null;
		attendance_05_12=null;
		attendance_06_12=null;
		attendance_07_12=null;
		attendance_08_12=null;
		attendance_09_12=null;
		attendance_10_12=null;
		attendance_11_12=null;
		attendance_12_12=null;
		attendance_13_12=null;
		attendance_14_12=null;

	}
	
	private void setBonusSpace01() {
		bonAllowance_01_01 =null;
		bonAllowance_02_01 =null;
		bonAllowance_03_01 =null;
		bonAllowance_04_01 =null;
		bonAllowance_05_01 =null;
		bonAllowance_06_01 =null;
		bonAllowance_07_01 =null;
		bonAllowance_08_01 =null;
		bonAllowance_09_01 =null;
		bonAllowance_10_01 =null;

		bonDeduction_01_01 =null;
		bonDeduction_02_01 =null;
		bonDeduction_03_01 =null;
		bonDeduction_04_01 =null;
		bonDeduction_05_01 =null;
		bonDeduction_06_01 =null;
		bonDeduction_07_01 =null;
		bonDeduction_08_01 =null;
		bonDeduction_09_01 =null;
		bonDeduction_10_01 =null;
		bonDeduction_11_01 =null;
		bonDeduction_12_01 =null;
		bonDeduction_13_01 =null;
		bonDeduction_14_01 =null;
		bonDeduction_15_01 =null;
		bonDeduction_16_01 =null;
		bonDeduction_17_01 =null;
		bonAllowanceTotal_01 =null;
		bonDeductionTotal_01 =null;
		bonPaymentTotal_01   =null;
		bonBank1PayAmount_01 =null;
		bonBank2PayAmount_01 =null;
		bonCashPayAmount_01  =null;
	}



	private void setBonusSpace02() {
		bonAllowance_01_02 =null;
		bonAllowance_02_02 =null;
		bonAllowance_03_02=null;
		bonAllowance_04_02=null;
		bonAllowance_05_02=null;
		bonAllowance_06_02=null;
		bonAllowance_07_02=null;
		bonAllowance_08_02=null;
		bonAllowance_09_02=null;
		bonAllowance_10_02=null;

		bonDeduction_01_02=null;
		bonDeduction_02_02=null;
		bonDeduction_03_02=null;
		bonDeduction_04_02=null;
		bonDeduction_05_02=null;
		bonDeduction_06_02=null;
		bonDeduction_07_02=null;
		bonDeduction_08_02=null;
		bonDeduction_09_02=null;
		bonDeduction_10_02=null;
		bonDeduction_11_02=null;
		bonDeduction_12_02=null;
		bonDeduction_13_02=null;
		bonDeduction_14_02=null;
		bonDeduction_15_02=null;
		bonDeduction_16_02=null;
		bonDeduction_17_02=null;
		bonAllowanceTotal_02=null;
		bonDeductionTotal_02=null;
		bonPaymentTotal_02=null;
		bonBank1PayAmount_02=null;
		bonBank2PayAmount_02=null;
		bonCashPayAmount_02=null;
	}

	private void setBonusSpace03() {
		bonAllowance_01_03 =null;
		bonAllowance_02_03 =null;
		bonAllowance_03_03=null;
		bonAllowance_04_03=null;
		bonAllowance_05_03=null;
		bonAllowance_06_03=null;
		bonAllowance_07_03=null;
		bonAllowance_08_03=null;
		bonAllowance_09_03=null;
		bonAllowance_10_03=null;

		bonDeduction_01_03=null;
		bonDeduction_02_03=null;
		bonDeduction_03_03=null;
		bonDeduction_04_03=null;
		bonDeduction_05_03=null;
		bonDeduction_06_03=null;
		bonDeduction_07_03=null;
		bonDeduction_08_03=null;
		bonDeduction_09_03=null;
		bonDeduction_10_03=null;
		bonDeduction_11_03=null;
		bonDeduction_12_03=null;
		bonDeduction_13_03=null;
		bonDeduction_14_03=null;
		bonDeduction_15_03=null;
		bonDeduction_16_03=null;
		bonDeduction_17_03=null;
		bonAllowanceTotal_03=null;
		bonDeductionTotal_03=null;
		bonPaymentTotal_03=null;
		bonBank1PayAmount_03=null;
		bonBank2PayAmount_03=null;
		bonCashPayAmount_03=null;
	}

	private void setBonusSpace04() {
		bonAllowance_01_04 =null;
		bonAllowance_02_04 =null;
		bonAllowance_03_04=null;
		bonAllowance_04_04=null;
		bonAllowance_05_04=null;
		bonAllowance_06_04=null;
		bonAllowance_07_04=null;
		bonAllowance_08_04=null;
		bonAllowance_09_04=null;
		bonAllowance_10_04=null;

		bonDeduction_01_04=null;
		bonDeduction_02_04=null;
		bonDeduction_03_04=null;
		bonDeduction_04_04=null;
		bonDeduction_05_04=null;
		bonDeduction_06_04=null;
		bonDeduction_07_04=null;
		bonDeduction_08_04=null;
		bonDeduction_09_04=null;
		bonDeduction_10_04=null;
		bonDeduction_11_04=null;
		bonDeduction_12_04=null;
		bonDeduction_13_04=null;
		bonDeduction_14_04=null;
		bonDeduction_15_04=null;
		bonDeduction_16_04=null;
		bonDeduction_17_04=null;
		bonAllowanceTotal_04=null;
		bonDeductionTotal_04=null;
		bonPaymentTotal_04=null;
		bonBank1PayAmount_04=null;
		bonBank2PayAmount_04=null;
		bonCashPayAmount_04=null;
	}

	private void setBonusSpace05() {
		bonAllowance_01_05 = null;
		bonAllowance_02_05 = null;
		bonAllowance_03_05 = null;
		bonAllowance_04_05 = null;
		bonAllowance_05_05 = null;
		bonAllowance_06_05 = null;
		bonAllowance_07_05 = null;
		bonAllowance_08_05 = null;
		bonAllowance_09_05 = null;
		bonAllowance_10_05 = null;

		bonDeduction_01_05 = null;
		bonDeduction_02_05 = null;
		bonDeduction_03_05 = null;
		bonDeduction_04_05 = null;
		bonDeduction_05_05 = null;
		bonDeduction_06_05 = null;
		bonDeduction_07_05 = null;
		bonDeduction_08_05 = null;
		bonDeduction_09_05 = null;
		bonDeduction_10_05 = null;
		bonDeduction_11_05 = null;
		bonDeduction_12_05 = null;
		bonDeduction_13_05 = null;
		bonDeduction_14_05 = null;
		bonDeduction_15_05 = null;
		bonDeduction_16_05 = null;
		bonDeduction_17_05 = null;
		bonAllowanceTotal_05 = null;
		bonDeductionTotal_05 = null;
		bonPaymentTotal_05 = null;
		bonBank1PayAmount_05 = null;
		bonBank2PayAmount_05 = null;
		bonCashPayAmount_05 = null;
	}
	
	private void setBonusSpace06() {
		bonAllowance_01_06 = null;
		bonAllowance_02_06 = null;
		bonAllowance_03_06 = null;
		bonAllowance_04_06 = null;
		bonAllowance_05_06 = null;
		bonAllowance_06_06 = null;
		bonAllowance_07_06 = null;
		bonAllowance_08_06 = null;
		bonAllowance_09_06 = null;
		bonAllowance_10_06 = null;

		bonDeduction_01_06 = null;
		bonDeduction_02_06 = null;
		bonDeduction_03_06 = null;
		bonDeduction_04_06 = null;
		bonDeduction_05_06 = null;
		bonDeduction_06_06 = null;
		bonDeduction_07_06 = null;
		bonDeduction_08_06 = null;
		bonDeduction_09_06 = null;
		bonDeduction_10_06 = null;
		bonDeduction_11_06 = null;
		bonDeduction_12_06 = null;
		bonDeduction_13_06 = null;
		bonDeduction_14_06 = null;
		bonDeduction_15_06 = null;
		bonDeduction_16_06 = null;
		bonDeduction_17_06 = null;
		bonAllowanceTotal_06 = null;
		bonDeductionTotal_06 = null;
		bonPaymentTotal_06 = null;
		bonBank1PayAmount_06 = null;
		bonBank2PayAmount_06 = null;
		bonCashPayAmount_06 = null;
	}
	
	
	/**
	 * }{T\֌W̐ݒ
	 * @param mapDetail
	 */
	private void setDependDeductionValue(CmIncomeTaxDto cmIncomeTaxDto) {
		if (cmIncomeTaxDto != null) {
			incomeTaxType     = cmIncomeTaxDto.getIncomeTaxType                    () ;	// ېŋ敪
			adjustmentType    = cmIncomeTaxDto.getAdjustmentType                   () ;	// N敪
			selfWidowType     = cmIncomeTaxDto.getSelfWidowType                    () ;	// {lǕw敪
			selfHandicapType  = cmIncomeTaxDto.getSelfHandicapType                 () ;	// {lQ敪
			selfStudentType   = cmIncomeTaxDto.getSelfStudentType                  () ;	// {lw敪
			spouseIntendType  = cmIncomeTaxDto.getSpouseIntendType                 () ;	// zҋ敪
			generalDependent  = String.valueOf(cmIncomeTaxDto.getGeneralDependent ()) + " " + PayrollConst.NAM_COMMON_NAME;	// ʕ}{e
			specificDependent = String.valueOf(cmIncomeTaxDto.getSpecificDependent()) + " " + PayrollConst.NAM_COMMON_NAME;	// }{e
			elderlyDependent  = String.valueOf(cmIncomeTaxDto.getElderlyDependent ()) + " " + PayrollConst.NAM_COMMON_NAME;	// Vl}{e
			liveWithEldRel    = String.valueOf(cmIncomeTaxDto.getLiveWithEldRel   ()) + " " + PayrollConst.NAM_COMMON_NAME;	// Ve
			liveWithHandiGe   = String.valueOf(cmIncomeTaxDto.getLiveWithHandiGe  ()) + " " + PayrollConst.NAM_COMMON_NAME;	// 
			liveWithHandiSp   = String.valueOf(cmIncomeTaxDto.getLiveWithHandiSp  ()) + " " + PayrollConst.NAM_COMMON_NAME;	// 
			liveWithHandiEl   = String.valueOf(cmIncomeTaxDto.getLiveWithHandiEl  ()) + " " + PayrollConst.NAM_COMMON_NAME;	// Vl
			liveWithHandiEr   = String.valueOf(cmIncomeTaxDto.getLiveWithHandiEr  ()) + " " + PayrollConst.NAM_COMMON_NAME;	// Ve
			generalHandicap   = String.valueOf(cmIncomeTaxDto.getGeneralHandicap  ()) + " " + PayrollConst.NAM_COMMON_NAME;	// ʏQ
			specificHandicap  = String.valueOf(cmIncomeTaxDto.getSpecificHandicap ()) + " " + PayrollConst.NAM_COMMON_NAME;	// ʏQ
		} else {
			incomeTaxType     = "";// ېŋ敪
			adjustmentType    = "";// N敪
			selfWidowType     = "";// {lǕw敪
			selfHandicapType  = "";// {lQ敪
			selfStudentType   = "";// {lw敪
			spouseIntendType  = "";// zҋ敪
			generalDependent  = " " + PayrollConst.NAM_COMMON_NAME;// ʕ}{e
			specificDependent = " " + PayrollConst.NAM_COMMON_NAME;// }{e
			elderlyDependent  = " " + PayrollConst.NAM_COMMON_NAME;// Vl}{e
			liveWithEldRel    = " " + PayrollConst.NAM_COMMON_NAME;// Ve
			liveWithHandiGe   = " " + PayrollConst.NAM_COMMON_NAME;// 
			liveWithHandiSp   = " " + PayrollConst.NAM_COMMON_NAME;// 
			liveWithHandiEl   = " " + PayrollConst.NAM_COMMON_NAME;// Vl
			liveWithHandiEr   = " " + PayrollConst.NAM_COMMON_NAME;// Ve
			generalHandicap   = " " + PayrollConst.NAM_COMMON_NAME;// ʏQ
			specificHandicap  = " " + PayrollConst.NAM_COMMON_NAME;// ʏQ
			
		}
		




	}
	
	/**
	 * l񖼏̐ݒ
	 */
	private void setIndividualName() {
		titleStationCode          = PayrollConst.NAM_STATION_CODE      ;	// R[h
		titleGender               = PayrollConst.TNM_GENDER            ;	// 
		titleAddress              = PayrollConst.NAM_ADDRESS           ;	// Z
		titlePositionCode         = PayrollConst.NAM_OUT_POSITION      ;	// E
		titleBirthDate            = PayrollConst.NAM_BIRTH_DATE        ;	// N
		titleKCode                = PayrollConst.NAM_M_KIHON_KCODE     ;	// ЈR[h
		titleEntranceDate         = PayrollConst.NAM_ENTRANCE_DATE     ;	// Г
		titleKName                = PayrollConst.NAM_M_KIHON_SHIME		;	// Ј
		titleRetirementDate       = PayrollConst.NAM_RETIREMENT_DATE   ;	// ގГ
		titlePhoneNumber          = PayrollConst.NAM_PHONE_NUMBER      ;	// dbԍ
		titleHealthNo             = PayrollConst.NAM_HEALTH_NO         ;	// Nیԍ
		titleFundNo               = PayrollConst.NAM_FUND_NO           ;	// Nԍ
		titlePensionNo            = PayrollConst.NAM_PENSION_NO        ;	// Nԍ
		titleUnemployNo           = PayrollConst.NAM_UNEMPLOY_NO       ;	// ٗpیԍ

		
	}

	/**
	 * llݒ
	 * @param mKojinDto
	 * @param mKihonDto
	 * @param cmSocInsuranceDto
	 */
	private void setIndividualValue(MKojinDto mKojinDto, MKihonDto mKihonDto,CmSocInsuranceDto cmSocInsuranceDto) {
		stationCode          = mKihonDto.getSCode			                ();	// R[h
		positionCode         = mKihonDto.getYCode			                ();	// E
		kCode                = mKihonDto.getKCode                         ();	// ЈR[h
		entranceDate         = String.valueOf(mKihonDto.getNyDate());			// Г
		kName                = mKihonDto.getSimei                         ();	// Ј
		retirementDate       = String.valueOf(mKihonDto.getTsDate());			// ގГ
		if (mKojinDto != null) {
			gender               = mKojinDto.getSeibetu();	// 
			birthDate            = String.valueOf(mKojinDto.getSeinenbi());		// N
			phoneNumber          = mKojinDto.getTel                			();	// dbԍ
			postalCode           = PayrollConst.NAM_COMMON_POSTAL + mKojinDto.getYubinban();	// X֔ԍ
			address              = CalculateAction.getPrefecture(mKojinDto.getPrefectures()) + 
									mKojinDto.getJyuusyo1() + mKojinDto.getJyuusyo2() + mKojinDto.getJyuusyo3();	// Z
			
		}
		if (cmSocInsuranceDto != null) {
			healthNo             = cmSocInsuranceDto.getHealthNo               ();	// Nیԍ
			fundNo               = cmSocInsuranceDto.getFundNo                 ();	// Nԍ
			pensionNo            = cmSocInsuranceDto.getPensionNo              ();	// Nԍ
			unemployNo           = cmSocInsuranceDto.getUnemployNo             ();	// ٗpیԍ
			
		}
	}
	
	
	/**
	 * ̑lݒ
	 * @param cmCompanyDto
	 */
	private void setOtherValue(CmCompanyDto cmCompanyDto,CdAdjustmentDto cdAdjustmentDto) {
		if (cmCompanyDto != null) {
			companyName = cmCompanyDto.getCompanyName();
		}
		if (cdAdjustmentDto != null) {
			outputYear  = String.valueOf(cdAdjustmentDto.getAdjustYear());
		}
		
	}
	
	
	/**
	 * ^x̖אݒ擾B<br>
	 * @param mapDetail  אݒ
	 * @param detailCode אݒR[h
	 * @return
	 */
	private DetailPaDto getDetail_pa(
			Map<String, DetailPaDto> mapDetail, String detailCode
	) {
		if (mapDetail == null) {
			return null;
		}
		return mapDetail.get(detailCode);
	}

	/**
	 * ^T̖אݒ擾B<br>
	 * @param mapDetail  אݒ
	 * @param detailCode אݒR[h
	 * @return
	 */
	private DetailPdDto getDetail_Pd(
			Map<String, DetailPdDto> mapDetail, String detailCode
	) {
		if (mapDetail == null) {
			return null;
		}
		return mapDetail.get(detailCode);
	}
	
	/**
	 * ܗ^x̖אݒ擾B<br>
	 * @param listDetail_Ba  אݒ
	 * @param detailCode אݒR[h
	 * @return
	 */
	private PmDetailBaDto getDetail_Ba(
			Map<String, PmDetailBaDto> listDetail_Ba, String detailCode
	) {
		if (listDetail_Ba == null) {
			return null;
		}
		return listDetail_Ba.get(detailCode);
	}
	
	/**
	 * ܗ^T̖אݒ擾B<br>
	 * @param listDetail_Bd  אݒ
	 * @param detailCode אݒR[h
	 * @return
	 */
	private PmDetailBdDto getDetail_Bd(
			Map<String, PmDetailBdDto> listDetail_Bd, String detailCode
	) {
		if (listDetail_Bd == null) {
			return null;
		}
		return listDetail_Bd.get(detailCode);
	}

	
	
	/**
	 * ^x̖ז̂擾B<br>
	 * @param dto אݒ
	 * @param value  גl
	 * @return ז
	 */
	private String getDetailName_Pa(DetailPaDto dto) {
		// אݒ肪ꍇ
		if (dto == null) {
			return "";
		}
		return dto.getDetailName();
	}

	/**
	 * ^T̖ז̂擾B<br>
	 * @param dto אݒ
	 * @param value  גl
	 * @return ז
	 */
	private String getDetailName_Pd(DetailPdDto dto) {
		// אݒ肪ꍇ
		if (dto == null) {
			return "";
		}
		return dto.getDetailName();
	}

	/**
	 * ܗ^x̖ז̂擾B<br>
	 * @param dto אݒ
	 * @param value  גl
	 * @return ז
	 */
	private String getDetailName_Ba(PmDetailBaDto dto) {
		// אݒ肪ꍇ
		if (dto == null) {
			return "";
		}
		return dto.getDetailName();
	}

	/**
	 * ܗ^T̖ז̂擾B<br>
	 * @param dto אݒ
	 * @param value  גl
	 * @return ז
	 */
	private String getDetailName_Bd(PmDetailBdDto dto) {
		// אݒ肪ꍇ
		if (dto == null) {
			return "";
		}
		return dto.getDetailName();
	}

	
	// ANZT\bh
	
	
	public String  getTitlePayAllowance_01 () { return titlePayAllowance_01     ; }	// ^x01^Cg
	public String  getTitlePayAllowance_02 () { return titlePayAllowance_02     ; }	// ^x02^Cg
	public String  getTitlePayAllowance_03 () { return titlePayAllowance_03     ; }	// ^x03^Cg
	public String  getTitlePayAllowance_04 () { return titlePayAllowance_04     ; }	// ^x04^Cg
	public String  getTitlePayAllowance_05 () { return titlePayAllowance_05     ; }	// ^x05^Cg
	public String  getTitlePayAllowance_06 () { return titlePayAllowance_06     ; }	// ^x06^Cg
	public String  getTitlePayAllowance_07 () { return titlePayAllowance_07     ; }	// ^x07^Cg
	public String  getTitlePayAllowance_08 () { return titlePayAllowance_08     ; }	// ^x08^Cg
	public String  getTitlePayAllowance_09 () { return titlePayAllowance_09     ; }	// ^x09^Cg
	public String  getTitlePayAllowance_10 () { return titlePayAllowance_10     ; }	// ^x10^Cg
	public String  getTitlePayAllowance_11 () { return titlePayAllowance_11     ; }	// ^x11^Cg
	public String  getTitlePayAllowance_12 () { return titlePayAllowance_12     ; }	// ^x12^Cg
	public String  getTitlePayAllowance_13 () { return titlePayAllowance_13     ; }	// ^x13^Cg
	public String  getTitlePayAllowance_14 () { return titlePayAllowance_14     ; }	// ^x14^Cg
	public String  getTitlePayAllowance_15 () { return titlePayAllowance_15     ; }	// ^x15^Cg
	public String  getTitlePayAllowance_16 () { return titlePayAllowance_16     ; }	// ^x16^Cg
	public String  getTitlePayAllowance_17 () { return titlePayAllowance_17     ; }	// ^x17^Cg
	public String  getTitlePayAllowance_18 () { return titlePayAllowance_18     ; }	// ^x18^Cg
	public String  getTitlePayAllowance_19 () { return titlePayAllowance_19     ; }	// ^x19^Cg
	public String  getTitlePayAllowance_20 () { return titlePayAllowance_20     ; }	// ^x20^Cg
	public String  getTitlePayAllowance_21 () { return titlePayAllowance_21     ; }	// ^x21^Cg
	public String  getTitlePayAllowance_22 () { return titlePayAllowance_22     ; }	// ^x22^Cg
	public String  getTitlePayAllowance_23 () { return titlePayAllowance_23     ; }	// ^x23^Cg
	public String  getTitlePayAllowance_24 () { return titlePayAllowance_24     ; }	// ^x24^Cg
	public String  getTitlePayAllowance_25 () { return titlePayAllowance_25     ; }	// ^x25^Cg
	public String  getTitlePayAllowance_26 () { return titlePayAllowance_26     ; }	// ^x26^Cg
	public String  getTitlePayAllowance_27 () { return titlePayAllowance_27     ; }	// ^x27^Cg
	public String  getTitlePayAllowance_28 () { return titlePayAllowance_28     ; }	// ^x28^Cg
	public String  getTitlePayAllowance_29 () { return titlePayAllowance_29     ; }	// ^x29^Cg
	public String  getTitlePayAllowance_30 () { return titlePayAllowance_30     ; }	// ^x30^Cg
	
	public String  getTitlePayDeduction_01 () { return titlePayDeduction_01     ; }	// ^T01^Cg
	public String  getTitlePayDeduction_02 () { return titlePayDeduction_02     ; }	// ^T02^Cg
	public String  getTitlePayDeduction_03 () { return titlePayDeduction_03     ; }	// ^T03^Cg
	public String  getTitlePayDeduction_04 () { return titlePayDeduction_04     ; }	// ^T04^Cg
	public String  getTitlePayDeduction_05 () { return titlePayDeduction_05     ; }	// ^T05^Cg
	public String  getTitlePayDeduction_06 () { return titlePayDeduction_06     ; }	// ^T06^Cg
	public String  getTitlePayDeduction_07 () { return titlePayDeduction_07     ; }	// ^T07^Cg
	public String  getTitlePayDeduction_08 () { return titlePayDeduction_08     ; }	// ^T08^Cg
	public String  getTitlePayDeduction_09 () { return titlePayDeduction_09     ; }	// ^T09^Cg
	public String  getTitlePayDeduction_10 () { return titlePayDeduction_10     ; }	// ^T10^Cg
	public String  getTitlePayDeduction_11 () { return titlePayDeduction_11     ; }	// ^T11^Cg
	public String  getTitlePayDeduction_12 () { return titlePayDeduction_12     ; }	// ^T12^Cg
	public String  getTitlePayDeduction_13 () { return titlePayDeduction_13     ; }	// ^T13^Cg
	public String  getTitlePayDeduction_14 () { return titlePayDeduction_14     ; }	// ^T14^Cg
	public String  getTitlePayDeduction_15 () { return titlePayDeduction_15     ; }	// ^T15^Cg
	public String  getTitlePayDeduction_16 () { return titlePayDeduction_16     ; }	// ^T16^Cg
	public String  getTitlePayDeduction_17 () { return titlePayDeduction_17     ; }	// ^T17^Cg
	public String  getTitlePayDeduction_18 () { return titlePayDeduction_18     ; }	// ^T18^Cg
	public String  getTitlePayDeduction_19 () { return titlePayDeduction_19     ; }	// ^T19^Cg
	public String  getTitlePayDeduction_20 () { return titlePayDeduction_20     ; }	// ^T20^Cg
	public String  getTitlePayDeduction_21 () { return titlePayDeduction_21     ; }	// ^T21^Cg
	public String  getTitlePayDeduction_22 () { return titlePayDeduction_22     ; }	// ^T22^Cg
	public String  getTitlePayDeduction_23 () { return titlePayDeduction_23     ; }	// ^T23^Cg
	public String  getTitlePayDeduction_24 () { return titlePayDeduction_24     ; }	// ^T24^Cg
	public String  getTitlePayDeduction_25 () { return titlePayDeduction_25     ; }	// ^T25^Cg
	public String  getTitlePayDeduction_26 () { return titlePayDeduction_26     ; }	// ^T26^Cg
	public String  getTitlePayDeduction_27 () { return titlePayDeduction_27     ; }	// ^T27^Cg
	
	public String  getTitleAttendance_01 () { return titleAttendance_01     ; }	// ΑӍ01^Cg
	public String  getTitleAttendance_02 () { return titleAttendance_02     ; }	// ΑӍ02^Cg
	public String  getTitleAttendance_03 () { return titleAttendance_03     ; }	// ΑӍ03^Cg
	public String  getTitleAttendance_04 () { return titleAttendance_04     ; }	// ΑӍ04^Cg
	public String  getTitleAttendance_05 () { return titleAttendance_05     ; }	// ΑӍ05^Cg
	public String  getTitleAttendance_06 () { return titleAttendance_06     ; }	// ΑӍ06^Cg
	public String  getTitleAttendance_07 () { return titleAttendance_07     ; }	// ΑӍ07^Cg
	public String  getTitleAttendance_08 () { return titleAttendance_08     ; }	// ΑӍ08^Cg
	public String  getTitleAttendance_09 () { return titleAttendance_09     ; }	// ΑӍ09^Cg
	public String  getTitleAttendance_10 () { return titleAttendance_10     ; }	// ΑӍ10^Cg
	public String  getTitleAttendance_11 () { return titleAttendance_11     ; }	// ΑӍ11^Cg
	public String  getTitleAttendance_12 () { return titleAttendance_12     ; }	// ΑӍ12^Cg
	public String  getTitleAttendance_13 () { return titleAttendance_13     ; }	// ΑӍ13^Cg
	public String  getTitleAttendance_14 () { return titleAttendance_14     ; }	// ΑӍ14^Cg
	
	public String  getTitleBonAllowance_01 () { return titleBonAllowance_01     ; }	// ܗ^x01^Cg
	public String  getTitleBonAllowance_02 () { return titleBonAllowance_02     ; }	// ܗ^x02^Cg
	public String  getTitleBonAllowance_03 () { return titleBonAllowance_03     ; }	// ܗ^x03^Cg
	public String  getTitleBonAllowance_04 () { return titleBonAllowance_04     ; }	// ܗ^x04^Cg
	public String  getTitleBonAllowance_05 () { return titleBonAllowance_05     ; }	// ܗ^x05^Cg
	public String  getTitleBonAllowance_06 () { return titleBonAllowance_06     ; }	// ܗ^x06^Cg
	public String  getTitleBonAllowance_07 () { return titleBonAllowance_07     ; }	// ܗ^x07^Cg
	public String  getTitleBonAllowance_08 () { return titleBonAllowance_08     ; }	// ܗ^x08^Cg
	public String  getTitleBonAllowance_09 () { return titleBonAllowance_09     ; }	// ܗ^x09^Cg
	public String  getTitleBonAllowance_10 () { return titleBonAllowance_10     ; }	// ܗ^x10^Cg
	public String  getTitleBonDeduction_01 () { return titleBonDeduction_01     ; }	// ܗ^T01^Cg
	public String  getTitleBonDeduction_02 () { return titleBonDeduction_02     ; }	// ܗ^T02^Cg
	public String  getTitleBonDeduction_03 () { return titleBonDeduction_03     ; }	// ܗ^T03^Cg
	public String  getTitleBonDeduction_04 () { return titleBonDeduction_04     ; }	// ܗ^T04^Cg
	public String  getTitleBonDeduction_05 () { return titleBonDeduction_05     ; }	// ܗ^T05^Cg
	public String  getTitleBonDeduction_06 () { return titleBonDeduction_06     ; }	// ܗ^T06^Cg
	public String  getTitleBonDeduction_07 () { return titleBonDeduction_07     ; }	// ܗ^T07^Cg
	public String  getTitleBonDeduction_08 () { return titleBonDeduction_08     ; }	// ܗ^T08^Cg
	public String  getTitleBonDeduction_09 () { return titleBonDeduction_09     ; }	// ܗ^T09^Cg
	public String  getTitleBonDeduction_10 () { return titleBonDeduction_10     ; }	// ܗ^T10^Cg
	public String  getTitleBonDeduction_11 () { return titleBonDeduction_11     ; }	// ܗ^T11^Cg
	public String  getTitleBonDeduction_12 () { return titleBonDeduction_12     ; }	// ܗ^T12^Cg
	public String  getTitleBonDeduction_13 () { return titleBonDeduction_13     ; }	// ܗ^T13^Cg
	public String  getTitleBonDeduction_14 () { return titleBonDeduction_14     ; }	// ܗ^T14^Cg
	public String  getTitleBonDeduction_15 () { return titleBonDeduction_15     ; }	// ܗ^T15^Cg
	public String  getTitleBonDeduction_16 () { return titleBonDeduction_16     ; }	// ܗ^T16^Cg
	public String  getTitleBonDeduction_17 () { return titleBonDeduction_17     ; }	// ܗ^T17^Cg
	
	public String  getTitleIncomeTaxType    () { return titleIncomeTaxType        ; }	// ېŋ敪
	public String  getTitleAdjustmentType   () { return titleAdjustmentType       ; }	// N敪
	public String  getTitleSelfWidowType    () { return titleSelfWidowType        ; }	// {lǕw敪
	public String  getTitleSelfHandicapType () { return titleSelfHandicapType     ; }	// {lQ敪
	public String  getTitleSelfStudentType  () { return titleSelfStudentType      ; }	// {lw敪
	public String  getTitleSpouseIntendType () { return titleSpouseIntendType     ; }	// zҋ敪
	public String  getTitleGeneralDependent () { return titleGeneralDependent     ; }	// ʕ}{e
	public String  getTitleSpecificDependent() { return titleSpecificDependent    ; }	// }{e
	public String  getTitleElderlyDependent () { return titleElderlyDependent     ; }	// Vl}{e
	public String  getTitleLiveWithEldRel   () { return titleLiveWithEldRel       ; }	// Ve
	public String  getTitleLiveWithHandiGe  () { return titleLiveWithHandiGe      ; }	// 
	public String  getTitleLiveWithHandiSp  () { return titleLiveWithHandiSp      ; }	// 
	public String  getTitleLiveWithHandiEl  () { return titleLiveWithHandiEl      ; }	// Vl
	public String  getTitleLiveWithHandiEr  () { return titleLiveWithHandiEr      ; }	// Ve
	public String  getTitleGeneralHandicap  () { return titleGeneralHandicap      ; }	// ʏQ
	public String  getTitleSpecificHandicap () { return titleSpecificHandicap     ; }	// ʏQ
	public String  getTitleStationCode      () { return titleStationCode          ; }	// R[h
	public String  getTitleGender           () { return titleGender               ; }	// 
	public String  getTitleAddress          () { return titleAddress              ; }	// Z
	public String  getTitlePositionCode     () { return titlePositionCode         ; }	// E
	public String  getTitleBirthDate        () { return titleBirthDate            ; }	// N
	public String  getTitleKCode            () { return titleKCode                ; }	// ЈR[h
	public String  getTitleEntranceDate     () { return titleEntranceDate         ; }	// Г
	public String  getTitleKName            () { return titleKName                ; }	// Ј
	public String  getTitleRetirementDate   () { return titleRetirementDate       ; }	// ގГ
	public String  getTitlePhoneNumber      () { return titlePhoneNumber          ; }	// dbԍ
	public String  getTitleHealthNo         () { return titleHealthNo             ; }	// Nیԍ
	public String  getTitleFundNo           () { return titleFundNo               ; }	// Nԍ
	public String  getTitlePensionNo        () { return titlePensionNo            ; }	// Nԍ
	public String  getTitleUnemployNo       () { return titleUnemployNo           ; }	// ٗpیԍ
	
	public String  getTitlePayday           () { return titlePayday               ; } 	// x
	public String  getTitleAllowanceItem    () { return titleAllowanceItem        ; } 	// x
	public String  getTitleAllowanceTotal   () { return titleAllowanceTotal       ; } 	// xz
	public String  getTitleDeductionItem    () { return titleDeductionItem        ; } 	// x
	public String  getTitleDeductionTotal   () { return titleDeductionTotal       ; } 	// Tz
	public String  getTitlePaymentTotal     () { return titlePaymentTotal         ; } 	// xz
	public String  getTitleBank1PayAmount   () { return titleBank1PayAmount       ; } 	// s1Uz
	public String  getTitleBank2PayAmount   () { return titleBank2PayAmount       ; } 	// s2Uz
	public String  getTitleCashPayAmount    () { return titleCashPayAmount        ; } 	// xz


	public void setTitlePayAllowance_01(String titlePayAllowance_01) { this.titlePayAllowance_01 = titlePayAllowance_01 ; }	// ^x01^Cg
	public void setTitlePayAllowance_02(String titlePayAllowance_02) { this.titlePayAllowance_02 = titlePayAllowance_02 ; }	// ^x02^Cg
	public void setTitlePayAllowance_03(String titlePayAllowance_03) { this.titlePayAllowance_03 = titlePayAllowance_03 ; }	// ^x03^Cg
	public void setTitlePayAllowance_04(String titlePayAllowance_04) { this.titlePayAllowance_04 = titlePayAllowance_04 ; }	// ^x04^Cg
	public void setTitlePayAllowance_05(String titlePayAllowance_05) { this.titlePayAllowance_05 = titlePayAllowance_05 ; }	// ^x05^Cg
	public void setTitlePayAllowance_06(String titlePayAllowance_06) { this.titlePayAllowance_06 = titlePayAllowance_06 ; }	// ^x06^Cg
	public void setTitlePayAllowance_07(String titlePayAllowance_07) { this.titlePayAllowance_07 = titlePayAllowance_07 ; }	// ^x07^Cg
	public void setTitlePayAllowance_08(String titlePayAllowance_08) { this.titlePayAllowance_08 = titlePayAllowance_08 ; }	// ^x08^Cg
	public void setTitlePayAllowance_09(String titlePayAllowance_09) { this.titlePayAllowance_09 = titlePayAllowance_09 ; }	// ^x09^Cg
	public void setTitlePayAllowance_10(String titlePayAllowance_10) { this.titlePayAllowance_10 = titlePayAllowance_10 ; }	// ^x10^Cg
	public void setTitlePayAllowance_11(String titlePayAllowance_11) { this.titlePayAllowance_11 = titlePayAllowance_11 ; }	// ^x11^Cg
	public void setTitlePayAllowance_12(String titlePayAllowance_12) { this.titlePayAllowance_12 = titlePayAllowance_12 ; }	// ^x12^Cg
	public void setTitlePayAllowance_13(String titlePayAllowance_13) { this.titlePayAllowance_13 = titlePayAllowance_13 ; }	// ^x13^Cg
	public void setTitlePayAllowance_14(String titlePayAllowance_14) { this.titlePayAllowance_14 = titlePayAllowance_14 ; }	// ^x14^Cg
	public void setTitlePayAllowance_15(String titlePayAllowance_15) { this.titlePayAllowance_15 = titlePayAllowance_15 ; }	// ^x15^Cg
	public void setTitlePayAllowance_16(String titlePayAllowance_16) { this.titlePayAllowance_16 = titlePayAllowance_16 ; }	// ^x16^Cg
	public void setTitlePayAllowance_17(String titlePayAllowance_17) { this.titlePayAllowance_17 = titlePayAllowance_17 ; }	// ^x17^Cg
	public void setTitlePayAllowance_18(String titlePayAllowance_18) { this.titlePayAllowance_18 = titlePayAllowance_18 ; }	// ^x18^Cg
	public void setTitlePayAllowance_19(String titlePayAllowance_19) { this.titlePayAllowance_19 = titlePayAllowance_19 ; }	// ^x19^Cg
	public void setTitlePayAllowance_20(String titlePayAllowance_20) { this.titlePayAllowance_20 = titlePayAllowance_20 ; }	// ^x20^Cg
	public void setTitlePayAllowance_21(String titlePayAllowance_21) { this.titlePayAllowance_21 = titlePayAllowance_21 ; }	// ^x21^Cg
	public void setTitlePayAllowance_22(String titlePayAllowance_22) { this.titlePayAllowance_22 = titlePayAllowance_22 ; }	// ^x22^Cg
	public void setTitlePayAllowance_23(String titlePayAllowance_23) { this.titlePayAllowance_23 = titlePayAllowance_23 ; }	// ^x23^Cg
	public void setTitlePayAllowance_24(String titlePayAllowance_24) { this.titlePayAllowance_24 = titlePayAllowance_24 ; }	// ^x24^Cg
	public void setTitlePayAllowance_25(String titlePayAllowance_25) { this.titlePayAllowance_25 = titlePayAllowance_25 ; }	// ^x25^Cg
	public void setTitlePayAllowance_26(String titlePayAllowance_26) { this.titlePayAllowance_26 = titlePayAllowance_26 ; }	// ^x26^Cg
	public void setTitlePayAllowance_27(String titlePayAllowance_27) { this.titlePayAllowance_27 = titlePayAllowance_27 ; }	// ^x27^Cg
	public void setTitlePayAllowance_28(String titlePayAllowance_28) { this.titlePayAllowance_28 = titlePayAllowance_28 ; }	// ^x28^Cg
	public void setTitlePayAllowance_29(String titlePayAllowance_29) { this.titlePayAllowance_29 = titlePayAllowance_29 ; }	// ^x29^Cg
	public void setTitlePayAllowance_30(String titlePayAllowance_30) { this.titlePayAllowance_30 = titlePayAllowance_30 ; }	// ^x30^Cg

	public void setTitlePayDeduction_01(String titlePayDeduction_01) { this.titlePayDeduction_01 = titlePayDeduction_01 ; }	// ^T01^Cg
	public void setTitlePayDeduction_02(String titlePayDeduction_02) { this.titlePayDeduction_02 = titlePayDeduction_02 ; }	// ^T02^Cg
	public void setTitlePayDeduction_03(String titlePayDeduction_03) { this.titlePayDeduction_03 = titlePayDeduction_03 ; }	// ^T03^Cg
	public void setTitlePayDeduction_04(String titlePayDeduction_04) { this.titlePayDeduction_04 = titlePayDeduction_04 ; }	// ^T04^Cg
	public void setTitlePayDeduction_05(String titlePayDeduction_05) { this.titlePayDeduction_05 = titlePayDeduction_05 ; }	// ^T05^Cg
	public void setTitlePayDeduction_06(String titlePayDeduction_06) { this.titlePayDeduction_06 = titlePayDeduction_06 ; }	// ^T06^Cg
	public void setTitlePayDeduction_07(String titlePayDeduction_07) { this.titlePayDeduction_07 = titlePayDeduction_07 ; }	// ^T07^Cg
	public void setTitlePayDeduction_08(String titlePayDeduction_08) { this.titlePayDeduction_08 = titlePayDeduction_08 ; }	// ^T08^Cg
	public void setTitlePayDeduction_09(String titlePayDeduction_09) { this.titlePayDeduction_09 = titlePayDeduction_09 ; }	// ^T09^Cg
	public void setTitlePayDeduction_10(String titlePayDeduction_10) { this.titlePayDeduction_10 = titlePayDeduction_10 ; }	// ^T10^Cg
	public void setTitlePayDeduction_11(String titlePayDeduction_11) { this.titlePayDeduction_11 = titlePayDeduction_11 ; }	// ^T11^Cg
	public void setTitlePayDeduction_12(String titlePayDeduction_12) { this.titlePayDeduction_12 = titlePayDeduction_12 ; }	// ^T12^Cg
	public void setTitlePayDeduction_13(String titlePayDeduction_13) { this.titlePayDeduction_13 = titlePayDeduction_13 ; }	// ^T13^Cg
	public void setTitlePayDeduction_14(String titlePayDeduction_14) { this.titlePayDeduction_14 = titlePayDeduction_14 ; }	// ^T14^Cg
	public void setTitlePayDeduction_15(String titlePayDeduction_15) { this.titlePayDeduction_15 = titlePayDeduction_15 ; }	// ^T15^Cg
	public void setTitlePayDeduction_16(String titlePayDeduction_16) { this.titlePayDeduction_16 = titlePayDeduction_16 ; }	// ^T16^Cg
	public void setTitlePayDeduction_17(String titlePayDeduction_17) { this.titlePayDeduction_17 = titlePayDeduction_17 ; }	// ^T17^Cg
	public void setTitlePayDeduction_18(String titlePayDeduction_18) { this.titlePayDeduction_18 = titlePayDeduction_18 ; }	// ^T18^Cg
	public void setTitlePayDeduction_19(String titlePayDeduction_19) { this.titlePayDeduction_19 = titlePayDeduction_19 ; }	// ^T19^Cg
	public void setTitlePayDeduction_20(String titlePayDeduction_20) { this.titlePayDeduction_20 = titlePayDeduction_20 ; }	// ^T20^Cg
	public void setTitlePayDeduction_21(String titlePayDeduction_21) { this.titlePayDeduction_21 = titlePayDeduction_21 ; }	// ^T21^Cg
	public void setTitlePayDeduction_22(String titlePayDeduction_22) { this.titlePayDeduction_22 = titlePayDeduction_22 ; }	// ^T22^Cg
	public void setTitlePayDeduction_23(String titlePayDeduction_23) { this.titlePayDeduction_23 = titlePayDeduction_23 ; }	// ^T23^Cg
	public void setTitlePayDeduction_24(String titlePayDeduction_24) { this.titlePayDeduction_24 = titlePayDeduction_24 ; }	// ^T24^Cg
	public void setTitlePayDeduction_25(String titlePayDeduction_25) { this.titlePayDeduction_25 = titlePayDeduction_25 ; }	// ^T25^Cg
	public void setTitlePayDeduction_26(String titlePayDeduction_26) { this.titlePayDeduction_26 = titlePayDeduction_26 ; }	// ^T26^Cg
	public void setTitlePayDeduction_27(String titlePayDeduction_27) { this.titlePayDeduction_27 = titlePayDeduction_27 ; }	// ^T27^Cg
	
	public void setTitleAttendance_01  (String titleAttendance_01  ) { this.titleAttendance_01 = titleAttendance_01 ; }	// ΑӍ01^Cg
	public void setTitleAttendance_02  (String titleAttendance_02  ) { this.titleAttendance_02 = titleAttendance_02 ; }	// ΑӍ02^Cg
	public void setTitleAttendance_03  (String titleAttendance_03  ) { this.titleAttendance_03 = titleAttendance_03 ; }	// ΑӍ03^Cg
	public void setTitleAttendance_04  (String titleAttendance_04  ) { this.titleAttendance_04 = titleAttendance_04 ; }	// ΑӍ04^Cg
	public void setTitleAttendance_05  (String titleAttendance_05  ) { this.titleAttendance_05 = titleAttendance_05 ; }	// ΑӍ05^Cg
	public void setTitleAttendance_06  (String titleAttendance_06  ) { this.titleAttendance_06 = titleAttendance_06 ; }	// ΑӍ06^Cg
	public void setTitleAttendance_07  (String titleAttendance_07  ) { this.titleAttendance_07 = titleAttendance_07 ; }	// ΑӍ07^Cg
	public void setTitleAttendance_08  (String titleAttendance_08  ) { this.titleAttendance_08 = titleAttendance_08 ; }	// ΑӍ08^Cg
	public void setTitleAttendance_09  (String titleAttendance_09  ) { this.titleAttendance_09 = titleAttendance_09 ; }	// ΑӍ09^Cg
	public void setTitleAttendance_10  (String titleAttendance_10  ) { this.titleAttendance_10 = titleAttendance_10 ; }	// ΑӍ10^Cg
	
	public void setTitleAttendance_11  (String titleAttendance_11) { this.titleAttendance_11 = titleAttendance_11 ; }	// ΑӍ11^Cg
	public void setTitleAttendance_12  (String titleAttendance_12) { this.titleAttendance_12 = titleAttendance_12 ; }	// ΑӍ12^Cg
	public void setTitleAttendance_13  (String titleAttendance_13) { this.titleAttendance_13 = titleAttendance_13 ; }	// ΑӍ13^Cg
	public void setTitleAttendance_14  (String titleAttendance_14) { this.titleAttendance_14 = titleAttendance_14 ; }	// ΑӍ14^Cg
	
	public void setTitleBonAllowance_01(String titleBonAllowance_01) { this.titleBonAllowance_01 = titleBonAllowance_01 ; }	// ܗ^x01^Cg
	public void setTitleBonAllowance_02(String titleBonAllowance_02) { this.titleBonAllowance_02 = titleBonAllowance_02 ; }	// ܗ^x02^Cg
	public void setTitleBonAllowance_03(String titleBonAllowance_03) { this.titleBonAllowance_03 = titleBonAllowance_03 ; }	// ܗ^x03^Cg
	public void setTitleBonAllowance_04(String titleBonAllowance_04) { this.titleBonAllowance_04 = titleBonAllowance_04 ; }	// ܗ^x04^Cg
	public void setTitleBonAllowance_05(String titleBonAllowance_05) { this.titleBonAllowance_05 = titleBonAllowance_05 ; }	// ܗ^x05^Cg
	public void setTitleBonAllowance_06(String titleBonAllowance_06) { this.titleBonAllowance_06 = titleBonAllowance_06 ; }	// ܗ^x06^Cg
	public void setTitleBonAllowance_07(String titleBonAllowance_07) { this.titleBonAllowance_07 = titleBonAllowance_07 ; }	// ܗ^x07^Cg
	public void setTitleBonAllowance_08(String titleBonAllowance_08) { this.titleBonAllowance_08 = titleBonAllowance_08 ; }	// ܗ^x08^Cg
	public void setTitleBonAllowance_09(String titleBonAllowance_09) { this.titleBonAllowance_09 = titleBonAllowance_09 ; }	// ܗ^x09^Cg
	public void setTitleBonAllowance_10(String titleBonAllowance_10) { this.titleBonAllowance_10 = titleBonAllowance_10 ; }	// ܗ^x10^Cg
	
	public void setTitleBonDeduction_01(String titleBonDeduction_01) { this.titleBonDeduction_01 = titleBonDeduction_01 ; }	// ܗ^T01^Cg
	public void setTitleBonDeduction_02(String titleBonDeduction_02) { this.titleBonDeduction_02 = titleBonDeduction_02 ; }	// ܗ^T02^Cg
	public void setTitleBonDeduction_03(String titleBonDeduction_03) { this.titleBonDeduction_03 = titleBonDeduction_03 ; }	// ܗ^T03^Cg
	public void setTitleBonDeduction_04(String titleBonDeduction_04) { this.titleBonDeduction_04 = titleBonDeduction_04 ; }	// ܗ^T04^Cg
	public void setTitleBonDeduction_05(String titleBonDeduction_05) { this.titleBonDeduction_05 = titleBonDeduction_05 ; }	// ܗ^T05^Cg
	public void setTitleBonDeduction_06(String titleBonDeduction_06) { this.titleBonDeduction_06 = titleBonDeduction_06 ; }	// ܗ^T06^Cg
	public void setTitleBonDeduction_07(String titleBonDeduction_07) { this.titleBonDeduction_07 = titleBonDeduction_07 ; }	// ܗ^T07^Cg
	public void setTitleBonDeduction_08(String titleBonDeduction_08) { this.titleBonDeduction_08 = titleBonDeduction_08 ; }	// ܗ^T08^Cg
	public void setTitleBonDeduction_09(String titleBonDeduction_09) { this.titleBonDeduction_09 = titleBonDeduction_09 ; }	// ܗ^T09^Cg
	public void setTitleBonDeduction_10(String titleBonDeduction_10) { this.titleBonDeduction_10 = titleBonDeduction_10 ; }	// ܗ^T10^Cg
	public void setTitleBonDeduction_11(String titleBonDeduction_11) { this.titleBonDeduction_11 = titleBonDeduction_11 ; }	// ܗ^T11^Cg
	public void setTitleBonDeduction_12(String titleBonDeduction_12) { this.titleBonDeduction_12 = titleBonDeduction_12 ; }	// ܗ^T12^Cg
	public void setTitleBonDeduction_13(String titleBonDeduction_13) { this.titleBonDeduction_13 = titleBonDeduction_13 ; }	// ܗ^T13^Cg
	public void setTitleBonDeduction_14(String titleBonDeduction_14) { this.titleBonDeduction_14 = titleBonDeduction_14 ; }	// ܗ^T14^Cg
	public void setTitleBonDeduction_15(String titleBonDeduction_15) { this.titleBonDeduction_15 = titleBonDeduction_15 ; }	// ܗ^T15^Cg
	public void setTitleBonDeduction_16(String titleBonDeduction_16) { this.titleBonDeduction_16 = titleBonDeduction_16 ; }	// ܗ^T16^Cg
	public void setTitleBonDeduction_17(String titleBonDeduction_17) { this.titleBonDeduction_17 = titleBonDeduction_17 ; }	// ܗ^T17^Cg
	
	public void setTitleIncomeTaxType   (String titleIncomeTaxType   ) { this.titleIncomeTaxType    = titleIncomeTaxType    ; }	// ېŋ敪
	public void setTitleAdjustmentType  (String titleAdjustmentType  ) { this.titleAdjustmentType   = titleAdjustmentType   ; }	// N敪
	public void setTitleSelfWidowType   (String titleSelfWidowType   ) { this.titleSelfWidowType    = titleSelfWidowType    ; }	// {lǕw敪
	public void setTitleSelfHandicapType(String titleSelfHandicapType) { this.titleSelfHandicapType = titleSelfHandicapType ; }	// {lQ敪
	public void setTitleSelfStudentType (String titleSelfStudentType ) { this.titleSelfStudentType  = titleSelfStudentType  ; }	// {lw敪
	public void setTitleSpouseIntendType(String titleSpouseIntendType) { this.titleSpouseIntendType = titleSpouseIntendType ; }	// zҋ敪
	public void setTitleGeneralDependent(String titleGeneralDependent) { this.titleGeneralDependent = titleGeneralDependent ; }	// ʕ}{e
	public void setTitleSpecificDependent(String titleSpecificDependent) { this.titleSpecificDependent = titleSpecificDependent; }	// }{e
	public void setTitleElderlyDependent(String titleElderlyDependent) { this.titleElderlyDependent = titleElderlyDependent ; }	// Vl}{e
	public void setTitleLiveWithEldRel  (String titleLiveWithEldRel  ) { this.titleLiveWithEldRel   = titleLiveWithEldRel   ; }	// Ve
	public void setTitleLiveWithHandiGe (String titleLiveWithHandiGe ) { this.titleLiveWithHandiGe  = titleLiveWithHandiGe  ; }	// 
	public void setTitleLiveWithHandiSp (String titleLiveWithHandiSp ) { this.titleLiveWithHandiSp  = titleLiveWithHandiSp  ; }	// 
	public void setTitleLiveWithHandiEl (String titleLiveWithHandiEl ) { this.titleLiveWithHandiEl  = titleLiveWithHandiEl  ; }	// Vl
	public void setTitleLiveWithHandiEr (String titleLiveWithHandiEr ) { this.titleLiveWithHandiEr  = titleLiveWithHandiEr  ; }	// Ve
	public void setTitleGeneralHandicap (String titleGeneralHandicap ) { this.titleGeneralHandicap  = titleGeneralHandicap  ; }	// ʏQ
	public void setTitleSpecificHandicap(String titleSpecificHandicap) { this.titleSpecificHandicap = titleSpecificHandicap ; }	// ʏQ
	public void setTitleStationCode     (String titleStationCode     ) { this.titleStationCode      = titleStationCode      ; }	// R[h
	public void setTitleGender          (String titleGender          ) { this.titleGender           = titleGender           ; }	// 
	public void setTitleAddress         (String titleAddress         ) { this.titleAddress          = titleAddress          ; }	// Z
	public void setTitlePositionCode    (String titlePositionCode    ) { this.titlePositionCode     = titlePositionCode     ; }	// E
	public void setTitleBirthDate       (String titleBirthDate       ) { this.titleBirthDate        = titleBirthDate        ; }	// N
	public void setTitleKCode           (String titleKCode           ) { this.titleKCode            = titleKCode            ; }	// ЈR[h
	public void setTitleEntranceDate    (String titleEntranceDate    ) { this.titleEntranceDate     = titleEntranceDate     ; }	// Г
	public void setTitleKName           (String titleKName           ) { this.titleKName            = titleKName            ; }	// Ј
	public void setTitleRetirementDate  (String titleRetirementDate  ) { this.titleRetirementDate   = titleRetirementDate   ; }	// ގГ
	public void setTitlePhoneNumber     (String titlePhoneNumber     ) { this.titlePhoneNumber      = titlePhoneNumber      ; }	// dbԍ
	public void setTitleHealthNo        (String titleHealthNo        ) { this.titleHealthNo         = titleHealthNo         ; }	// Nیԍ
	public void setTitleFundNo          (String titleFundNo          ) { this.titleFundNo           = titleFundNo           ; }	// Nԍ
	public void setTitlePensionNo       (String titlePensionNo       ) { this.titlePensionNo        = titlePensionNo        ; }	// Nԍ
	public void setTitleUnemployNo      (String titleUnemployNo      ) { this.titleUnemployNo       = titleUnemployNo       ; }	// ٗpیԍ
	
	public void setTitlePayday        (String titlePayday        ) { this.titlePayday         =  titlePayday        ; } 	// x
	public void setTitleAllowanceItem (String titleAllowanceItem ) { this.titleAllowanceItem  =  titleAllowanceItem ; } 	// x
	public void setTitleAllowanceTotal(String titleAllowanceTotal) { this.titleAllowanceTotal =  titleAllowanceTotal; } 	// xz
	public void setTitleDeductionItem (String titleDeductionItem ) { this.titleDeductionItem  =  titleDeductionItem ; } 	// x
	public void setTitleDeductionTotal(String titleDeductionTotal) { this.titleDeductionTotal =  titleDeductionTotal; } 	// Tz
	public void setTitlePaymentTotal  (String titlePaymentTotal  ) { this.titlePaymentTotal   =  titlePaymentTotal  ; } 	// xz
	public void setTitleBank1PayAmount(String titleBank1PayAmount) { this.titleBank1PayAmount =  titleBank1PayAmount; } 	// s1Uz
	public void setTitleBank2PayAmount(String titleBank2PayAmount) { this.titleBank2PayAmount =  titleBank2PayAmount; } 	// s2Uz
	public void setTitleCashPayAmount (String titleCashPayAmount ) { this.titleCashPayAmount  =  titleCashPayAmount ; } 	// xz
	

	public String getCompanyName       () { return companyName           ; } 	// Ж
	public String getOutputYear        () { return outputYear            ; } 	// 䒠o͔N(a)
	public String getOutputDate        () { return outputDate            ; } 	// o͓


	
	public String  getPayPayday_01        () { return payPayday_01            ; }// ^x_01
	public String  getPayPayday_02        () { return payPayday_02            ; }// ^x_02
	public String  getPayPayday_03        () { return payPayday_03            ; }// ^x_03
	public String  getPayPayday_04        () { return payPayday_04            ; }// ^x_04
	public String  getPayPayday_05        () { return payPayday_05            ; }// ^x_05
	public String  getPayPayday_06        () { return payPayday_06            ; }// ^x_06
	public String  getPayPayday_07        () { return payPayday_07            ; }// ^x_07
	public String  getPayPayday_08        () { return payPayday_08            ; }// ^x_08
	public String  getPayPayday_09        () { return payPayday_09            ; }// ^x_09
	public String  getPayPayday_10        () { return payPayday_10            ; }// ^x_10
	public String  getPayPayday_11        () { return payPayday_11            ; }// ^x_11
	public String  getPayPayday_12        () { return payPayday_12            ; }// ^x_12
	public String  getBonPayday_01        () { return bonPayday_01            ; }// ܗ^x_01
	public String  getBonPayday_02        () { return bonPayday_02            ; }// ܗ^x_02
	public String  getBonPayday_03        () { return bonPayday_03            ; }// ܗ^x_03
	public String  getBonPayday_04        () { return bonPayday_04            ; }// ܗ^x_04
	public String  getBonPayday_05        () { return bonPayday_05            ; }// ܗ^x_05
	public String  getBonPayday_06        () { return bonPayday_06            ; }// ܗ^x_06


	public Integer  getPayAllowanceTotal_01() { return payAllowanceTotal_01    ; }// ^xz_01
	public Integer  getPayDeductionTotal_01() { return payDeductionTotal_01    ; }// ^Tz_01
	public Integer  getPayPaymentTotal_01  () { return payPaymentTotal_01      ; }// ^xz_01
	public Integer  getPayBank1PayAmount_01() { return payBank1PayAmount_01    ; }// ^s1Uz_01
	public Integer  getPayBank2PayAmount_01() { return payBank2PayAmount_01    ; }// ^s2Uz_01
	public Integer  getPayCashPayAmount_01 () { return payCashPayAmount_01     ; }// ^xz_01
	public Integer  getPayAllowanceTotal_02() { return payAllowanceTotal_02    ; }// ^xz_02
	public Integer  getPayDeductionTotal_02() { return payDeductionTotal_02    ; }// ^Tz_02
	public Integer  getPayPaymentTotal_02  () { return payPaymentTotal_02      ; }// ^xz_02
	public Integer  getPayBank1PayAmount_02() { return payBank1PayAmount_02    ; }// ^s1Uz_02
	public Integer  getPayBank2PayAmount_02() { return payBank2PayAmount_02    ; }// ^s2Uz_02
	public Integer  getPayCashPayAmount_02 () { return payCashPayAmount_02     ; }// ^xz_02
	public Integer  getPayAllowanceTotal_03() { return payAllowanceTotal_03    ; }// ^xz_03
	public Integer  getPayDeductionTotal_03() { return payDeductionTotal_03    ; }// ^Tz_03
	public Integer  getPayPaymentTotal_03  () { return payPaymentTotal_03      ; }// ^xz_03
	public Integer  getPayBank1PayAmount_03() { return payBank1PayAmount_03    ; }// ^s1Uz_03
	public Integer  getPayBank2PayAmount_03() { return payBank2PayAmount_03    ; }// ^s2Uz_03
	public Integer  getPayCashPayAmount_03 () { return payCashPayAmount_03     ; }// ^xz_03
	public Integer  getPayAllowanceTotal_04() { return payAllowanceTotal_04    ; }// ^xz_04
	public Integer  getPayDeductionTotal_04() { return payDeductionTotal_04    ; }// ^Tz_04
	public Integer  getPayPaymentTotal_04  () { return payPaymentTotal_04      ; }// ^xz_04
	public Integer  getPayBank1PayAmount_04() { return payBank1PayAmount_04    ; }// ^s1Uz_04
	public Integer  getPayBank2PayAmount_04() { return payBank2PayAmount_04    ; }// ^s2Uz_04
	public Integer  getPayCashPayAmount_04 () { return payCashPayAmount_04     ; }// ^xz_04
	public Integer  getPayAllowanceTotal_05() { return payAllowanceTotal_05    ; }// ^xz_05
	public Integer  getPayDeductionTotal_05() { return payDeductionTotal_05    ; }// ^Tz_05
	public Integer  getPayPaymentTotal_05  () { return payPaymentTotal_05      ; }// ^xz_05
	public Integer  getPayBank1PayAmount_05() { return payBank1PayAmount_05    ; }// ^s1Uz_05
	public Integer  getPayBank2PayAmount_05() { return payBank2PayAmount_05    ; }// ^s2Uz_05
	public Integer  getPayCashPayAmount_05 () { return payCashPayAmount_05     ; }// ^xz_05
	public Integer  getPayAllowanceTotal_06() { return payAllowanceTotal_06    ; }// ^xz_06
	public Integer  getPayDeductionTotal_06() { return payDeductionTotal_06    ; }// ^Tz_06
	public Integer  getPayPaymentTotal_06  () { return payPaymentTotal_06      ; }// ^xz_06
	public Integer  getPayBank1PayAmount_06() { return payBank1PayAmount_06    ; }// ^s1Uz_06
	public Integer  getPayBank2PayAmount_06() { return payBank2PayAmount_06    ; }// ^s2Uz_06
	public Integer  getPayCashPayAmount_06 () { return payCashPayAmount_06     ; }// ^xz_06
	public Integer  getPayAllowanceTotal_07() { return payAllowanceTotal_07    ; }// ^xz_07
	public Integer  getPayDeductionTotal_07() { return payDeductionTotal_07    ; }// ^Tz_07
	public Integer  getPayPaymentTotal_07  () { return payPaymentTotal_07      ; }// ^xz_07
	public Integer  getPayBank1PayAmount_07() { return payBank1PayAmount_07    ; }// ^s1Uz_07
	public Integer  getPayBank2PayAmount_07() { return payBank2PayAmount_07    ; }// ^s2Uz_07
	public Integer  getPayCashPayAmount_07 () { return payCashPayAmount_07     ; }// ^xz_07
	public Integer  getPayAllowanceTotal_08() { return payAllowanceTotal_08    ; }// ^xz_08
	public Integer  getPayDeductionTotal_08() { return payDeductionTotal_08    ; }// ^Tz_08
	public Integer  getPayPaymentTotal_08  () { return payPaymentTotal_08      ; }// ^xz_08
	public Integer  getPayBank1PayAmount_08() { return payBank1PayAmount_08    ; }// ^s1Uz_08
	public Integer  getPayBank2PayAmount_08() { return payBank2PayAmount_08    ; }// ^s2Uz_08
	public Integer  getPayCashPayAmount_08 () { return payCashPayAmount_08     ; }// ^xz_08
	public Integer  getPayAllowanceTotal_09() { return payAllowanceTotal_09    ; }// ^xz_09
	public Integer  getPayDeductionTotal_09() { return payDeductionTotal_09    ; }// ^Tz_09
	public Integer  getPayPaymentTotal_09  () { return payPaymentTotal_09      ; }// ^xz_09
	public Integer  getPayBank1PayAmount_09() { return payBank1PayAmount_09    ; }// ^s1Uz_09
	public Integer  getPayBank2PayAmount_09() { return payBank2PayAmount_09    ; }// ^s2Uz_09
	public Integer  getPayCashPayAmount_09 () { return payCashPayAmount_09     ; }// ^xz_09
	public Integer  getPayAllowanceTotal_10() { return payAllowanceTotal_10    ; }// ^xz_10
	public Integer  getPayDeductionTotal_10() { return payDeductionTotal_10    ; }// ^Tz_10
	public Integer  getPayPaymentTotal_10  () { return payPaymentTotal_10      ; }// ^xz_10
	public Integer  getPayBank1PayAmount_10() { return payBank1PayAmount_10    ; }// ^s1Uz_10
	public Integer  getPayBank2PayAmount_10() { return payBank2PayAmount_10    ; }// ^s2Uz_10
	public Integer  getPayCashPayAmount_10 () { return payCashPayAmount_10     ; }// ^xz_10
	public Integer  getPayAllowanceTotal_11() { return payAllowanceTotal_11    ; }// ^xz_11
	public Integer  getPayDeductionTotal_11() { return payDeductionTotal_11    ; }// ^Tz_11
	public Integer  getPayPaymentTotal_11  () { return payPaymentTotal_11      ; }// ^xz_11
	public Integer  getPayBank1PayAmount_11() { return payBank1PayAmount_11    ; }// ^s1Uz_11
	public Integer  getPayBank2PayAmount_11() { return payBank2PayAmount_11    ; }// ^s2Uz_11
	public Integer  getPayCashPayAmount_11 () { return payCashPayAmount_11     ; }// ^xz_11
	public Integer  getPayAllowanceTotal_12() { return payAllowanceTotal_12    ; }// ^xz_12
	public Integer  getPayDeductionTotal_12() { return payDeductionTotal_12    ; }// ^Tz_12
	public Integer  getPayPaymentTotal_12  () { return payPaymentTotal_12      ; }// ^xz_12
	public Integer  getPayBank1PayAmount_12() { return payBank1PayAmount_12    ; }// ^s1Uz_12
	public Integer  getPayBank2PayAmount_12() { return payBank2PayAmount_12    ; }// ^s2Uz_12
	public Integer  getPayCashPayAmount_12 () { return payCashPayAmount_12     ; }// ^xz_12
	public Integer  getBonAllowanceTotal_01() { return bonAllowanceTotal_01    ; }// ܗ^xz_01
	public Integer  getBonDeductionTotal_01() { return bonDeductionTotal_01    ; }// ܗ^Tz_01
	public Integer  getBonPaymentTotal_01  () { return bonPaymentTotal_01      ; }// ܗ^xz_01
	public Integer  getBonBank1PayAmount_01() { return bonBank1PayAmount_01    ; }// ܗ^s1Uz_01
	public Integer  getBonBank2PayAmount_01() { return bonBank2PayAmount_01    ; }// ܗ^s2Uz_01
	public Integer  getBonCashPayAmount_01 () { return bonCashPayAmount_01     ; }// ܗ^xz_01
	public Integer  getBonAllowanceTotal_02() { return bonAllowanceTotal_02    ; }// ܗ^xz_02
	public Integer  getBonDeductionTotal_02() { return bonDeductionTotal_02    ; }// ܗ^Tz_02
	public Integer  getBonPaymentTotal_02  () { return bonPaymentTotal_02      ; }// ܗ^xz_02
	public Integer  getBonBank1PayAmount_02() { return bonBank1PayAmount_02    ; }// ܗ^s1Uz_02
	public Integer  getBonBank2PayAmount_02() { return bonBank2PayAmount_02    ; }// ܗ^s2Uz_02
	public Integer  getBonCashPayAmount_02 () { return bonCashPayAmount_02     ; }// ܗ^xz_02
	public Integer  getBonAllowanceTotal_03() { return bonAllowanceTotal_03    ; }// ܗ^xz_03
	public Integer  getBonDeductionTotal_03() { return bonDeductionTotal_03    ; }// ܗ^Tz_03
	public Integer  getBonPaymentTotal_03  () { return bonPaymentTotal_03      ; }// ܗ^xz_03
	public Integer  getBonBank1PayAmount_03() { return bonBank1PayAmount_03    ; }// ܗ^s1Uz_03
	public Integer  getBonBank2PayAmount_03() { return bonBank2PayAmount_03    ; }// ܗ^s2Uz_03
	public Integer  getBonCashPayAmount_03 () { return bonCashPayAmount_03     ; }// ܗ^xz_03
	public Integer  getBonAllowanceTotal_04() { return bonAllowanceTotal_04    ; }// ܗ^xz_04
	public Integer  getBonDeductionTotal_04() { return bonDeductionTotal_04    ; }// ܗ^Tz_04
	public Integer  getBonPaymentTotal_04  () { return bonPaymentTotal_04      ; }// ܗ^xz_04
	public Integer  getBonBank1PayAmount_04() { return bonBank1PayAmount_04    ; }// ܗ^s1Uz_04
	public Integer  getBonBank2PayAmount_04() { return bonBank2PayAmount_04    ; }// ܗ^s2Uz_04
	public Integer  getBonCashPayAmount_04 () { return bonCashPayAmount_04     ; }// ܗ^xz_04
	
	public Integer  getBonAllowanceTotal_05() { return bonAllowanceTotal_05    ; }// ܗ^xz_05
	public Integer  getBonDeductionTotal_05() { return bonDeductionTotal_05    ; }// ܗ^Tz_05
	public Integer  getBonPaymentTotal_05  () { return bonPaymentTotal_05      ; }// ܗ^xz_05
	public Integer  getBonBank1PayAmount_05() { return bonBank1PayAmount_05    ; }// ܗ^s1Uz_05
	public Integer  getBonBank2PayAmount_05() { return bonBank2PayAmount_05    ; }// ܗ^s2Uz_05
	public Integer  getBonCashPayAmount_05 () { return bonCashPayAmount_05     ; }// ܗ^xz_05

	public Integer  getBonAllowanceTotal_06() { return bonAllowanceTotal_06    ; }// ܗ^xz_06
	public Integer  getBonDeductionTotal_06() { return bonDeductionTotal_06    ; }// ܗ^Tz_06
	public Integer  getBonPaymentTotal_06  () { return bonPaymentTotal_06      ; }// ܗ^xz_06
	public Integer  getBonBank1PayAmount_06() { return bonBank1PayAmount_06    ; }// ܗ^s1Uz_06
	public Integer  getBonBank2PayAmount_06() { return bonBank2PayAmount_06    ; }// ܗ^s2Uz_06
	public Integer  getBonCashPayAmount_06 () { return bonCashPayAmount_06     ; }// ܗ^xz_06


	public Integer  getPayTotalAllowanceTotal () { return payTotalAllowanceTotal     ; }	// ^xz(v)
	public Integer  getPayTotalDeductionTotal () { return payTotalDeductionTotal     ; }	// ^Tz(v)
	public Integer  getPayTotalPaymentTotal   () { return payTotalPaymentTotal       ; }	// ^xz(v)
	public Integer  getPayTotalBank1PayAmount () { return payTotalBank1PayAmount     ; }	// ^s1Uz(v)
	public Integer  getPayTotalBank2PayAmount () { return payTotalBank2PayAmount     ; }	// ^s2Uz(v)
	public Integer  getPayTotalCashPayAmount  () { return payTotalCashPayAmount      ; }	// ^xz(v)
                                                                                
	public Integer  getBonTotalAllowanceTotal () { return bonTotalAllowanceTotal     ; }	// ܗ^xz(v)
	public Integer  getBonTotalDeductionTotal () { return bonTotalDeductionTotal     ; }	// ܗ^Tz(v)
	public Integer  getBonTotalPaymentTotal   () { return bonTotalPaymentTotal       ; }	// ܗ^xz(v)
	public Integer  getBonTotalBank1PayAmount () { return bonTotalBank1PayAmount     ; }	// ܗ^s1Uz(v)
	public Integer  getBonTotalBank2PayAmount () { return bonTotalBank2PayAmount     ; }	// ܗ^s2Uz(v)
	public Integer  getBonTotalCashPayAmount  () { return bonTotalCashPayAmount      ; }	// ܗ^xz(v)



	
	public Integer getPayTotalAllowance_01() { return payTotalAllowance_01    ; } 	// ^x01(v)
	public Integer getPayTotalAllowance_02() { return payTotalAllowance_02    ; } 	// ^x02(v)
	public Integer getPayTotalAllowance_03() { return payTotalAllowance_03    ; } 	// ^x03(v)
	public Integer getPayTotalAllowance_04() { return payTotalAllowance_04    ; } 	// ^x04(v)
	public Integer getPayTotalAllowance_05() { return payTotalAllowance_05    ; } 	// ^x05(v)
	public Integer getPayTotalAllowance_06() { return payTotalAllowance_06    ; } 	// ^x06(v)
	public Integer getPayTotalAllowance_07() { return payTotalAllowance_07    ; } 	// ^x07(v)
	public Integer getPayTotalAllowance_08() { return payTotalAllowance_08    ; } 	// ^x08(v)
	public Integer getPayTotalAllowance_09() { return payTotalAllowance_09    ; } 	// ^x09(v)
	public Integer getPayTotalAllowance_10() { return payTotalAllowance_10    ; } 	// ^x10(v)
	public Integer getPayTotalAllowance_11() { return payTotalAllowance_11    ; } 	// ^x11(v)
	public Integer getPayTotalAllowance_12() { return payTotalAllowance_12    ; } 	// ^x12(v)
	public Integer getPayTotalAllowance_13() { return payTotalAllowance_13    ; } 	// ^x13(v)
	public Integer getPayTotalAllowance_14() { return payTotalAllowance_14    ; } 	// ^x14(v)
	public Integer getPayTotalAllowance_15() { return payTotalAllowance_15    ; } 	// ^x15(v)
	public Integer getPayTotalAllowance_16() { return payTotalAllowance_16    ; } 	// ^x16(v)
	public Integer getPayTotalAllowance_17() { return payTotalAllowance_17    ; } 	// ^x17(v)
	public Integer getPayTotalAllowance_18() { return payTotalAllowance_18    ; } 	// ^x18(v)
	public Integer getPayTotalAllowance_19() { return payTotalAllowance_19    ; } 	// ^x19(v)
	public Integer getPayTotalAllowance_20() { return payTotalAllowance_20    ; } 	// ^x20(v)
	public Integer getPayTotalAllowance_21() { return payTotalAllowance_21    ; } 	// ^x21(v)
	public Integer getPayTotalAllowance_22() { return payTotalAllowance_22    ; } 	// ^x22(v)
	public Integer getPayTotalAllowance_23() { return payTotalAllowance_23    ; } 	// ^x23(v)
	public Integer getPayTotalAllowance_24() { return payTotalAllowance_24    ; } 	// ^x24(v)
	public Integer getPayTotalAllowance_25() { return payTotalAllowance_25    ; } 	// ^x25(v)
	public Integer getPayTotalAllowance_26() { return payTotalAllowance_26    ; } 	// ^x26(v)
	public Integer getPayTotalAllowance_27() { return payTotalAllowance_27    ; } 	// ^x27(v)
	public Integer getPayTotalAllowance_28() { return payTotalAllowance_28    ; } 	// ^x28(v)
	public Integer getPayTotalAllowance_29() { return payTotalAllowance_29    ; } 	// ^x29(v)
	public Integer getPayTotalAllowance_30() { return payTotalAllowance_30    ; } 	// ^x30(v)
	public Integer getPayTotalDeduction_01() { return payTotalDeduction_01    ; } 	// ^T01(v)
	public Integer getPayTotalDeduction_02() { return payTotalDeduction_02    ; } 	// ^T02(v)
	public Integer getPayTotalDeduction_03() { return payTotalDeduction_03    ; } 	// ^T03(v)
	public Integer getPayTotalDeduction_04() { return payTotalDeduction_04    ; } 	// ^T04(v)
	public Integer getPayTotalDeduction_05() { return payTotalDeduction_05    ; } 	// ^T05(v)
	public Integer getPayTotalDeduction_06() { return payTotalDeduction_06    ; } 	// ^T06(v)
	public Integer getPayTotalDeduction_07() { return payTotalDeduction_07    ; } 	// ^T07(v)
	public Integer getPayTotalDeduction_08() { return payTotalDeduction_08    ; } 	// ^T08(v)
	public Integer getPayTotalDeduction_09() { return payTotalDeduction_09    ; } 	// ^T09(v)
	public Integer getPayTotalDeduction_10() { return payTotalDeduction_10    ; } 	// ^T10(v)
	public Integer getPayTotalDeduction_11() { return payTotalDeduction_11    ; } 	// ^T11(v)
	public Integer getPayTotalDeduction_12() { return payTotalDeduction_12    ; } 	// ^T12(v)
	public Integer getPayTotalDeduction_13() { return payTotalDeduction_13    ; } 	// ^T13(v)
	public Integer getPayTotalDeduction_14() { return payTotalDeduction_14    ; } 	// ^T14(v)
	public Integer getPayTotalDeduction_15() { return payTotalDeduction_15    ; } 	// ^T15(v)
	public Integer getPayTotalDeduction_16() { return payTotalDeduction_16    ; } 	// ^T16(v)
	public Integer getPayTotalDeduction_17() { return payTotalDeduction_17    ; } 	// ^T17(v)
	public Integer getPayTotalDeduction_18() { return payTotalDeduction_18    ; } 	// ^T18(v)
	public Integer getPayTotalDeduction_19() { return payTotalDeduction_19    ; } 	// ^T19(v)
	public Integer getPayTotalDeduction_20() { return payTotalDeduction_20    ; } 	// ^T20(v)
	public Integer getPayTotalDeduction_21() { return payTotalDeduction_21    ; } 	// ^T21(v)
	public Integer getPayTotalDeduction_22() { return payTotalDeduction_22    ; } 	// ^T22(v)
	public Integer getPayTotalDeduction_23() { return payTotalDeduction_23    ; } 	// ^T23(v)
	public Integer getPayTotalDeduction_24() { return payTotalDeduction_24    ; } 	// ^T24(v)
	public Integer getPayTotalDeduction_25() { return payTotalDeduction_25    ; } 	// ^T25(v)
	public Integer getPayTotalDeduction_26() { return payTotalDeduction_26    ; } 	// ^T26(v)
	public Integer getPayTotalDeduction_27() { return payTotalDeduction_27    ; } 	// ^T27(v)
	public Float getTotalAttendance_01() { return totalAttendance_01    ; } 	// ΑӍ01(v)
	public Float getTotalAttendance_02() { return totalAttendance_02    ; } 	// ΑӍ02(v)
	public Float getTotalAttendance_03() { return totalAttendance_03    ; } 	// ΑӍ03(v)
	public Float getTotalAttendance_04() { return totalAttendance_04    ; } 	// ΑӍ04(v)
	public Float getTotalAttendance_05() { return totalAttendance_05    ; } 	// ΑӍ05(v)
	public Integer getTotalAttendance_06() { return totalAttendance_06    ; } 	// ΑӍ06(v)
	public Integer getTotalAttendance_07() { return totalAttendance_07    ; } 	// ΑӍ07(v)
	public Float getTotalAttendance_08() { return totalAttendance_08    ; } 	// ΑӍ08(v)
	public Float getTotalAttendance_09() { return totalAttendance_09    ; } 	// ΑӍ09(v)
	public Float getTotalAttendance_10() { return totalAttendance_10    ; } 	// ΑӍ10(v)
	public Float getTotalAttendance_11() { return totalAttendance_11    ; } 	// ΑӍ11(v)
	public Float getTotalAttendance_12() { return totalAttendance_12    ; } 	// ΑӍ12(v)
	public Integer getTotalAttendance_13() { return totalAttendance_13    ; } 	// ΑӍ13(v)
	public Integer getTotalAttendance_14() { return totalAttendance_14    ; } 	// ΑӍ14(v)
	public Integer getBonTotalAllowance_01() { return bonTotalAllowance_01    ; } 	// ܗ^x01(v)
	public Integer getBonTotalAllowance_02() { return bonTotalAllowance_02    ; } 	// ܗ^x02(v)
	public Integer getBonTotalAllowance_03() { return bonTotalAllowance_03    ; } 	// ܗ^x03(v)
	public Integer getBonTotalAllowance_04() { return bonTotalAllowance_04    ; } 	// ܗ^x04(v)
	public Integer getBonTotalAllowance_05() { return bonTotalAllowance_05    ; } 	// ܗ^x05(v)
	public Integer getBonTotalAllowance_06() { return bonTotalAllowance_06    ; } 	// ܗ^x06(v)
	public Integer getBonTotalAllowance_07() { return bonTotalAllowance_07    ; } 	// ܗ^x07(v)
	public Integer getBonTotalAllowance_08() { return bonTotalAllowance_08    ; } 	// ܗ^x08(v)
	public Integer getBonTotalAllowance_09() { return bonTotalAllowance_09    ; } 	// ܗ^x09(v)
	public Integer getBonTotalAllowance_10() { return bonTotalAllowance_10    ; } 	// ܗ^x10(v)
	public Integer getBonTotalDeduction_01() { return bonTotalDeduction_01    ; } 	// ܗ^T01(v)
	public Integer getBonTotalDeduction_02() { return bonTotalDeduction_02    ; } 	// ܗ^T02(v)
	public Integer getBonTotalDeduction_03() { return bonTotalDeduction_03    ; } 	// ܗ^T03(v)
	public Integer getBonTotalDeduction_04() { return bonTotalDeduction_04    ; } 	// ܗ^T04(v)
	public Integer getBonTotalDeduction_05() { return bonTotalDeduction_05    ; } 	// ܗ^T05(v)
	public Integer getBonTotalDeduction_06() { return bonTotalDeduction_06    ; } 	// ܗ^T06(v)
	public Integer getBonTotalDeduction_07() { return bonTotalDeduction_07    ; } 	// ܗ^T07(v)
	public Integer getBonTotalDeduction_08() { return bonTotalDeduction_08    ; } 	// ܗ^T08(v)
	public Integer getBonTotalDeduction_09() { return bonTotalDeduction_09    ; } 	// ܗ^T09(v)
	public Integer getBonTotalDeduction_10() { return bonTotalDeduction_10    ; } 	// ܗ^T10(v)
	public Integer getBonTotalDeduction_11() { return bonTotalDeduction_11    ; } 	// ܗ^T11(v)
	public Integer getBonTotalDeduction_12() { return bonTotalDeduction_12    ; } 	// ܗ^T12(v)
	public Integer getBonTotalDeduction_13() { return bonTotalDeduction_13    ; } 	// ܗ^T13(v)
	public Integer getBonTotalDeduction_14() { return bonTotalDeduction_14    ; } 	// ܗ^T14(v)
	public Integer getBonTotalDeduction_15() { return bonTotalDeduction_15    ; } 	// ܗ^T15(v)
	public Integer getBonTotalDeduction_16() { return bonTotalDeduction_16    ; } 	// ܗ^T16(v)
	public Integer getBonTotalDeduction_17() { return bonTotalDeduction_17    ; } 	// ܗ^T17(v)


	
	public Integer getPayAllowance_01_01() { return payAllowance_01_01    ; } 	// ^x01_01
	public Integer getPayAllowance_02_01() { return payAllowance_02_01    ; } 	// ^x02_01
	public Integer getPayAllowance_03_01() { return payAllowance_03_01    ; } 	// ^x03_01
	public Integer getPayAllowance_04_01() { return payAllowance_04_01    ; } 	// ^x04_01
	public Integer getPayAllowance_05_01() { return payAllowance_05_01    ; } 	// ^x05_01
	public Integer getPayAllowance_06_01() { return payAllowance_06_01    ; } 	// ^x06_01
	public Integer getPayAllowance_07_01() { return payAllowance_07_01    ; } 	// ^x07_01
	public Integer getPayAllowance_08_01() { return payAllowance_08_01    ; } 	// ^x08_01
	public Integer getPayAllowance_09_01() { return payAllowance_09_01    ; } 	// ^x09_01
	public Integer getPayAllowance_10_01() { return payAllowance_10_01    ; } 	// ^x10_01
	public Integer getPayAllowance_11_01() { return payAllowance_11_01    ; } 	// ^x11_01
	public Integer getPayAllowance_12_01() { return payAllowance_12_01    ; } 	// ^x12_01
	public Integer getPayAllowance_13_01() { return payAllowance_13_01    ; } 	// ^x13_01
	public Integer getPayAllowance_14_01() { return payAllowance_14_01    ; } 	// ^x14_01
	public Integer getPayAllowance_15_01() { return payAllowance_15_01    ; } 	// ^x15_01
	public Integer getPayAllowance_16_01() { return payAllowance_16_01    ; } 	// ^x16_01
	public Integer getPayAllowance_17_01() { return payAllowance_17_01    ; } 	// ^x17_01
	public Integer getPayAllowance_18_01() { return payAllowance_18_01    ; } 	// ^x18_01
	public Integer getPayAllowance_19_01() { return payAllowance_19_01    ; } 	// ^x19_01
	public Integer getPayAllowance_20_01() { return payAllowance_20_01    ; } 	// ^x20_01
	public Integer getPayAllowance_21_01() { return payAllowance_21_01    ; } 	// ^x21_01
	public Integer getPayAllowance_22_01() { return payAllowance_22_01    ; } 	// ^x22_01
	public Integer getPayAllowance_23_01() { return payAllowance_23_01    ; } 	// ^x23_01
	public Integer getPayAllowance_24_01() { return payAllowance_24_01    ; } 	// ^x24_01
	public Integer getPayAllowance_25_01() { return payAllowance_25_01    ; } 	// ^x25_01
	public Integer getPayAllowance_26_01() { return payAllowance_26_01    ; } 	// ^x26_01
	public Integer getPayAllowance_27_01() { return payAllowance_27_01    ; } 	// ^x27_01
	public Integer getPayAllowance_28_01() { return payAllowance_28_01    ; } 	// ^x28_01
	public Integer getPayAllowance_29_01() { return payAllowance_29_01    ; } 	// ^x29_01
	public Integer getPayAllowance_30_01() { return payAllowance_30_01    ; } 	// ^x30_01
	public Integer getPayDeduction_01_01() { return payDeduction_01_01    ; } 	// ^T01_01
	public Integer getPayDeduction_02_01() { return payDeduction_02_01    ; } 	// ^T02_01
	public Integer getPayDeduction_03_01() { return payDeduction_03_01    ; } 	// ^T03_01
	public Integer getPayDeduction_04_01() { return payDeduction_04_01    ; } 	// ^T04_01
	public Integer getPayDeduction_05_01() { return payDeduction_05_01    ; } 	// ^T05_01
	public Integer getPayDeduction_06_01() { return payDeduction_06_01    ; } 	// ^T06_01
	public Integer getPayDeduction_07_01() { return payDeduction_07_01    ; } 	// ^T07_01
	public Integer getPayDeduction_08_01() { return payDeduction_08_01    ; } 	// ^T08_01
	public Integer getPayDeduction_09_01() { return payDeduction_09_01    ; } 	// ^T09_01
	public Integer getPayDeduction_10_01() { return payDeduction_10_01    ; } 	// ^T10_01
	public Integer getPayDeduction_11_01() { return payDeduction_11_01    ; } 	// ^T11_01
	public Integer getPayDeduction_12_01() { return payDeduction_12_01    ; } 	// ^T12_01
	public Integer getPayDeduction_13_01() { return payDeduction_13_01    ; } 	// ^T13_01
	public Integer getPayDeduction_14_01() { return payDeduction_14_01    ; } 	// ^T14_01
	public Integer getPayDeduction_15_01() { return payDeduction_15_01    ; } 	// ^T15_01
	public Integer getPayDeduction_16_01() { return payDeduction_16_01    ; } 	// ^T16_01
	public Integer getPayDeduction_17_01() { return payDeduction_17_01    ; } 	// ^T17_01
	public Integer getPayDeduction_18_01() { return payDeduction_18_01    ; } 	// ^T18_01
	public Integer getPayDeduction_19_01() { return payDeduction_19_01    ; } 	// ^T19_01
	public Integer getPayDeduction_20_01() { return payDeduction_20_01    ; } 	// ^T20_01
	public Integer getPayDeduction_21_01() { return payDeduction_21_01    ; } 	// ^T21_01
	public Integer getPayDeduction_22_01() { return payDeduction_22_01    ; } 	// ^T22_01
	public Integer getPayDeduction_23_01() { return payDeduction_23_01    ; } 	// ^T23_01
	public Integer getPayDeduction_24_01() { return payDeduction_24_01    ; } 	// ^T24_01
	public Integer getPayDeduction_25_01() { return payDeduction_25_01    ; } 	// ^T25_01
	public Integer getPayDeduction_26_01() { return payDeduction_26_01    ; } 	// ^T26_01
	public Integer getPayDeduction_27_01() { return payDeduction_27_01    ; } 	// ^T27_01
	public Float getAttendance_01_01() { return attendance_01_01    ; } 	// ΑӍ01_01
	public Float getAttendance_02_01() { return attendance_02_01    ; } 	// ΑӍ02_01
	public Float getAttendance_03_01() { return attendance_03_01    ; } 	// ΑӍ03_01
	public Float getAttendance_04_01() { return attendance_04_01    ; } 	// ΑӍ04_01
	public Float getAttendance_05_01() { return attendance_05_01    ; } 	// ΑӍ05_01
	public Integer getAttendance_06_01() { return attendance_06_01    ; } 	// ΑӍ06_01
	public Integer getAttendance_07_01() { return attendance_07_01    ; } 	// ΑӍ07_01
	public Float getAttendance_08_01() { return attendance_08_01    ; } 	// ΑӍ08_01
	public Float getAttendance_09_01() { return attendance_09_01    ; } 	// ΑӍ09_01
	public Float getAttendance_10_01() { return attendance_10_01    ; } 	// ΑӍ10_01
	public Float getAttendance_11_01() { return attendance_11_01    ; } 	// ΑӍ11_01
	public Float getAttendance_12_01() { return attendance_12_01    ; } 	// ΑӍ12_01
	public Integer getAttendance_13_01() { return attendance_13_01    ; } 	// ΑӍ13_01
	public Integer getAttendance_14_01() { return attendance_14_01    ; } 	// ΑӍ14_01
	public Integer getBonAllowance_01_01() { return bonAllowance_01_01    ; } 	// ܗ^x01_01
	public Integer getBonAllowance_02_01() { return bonAllowance_02_01    ; } 	// ܗ^x02_01
	public Integer getBonAllowance_03_01() { return bonAllowance_03_01    ; } 	// ܗ^x03_01
	public Integer getBonAllowance_04_01() { return bonAllowance_04_01    ; } 	// ܗ^x04_01
	public Integer getBonAllowance_05_01() { return bonAllowance_05_01    ; } 	// ܗ^x05_01
	public Integer getBonAllowance_06_01() { return bonAllowance_06_01    ; } 	// ܗ^x06_01
	public Integer getBonAllowance_07_01() { return bonAllowance_07_01    ; } 	// ܗ^x07_01
	public Integer getBonAllowance_08_01() { return bonAllowance_08_01    ; } 	// ܗ^x08_01
	public Integer getBonAllowance_09_01() { return bonAllowance_09_01    ; } 	// ܗ^x09_01
	public Integer getBonAllowance_10_01() { return bonAllowance_10_01    ; } 	// ܗ^x10_01
	public Integer getBonDeduction_01_01() { return bonDeduction_01_01    ; } 	// ܗ^T01_01
	public Integer getBonDeduction_02_01() { return bonDeduction_02_01    ; } 	// ܗ^T02_01
	public Integer getBonDeduction_03_01() { return bonDeduction_03_01    ; } 	// ܗ^T03_01
	public Integer getBonDeduction_04_01() { return bonDeduction_04_01    ; } 	// ܗ^T04_01
	public Integer getBonDeduction_05_01() { return bonDeduction_05_01    ; } 	// ܗ^T05_01
	public Integer getBonDeduction_06_01() { return bonDeduction_06_01    ; } 	// ܗ^T06_01
	public Integer getBonDeduction_07_01() { return bonDeduction_07_01    ; } 	// ܗ^T07_01
	public Integer getBonDeduction_08_01() { return bonDeduction_08_01    ; } 	// ܗ^T08_01
	public Integer getBonDeduction_09_01() { return bonDeduction_09_01    ; } 	// ܗ^T09_01
	public Integer getBonDeduction_10_01() { return bonDeduction_10_01    ; } 	// ܗ^T10_01
	public Integer getBonDeduction_11_01() { return bonDeduction_11_01    ; } 	// ܗ^T11_01
	public Integer getBonDeduction_12_01() { return bonDeduction_12_01    ; } 	// ܗ^T12_01
	public Integer getBonDeduction_13_01() { return bonDeduction_13_01    ; } 	// ܗ^T13_01
	public Integer getBonDeduction_14_01() { return bonDeduction_14_01    ; } 	// ܗ^T14_01
	public Integer getBonDeduction_15_01() { return bonDeduction_15_01    ; } 	// ܗ^T15_01
	public Integer getBonDeduction_16_01() { return bonDeduction_16_01    ; } 	// ܗ^T16_01
	public Integer getBonDeduction_17_01() { return bonDeduction_17_01    ; } 	// ܗ^T17_01
	public Integer getPayAllowance_01_02() { return payAllowance_01_02    ; } 	// ^x01_02
	public Integer getPayAllowance_02_02() { return payAllowance_02_02    ; } 	// ^x02_02
	public Integer getPayAllowance_03_02() { return payAllowance_03_02    ; } 	// ^x03_02
	public Integer getPayAllowance_04_02() { return payAllowance_04_02    ; } 	// ^x04_02
	public Integer getPayAllowance_05_02() { return payAllowance_05_02    ; } 	// ^x05_02
	public Integer getPayAllowance_06_02() { return payAllowance_06_02    ; } 	// ^x06_02
	public Integer getPayAllowance_07_02() { return payAllowance_07_02    ; } 	// ^x07_02
	public Integer getPayAllowance_08_02() { return payAllowance_08_02    ; } 	// ^x08_02
	public Integer getPayAllowance_09_02() { return payAllowance_09_02    ; } 	// ^x09_02
	public Integer getPayAllowance_10_02() { return payAllowance_10_02    ; } 	// ^x10_02
	public Integer getPayAllowance_11_02() { return payAllowance_11_02    ; } 	// ^x11_02
	public Integer getPayAllowance_12_02() { return payAllowance_12_02    ; } 	// ^x12_02
	public Integer getPayAllowance_13_02() { return payAllowance_13_02    ; } 	// ^x13_02
	public Integer getPayAllowance_14_02() { return payAllowance_14_02    ; } 	// ^x14_02
	public Integer getPayAllowance_15_02() { return payAllowance_15_02    ; } 	// ^x15_02
	public Integer getPayAllowance_16_02() { return payAllowance_16_02    ; } 	// ^x16_02
	public Integer getPayAllowance_17_02() { return payAllowance_17_02    ; } 	// ^x17_02
	public Integer getPayAllowance_18_02() { return payAllowance_18_02    ; } 	// ^x18_02
	public Integer getPayAllowance_19_02() { return payAllowance_19_02    ; } 	// ^x19_02
	public Integer getPayAllowance_20_02() { return payAllowance_20_02    ; } 	// ^x20_02
	public Integer getPayAllowance_21_02() { return payAllowance_21_02    ; } 	// ^x21_02
	public Integer getPayAllowance_22_02() { return payAllowance_22_02    ; } 	// ^x22_02
	public Integer getPayAllowance_23_02() { return payAllowance_23_02    ; } 	// ^x23_02
	public Integer getPayAllowance_24_02() { return payAllowance_24_02    ; } 	// ^x24_02
	public Integer getPayAllowance_25_02() { return payAllowance_25_02    ; } 	// ^x25_02
	public Integer getPayAllowance_26_02() { return payAllowance_26_02    ; } 	// ^x26_02
	public Integer getPayAllowance_27_02() { return payAllowance_27_02    ; } 	// ^x27_02
	public Integer getPayAllowance_28_02() { return payAllowance_28_02    ; } 	// ^x28_02
	public Integer getPayAllowance_29_02() { return payAllowance_29_02    ; } 	// ^x29_02
	public Integer getPayAllowance_30_02() { return payAllowance_30_02    ; } 	// ^x30_02
	public Integer getPayDeduction_01_02() { return payDeduction_01_02    ; } 	// ^T01_02
	public Integer getPayDeduction_02_02() { return payDeduction_02_02    ; } 	// ^T02_02
	public Integer getPayDeduction_03_02() { return payDeduction_03_02    ; } 	// ^T03_02
	public Integer getPayDeduction_04_02() { return payDeduction_04_02    ; } 	// ^T04_02
	public Integer getPayDeduction_05_02() { return payDeduction_05_02    ; } 	// ^T05_02
	public Integer getPayDeduction_06_02() { return payDeduction_06_02    ; } 	// ^T06_02
	public Integer getPayDeduction_07_02() { return payDeduction_07_02    ; } 	// ^T07_02
	public Integer getPayDeduction_08_02() { return payDeduction_08_02    ; } 	// ^T08_02
	public Integer getPayDeduction_09_02() { return payDeduction_09_02    ; } 	// ^T09_02
	public Integer getPayDeduction_10_02() { return payDeduction_10_02    ; } 	// ^T10_02
	public Integer getPayDeduction_11_02() { return payDeduction_11_02    ; } 	// ^T11_02
	public Integer getPayDeduction_12_02() { return payDeduction_12_02    ; } 	// ^T12_02
	public Integer getPayDeduction_13_02() { return payDeduction_13_02    ; } 	// ^T13_02
	public Integer getPayDeduction_14_02() { return payDeduction_14_02    ; } 	// ^T14_02
	public Integer getPayDeduction_15_02() { return payDeduction_15_02    ; } 	// ^T15_02
	public Integer getPayDeduction_16_02() { return payDeduction_16_02    ; } 	// ^T16_02
	public Integer getPayDeduction_17_02() { return payDeduction_17_02    ; } 	// ^T17_02
	public Integer getPayDeduction_18_02() { return payDeduction_18_02    ; } 	// ^T18_02
	public Integer getPayDeduction_19_02() { return payDeduction_19_02    ; } 	// ^T19_02
	public Integer getPayDeduction_20_02() { return payDeduction_20_02    ; } 	// ^T20_02
	public Integer getPayDeduction_21_02() { return payDeduction_21_02    ; } 	// ^T21_02
	public Integer getPayDeduction_22_02() { return payDeduction_22_02    ; } 	// ^T22_02
	public Integer getPayDeduction_23_02() { return payDeduction_23_02    ; } 	// ^T23_02
	public Integer getPayDeduction_24_02() { return payDeduction_24_02    ; } 	// ^T24_02
	public Integer getPayDeduction_25_02() { return payDeduction_25_02    ; } 	// ^T25_02
	public Integer getPayDeduction_26_02() { return payDeduction_26_02    ; } 	// ^T26_02
	public Integer getPayDeduction_27_02() { return payDeduction_27_02    ; } 	// ^T27_02
	public Float getAttendance_01_02() { return attendance_01_02    ; } 	// ΑӍ01_02
	public Float getAttendance_02_02() { return attendance_02_02    ; } 	// ΑӍ02_02
	public Float getAttendance_03_02() { return attendance_03_02    ; } 	// ΑӍ03_02
	public Float getAttendance_04_02() { return attendance_04_02    ; } 	// ΑӍ04_02
	public Float getAttendance_05_02() { return attendance_05_02    ; } 	// ΑӍ05_02
	public Integer getAttendance_06_02() { return attendance_06_02    ; } 	// ΑӍ06_02
	public Integer getAttendance_07_02() { return attendance_07_02    ; } 	// ΑӍ07_02
	public Float getAttendance_08_02() { return attendance_08_02    ; } 	// ΑӍ08_02
	public Float getAttendance_09_02() { return attendance_09_02    ; } 	// ΑӍ09_02
	public Float getAttendance_10_02() { return attendance_10_02    ; } 	// ΑӍ10_02
	public Float getAttendance_11_02() { return attendance_11_02    ; } 	// ΑӍ11_02
	public Float getAttendance_12_02() { return attendance_12_02    ; } 	// ΑӍ12_02
	public Integer getAttendance_13_02() { return attendance_13_02    ; } 	// ΑӍ13_02
	public Integer getAttendance_14_02() { return attendance_14_02    ; } 	// ΑӍ14_02
	public Integer getBonAllowance_01_02() { return bonAllowance_01_02    ; } 	// ܗ^x01_02
	public Integer getBonAllowance_02_02() { return bonAllowance_02_02    ; } 	// ܗ^x02_02
	public Integer getBonAllowance_03_02() { return bonAllowance_03_02    ; } 	// ܗ^x03_02
	public Integer getBonAllowance_04_02() { return bonAllowance_04_02    ; } 	// ܗ^x04_02
	public Integer getBonAllowance_05_02() { return bonAllowance_05_02    ; } 	// ܗ^x05_02
	public Integer getBonAllowance_06_02() { return bonAllowance_06_02    ; } 	// ܗ^x06_02
	public Integer getBonAllowance_07_02() { return bonAllowance_07_02    ; } 	// ܗ^x07_02
	public Integer getBonAllowance_08_02() { return bonAllowance_08_02    ; } 	// ܗ^x08_02
	public Integer getBonAllowance_09_02() { return bonAllowance_09_02    ; } 	// ܗ^x09_02
	public Integer getBonAllowance_10_02() { return bonAllowance_10_02    ; } 	// ܗ^x10_02
	public Integer getBonDeduction_01_02() { return bonDeduction_01_02    ; } 	// ܗ^T01_02
	public Integer getBonDeduction_02_02() { return bonDeduction_02_02    ; } 	// ܗ^T02_02
	public Integer getBonDeduction_03_02() { return bonDeduction_03_02    ; } 	// ܗ^T03_02
	public Integer getBonDeduction_04_02() { return bonDeduction_04_02    ; } 	// ܗ^T04_02
	public Integer getBonDeduction_05_02() { return bonDeduction_05_02    ; } 	// ܗ^T05_02
	public Integer getBonDeduction_06_02() { return bonDeduction_06_02    ; } 	// ܗ^T06_02
	public Integer getBonDeduction_07_02() { return bonDeduction_07_02    ; } 	// ܗ^T07_02
	public Integer getBonDeduction_08_02() { return bonDeduction_08_02    ; } 	// ܗ^T08_02
	public Integer getBonDeduction_09_02() { return bonDeduction_09_02    ; } 	// ܗ^T09_02
	public Integer getBonDeduction_10_02() { return bonDeduction_10_02    ; } 	// ܗ^T10_02
	public Integer getBonDeduction_11_02() { return bonDeduction_11_02    ; } 	// ܗ^T11_02
	public Integer getBonDeduction_12_02() { return bonDeduction_12_02    ; } 	// ܗ^T12_02
	public Integer getBonDeduction_13_02() { return bonDeduction_13_02    ; } 	// ܗ^T13_02
	public Integer getBonDeduction_14_02() { return bonDeduction_14_02    ; } 	// ܗ^T14_02
	public Integer getBonDeduction_15_02() { return bonDeduction_15_02    ; } 	// ܗ^T15_02
	public Integer getBonDeduction_16_02() { return bonDeduction_16_02    ; } 	// ܗ^T16_02
	public Integer getBonDeduction_17_02() { return bonDeduction_17_02    ; } 	// ܗ^T17_02
	public Integer getPayAllowance_01_03() { return payAllowance_01_03    ; } 	// ^x01_03
	public Integer getPayAllowance_02_03() { return payAllowance_02_03    ; } 	// ^x02_03
	public Integer getPayAllowance_03_03() { return payAllowance_03_03    ; } 	// ^x03_03
	public Integer getPayAllowance_04_03() { return payAllowance_04_03    ; } 	// ^x04_03
	public Integer getPayAllowance_05_03() { return payAllowance_05_03    ; } 	// ^x05_03
	public Integer getPayAllowance_06_03() { return payAllowance_06_03    ; } 	// ^x06_03
	public Integer getPayAllowance_07_03() { return payAllowance_07_03    ; } 	// ^x07_03
	public Integer getPayAllowance_08_03() { return payAllowance_08_03    ; } 	// ^x08_03
	public Integer getPayAllowance_09_03() { return payAllowance_09_03    ; } 	// ^x09_03
	public Integer getPayAllowance_10_03() { return payAllowance_10_03    ; } 	// ^x10_03
	public Integer getPayAllowance_11_03() { return payAllowance_11_03    ; } 	// ^x11_03
	public Integer getPayAllowance_12_03() { return payAllowance_12_03    ; } 	// ^x12_03
	public Integer getPayAllowance_13_03() { return payAllowance_13_03    ; } 	// ^x13_03
	public Integer getPayAllowance_14_03() { return payAllowance_14_03    ; } 	// ^x14_03
	public Integer getPayAllowance_15_03() { return payAllowance_15_03    ; } 	// ^x15_03
	public Integer getPayAllowance_16_03() { return payAllowance_16_03    ; } 	// ^x16_03
	public Integer getPayAllowance_17_03() { return payAllowance_17_03    ; } 	// ^x17_03
	public Integer getPayAllowance_18_03() { return payAllowance_18_03    ; } 	// ^x18_03
	public Integer getPayAllowance_19_03() { return payAllowance_19_03    ; } 	// ^x19_03
	public Integer getPayAllowance_20_03() { return payAllowance_20_03    ; } 	// ^x20_03
	public Integer getPayAllowance_21_03() { return payAllowance_21_03    ; } 	// ^x21_03
	public Integer getPayAllowance_22_03() { return payAllowance_22_03    ; } 	// ^x22_03
	public Integer getPayAllowance_23_03() { return payAllowance_23_03    ; } 	// ^x23_03
	public Integer getPayAllowance_24_03() { return payAllowance_24_03    ; } 	// ^x24_03
	public Integer getPayAllowance_25_03() { return payAllowance_25_03    ; } 	// ^x25_03
	public Integer getPayAllowance_26_03() { return payAllowance_26_03    ; } 	// ^x26_03
	public Integer getPayAllowance_27_03() { return payAllowance_27_03    ; } 	// ^x27_03
	public Integer getPayAllowance_28_03() { return payAllowance_28_03    ; } 	// ^x28_03
	public Integer getPayAllowance_29_03() { return payAllowance_29_03    ; } 	// ^x29_03
	public Integer getPayAllowance_30_03() { return payAllowance_30_03    ; } 	// ^x30_03
	public Integer getPayDeduction_01_03() { return payDeduction_01_03    ; } 	// ^T01_03
	public Integer getPayDeduction_02_03() { return payDeduction_02_03    ; } 	// ^T02_03
	public Integer getPayDeduction_03_03() { return payDeduction_03_03    ; } 	// ^T03_03
	public Integer getPayDeduction_04_03() { return payDeduction_04_03    ; } 	// ^T04_03
	public Integer getPayDeduction_05_03() { return payDeduction_05_03    ; } 	// ^T05_03
	public Integer getPayDeduction_06_03() { return payDeduction_06_03    ; } 	// ^T06_03
	public Integer getPayDeduction_07_03() { return payDeduction_07_03    ; } 	// ^T07_03
	public Integer getPayDeduction_08_03() { return payDeduction_08_03    ; } 	// ^T08_03
	public Integer getPayDeduction_09_03() { return payDeduction_09_03    ; } 	// ^T09_03
	public Integer getPayDeduction_10_03() { return payDeduction_10_03    ; } 	// ^T10_03
	public Integer getPayDeduction_11_03() { return payDeduction_11_03    ; } 	// ^T11_03
	public Integer getPayDeduction_12_03() { return payDeduction_12_03    ; } 	// ^T12_03
	public Integer getPayDeduction_13_03() { return payDeduction_13_03    ; } 	// ^T13_03
	public Integer getPayDeduction_14_03() { return payDeduction_14_03    ; } 	// ^T14_03
	public Integer getPayDeduction_15_03() { return payDeduction_15_03    ; } 	// ^T15_03
	public Integer getPayDeduction_16_03() { return payDeduction_16_03    ; } 	// ^T16_03
	public Integer getPayDeduction_17_03() { return payDeduction_17_03    ; } 	// ^T17_03
	public Integer getPayDeduction_18_03() { return payDeduction_18_03    ; } 	// ^T18_03
	public Integer getPayDeduction_19_03() { return payDeduction_19_03    ; } 	// ^T19_03
	public Integer getPayDeduction_20_03() { return payDeduction_20_03    ; } 	// ^T20_03
	public Integer getPayDeduction_21_03() { return payDeduction_21_03    ; } 	// ^T21_03
	public Integer getPayDeduction_22_03() { return payDeduction_22_03    ; } 	// ^T22_03
	public Integer getPayDeduction_23_03() { return payDeduction_23_03    ; } 	// ^T23_03
	public Integer getPayDeduction_24_03() { return payDeduction_24_03    ; } 	// ^T24_03
	public Integer getPayDeduction_25_03() { return payDeduction_25_03    ; } 	// ^T25_03
	public Integer getPayDeduction_26_03() { return payDeduction_26_03    ; } 	// ^T26_03
	public Integer getPayDeduction_27_03() { return payDeduction_27_03    ; } 	// ^T27_03
	public Float  getAttendance_01_03() { return attendance_01_03    ; } 	// ΑӍ01_03
	public Float  getAttendance_02_03() { return attendance_02_03    ; } 	// ΑӍ02_03
	public Float  getAttendance_03_03() { return attendance_03_03    ; } 	// ΑӍ03_03
	public Float  getAttendance_04_03() { return attendance_04_03    ; } 	// ΑӍ04_03
	public Float  getAttendance_05_03() { return attendance_05_03    ; } 	// ΑӍ05_03
	public Integer getAttendance_06_03() { return attendance_06_03    ; } 	// ΑӍ06_03
	public Integer getAttendance_07_03() { return attendance_07_03    ; } 	// ΑӍ07_03
	public Float  getAttendance_08_03() { return attendance_08_03    ; } 	// ΑӍ08_03
	public Float  getAttendance_09_03() { return attendance_09_03    ; } 	// ΑӍ09_03
	public Float  getAttendance_10_03() { return attendance_10_03    ; } 	// ΑӍ10_03
	public Float  getAttendance_11_03() { return attendance_11_03    ; } 	// ΑӍ11_03
	public Float  getAttendance_12_03() { return attendance_12_03    ; } 	// ΑӍ12_03
	public Integer getAttendance_13_03() { return attendance_13_03    ; } 	// ΑӍ13_03
	public Integer getAttendance_14_03() { return attendance_14_03    ; } 	// ΑӍ14_03
	public Integer getBonAllowance_01_03() { return bonAllowance_01_03    ; } 	// ܗ^x01_03
	public Integer getBonAllowance_02_03() { return bonAllowance_02_03    ; } 	// ܗ^x02_03
	public Integer getBonAllowance_03_03() { return bonAllowance_03_03    ; } 	// ܗ^x03_03
	public Integer getBonAllowance_04_03() { return bonAllowance_04_03    ; } 	// ܗ^x04_03
	public Integer getBonAllowance_05_03() { return bonAllowance_05_03    ; } 	// ܗ^x05_03
	public Integer getBonAllowance_06_03() { return bonAllowance_06_03    ; } 	// ܗ^x06_03
	public Integer getBonAllowance_07_03() { return bonAllowance_07_03    ; } 	// ܗ^x07_03
	public Integer getBonAllowance_08_03() { return bonAllowance_08_03    ; } 	// ܗ^x08_03
	public Integer getBonAllowance_09_03() { return bonAllowance_09_03    ; } 	// ܗ^x09_03
	public Integer getBonAllowance_10_03() { return bonAllowance_10_03    ; } 	// ܗ^x10_03
	public Integer getBonDeduction_01_03() { return bonDeduction_01_03    ; } 	// ܗ^T01_03
	public Integer getBonDeduction_02_03() { return bonDeduction_02_03    ; } 	// ܗ^T02_03
	public Integer getBonDeduction_03_03() { return bonDeduction_03_03    ; } 	// ܗ^T03_03
	public Integer getBonDeduction_04_03() { return bonDeduction_04_03    ; } 	// ܗ^T04_03
	public Integer getBonDeduction_05_03() { return bonDeduction_05_03    ; } 	// ܗ^T05_03
	public Integer getBonDeduction_06_03() { return bonDeduction_06_03    ; } 	// ܗ^T06_03
	public Integer getBonDeduction_07_03() { return bonDeduction_07_03    ; } 	// ܗ^T07_03
	public Integer getBonDeduction_08_03() { return bonDeduction_08_03    ; } 	// ܗ^T08_03
	public Integer getBonDeduction_09_03() { return bonDeduction_09_03    ; } 	// ܗ^T09_03
	public Integer getBonDeduction_10_03() { return bonDeduction_10_03    ; } 	// ܗ^T10_03
	public Integer getBonDeduction_11_03() { return bonDeduction_11_03    ; } 	// ܗ^T11_03
	public Integer getBonDeduction_12_03() { return bonDeduction_12_03    ; } 	// ܗ^T12_03
	public Integer getBonDeduction_13_03() { return bonDeduction_13_03    ; } 	// ܗ^T13_03
	public Integer getBonDeduction_14_03() { return bonDeduction_14_03    ; } 	// ܗ^T14_03
	public Integer getBonDeduction_15_03() { return bonDeduction_15_03    ; } 	// ܗ^T15_03
	public Integer getBonDeduction_16_03() { return bonDeduction_16_03    ; } 	// ܗ^T16_03
	public Integer getBonDeduction_17_03() { return bonDeduction_17_03    ; } 	// ܗ^T17_03
	public Integer getPayAllowance_01_04() { return payAllowance_01_04    ; } 	// ^x01_04
	public Integer getPayAllowance_02_04() { return payAllowance_02_04    ; } 	// ^x02_04
	public Integer getPayAllowance_03_04() { return payAllowance_03_04    ; } 	// ^x03_04
	public Integer getPayAllowance_04_04() { return payAllowance_04_04    ; } 	// ^x04_04
	public Integer getPayAllowance_05_04() { return payAllowance_05_04    ; } 	// ^x05_04
	public Integer getPayAllowance_06_04() { return payAllowance_06_04    ; } 	// ^x06_04
	public Integer getPayAllowance_07_04() { return payAllowance_07_04    ; } 	// ^x07_04
	public Integer getPayAllowance_08_04() { return payAllowance_08_04    ; } 	// ^x08_04
	public Integer getPayAllowance_09_04() { return payAllowance_09_04    ; } 	// ^x09_04
	public Integer getPayAllowance_10_04() { return payAllowance_10_04    ; } 	// ^x10_04
	public Integer getPayAllowance_11_04() { return payAllowance_11_04    ; } 	// ^x11_04
	public Integer getPayAllowance_12_04() { return payAllowance_12_04    ; } 	// ^x12_04
	public Integer getPayAllowance_13_04() { return payAllowance_13_04    ; } 	// ^x13_04
	public Integer getPayAllowance_14_04() { return payAllowance_14_04    ; } 	// ^x14_04
	public Integer getPayAllowance_15_04() { return payAllowance_15_04    ; } 	// ^x15_04
	public Integer getPayAllowance_16_04() { return payAllowance_16_04    ; } 	// ^x16_04
	public Integer getPayAllowance_17_04() { return payAllowance_17_04    ; } 	// ^x17_04
	public Integer getPayAllowance_18_04() { return payAllowance_18_04    ; } 	// ^x18_04
	public Integer getPayAllowance_19_04() { return payAllowance_19_04    ; } 	// ^x19_04
	public Integer getPayAllowance_20_04() { return payAllowance_20_04    ; } 	// ^x20_04
	public Integer getPayAllowance_21_04() { return payAllowance_21_04    ; } 	// ^x21_04
	public Integer getPayAllowance_22_04() { return payAllowance_22_04    ; } 	// ^x22_04
	public Integer getPayAllowance_23_04() { return payAllowance_23_04    ; } 	// ^x23_04
	public Integer getPayAllowance_24_04() { return payAllowance_24_04    ; } 	// ^x24_04
	public Integer getPayAllowance_25_04() { return payAllowance_25_04    ; } 	// ^x25_04
	public Integer getPayAllowance_26_04() { return payAllowance_26_04    ; } 	// ^x26_04
	public Integer getPayAllowance_27_04() { return payAllowance_27_04    ; } 	// ^x27_04
	public Integer getPayAllowance_28_04() { return payAllowance_28_04    ; } 	// ^x28_04
	public Integer getPayAllowance_29_04() { return payAllowance_29_04    ; } 	// ^x29_04
	public Integer getPayAllowance_30_04() { return payAllowance_30_04    ; } 	// ^x30_04
	public Integer getPayDeduction_01_04() { return payDeduction_01_04    ; } 	// ^T01_04
	public Integer getPayDeduction_02_04() { return payDeduction_02_04    ; } 	// ^T02_04
	public Integer getPayDeduction_03_04() { return payDeduction_03_04    ; } 	// ^T03_04
	public Integer getPayDeduction_04_04() { return payDeduction_04_04    ; } 	// ^T04_04
	public Integer getPayDeduction_05_04() { return payDeduction_05_04    ; } 	// ^T05_04
	public Integer getPayDeduction_06_04() { return payDeduction_06_04    ; } 	// ^T06_04
	public Integer getPayDeduction_07_04() { return payDeduction_07_04    ; } 	// ^T07_04
	public Integer getPayDeduction_08_04() { return payDeduction_08_04    ; } 	// ^T08_04
	public Integer getPayDeduction_09_04() { return payDeduction_09_04    ; } 	// ^T09_04
	public Integer getPayDeduction_10_04() { return payDeduction_10_04    ; } 	// ^T10_04
	public Integer getPayDeduction_11_04() { return payDeduction_11_04    ; } 	// ^T11_04
	public Integer getPayDeduction_12_04() { return payDeduction_12_04    ; } 	// ^T12_04
	public Integer getPayDeduction_13_04() { return payDeduction_13_04    ; } 	// ^T13_04
	public Integer getPayDeduction_14_04() { return payDeduction_14_04    ; } 	// ^T14_04
	public Integer getPayDeduction_15_04() { return payDeduction_15_04    ; } 	// ^T15_04
	public Integer getPayDeduction_16_04() { return payDeduction_16_04    ; } 	// ^T16_04
	public Integer getPayDeduction_17_04() { return payDeduction_17_04    ; } 	// ^T17_04
	public Integer getPayDeduction_18_04() { return payDeduction_18_04    ; } 	// ^T18_04
	public Integer getPayDeduction_19_04() { return payDeduction_19_04    ; } 	// ^T19_04
	public Integer getPayDeduction_20_04() { return payDeduction_20_04    ; } 	// ^T20_04
	public Integer getPayDeduction_21_04() { return payDeduction_21_04    ; } 	// ^T21_04
	public Integer getPayDeduction_22_04() { return payDeduction_22_04    ; } 	// ^T22_04
	public Integer getPayDeduction_23_04() { return payDeduction_23_04    ; } 	// ^T23_04
	public Integer getPayDeduction_24_04() { return payDeduction_24_04    ; } 	// ^T24_04
	public Integer getPayDeduction_25_04() { return payDeduction_25_04    ; } 	// ^T25_04
	public Integer getPayDeduction_26_04() { return payDeduction_26_04    ; } 	// ^T26_04
	public Integer getPayDeduction_27_04() { return payDeduction_27_04    ; } 	// ^T27_04
	public Float   getAttendance_01_04()	{ return attendance_01_04    ; } 	// ΑӍ01_04
	public Float   getAttendance_02_04()	{ return attendance_02_04    ; } 	// ΑӍ02_04
	public Float   getAttendance_03_04()	{ return attendance_03_04    ; } 	// ΑӍ03_04
	public Float   getAttendance_04_04()	{ return attendance_04_04    ; } 	// ΑӍ04_04
	public Float   getAttendance_05_04()	{ return attendance_05_04    ; } 	// ΑӍ05_04
	public Integer getAttendance_06_04()	{ return attendance_06_04    ; } 	// ΑӍ06_04
	public Integer getAttendance_07_04()	{ return attendance_07_04    ; } 	// ΑӍ07_04
	public Float   getAttendance_08_04()	{ return attendance_08_04    ; } 	// ΑӍ08_04
	public Float   getAttendance_09_04()	{ return attendance_09_04    ; } 	// ΑӍ09_04
	public Float   getAttendance_10_04()	{ return attendance_10_04    ; } 	// ΑӍ10_04
	public Float   getAttendance_11_04()	{ return attendance_11_04    ; } 	// ΑӍ11_04
	public Float   getAttendance_12_04()	{ return attendance_12_04    ; } 	// ΑӍ12_04
	public Integer getAttendance_13_04()	{ return attendance_13_04    ; } 	// ΑӍ13_04
	public Integer getAttendance_14_04()	{ return attendance_14_04    ; } 	// ΑӍ14_04
	public Integer getBonAllowance_01_04() { return bonAllowance_01_04    ; } 	// ܗ^x01_04
	public Integer getBonAllowance_02_04() { return bonAllowance_02_04    ; } 	// ܗ^x02_04
	public Integer getBonAllowance_03_04() { return bonAllowance_03_04    ; } 	// ܗ^x03_04
	public Integer getBonAllowance_04_04() { return bonAllowance_04_04    ; } 	// ܗ^x04_04
	public Integer getBonAllowance_05_04() { return bonAllowance_05_04    ; } 	// ܗ^x05_04
	public Integer getBonAllowance_06_04() { return bonAllowance_06_04    ; } 	// ܗ^x06_04
	public Integer getBonAllowance_07_04() { return bonAllowance_07_04    ; } 	// ܗ^x07_04
	public Integer getBonAllowance_08_04() { return bonAllowance_08_04    ; } 	// ܗ^x08_04
	public Integer getBonAllowance_09_04() { return bonAllowance_09_04    ; } 	// ܗ^x09_04
	public Integer getBonAllowance_10_04() { return bonAllowance_10_04    ; } 	// ܗ^x10_04
	public Integer getBonDeduction_01_04() { return bonDeduction_01_04    ; } 	// ܗ^T01_04
	public Integer getBonDeduction_02_04() { return bonDeduction_02_04    ; } 	// ܗ^T02_04
	public Integer getBonDeduction_03_04() { return bonDeduction_03_04    ; } 	// ܗ^T03_04
	public Integer getBonDeduction_04_04() { return bonDeduction_04_04    ; } 	// ܗ^T04_04
	public Integer getBonDeduction_05_04() { return bonDeduction_05_04    ; } 	// ܗ^T05_04
	public Integer getBonDeduction_06_04() { return bonDeduction_06_04    ; } 	// ܗ^T06_04
	public Integer getBonDeduction_07_04() { return bonDeduction_07_04    ; } 	// ܗ^T07_04
	public Integer getBonDeduction_08_04() { return bonDeduction_08_04    ; } 	// ܗ^T08_04
	public Integer getBonDeduction_09_04() { return bonDeduction_09_04    ; } 	// ܗ^T09_04
	public Integer getBonDeduction_10_04() { return bonDeduction_10_04    ; } 	// ܗ^T10_04
	public Integer getBonDeduction_11_04() { return bonDeduction_11_04    ; } 	// ܗ^T11_04
	public Integer getBonDeduction_12_04() { return bonDeduction_12_04    ; } 	// ܗ^T12_04
	public Integer getBonDeduction_13_04() { return bonDeduction_13_04    ; } 	// ܗ^T13_04
	public Integer getBonDeduction_14_04() { return bonDeduction_14_04    ; } 	// ܗ^T14_04
	public Integer getBonDeduction_15_04() { return bonDeduction_15_04    ; } 	// ܗ^T15_04
	public Integer getBonDeduction_16_04() { return bonDeduction_16_04    ; } 	// ܗ^T16_04
	public Integer getBonDeduction_17_04() { return bonDeduction_17_04    ; } 	// ܗ^T17_04
	public Integer getPayAllowance_01_05() { return payAllowance_01_05    ; } 	// ^x01_05
	public Integer getPayAllowance_02_05() { return payAllowance_02_05    ; } 	// ^x02_05
	public Integer getPayAllowance_03_05() { return payAllowance_03_05    ; } 	// ^x03_05
	public Integer getPayAllowance_04_05() { return payAllowance_04_05    ; } 	// ^x04_05
	public Integer getPayAllowance_05_05() { return payAllowance_05_05    ; } 	// ^x05_05
	public Integer getPayAllowance_06_05() { return payAllowance_06_05    ; } 	// ^x06_05
	public Integer getPayAllowance_07_05() { return payAllowance_07_05    ; } 	// ^x07_05
	public Integer getPayAllowance_08_05() { return payAllowance_08_05    ; } 	// ^x08_05
	public Integer getPayAllowance_09_05() { return payAllowance_09_05    ; } 	// ^x09_05
	public Integer getPayAllowance_10_05() { return payAllowance_10_05    ; } 	// ^x10_05
	public Integer getPayAllowance_11_05() { return payAllowance_11_05    ; } 	// ^x11_05
	public Integer getPayAllowance_12_05() { return payAllowance_12_05    ; } 	// ^x12_05
	public Integer getPayAllowance_13_05() { return payAllowance_13_05    ; } 	// ^x13_05
	public Integer getPayAllowance_14_05() { return payAllowance_14_05    ; } 	// ^x14_05
	public Integer getPayAllowance_15_05() { return payAllowance_15_05    ; } 	// ^x15_05
	public Integer getPayAllowance_16_05() { return payAllowance_16_05    ; } 	// ^x16_05
	public Integer getPayAllowance_17_05() { return payAllowance_17_05    ; } 	// ^x17_05
	public Integer getPayAllowance_18_05() { return payAllowance_18_05    ; } 	// ^x18_05
	public Integer getPayAllowance_19_05() { return payAllowance_19_05    ; } 	// ^x19_05
	public Integer getPayAllowance_20_05() { return payAllowance_20_05    ; } 	// ^x20_05
	public Integer getPayAllowance_21_05() { return payAllowance_21_05    ; } 	// ^x21_05
	public Integer getPayAllowance_22_05() { return payAllowance_22_05    ; } 	// ^x22_05
	public Integer getPayAllowance_23_05() { return payAllowance_23_05    ; } 	// ^x23_05
	public Integer getPayAllowance_24_05() { return payAllowance_24_05    ; } 	// ^x24_05
	public Integer getPayAllowance_25_05() { return payAllowance_25_05    ; } 	// ^x25_05
	public Integer getPayAllowance_26_05() { return payAllowance_26_05    ; } 	// ^x26_05
	public Integer getPayAllowance_27_05() { return payAllowance_27_05    ; } 	// ^x27_05
	public Integer getPayAllowance_28_05() { return payAllowance_28_05    ; } 	// ^x28_05
	public Integer getPayAllowance_29_05() { return payAllowance_29_05    ; } 	// ^x29_05
	public Integer getPayAllowance_30_05() { return payAllowance_30_05    ; } 	// ^x30_05
	public Integer getPayDeduction_01_05() { return payDeduction_01_05    ; } 	// ^T01_05
	public Integer getPayDeduction_02_05() { return payDeduction_02_05    ; } 	// ^T02_05
	public Integer getPayDeduction_03_05() { return payDeduction_03_05    ; } 	// ^T03_05
	public Integer getPayDeduction_04_05() { return payDeduction_04_05    ; } 	// ^T04_05
	public Integer getPayDeduction_05_05() { return payDeduction_05_05    ; } 	// ^T05_05
	public Integer getPayDeduction_06_05() { return payDeduction_06_05    ; } 	// ^T06_05
	public Integer getPayDeduction_07_05() { return payDeduction_07_05    ; } 	// ^T07_05
	public Integer getPayDeduction_08_05() { return payDeduction_08_05    ; } 	// ^T08_05
	public Integer getPayDeduction_09_05() { return payDeduction_09_05    ; } 	// ^T09_05
	public Integer getPayDeduction_10_05() { return payDeduction_10_05    ; } 	// ^T10_05
	public Integer getPayDeduction_11_05() { return payDeduction_11_05    ; } 	// ^T11_05
	public Integer getPayDeduction_12_05() { return payDeduction_12_05    ; } 	// ^T12_05
	public Integer getPayDeduction_13_05() { return payDeduction_13_05    ; } 	// ^T13_05
	public Integer getPayDeduction_14_05() { return payDeduction_14_05    ; } 	// ^T14_05
	public Integer getPayDeduction_15_05() { return payDeduction_15_05    ; } 	// ^T15_05
	public Integer getPayDeduction_16_05() { return payDeduction_16_05    ; } 	// ^T16_05
	public Integer getPayDeduction_17_05() { return payDeduction_17_05    ; } 	// ^T17_05
	public Integer getPayDeduction_18_05() { return payDeduction_18_05    ; } 	// ^T18_05
	public Integer getPayDeduction_19_05() { return payDeduction_19_05    ; } 	// ^T19_05
	public Integer getPayDeduction_20_05() { return payDeduction_20_05    ; } 	// ^T20_05
	public Integer getPayDeduction_21_05() { return payDeduction_21_05    ; } 	// ^T21_05
	public Integer getPayDeduction_22_05() { return payDeduction_22_05    ; } 	// ^T22_05
	public Integer getPayDeduction_23_05() { return payDeduction_23_05    ; } 	// ^T23_05
	public Integer getPayDeduction_24_05() { return payDeduction_24_05    ; } 	// ^T24_05
	public Integer getPayDeduction_25_05() { return payDeduction_25_05    ; } 	// ^T25_05
	public Integer getPayDeduction_26_05() { return payDeduction_26_05    ; } 	// ^T26_05
	public Integer getPayDeduction_27_05() { return payDeduction_27_05    ; } 	// ^T27_05
	public Float   getAttendance_01_05()	{ return attendance_01_05    ; } 	// ΑӍ01_05
	public Float   getAttendance_02_05()	{ return attendance_02_05    ; } 	// ΑӍ02_05
	public Float   getAttendance_03_05()	{ return attendance_03_05    ; } 	// ΑӍ03_05
	public Float   getAttendance_04_05()	{ return attendance_04_05    ; } 	// ΑӍ04_05
	public Float   getAttendance_05_05()	{ return attendance_05_05    ; } 	// ΑӍ05_05
	public Integer getAttendance_06_05()	{ return attendance_06_05    ; } 	// ΑӍ06_05
	public Integer getAttendance_07_05()	{ return attendance_07_05    ; } 	// ΑӍ07_05
	public Float   getAttendance_08_05()	{ return attendance_08_05    ; } 	// ΑӍ08_05
	public Float   getAttendance_09_05()	{ return attendance_09_05    ; } 	// ΑӍ09_05
	public Float   getAttendance_10_05()	{ return attendance_10_05    ; } 	// ΑӍ10_05
	public Float   getAttendance_11_05()	{ return attendance_11_05    ; } 	// ΑӍ11_05
	public Float   getAttendance_12_05()	{ return attendance_12_05    ; } 	// ΑӍ12_05
	public Integer getAttendance_13_05()	{ return attendance_13_05    ; } 	// ΑӍ13_05
	public Integer getAttendance_14_05()	{ return attendance_14_05    ; } 	// ΑӍ14_05
	public Integer getBonAllowance_01_05() { return bonAllowance_01_05    ; } 	// ܗ^x01_05
	public Integer getBonAllowance_02_05() { return bonAllowance_02_05    ; } 	// ܗ^x02_05
	public Integer getBonAllowance_03_05() { return bonAllowance_03_05    ; } 	// ܗ^x03_05
	public Integer getBonAllowance_04_05() { return bonAllowance_04_05    ; } 	// ܗ^x04_05
	public Integer getBonAllowance_05_05() { return bonAllowance_05_05    ; } 	// ܗ^x05_05
	public Integer getBonAllowance_06_05() { return bonAllowance_06_05    ; } 	// ܗ^x06_05
	public Integer getBonAllowance_07_05() { return bonAllowance_07_05    ; } 	// ܗ^x07_05
	public Integer getBonAllowance_08_05() { return bonAllowance_08_05    ; } 	// ܗ^x08_05
	public Integer getBonAllowance_09_05() { return bonAllowance_09_05    ; } 	// ܗ^x09_05
	public Integer getBonAllowance_10_05() { return bonAllowance_10_05    ; } 	// ܗ^x10_05
	public Integer getBonDeduction_01_05() { return bonDeduction_01_05    ; } 	// ܗ^T01_05
	public Integer getBonDeduction_02_05() { return bonDeduction_02_05    ; } 	// ܗ^T02_05
	public Integer getBonDeduction_03_05() { return bonDeduction_03_05    ; } 	// ܗ^T03_05
	public Integer getBonDeduction_04_05() { return bonDeduction_04_05    ; } 	// ܗ^T04_05
	public Integer getBonDeduction_05_05() { return bonDeduction_05_05    ; } 	// ܗ^T05_05
	public Integer getBonDeduction_06_05() { return bonDeduction_06_05    ; } 	// ܗ^T06_05
	public Integer getBonDeduction_07_05() { return bonDeduction_07_05    ; } 	// ܗ^T07_05
	public Integer getBonDeduction_08_05() { return bonDeduction_08_05    ; } 	// ܗ^T08_05
	public Integer getBonDeduction_09_05() { return bonDeduction_09_05    ; } 	// ܗ^T09_05
	public Integer getBonDeduction_10_05() { return bonDeduction_10_05    ; } 	// ܗ^T10_05
	public Integer getBonDeduction_11_05() { return bonDeduction_11_05    ; } 	// ܗ^T11_05
	public Integer getBonDeduction_12_05() { return bonDeduction_12_05    ; } 	// ܗ^T12_05
	public Integer getBonDeduction_13_05() { return bonDeduction_13_05    ; } 	// ܗ^T13_05
	public Integer getBonDeduction_14_05() { return bonDeduction_14_05    ; } 	// ܗ^T14_05
	public Integer getBonDeduction_15_05() { return bonDeduction_15_05    ; } 	// ܗ^T15_05
	public Integer getBonDeduction_16_05() { return bonDeduction_16_05    ; } 	// ܗ^T16_05
	public Integer  getBonDeduction_17_05() { return bonDeduction_17_05    ; } 	// ܗ^T17_05

	public Integer getPayAllowance_01_06() { return payAllowance_01_06    ; } 	// ^x01_06
	public Integer getPayAllowance_02_06() { return payAllowance_02_06    ; } 	// ^x02_06
	public Integer getPayAllowance_03_06() { return payAllowance_03_06    ; } 	// ^x03_06
	public Integer getPayAllowance_04_06() { return payAllowance_04_06    ; } 	// ^x04_06
	public Integer getPayAllowance_05_06() { return payAllowance_05_06    ; } 	// ^x05_06
	public Integer getPayAllowance_06_06() { return payAllowance_06_06    ; } 	// ^x06_06
	public Integer getPayAllowance_07_06() { return payAllowance_07_06    ; } 	// ^x07_06
	public Integer getPayAllowance_08_06() { return payAllowance_08_06    ; } 	// ^x08_06
	public Integer getPayAllowance_09_06() { return payAllowance_09_06    ; } 	// ^x09_06
	public Integer getPayAllowance_10_06() { return payAllowance_10_06    ; } 	// ^x10_06
	public Integer getPayAllowance_11_06() { return payAllowance_11_06    ; } 	// ^x11_06
	public Integer getPayAllowance_12_06() { return payAllowance_12_06    ; } 	// ^x12_06
	public Integer getPayAllowance_13_06() { return payAllowance_13_06    ; } 	// ^x13_06
	public Integer getPayAllowance_14_06() { return payAllowance_14_06    ; } 	// ^x14_06
	public Integer getPayAllowance_15_06() { return payAllowance_15_06    ; } 	// ^x15_06
	public Integer getPayAllowance_16_06() { return payAllowance_16_06    ; } 	// ^x16_06
	public Integer getPayAllowance_17_06() { return payAllowance_17_06    ; } 	// ^x17_06
	public Integer getPayAllowance_18_06() { return payAllowance_18_06    ; } 	// ^x18_06
	public Integer getPayAllowance_19_06() { return payAllowance_19_06    ; } 	// ^x19_06
	public Integer getPayAllowance_20_06() { return payAllowance_20_06    ; } 	// ^x20_06
	public Integer getPayAllowance_21_06() { return payAllowance_21_06    ; } 	// ^x21_06
	public Integer getPayAllowance_22_06() { return payAllowance_22_06    ; } 	// ^x22_06
	public Integer getPayAllowance_23_06() { return payAllowance_23_06    ; } 	// ^x23_06
	public Integer getPayAllowance_24_06() { return payAllowance_24_06    ; } 	// ^x24_06
	public Integer getPayAllowance_25_06() { return payAllowance_25_06    ; } 	// ^x25_06
	public Integer getPayAllowance_26_06() { return payAllowance_26_06    ; } 	// ^x26_06
	public Integer getPayAllowance_27_06() { return payAllowance_27_06    ; } 	// ^x27_06
	public Integer getPayAllowance_28_06() { return payAllowance_28_06    ; } 	// ^x28_06
	public Integer getPayAllowance_29_06() { return payAllowance_29_06    ; } 	// ^x29_06
	public Integer getPayAllowance_30_06() { return payAllowance_30_06    ; } 	// ^x30_06
	public Integer getPayDeduction_01_06() { return payDeduction_01_06    ; } 	// ^T01_06
	public Integer getPayDeduction_02_06() { return payDeduction_02_06    ; } 	// ^T02_06
	public Integer getPayDeduction_03_06() { return payDeduction_03_06    ; } 	// ^T03_06
	public Integer getPayDeduction_04_06() { return payDeduction_04_06    ; } 	// ^T04_06
	public Integer getPayDeduction_05_06() { return payDeduction_05_06    ; } 	// ^T05_06
	public Integer getPayDeduction_06_06() { return payDeduction_06_06    ; } 	// ^T06_06
	public Integer getPayDeduction_07_06() { return payDeduction_07_06    ; } 	// ^T07_06
	public Integer getPayDeduction_08_06() { return payDeduction_08_06    ; } 	// ^T08_06
	public Integer getPayDeduction_09_06() { return payDeduction_09_06    ; } 	// ^T09_06
	public Integer getPayDeduction_10_06() { return payDeduction_10_06    ; } 	// ^T10_06
	public Integer getPayDeduction_11_06() { return payDeduction_11_06    ; } 	// ^T11_06
	public Integer getPayDeduction_12_06() { return payDeduction_12_06    ; } 	// ^T12_06
	public Integer getPayDeduction_13_06() { return payDeduction_13_06    ; } 	// ^T13_06
	public Integer getPayDeduction_14_06() { return payDeduction_14_06    ; } 	// ^T14_06
	public Integer getPayDeduction_15_06() { return payDeduction_15_06    ; } 	// ^T15_06
	public Integer getPayDeduction_16_06() { return payDeduction_16_06    ; } 	// ^T16_06
	public Integer getPayDeduction_17_06() { return payDeduction_17_06    ; } 	// ^T17_06
	public Integer getPayDeduction_18_06() { return payDeduction_18_06    ; } 	// ^T18_06
	public Integer getPayDeduction_19_06() { return payDeduction_19_06    ; } 	// ^T19_06
	public Integer getPayDeduction_20_06() { return payDeduction_20_06    ; } 	// ^T20_06
	public Integer getPayDeduction_21_06() { return payDeduction_21_06    ; } 	// ^T21_06
	public Integer getPayDeduction_22_06() { return payDeduction_22_06    ; } 	// ^T22_06
	public Integer getPayDeduction_23_06() { return payDeduction_23_06    ; } 	// ^T23_06
	public Integer getPayDeduction_24_06() { return payDeduction_24_06    ; } 	// ^T24_06
	public Integer getPayDeduction_25_06() { return payDeduction_25_06    ; } 	// ^T25_06
	public Integer getPayDeduction_26_06() { return payDeduction_26_06    ; } 	// ^T26_06
	public Integer getPayDeduction_27_06() { return payDeduction_27_06    ; } 	// ^T27_06
	public Float   getAttendance_01_06()	{ return attendance_01_06		; } 	// ΑӍ01_06
	public Float   getAttendance_02_06()	{ return attendance_02_06		; } 	// ΑӍ02_06
	public Float   getAttendance_03_06()	{ return attendance_03_06		; } 	// ΑӍ03_06
	public Float   getAttendance_04_06()	{ return attendance_04_06		; } 	// ΑӍ04_06
	public Float   getAttendance_05_06()	{ return attendance_05_06		; } 	// ΑӍ05_06
	public Integer getAttendance_06_06()	{ return attendance_06_06		; } 	// ΑӍ06_06
	public Integer getAttendance_07_06()	{ return attendance_07_06		; } 	// ΑӍ07_06
	public Float   getAttendance_08_06()	{ return attendance_08_06		; } 	// ΑӍ08_06
	public Float   getAttendance_09_06()	{ return attendance_09_06		; } 	// ΑӍ09_06
	public Float   getAttendance_10_06()	{ return attendance_10_06		; } 	// ΑӍ10_06
	public Float   getAttendance_11_06()	{ return attendance_11_06		; } 	// ΑӍ11_06
	public Float   getAttendance_12_06()	{ return attendance_12_06		; } 	// ΑӍ12_06
	public Integer getAttendance_13_06()	{ return attendance_13_06		; } 	// ΑӍ13_06
	public Integer getAttendance_14_06()	{ return attendance_14_06		; } 	// ΑӍ14_06
	public Integer getBonAllowance_01_06() { return bonAllowance_01_06    ; } 	// ܗ^x01_06
	public Integer getBonAllowance_02_06() { return bonAllowance_02_06    ; } 	// ܗ^x02_06
	public Integer getBonAllowance_03_06() { return bonAllowance_03_06    ; } 	// ܗ^x03_06
	public Integer getBonAllowance_04_06() { return bonAllowance_04_06    ; } 	// ܗ^x04_06
	public Integer getBonAllowance_05_06() { return bonAllowance_05_06    ; } 	// ܗ^x05_06
	public Integer getBonAllowance_06_06() { return bonAllowance_06_06    ; } 	// ܗ^x06_06
	public Integer getBonAllowance_07_06() { return bonAllowance_07_06    ; } 	// ܗ^x07_06
	public Integer getBonAllowance_08_06() { return bonAllowance_08_06    ; } 	// ܗ^x08_06
	public Integer getBonAllowance_09_06() { return bonAllowance_09_06    ; } 	// ܗ^x09_06
	public Integer getBonAllowance_10_06() { return bonAllowance_10_06    ; } 	// ܗ^x10_06
	public Integer getBonDeduction_01_06() { return bonDeduction_01_06    ; } 	// ܗ^T01_06
	public Integer getBonDeduction_02_06() { return bonDeduction_02_06    ; } 	// ܗ^T02_06
	public Integer getBonDeduction_03_06() { return bonDeduction_03_06    ; } 	// ܗ^T03_06
	public Integer getBonDeduction_04_06() { return bonDeduction_04_06    ; } 	// ܗ^T04_06
	public Integer getBonDeduction_05_06() { return bonDeduction_05_06    ; } 	// ܗ^T05_06
	public Integer getBonDeduction_06_06() { return bonDeduction_06_06    ; } 	// ܗ^T06_06
	public Integer getBonDeduction_07_06() { return bonDeduction_07_06    ; } 	// ܗ^T07_06
	public Integer getBonDeduction_08_06() { return bonDeduction_08_06    ; } 	// ܗ^T08_06
	public Integer getBonDeduction_09_06() { return bonDeduction_09_06    ; } 	// ܗ^T09_06
	public Integer getBonDeduction_10_06() { return bonDeduction_10_06    ; } 	// ܗ^T10_06
	public Integer getBonDeduction_11_06() { return bonDeduction_11_06    ; } 	// ܗ^T11_06
	public Integer getBonDeduction_12_06() { return bonDeduction_12_06    ; } 	// ܗ^T12_06
	public Integer getBonDeduction_13_06() { return bonDeduction_13_06    ; } 	// ܗ^T13_06
	public Integer getBonDeduction_14_06() { return bonDeduction_14_06    ; } 	// ܗ^T14_06
	public Integer getBonDeduction_15_06() { return bonDeduction_15_06    ; } 	// ܗ^T15_06
	public Integer getBonDeduction_16_06() { return bonDeduction_16_06    ; } 	// ܗ^T16_06
	public Integer getBonDeduction_17_06() { return bonDeduction_17_06    ; } 	// ܗ^T17_06
	
	public Integer getPayAllowance_01_07() { return payAllowance_01_07    ; } 	// ^x01_07
	public Integer getPayAllowance_02_07() { return payAllowance_02_07    ; } 	// ^x02_07
	public Integer getPayAllowance_03_07() { return payAllowance_03_07    ; } 	// ^x03_07
	public Integer getPayAllowance_04_07() { return payAllowance_04_07    ; } 	// ^x04_07
	public Integer getPayAllowance_05_07() { return payAllowance_05_07    ; } 	// ^x05_07
	public Integer getPayAllowance_06_07() { return payAllowance_06_07    ; } 	// ^x06_07
	public Integer getPayAllowance_07_07() { return payAllowance_07_07    ; } 	// ^x07_07
	public Integer getPayAllowance_08_07() { return payAllowance_08_07    ; } 	// ^x08_07
	public Integer getPayAllowance_09_07() { return payAllowance_09_07    ; } 	// ^x09_07
	public Integer getPayAllowance_10_07() { return payAllowance_10_07    ; } 	// ^x10_07
	public Integer getPayAllowance_11_07() { return payAllowance_11_07    ; } 	// ^x11_07
	public Integer getPayAllowance_12_07() { return payAllowance_12_07    ; } 	// ^x12_07
	public Integer getPayAllowance_13_07() { return payAllowance_13_07    ; } 	// ^x13_07
	public Integer getPayAllowance_14_07() { return payAllowance_14_07    ; } 	// ^x14_07
	public Integer getPayAllowance_15_07() { return payAllowance_15_07    ; } 	// ^x15_07
	public Integer getPayAllowance_16_07() { return payAllowance_16_07    ; } 	// ^x16_07
	public Integer getPayAllowance_17_07() { return payAllowance_17_07    ; } 	// ^x17_07
	public Integer getPayAllowance_18_07() { return payAllowance_18_07    ; } 	// ^x18_07
	public Integer getPayAllowance_19_07() { return payAllowance_19_07    ; } 	// ^x19_07
	public Integer getPayAllowance_20_07() { return payAllowance_20_07    ; } 	// ^x20_07
	public Integer getPayAllowance_21_07() { return payAllowance_21_07    ; } 	// ^x21_07
	public Integer getPayAllowance_22_07() { return payAllowance_22_07    ; } 	// ^x22_07
	public Integer getPayAllowance_23_07() { return payAllowance_23_07    ; } 	// ^x23_07
	public Integer getPayAllowance_24_07() { return payAllowance_24_07    ; } 	// ^x24_07
	public Integer getPayAllowance_25_07() { return payAllowance_25_07    ; } 	// ^x25_07
	public Integer getPayAllowance_26_07() { return payAllowance_26_07    ; } 	// ^x26_07
	public Integer getPayAllowance_27_07() { return payAllowance_27_07    ; } 	// ^x27_07
	public Integer getPayAllowance_28_07() { return payAllowance_28_07    ; } 	// ^x28_07
	public Integer getPayAllowance_29_07() { return payAllowance_29_07    ; } 	// ^x29_07
	public Integer getPayAllowance_30_07() { return payAllowance_30_07    ; } 	// ^x30_07
	public Integer getPayDeduction_01_07() { return payDeduction_01_07    ; } 	// ^T01_07
	public Integer getPayDeduction_02_07() { return payDeduction_02_07    ; } 	// ^T02_07
	public Integer getPayDeduction_03_07() { return payDeduction_03_07    ; } 	// ^T03_07
	public Integer getPayDeduction_04_07() { return payDeduction_04_07    ; } 	// ^T04_07
	public Integer getPayDeduction_05_07() { return payDeduction_05_07    ; } 	// ^T05_07
	public Integer getPayDeduction_06_07() { return payDeduction_06_07    ; } 	// ^T06_07
	public Integer getPayDeduction_07_07() { return payDeduction_07_07    ; } 	// ^T07_07
	public Integer getPayDeduction_08_07() { return payDeduction_08_07    ; } 	// ^T08_07
	public Integer getPayDeduction_09_07() { return payDeduction_09_07    ; } 	// ^T09_07
	public Integer getPayDeduction_10_07() { return payDeduction_10_07    ; } 	// ^T10_07
	public Integer getPayDeduction_11_07() { return payDeduction_11_07    ; } 	// ^T11_07
	public Integer getPayDeduction_12_07() { return payDeduction_12_07    ; } 	// ^T12_07
	public Integer getPayDeduction_13_07() { return payDeduction_13_07    ; } 	// ^T13_07
	public Integer getPayDeduction_14_07() { return payDeduction_14_07    ; } 	// ^T14_07
	public Integer getPayDeduction_15_07() { return payDeduction_15_07    ; } 	// ^T15_07
	public Integer getPayDeduction_16_07() { return payDeduction_16_07    ; } 	// ^T16_07
	public Integer getPayDeduction_17_07() { return payDeduction_17_07    ; } 	// ^T17_07
	public Integer getPayDeduction_18_07() { return payDeduction_18_07    ; } 	// ^T18_07
	public Integer getPayDeduction_19_07() { return payDeduction_19_07    ; } 	// ^T19_07
	public Integer getPayDeduction_20_07() { return payDeduction_20_07    ; } 	// ^T20_07
	public Integer getPayDeduction_21_07() { return payDeduction_21_07    ; } 	// ^T21_07
	public Integer getPayDeduction_22_07() { return payDeduction_22_07    ; } 	// ^T22_07
	public Integer getPayDeduction_23_07() { return payDeduction_23_07    ; } 	// ^T23_07
	public Integer getPayDeduction_24_07() { return payDeduction_24_07    ; } 	// ^T24_07
	public Integer getPayDeduction_25_07() { return payDeduction_25_07    ; } 	// ^T25_07
	public Integer getPayDeduction_26_07() { return payDeduction_26_07    ; } 	// ^T26_07
	public Integer getPayDeduction_27_07() { return payDeduction_27_07    ; } 	// ^T27_07
	public Float   getAttendance_01_07() { return attendance_01_07    ; } 	// ΑӍ01_07
	public Float   getAttendance_02_07() { return attendance_02_07    ; } 	// ΑӍ02_07
	public Float   getAttendance_03_07() { return attendance_03_07    ; } 	// ΑӍ03_07
	public Float   getAttendance_04_07() { return attendance_04_07    ; } 	// ΑӍ04_07
	public Float   getAttendance_05_07() { return attendance_05_07    ; } 	// ΑӍ05_07
	public Integer getAttendance_06_07() { return attendance_06_07    ; } 	// ΑӍ06_07
	public Integer getAttendance_07_07() { return attendance_07_07    ; } 	// ΑӍ07_07
	public Float   getAttendance_08_07() { return attendance_08_07    ; } 	// ΑӍ08_07
	public Float   getAttendance_09_07() { return attendance_09_07    ; } 	// ΑӍ09_07
	public Float   getAttendance_10_07() { return attendance_10_07    ; } 	// ΑӍ10_07
	public Float   getAttendance_11_07() { return attendance_11_07    ; } 	// ΑӍ11_07
	public Float   getAttendance_12_07() { return attendance_12_07    ; } 	// ΑӍ12_07
	public Integer getAttendance_13_07() { return attendance_13_07    ; } 	// ΑӍ13_07
	public Integer getAttendance_14_07() { return attendance_14_07    ; } 	// ΑӍ14_07
	public Integer getPayAllowance_01_08() { return payAllowance_01_08    ; } 	// ^x01_08
	public Integer getPayAllowance_02_08() { return payAllowance_02_08    ; } 	// ^x02_08
	public Integer getPayAllowance_03_08() { return payAllowance_03_08    ; } 	// ^x03_08
	public Integer getPayAllowance_04_08() { return payAllowance_04_08    ; } 	// ^x04_08
	public Integer getPayAllowance_05_08() { return payAllowance_05_08    ; } 	// ^x05_08
	public Integer getPayAllowance_06_08() { return payAllowance_06_08    ; } 	// ^x06_08
	public Integer getPayAllowance_07_08() { return payAllowance_07_08    ; } 	// ^x07_08
	public Integer getPayAllowance_08_08() { return payAllowance_08_08    ; } 	// ^x08_08
	public Integer getPayAllowance_09_08() { return payAllowance_09_08    ; } 	// ^x09_08
	public Integer getPayAllowance_10_08() { return payAllowance_10_08    ; } 	// ^x10_08
	public Integer getPayAllowance_11_08() { return payAllowance_11_08    ; } 	// ^x11_08
	public Integer getPayAllowance_12_08() { return payAllowance_12_08    ; } 	// ^x12_08
	public Integer getPayAllowance_13_08() { return payAllowance_13_08    ; } 	// ^x13_08
	public Integer getPayAllowance_14_08() { return payAllowance_14_08    ; } 	// ^x14_08
	public Integer getPayAllowance_15_08() { return payAllowance_15_08    ; } 	// ^x15_08
	public Integer getPayAllowance_16_08() { return payAllowance_16_08    ; } 	// ^x16_08
	public Integer getPayAllowance_17_08() { return payAllowance_17_08    ; } 	// ^x17_08
	public Integer getPayAllowance_18_08() { return payAllowance_18_08    ; } 	// ^x18_08
	public Integer getPayAllowance_19_08() { return payAllowance_19_08    ; } 	// ^x19_08
	public Integer getPayAllowance_20_08() { return payAllowance_20_08    ; } 	// ^x20_08
	public Integer getPayAllowance_21_08() { return payAllowance_21_08    ; } 	// ^x21_08
	public Integer getPayAllowance_22_08() { return payAllowance_22_08    ; } 	// ^x22_08
	public Integer getPayAllowance_23_08() { return payAllowance_23_08    ; } 	// ^x23_08
	public Integer getPayAllowance_24_08() { return payAllowance_24_08    ; } 	// ^x24_08
	public Integer getPayAllowance_25_08() { return payAllowance_25_08    ; } 	// ^x25_08
	public Integer getPayAllowance_26_08() { return payAllowance_26_08    ; } 	// ^x26_08
	public Integer getPayAllowance_27_08() { return payAllowance_27_08    ; } 	// ^x27_08
	public Integer getPayAllowance_28_08() { return payAllowance_28_08    ; } 	// ^x28_08
	public Integer getPayAllowance_29_08() { return payAllowance_29_08    ; } 	// ^x29_08
	public Integer getPayAllowance_30_08() { return payAllowance_30_08    ; } 	// ^x30_08
	public Integer getPayDeduction_01_08() { return payDeduction_01_08    ; } 	// ^T01_08
	public Integer getPayDeduction_02_08() { return payDeduction_02_08    ; } 	// ^T02_08
	public Integer getPayDeduction_03_08() { return payDeduction_03_08    ; } 	// ^T03_08
	public Integer getPayDeduction_04_08() { return payDeduction_04_08    ; } 	// ^T04_08
	public Integer getPayDeduction_05_08() { return payDeduction_05_08    ; } 	// ^T05_08
	public Integer getPayDeduction_06_08() { return payDeduction_06_08    ; } 	// ^T06_08
	public Integer getPayDeduction_07_08() { return payDeduction_07_08    ; } 	// ^T07_08
	public Integer getPayDeduction_08_08() { return payDeduction_08_08    ; } 	// ^T08_08
	public Integer getPayDeduction_09_08() { return payDeduction_09_08    ; } 	// ^T09_08
	public Integer getPayDeduction_10_08() { return payDeduction_10_08    ; } 	// ^T10_08
	public Integer getPayDeduction_11_08() { return payDeduction_11_08    ; } 	// ^T11_08
	public Integer getPayDeduction_12_08() { return payDeduction_12_08    ; } 	// ^T12_08
	public Integer getPayDeduction_13_08() { return payDeduction_13_08    ; } 	// ^T13_08
	public Integer getPayDeduction_14_08() { return payDeduction_14_08    ; } 	// ^T14_08
	public Integer getPayDeduction_15_08() { return payDeduction_15_08    ; } 	// ^T15_08
	public Integer getPayDeduction_16_08() { return payDeduction_16_08    ; } 	// ^T16_08
	public Integer getPayDeduction_17_08() { return payDeduction_17_08    ; } 	// ^T17_08
	public Integer getPayDeduction_18_08() { return payDeduction_18_08    ; } 	// ^T18_08
	public Integer getPayDeduction_19_08() { return payDeduction_19_08    ; } 	// ^T19_08
	public Integer getPayDeduction_20_08() { return payDeduction_20_08    ; } 	// ^T20_08
	public Integer getPayDeduction_21_08() { return payDeduction_21_08    ; } 	// ^T21_08
	public Integer getPayDeduction_22_08() { return payDeduction_22_08    ; } 	// ^T22_08
	public Integer getPayDeduction_23_08() { return payDeduction_23_08    ; } 	// ^T23_08
	public Integer getPayDeduction_24_08() { return payDeduction_24_08    ; } 	// ^T24_08
	public Integer getPayDeduction_25_08() { return payDeduction_25_08    ; } 	// ^T25_08
	public Integer getPayDeduction_26_08() { return payDeduction_26_08    ; } 	// ^T26_08
	public Integer getPayDeduction_27_08() { return payDeduction_27_08    ; } 	// ^T27_08
	public Float  getAttendance_01_08() { return attendance_01_08    ; } 	// ΑӍ01_08
	public Float  getAttendance_02_08() { return attendance_02_08    ; } 	// ΑӍ02_08
	public Float  getAttendance_03_08() { return attendance_03_08    ; } 	// ΑӍ03_08
	public Float  getAttendance_04_08() { return attendance_04_08    ; } 	// ΑӍ04_08
	public Float  getAttendance_05_08() { return attendance_05_08    ; } 	// ΑӍ05_08
	public Integer getAttendance_06_08() { return attendance_06_08    ; } 	// ΑӍ06_08
	public Integer getAttendance_07_08() { return attendance_07_08    ; } 	// ΑӍ07_08
	public Float  getAttendance_08_08() { return attendance_08_08    ; } 	// ΑӍ08_08
	public Float  getAttendance_09_08() { return attendance_09_08    ; } 	// ΑӍ09_08
	public Float  getAttendance_10_08() { return attendance_10_08    ; } 	// ΑӍ10_08
	public Float  getAttendance_11_08() { return attendance_11_08    ; } 	// ΑӍ11_08
	public Float  getAttendance_12_08() { return attendance_12_08    ; } 	// ΑӍ12_08
	public Integer getAttendance_13_08() { return attendance_13_08    ; } 	// ΑӍ13_08
	public Integer getAttendance_14_08() { return attendance_14_08    ; } 	// ΑӍ14_08

	public Integer getPayAllowance_01_09() { return payAllowance_01_09    ; } 	// ^x01_09
	public Integer getPayAllowance_02_09() { return payAllowance_02_09    ; } 	// ^x02_09
	public Integer getPayAllowance_03_09() { return payAllowance_03_09    ; } 	// ^x03_09
	public Integer getPayAllowance_04_09() { return payAllowance_04_09    ; } 	// ^x04_09
	public Integer getPayAllowance_05_09() { return payAllowance_05_09    ; } 	// ^x05_09
	public Integer getPayAllowance_06_09() { return payAllowance_06_09    ; } 	// ^x06_09
	public Integer getPayAllowance_07_09() { return payAllowance_07_09    ; } 	// ^x07_09
	public Integer getPayAllowance_08_09() { return payAllowance_08_09    ; } 	// ^x08_09
	public Integer getPayAllowance_09_09() { return payAllowance_09_09    ; } 	// ^x09_09
	public Integer getPayAllowance_10_09() { return payAllowance_10_09    ; } 	// ^x10_09
	public Integer getPayAllowance_11_09() { return payAllowance_11_09    ; } 	// ^x11_09
	public Integer getPayAllowance_12_09() { return payAllowance_12_09    ; } 	// ^x12_09
	public Integer getPayAllowance_13_09() { return payAllowance_13_09    ; } 	// ^x13_09
	public Integer getPayAllowance_14_09() { return payAllowance_14_09    ; } 	// ^x14_09
	public Integer getPayAllowance_15_09() { return payAllowance_15_09    ; } 	// ^x15_09
	public Integer getPayAllowance_16_09() { return payAllowance_16_09    ; } 	// ^x16_09
	public Integer getPayAllowance_17_09() { return payAllowance_17_09    ; } 	// ^x17_09
	public Integer getPayAllowance_18_09() { return payAllowance_18_09    ; } 	// ^x18_09
	public Integer getPayAllowance_19_09() { return payAllowance_19_09    ; } 	// ^x19_09
	public Integer getPayAllowance_20_09() { return payAllowance_20_09    ; } 	// ^x20_09
	public Integer getPayAllowance_21_09() { return payAllowance_21_09    ; } 	// ^x21_09
	public Integer getPayAllowance_22_09() { return payAllowance_22_09    ; } 	// ^x22_09
	public Integer getPayAllowance_23_09() { return payAllowance_23_09    ; } 	// ^x23_09
	public Integer getPayAllowance_24_09() { return payAllowance_24_09    ; } 	// ^x24_09
	public Integer getPayAllowance_25_09() { return payAllowance_25_09    ; } 	// ^x25_09
	public Integer getPayAllowance_26_09() { return payAllowance_26_09    ; } 	// ^x26_09
	public Integer getPayAllowance_27_09() { return payAllowance_27_09    ; } 	// ^x27_09
	public Integer getPayAllowance_28_09() { return payAllowance_28_09    ; } 	// ^x28_09
	public Integer getPayAllowance_29_09() { return payAllowance_29_09    ; } 	// ^x29_09
	public Integer getPayAllowance_30_09() { return payAllowance_30_09    ; } 	// ^x30_09
	public Integer getPayDeduction_01_09() { return payDeduction_01_09    ; } 	// ^T01_09
	public Integer getPayDeduction_02_09() { return payDeduction_02_09    ; } 	// ^T02_09
	public Integer getPayDeduction_03_09() { return payDeduction_03_09    ; } 	// ^T03_09
	public Integer getPayDeduction_04_09() { return payDeduction_04_09    ; } 	// ^T04_09
	public Integer getPayDeduction_05_09() { return payDeduction_05_09    ; } 	// ^T05_09
	public Integer getPayDeduction_06_09() { return payDeduction_06_09    ; } 	// ^T06_09
	public Integer getPayDeduction_07_09() { return payDeduction_07_09    ; } 	// ^T07_09
	public Integer getPayDeduction_08_09() { return payDeduction_08_09    ; } 	// ^T08_09
	public Integer getPayDeduction_09_09() { return payDeduction_09_09    ; } 	// ^T09_09
	public Integer getPayDeduction_10_09() { return payDeduction_10_09    ; } 	// ^T10_09
	public Integer getPayDeduction_11_09() { return payDeduction_11_09    ; } 	// ^T11_09
	public Integer getPayDeduction_12_09() { return payDeduction_12_09    ; } 	// ^T12_09
	public Integer getPayDeduction_13_09() { return payDeduction_13_09    ; } 	// ^T13_09
	public Integer getPayDeduction_14_09() { return payDeduction_14_09    ; } 	// ^T14_09
	public Integer getPayDeduction_15_09() { return payDeduction_15_09    ; } 	// ^T15_09
	public Integer getPayDeduction_16_09() { return payDeduction_16_09    ; } 	// ^T16_09
	public Integer getPayDeduction_17_09() { return payDeduction_17_09    ; } 	// ^T17_09
	public Integer getPayDeduction_18_09() { return payDeduction_18_09    ; } 	// ^T18_09
	public Integer getPayDeduction_19_09() { return payDeduction_19_09    ; } 	// ^T19_09
	public Integer getPayDeduction_20_09() { return payDeduction_20_09    ; } 	// ^T20_09
	public Integer getPayDeduction_21_09() { return payDeduction_21_09    ; } 	// ^T21_09
	public Integer getPayDeduction_22_09() { return payDeduction_22_09    ; } 	// ^T22_09
	public Integer getPayDeduction_23_09() { return payDeduction_23_09    ; } 	// ^T23_09
	public Integer getPayDeduction_24_09() { return payDeduction_24_09    ; } 	// ^T24_09
	public Integer getPayDeduction_25_09() { return payDeduction_25_09    ; } 	// ^T25_09
	public Integer getPayDeduction_26_09() { return payDeduction_26_09    ; } 	// ^T26_09
	public Integer getPayDeduction_27_09() { return payDeduction_27_09    ; } 	// ^T27_09
	public Float  getAttendance_01_09() { return attendance_01_09    ; } 	// ΑӍ01_09
	public Float  getAttendance_02_09() { return attendance_02_09    ; } 	// ΑӍ02_09
	public Float  getAttendance_03_09() { return attendance_03_09    ; } 	// ΑӍ03_09
	public Float  getAttendance_04_09() { return attendance_04_09    ; } 	// ΑӍ04_09
	public Float  getAttendance_05_09() { return attendance_05_09    ; } 	// ΑӍ05_09
	public Integer getAttendance_06_09() { return attendance_06_09    ; } 	// ΑӍ06_09
	public Integer getAttendance_07_09() { return attendance_07_09    ; } 	// ΑӍ07_09
	public Float  getAttendance_08_09() { return attendance_08_09    ; } 	// ΑӍ08_09
	public Float  getAttendance_09_09() { return attendance_09_09    ; } 	// ΑӍ09_09
	public Float  getAttendance_10_09() { return attendance_10_09    ; } 	// ΑӍ10_09
	public Float  getAttendance_11_09() { return attendance_11_09    ; } 	// ΑӍ11_09
	public Float  getAttendance_12_09() { return attendance_12_09    ; } 	// ΑӍ12_09
	public Integer getAttendance_13_09() { return attendance_13_09    ; } 	// ΑӍ13_09
	public Integer getAttendance_14_09() { return attendance_14_09    ; } 	// ΑӍ14_09

	public Integer getPayAllowance_01_10() { return payAllowance_01_10    ; } 	// ^x01_10
	public Integer getPayAllowance_02_10() { return payAllowance_02_10    ; } 	// ^x02_10
	public Integer getPayAllowance_03_10() { return payAllowance_03_10    ; } 	// ^x03_10
	public Integer getPayAllowance_04_10() { return payAllowance_04_10    ; } 	// ^x04_10
	public Integer getPayAllowance_05_10() { return payAllowance_05_10    ; } 	// ^x05_10
	public Integer getPayAllowance_06_10() { return payAllowance_06_10    ; } 	// ^x06_10
	public Integer getPayAllowance_07_10() { return payAllowance_07_10    ; } 	// ^x07_10
	public Integer getPayAllowance_08_10() { return payAllowance_08_10    ; } 	// ^x08_10
	public Integer getPayAllowance_09_10() { return payAllowance_09_10    ; } 	// ^x09_10
	public Integer getPayAllowance_10_10() { return payAllowance_10_10    ; } 	// ^x10_10
	public Integer getPayAllowance_11_10() { return payAllowance_11_10    ; } 	// ^x11_10
	public Integer getPayAllowance_12_10() { return payAllowance_12_10    ; } 	// ^x12_10
	public Integer getPayAllowance_13_10() { return payAllowance_13_10    ; } 	// ^x13_10
	public Integer getPayAllowance_14_10() { return payAllowance_14_10    ; } 	// ^x14_10
	public Integer getPayAllowance_15_10() { return payAllowance_15_10    ; } 	// ^x15_10
	public Integer getPayAllowance_16_10() { return payAllowance_16_10    ; } 	// ^x16_10
	public Integer getPayAllowance_17_10() { return payAllowance_17_10    ; } 	// ^x17_10
	public Integer getPayAllowance_18_10() { return payAllowance_18_10    ; } 	// ^x18_10
	public Integer getPayAllowance_19_10() { return payAllowance_19_10    ; } 	// ^x19_10
	public Integer getPayAllowance_20_10() { return payAllowance_20_10    ; } 	// ^x20_10
	public Integer getPayAllowance_21_10() { return payAllowance_21_10    ; } 	// ^x21_10
	public Integer getPayAllowance_22_10() { return payAllowance_22_10    ; } 	// ^x22_10
	public Integer getPayAllowance_23_10() { return payAllowance_23_10    ; } 	// ^x23_10
	public Integer getPayAllowance_24_10() { return payAllowance_24_10    ; } 	// ^x24_10
	public Integer getPayAllowance_25_10() { return payAllowance_25_10    ; } 	// ^x25_10
	public Integer getPayAllowance_26_10() { return payAllowance_26_10    ; } 	// ^x26_10
	public Integer getPayAllowance_27_10() { return payAllowance_27_10    ; } 	// ^x27_10
	public Integer getPayAllowance_28_10() { return payAllowance_28_10    ; } 	// ^x28_10
	public Integer getPayAllowance_29_10() { return payAllowance_29_10    ; } 	// ^x29_10
	public Integer getPayAllowance_30_10() { return payAllowance_30_10    ; } 	// ^x30_10
	public Integer getPayDeduction_01_10() { return payDeduction_01_10    ; } 	// ^T01_10
	public Integer getPayDeduction_02_10() { return payDeduction_02_10    ; } 	// ^T02_10
	public Integer getPayDeduction_03_10() { return payDeduction_03_10    ; } 	// ^T03_10
	public Integer getPayDeduction_04_10() { return payDeduction_04_10    ; } 	// ^T04_10
	public Integer getPayDeduction_05_10() { return payDeduction_05_10    ; } 	// ^T05_10
	public Integer getPayDeduction_06_10() { return payDeduction_06_10    ; } 	// ^T06_10
	public Integer getPayDeduction_07_10() { return payDeduction_07_10    ; } 	// ^T07_10
	public Integer getPayDeduction_08_10() { return payDeduction_08_10    ; } 	// ^T08_10
	public Integer getPayDeduction_09_10() { return payDeduction_09_10    ; } 	// ^T09_10
	public Integer getPayDeduction_10_10() { return payDeduction_10_10    ; } 	// ^T10_10
	public Integer getPayDeduction_11_10() { return payDeduction_11_10    ; } 	// ^T11_10
	public Integer getPayDeduction_12_10() { return payDeduction_12_10    ; } 	// ^T12_10
	public Integer getPayDeduction_13_10() { return payDeduction_13_10    ; } 	// ^T13_10
	public Integer getPayDeduction_14_10() { return payDeduction_14_10    ; } 	// ^T14_10
	public Integer getPayDeduction_15_10() { return payDeduction_15_10    ; } 	// ^T15_10
	public Integer getPayDeduction_16_10() { return payDeduction_16_10    ; } 	// ^T16_10
	public Integer getPayDeduction_17_10() { return payDeduction_17_10    ; } 	// ^T17_10
	public Integer getPayDeduction_18_10() { return payDeduction_18_10    ; } 	// ^T18_10
	public Integer getPayDeduction_19_10() { return payDeduction_19_10    ; } 	// ^T19_10
	public Integer getPayDeduction_20_10() { return payDeduction_20_10    ; } 	// ^T20_10
	public Integer getPayDeduction_21_10() { return payDeduction_21_10    ; } 	// ^T21_10
	public Integer getPayDeduction_22_10() { return payDeduction_22_10    ; } 	// ^T22_10
	public Integer getPayDeduction_23_10() { return payDeduction_23_10    ; } 	// ^T23_10
	public Integer getPayDeduction_24_10() { return payDeduction_24_10    ; } 	// ^T24_10
	public Integer getPayDeduction_25_10() { return payDeduction_25_10    ; } 	// ^T25_10
	public Integer getPayDeduction_26_10() { return payDeduction_26_10    ; } 	// ^T26_10
	public Integer getPayDeduction_27_10() { return payDeduction_27_10    ; } 	// ^T27_10
	public Float   getAttendance_01_10() { return attendance_01_10    ; } 	// ΑӍ01_10
	public Float   getAttendance_02_10() { return attendance_02_10    ; } 	// ΑӍ02_10
	public Float   getAttendance_03_10() { return attendance_03_10    ; } 	// ΑӍ03_10
	public Float   getAttendance_04_10() { return attendance_04_10    ; } 	// ΑӍ04_10
	public Float   getAttendance_05_10() { return attendance_05_10    ; } 	// ΑӍ05_10
	public Integer getAttendance_06_10() { return attendance_06_10    ; } 	// ΑӍ06_10
	public Integer getAttendance_07_10() { return attendance_07_10    ; } 	// ΑӍ07_10
	public Float   getAttendance_08_10() { return attendance_08_10    ; } 	// ΑӍ08_10
	public Float   getAttendance_09_10() { return attendance_09_10    ; } 	// ΑӍ09_10
	public Float   getAttendance_10_10() { return attendance_10_10    ; } 	// ΑӍ10_10
	public Float   getAttendance_11_10() { return attendance_11_10    ; } 	// ΑӍ11_10
	public Float   getAttendance_12_10() { return attendance_12_10    ; } 	// ΑӍ12_10
	public Integer getAttendance_13_10() { return attendance_13_10    ; } 	// ΑӍ13_10
	public Integer getAttendance_14_10() { return attendance_14_10    ; } 	// ΑӍ14_10

	public Integer getPayAllowance_01_11() { return payAllowance_01_11    ; } 	// ^x01_11
	public Integer getPayAllowance_02_11() { return payAllowance_02_11    ; } 	// ^x02_11
	public Integer getPayAllowance_03_11() { return payAllowance_03_11    ; } 	// ^x03_11
	public Integer getPayAllowance_04_11() { return payAllowance_04_11    ; } 	// ^x04_11
	public Integer getPayAllowance_05_11() { return payAllowance_05_11    ; } 	// ^x05_11
	public Integer getPayAllowance_06_11() { return payAllowance_06_11    ; } 	// ^x06_11
	public Integer getPayAllowance_07_11() { return payAllowance_07_11    ; } 	// ^x07_11
	public Integer getPayAllowance_08_11() { return payAllowance_08_11    ; } 	// ^x08_11
	public Integer getPayAllowance_09_11() { return payAllowance_09_11    ; } 	// ^x09_11
	public Integer getPayAllowance_10_11() { return payAllowance_10_11    ; } 	// ^x10_11
	public Integer getPayAllowance_11_11() { return payAllowance_11_11    ; } 	// ^x11_11
	public Integer getPayAllowance_12_11() { return payAllowance_12_11    ; } 	// ^x12_11
	public Integer getPayAllowance_13_11() { return payAllowance_13_11    ; } 	// ^x13_11
	public Integer getPayAllowance_14_11() { return payAllowance_14_11    ; } 	// ^x14_11
	public Integer getPayAllowance_15_11() { return payAllowance_15_11    ; } 	// ^x15_11
	public Integer getPayAllowance_16_11() { return payAllowance_16_11    ; } 	// ^x16_11
	public Integer getPayAllowance_17_11() { return payAllowance_17_11    ; } 	// ^x17_11
	public Integer getPayAllowance_18_11() { return payAllowance_18_11    ; } 	// ^x18_11
	public Integer getPayAllowance_19_11() { return payAllowance_19_11    ; } 	// ^x19_11
	public Integer getPayAllowance_20_11() { return payAllowance_20_11    ; } 	// ^x20_11
	public Integer getPayAllowance_21_11() { return payAllowance_21_11    ; } 	// ^x21_11
	public Integer getPayAllowance_22_11() { return payAllowance_22_11    ; } 	// ^x22_11
	public Integer getPayAllowance_23_11() { return payAllowance_23_11    ; } 	// ^x23_11
	public Integer getPayAllowance_24_11() { return payAllowance_24_11    ; } 	// ^x24_11
	public Integer getPayAllowance_25_11() { return payAllowance_25_11    ; } 	// ^x25_11
	public Integer getPayAllowance_26_11() { return payAllowance_26_11    ; } 	// ^x26_11
	public Integer getPayAllowance_27_11() { return payAllowance_27_11    ; } 	// ^x27_11
	public Integer getPayAllowance_28_11() { return payAllowance_28_11    ; } 	// ^x28_11
	public Integer getPayAllowance_29_11() { return payAllowance_29_11    ; } 	// ^x29_11
	public Integer getPayAllowance_30_11() { return payAllowance_30_11    ; } 	// ^x30_11
	public Integer getPayDeduction_01_11() { return payDeduction_01_11    ; } 	// ^T01_11
	public Integer getPayDeduction_02_11() { return payDeduction_02_11    ; } 	// ^T02_11
	public Integer getPayDeduction_03_11() { return payDeduction_03_11    ; } 	// ^T03_11
	public Integer getPayDeduction_04_11() { return payDeduction_04_11    ; } 	// ^T04_11
	public Integer getPayDeduction_05_11() { return payDeduction_05_11    ; } 	// ^T05_11
	public Integer getPayDeduction_06_11() { return payDeduction_06_11    ; } 	// ^T06_11
	public Integer getPayDeduction_07_11() { return payDeduction_07_11    ; } 	// ^T07_11
	public Integer getPayDeduction_08_11() { return payDeduction_08_11    ; } 	// ^T08_11
	public Integer getPayDeduction_09_11() { return payDeduction_09_11    ; } 	// ^T09_11
	public Integer getPayDeduction_10_11() { return payDeduction_10_11    ; } 	// ^T10_11
	public Integer getPayDeduction_11_11() { return payDeduction_11_11    ; } 	// ^T11_11
	public Integer getPayDeduction_12_11() { return payDeduction_12_11    ; } 	// ^T12_11
	public Integer getPayDeduction_13_11() { return payDeduction_13_11    ; } 	// ^T13_11
	public Integer getPayDeduction_14_11() { return payDeduction_14_11    ; } 	// ^T14_11
	public Integer getPayDeduction_15_11() { return payDeduction_15_11    ; } 	// ^T15_11
	public Integer getPayDeduction_16_11() { return payDeduction_16_11    ; } 	// ^T16_11
	public Integer getPayDeduction_17_11() { return payDeduction_17_11    ; } 	// ^T17_11
	public Integer getPayDeduction_18_11() { return payDeduction_18_11    ; } 	// ^T18_11
	public Integer getPayDeduction_19_11() { return payDeduction_19_11    ; } 	// ^T19_11
	public Integer getPayDeduction_20_11() { return payDeduction_20_11    ; } 	// ^T20_11
	public Integer getPayDeduction_21_11() { return payDeduction_21_11    ; } 	// ^T21_11
	public Integer getPayDeduction_22_11() { return payDeduction_22_11    ; } 	// ^T22_11
	public Integer getPayDeduction_23_11() { return payDeduction_23_11    ; } 	// ^T23_11
	public Integer getPayDeduction_24_11() { return payDeduction_24_11    ; } 	// ^T24_11
	public Integer getPayDeduction_25_11() { return payDeduction_25_11    ; } 	// ^T25_11
	public Integer getPayDeduction_26_11() { return payDeduction_26_11    ; } 	// ^T26_11
	public Integer getPayDeduction_27_11() { return payDeduction_27_11    ; } 	// ^T27_11
	public Float   getAttendance_01_11() { return attendance_01_11    ; } 	// ΑӍ01_11
	public Float   getAttendance_02_11() { return attendance_02_11    ; } 	// ΑӍ02_11
	public Float   getAttendance_03_11() { return attendance_03_11    ; } 	// ΑӍ03_11
	public Float   getAttendance_04_11() { return attendance_04_11    ; } 	// ΑӍ04_11
	public Float   getAttendance_05_11() { return attendance_05_11    ; } 	// ΑӍ05_11
	public Integer getAttendance_06_11() { return attendance_06_11    ; } 	// ΑӍ06_11
	public Integer getAttendance_07_11() { return attendance_07_11    ; } 	// ΑӍ07_11
	public Float   getAttendance_08_11() { return attendance_08_11    ; } 	// ΑӍ08_11
	public Float   getAttendance_09_11() { return attendance_09_11    ; } 	// ΑӍ09_11
	public Float   getAttendance_10_11() { return attendance_10_11    ; } 	// ΑӍ10_11
	public Float   getAttendance_11_11() { return attendance_11_11    ; } 	// ΑӍ11_11
	public Float   getAttendance_12_11() { return attendance_12_11    ; } 	// ΑӍ12_11
	public Integer getAttendance_13_11() { return attendance_13_11    ; } 	// ΑӍ13_11
	public Integer getAttendance_14_11() { return attendance_14_11    ; } 	// ΑӍ14_11
	public Integer getBonAllowance_01_11() { return bonAllowance_01_11    ; } 	// ܗ^x01_11
	public Integer getBonAllowance_02_11() { return bonAllowance_02_11    ; } 	// ܗ^x02_11
	public Integer getBonAllowance_03_11() { return bonAllowance_03_11    ; } 	// ܗ^x03_11
	public Integer getBonAllowance_04_11() { return bonAllowance_04_11    ; } 	// ܗ^x04_11
	public Integer getBonAllowance_05_11() { return bonAllowance_05_11    ; } 	// ܗ^x05_11
	public Integer getBonAllowance_06_11() { return bonAllowance_06_11    ; } 	// ܗ^x06_11
	public Integer getBonAllowance_07_11() { return bonAllowance_07_11    ; } 	// ܗ^x07_11
	public Integer getBonAllowance_08_11() { return bonAllowance_08_11    ; } 	// ܗ^x08_11
	public Integer getBonAllowance_09_11() { return bonAllowance_09_11    ; } 	// ܗ^x09_11
	public Integer getBonAllowance_10_11() { return bonAllowance_10_11    ; } 	// ܗ^x10_11
	public Integer getBonDeduction_01_11() { return bonDeduction_01_11    ; } 	// ܗ^T01_11
	public Integer getBonDeduction_02_11() { return bonDeduction_02_11    ; } 	// ܗ^T02_11
	public Integer getBonDeduction_03_11() { return bonDeduction_03_11    ; } 	// ܗ^T03_11
	public Integer getBonDeduction_04_11() { return bonDeduction_04_11    ; } 	// ܗ^T04_11
	public Integer getBonDeduction_05_11() { return bonDeduction_05_11    ; } 	// ܗ^T05_11
	public Integer getBonDeduction_06_11() { return bonDeduction_06_11    ; } 	// ܗ^T06_11
	public Integer getBonDeduction_07_11() { return bonDeduction_07_11    ; } 	// ܗ^T07_11
	public Integer getBonDeduction_08_11() { return bonDeduction_08_11    ; } 	// ܗ^T08_11
	public Integer getBonDeduction_09_11() { return bonDeduction_09_11    ; } 	// ܗ^T09_11
	public Integer getBonDeduction_10_11() { return bonDeduction_10_11    ; } 	// ܗ^T10_11
	public Integer getBonDeduction_11_11() { return bonDeduction_11_11    ; } 	// ܗ^T11_11
	public Integer getBonDeduction_12_11() { return bonDeduction_12_11    ; } 	// ܗ^T12_11
	public Integer getBonDeduction_13_11() { return bonDeduction_13_11    ; } 	// ܗ^T13_11
	public Integer getBonDeduction_14_11() { return bonDeduction_14_11    ; } 	// ܗ^T14_11
	public Integer getBonDeduction_15_11() { return bonDeduction_15_11    ; } 	// ܗ^T15_11
	public Integer getBonDeduction_16_11() { return bonDeduction_16_11    ; } 	// ܗ^T16_11
	public Integer getBonDeduction_17_11() { return bonDeduction_17_11    ; } 	// ܗ^T17_11
	public Integer getPayAllowance_01_12() { return payAllowance_01_12    ; } 	// ^x01_12
	public Integer getPayAllowance_02_12() { return payAllowance_02_12    ; } 	// ^x02_12
	public Integer getPayAllowance_03_12() { return payAllowance_03_12    ; } 	// ^x03_12
	public Integer getPayAllowance_04_12() { return payAllowance_04_12    ; } 	// ^x04_12
	public Integer getPayAllowance_05_12() { return payAllowance_05_12    ; } 	// ^x05_12
	public Integer getPayAllowance_06_12() { return payAllowance_06_12    ; } 	// ^x06_12
	public Integer getPayAllowance_07_12() { return payAllowance_07_12    ; } 	// ^x07_12
	public Integer getPayAllowance_08_12() { return payAllowance_08_12    ; } 	// ^x08_12
	public Integer getPayAllowance_09_12() { return payAllowance_09_12    ; } 	// ^x09_12
	public Integer getPayAllowance_10_12() { return payAllowance_10_12    ; } 	// ^x10_12
	public Integer getPayAllowance_11_12() { return payAllowance_11_12    ; } 	// ^x11_12
	public Integer getPayAllowance_12_12() { return payAllowance_12_12    ; } 	// ^x12_12
	public Integer getPayAllowance_13_12() { return payAllowance_13_12    ; } 	// ^x13_12
	public Integer getPayAllowance_14_12() { return payAllowance_14_12    ; } 	// ^x14_12
	public Integer getPayAllowance_15_12() { return payAllowance_15_12    ; } 	// ^x15_12
	public Integer getPayAllowance_16_12() { return payAllowance_16_12    ; } 	// ^x16_12
	public Integer getPayAllowance_17_12() { return payAllowance_17_12    ; } 	// ^x17_12
	public Integer getPayAllowance_18_12() { return payAllowance_18_12    ; } 	// ^x18_12
	public Integer getPayAllowance_19_12() { return payAllowance_19_12    ; } 	// ^x19_12
	public Integer getPayAllowance_20_12() { return payAllowance_20_12    ; } 	// ^x20_12
	public Integer getPayAllowance_21_12() { return payAllowance_21_12    ; } 	// ^x21_12
	public Integer getPayAllowance_22_12() { return payAllowance_22_12    ; } 	// ^x22_12
	public Integer getPayAllowance_23_12() { return payAllowance_23_12    ; } 	// ^x23_12
	public Integer getPayAllowance_24_12() { return payAllowance_24_12    ; } 	// ^x24_12
	public Integer getPayAllowance_25_12() { return payAllowance_25_12    ; } 	// ^x25_12
	public Integer getPayAllowance_26_12() { return payAllowance_26_12    ; } 	// ^x26_12
	public Integer getPayAllowance_27_12() { return payAllowance_27_12    ; } 	// ^x27_12
	public Integer getPayAllowance_28_12() { return payAllowance_28_12    ; } 	// ^x28_12
	public Integer getPayAllowance_29_12() { return payAllowance_29_12    ; } 	// ^x29_12
	public Integer getPayAllowance_30_12() { return payAllowance_30_12    ; } 	// ^x30_12
	public Integer getPayDeduction_01_12() { return payDeduction_01_12    ; } 	// ^T01_12
	public Integer getPayDeduction_02_12() { return payDeduction_02_12    ; } 	// ^T02_12
	public Integer getPayDeduction_03_12() { return payDeduction_03_12    ; } 	// ^T03_12
	public Integer getPayDeduction_04_12() { return payDeduction_04_12    ; } 	// ^T04_12
	public Integer getPayDeduction_05_12() { return payDeduction_05_12    ; } 	// ^T05_12
	public Integer getPayDeduction_06_12() { return payDeduction_06_12    ; } 	// ^T06_12
	public Integer getPayDeduction_07_12() { return payDeduction_07_12    ; } 	// ^T07_12
	public Integer getPayDeduction_08_12() { return payDeduction_08_12    ; } 	// ^T08_12
	public Integer getPayDeduction_09_12() { return payDeduction_09_12    ; } 	// ^T09_12
	public Integer getPayDeduction_10_12() { return payDeduction_10_12    ; } 	// ^T10_12
	public Integer getPayDeduction_11_12() { return payDeduction_11_12    ; } 	// ^T11_12
	public Integer getPayDeduction_12_12() { return payDeduction_12_12    ; } 	// ^T12_12
	public Integer getPayDeduction_13_12() { return payDeduction_13_12    ; } 	// ^T13_12
	public Integer getPayDeduction_14_12() { return payDeduction_14_12    ; } 	// ^T14_12
	public Integer getPayDeduction_15_12() { return payDeduction_15_12    ; } 	// ^T15_12
	public Integer getPayDeduction_16_12() { return payDeduction_16_12    ; } 	// ^T16_12
	public Integer getPayDeduction_17_12() { return payDeduction_17_12    ; } 	// ^T17_12
	public Integer getPayDeduction_18_12() { return payDeduction_18_12    ; } 	// ^T18_12
	public Integer getPayDeduction_19_12() { return payDeduction_19_12    ; } 	// ^T19_12
	public Integer getPayDeduction_20_12() { return payDeduction_20_12    ; } 	// ^T20_12
	public Integer getPayDeduction_21_12() { return payDeduction_21_12    ; } 	// ^T21_12
	public Integer getPayDeduction_22_12() { return payDeduction_22_12    ; } 	// ^T22_12
	public Integer getPayDeduction_23_12() { return payDeduction_23_12    ; } 	// ^T23_12
	public Integer getPayDeduction_24_12() { return payDeduction_24_12    ; } 	// ^T24_12
	public Integer getPayDeduction_25_12() { return payDeduction_25_12    ; } 	// ^T25_12
	public Integer getPayDeduction_26_12() { return payDeduction_26_12    ; } 	// ^T26_12
	public Integer getPayDeduction_27_12() { return payDeduction_27_12    ; } 	// ^T27_12
	public Float   getAttendance_01_12() { return attendance_01_12    ; } 	// ΑӍ01_12
	public Float   getAttendance_02_12() { return attendance_02_12    ; } 	// ΑӍ02_12
	public Float   getAttendance_03_12() { return attendance_03_12    ; } 	// ΑӍ03_12
	public Float   getAttendance_04_12() { return attendance_04_12    ; } 	// ΑӍ04_12
	public Float   getAttendance_05_12() { return attendance_05_12    ; } 	// ΑӍ05_12
	public Integer getAttendance_06_12() { return attendance_06_12    ; } 	// ΑӍ06_12
	public Integer getAttendance_07_12() { return attendance_07_12    ; } 	// ΑӍ07_12
	public Float   getAttendance_08_12() { return attendance_08_12    ; } 	// ΑӍ08_12
	public Float   getAttendance_09_12() { return attendance_09_12    ; } 	// ΑӍ09_12
	public Float   getAttendance_10_12() { return attendance_10_12    ; } 	// ΑӍ10_12
	public Float   getAttendance_11_12() { return attendance_11_12    ; } 	// ΑӍ11_12
	public Float   getAttendance_12_12() { return attendance_12_12    ; } 	// ΑӍ12_12
	public Integer getAttendance_13_12() { return attendance_13_12    ; } 	// ΑӍ13_12
	public Integer getAttendance_14_12() { return attendance_14_12    ; } 	// ΑӍ14_12

	public String getIncomeTaxType    () { return incomeTaxType        ; } 	// ېŋ敪
	public String getAdjustmentType   () { return adjustmentType       ; } 	// N敪
	public String getSelfWidowType    () { return selfWidowType        ; } 	// {lǕw敪
	public String getSelfHandicapType () { return selfHandicapType     ; } 	// {lQ敪
	public String getSelfStudentType  () { return selfStudentType      ; } 	// {lw敪
	public String getSpouseIntendType () { return spouseIntendType     ; } 	// zҋ敪
	public String getGeneralDependent () { return generalDependent     ; } 	// ʕ}{e
	public String getSpecificDependent() { return specificDependent    ; } 	// }{e
	public String getElderlyDependent () { return elderlyDependent     ; } 	// Vl}{e
	public String getLiveWithEldRel   () { return liveWithEldRel       ; } 	// Ve
	public String getLiveWithHandiGe  () { return liveWithHandiGe      ; } 	// 
	public String getLiveWithHandiSp  () { return liveWithHandiSp      ; } 	// 
	public String getLiveWithHandiEl  () { return liveWithHandiEl      ; } 	// Vl
	public String getLiveWithHandiEr  () { return liveWithHandiEr      ; } 	// Ve
	public String getGeneralHandicap  () { return generalHandicap      ; } 	// ʏQ
	public String getSpecificHandicap () { return specificHandicap     ; } 	// ʏQ
	public String getStationCode      () { return stationCode          ; } 	// R[h
	public String getGender           () { return gender               ; } 	// 
	public String getPostalCode       () { return postalCode           ; } 	// X֔ԍ
	public String getAddress          () { return address              ; } 	// Z
	public String getPositionCode     () { return positionCode         ; } 	// E
	public String getBirthDate        () { return birthDate            ; } 	// N
	public String getKCode            () { return kCode                ; } 	// ЈR[h
	public String getEntranceDate     () { return entranceDate         ; } 	// Г
	public String getKName            () { return kName                ; } 	// Ј
	public String getRetirementDate   () { return retirementDate       ; } 	// ގГ
	public String getPhoneNumber      () { return phoneNumber          ; } 	// dbԍ
	public String getHealthNo         () { return healthNo             ; } 	// Nیԍ
	public String getFundNo           () { return fundNo               ; } 	// Nԍ
	public String getPensionNo        () { return pensionNo            ; } 	// Nԍ
	public String getUnemployNo       () { return unemployNo           ; } 	// ٗpیԍ
	


	
	
	public void setCompanyName (String companyName) { this.companyName  = companyName                        ; }	// Ж
	public void setOutputYear  (String outputYear ) { this.outputYear   = outputYear                         ; }	// 䒠o͔N(a)
	public void setOutputDate  (String outputDate ) { this.outputDate   = outputDate                         ; }	// o͓


	
	public void setPayPayday_01        (String  payPayday_01        ) { this.payPayday_01         = payPayday_01                         ; }// ^x_01
	public void setPayPayday_02        (String  payPayday_02        ) { this.payPayday_02         = payPayday_02                         ; }// ^x_02
	public void setPayPayday_03        (String  payPayday_03        ) { this.payPayday_03         = payPayday_03                         ; }// ^x_03
	public void setPayPayday_04        (String  payPayday_04        ) { this.payPayday_04         = payPayday_04                         ; }// ^x_04
	public void setPayPayday_05        (String  payPayday_05        ) { this.payPayday_05         = payPayday_05                         ; }// ^x_05
	public void setPayPayday_06        (String  payPayday_06        ) { this.payPayday_06         = payPayday_06                         ; }// ^x_06
	public void setPayPayday_07        (String  payPayday_07        ) { this.payPayday_07         = payPayday_07                         ; }// ^x_07
	public void setPayPayday_08        (String  payPayday_08        ) { this.payPayday_08         = payPayday_08                         ; }// ^x_08
	public void setPayPayday_09        (String  payPayday_09        ) { this.payPayday_09         = payPayday_09                         ; }// ^x_09
	public void setPayPayday_10        (String  payPayday_10        ) { this.payPayday_10         = payPayday_10                         ; }// ^x_10
	public void setPayPayday_11        (String  payPayday_11        ) { this.payPayday_11         = payPayday_11                         ; }// ^x_11
	public void setPayPayday_12        (String  payPayday_12        ) { this.payPayday_12         = payPayday_12                         ; }// ^x_12

	public void setBonPayday_01        (String  bonPayday_01        ) { this.bonPayday_01         = bonPayday_01                         ; }// ܗ^x_01
	public void setBonPayday_02        (String  bonPayday_02        ) { this.bonPayday_02         = bonPayday_02                         ; }// ܗ^x_02
	public void setBonPayday_03        (String  bonPayday_03        ) { this.bonPayday_03         = bonPayday_03                         ; }// ܗ^x_03
	public void setBonPayday_04        (String  bonPayday_04        ) { this.bonPayday_04         = bonPayday_04                         ; }// ܗ^x_04
	public void setBonPayday_05        (String  bonPayday_05        ) { this.bonPayday_05         = bonPayday_05                         ; }// ܗ^x_05
	public void setBonPayday_06        (String  bonPayday_06        ) { this.bonPayday_06         = bonPayday_06                         ; }// ܗ^x_06



	public void setPayAllowanceTotal_01(Integer  payAllowanceTotal_01) { this.payAllowanceTotal_01 = payAllowanceTotal_01                 ; }// ^xz_01
	public void setPayDeductionTotal_01(Integer  payDeductionTotal_01) { this.payDeductionTotal_01 = payDeductionTotal_01                 ; }// ^Tz_01
	public void setPayPaymentTotal_01  (Integer  payPaymentTotal_01  ) { this.payPaymentTotal_01   = payPaymentTotal_01                   ; }// ^xz_01
	public void setPayBank1PayAmount_01(Integer  payBank1PayAmount_01) { this.payBank1PayAmount_01 = payBank1PayAmount_01                 ; }// ^s1Uz_01
	public void setPayBank2PayAmount_01(Integer  payBank2PayAmount_01) { this.payBank2PayAmount_01 = payBank2PayAmount_01                 ; }// ^s2Uz_01
	public void setPayCashPayAmount_01 (Integer  payCashPayAmount_01 ) { this.payCashPayAmount_01  = payCashPayAmount_01                  ; }// ^xz_01
	public void setPayAllowanceTotal_02(Integer  payAllowanceTotal_02) { this.payAllowanceTotal_02 = payAllowanceTotal_02                 ; }// ^xz_02
	public void setPayDeductionTotal_02(Integer  payDeductionTotal_02) { this.payDeductionTotal_02 = payDeductionTotal_02                 ; }// ^Tz_02
	public void setPayPaymentTotal_02  (Integer  payPaymentTotal_02  ) { this.payPaymentTotal_02   = payPaymentTotal_02                   ; }// ^xz_02
	public void setPayBank1PayAmount_02(Integer  payBank1PayAmount_02) { this.payBank1PayAmount_02 = payBank1PayAmount_02                 ; }// ^s1Uz_02
	public void setPayBank2PayAmount_02(Integer  payBank2PayAmount_02) { this.payBank2PayAmount_02 = payBank2PayAmount_02                 ; }// ^s2Uz_02
	public void setPayCashPayAmount_02 (Integer  payCashPayAmount_02 ) { this.payCashPayAmount_02  = payCashPayAmount_02                  ; }// ^xz_02
	public void setPayAllowanceTotal_03(Integer  payAllowanceTotal_03) { this.payAllowanceTotal_03 = payAllowanceTotal_03                 ; }// ^xz_03
	public void setPayDeductionTotal_03(Integer  payDeductionTotal_03) { this.payDeductionTotal_03 = payDeductionTotal_03                 ; }// ^Tz_03
	public void setPayPaymentTotal_03  (Integer  payPaymentTotal_03  ) { this.payPaymentTotal_03   = payPaymentTotal_03                   ; }// ^xz_03
	public void setPayBank1PayAmount_03(Integer  payBank1PayAmount_03) { this.payBank1PayAmount_03 = payBank1PayAmount_03                 ; }// ^s1Uz_03
	public void setPayBank2PayAmount_03(Integer  payBank2PayAmount_03) { this.payBank2PayAmount_03 = payBank2PayAmount_03                 ; }// ^s2Uz_03
	public void setPayCashPayAmount_03 (Integer  payCashPayAmount_03 ) { this.payCashPayAmount_03  = payCashPayAmount_03                  ; }// ^xz_03
	public void setPayAllowanceTotal_04(Integer  payAllowanceTotal_04) { this.payAllowanceTotal_04 = payAllowanceTotal_04                 ; }// ^xz_04
	public void setPayDeductionTotal_04(Integer  payDeductionTotal_04) { this.payDeductionTotal_04 = payDeductionTotal_04                 ; }// ^Tz_04
	public void setPayPaymentTotal_04  (Integer  payPaymentTotal_04  ) { this.payPaymentTotal_04   = payPaymentTotal_04                   ; }// ^xz_04
	public void setPayBank1PayAmount_04(Integer  payBank1PayAmount_04) { this.payBank1PayAmount_04 = payBank1PayAmount_04                 ; }// ^s1Uz_04
	public void setPayBank2PayAmount_04(Integer  payBank2PayAmount_04) { this.payBank2PayAmount_04 = payBank2PayAmount_04                 ; }// ^s2Uz_04
	public void setPayCashPayAmount_04 (Integer  payCashPayAmount_04 ) { this.payCashPayAmount_04  = payCashPayAmount_04                  ; }// ^xz_04
	public void setPayAllowanceTotal_05(Integer  payAllowanceTotal_05) { this.payAllowanceTotal_05 = payAllowanceTotal_05                 ; }// ^xz_05
	public void setPayDeductionTotal_05(Integer  payDeductionTotal_05) { this.payDeductionTotal_05 = payDeductionTotal_05                 ; }// ^Tz_05
	public void setPayPaymentTotal_05  (Integer  payPaymentTotal_05  ) { this.payPaymentTotal_05   = payPaymentTotal_05                   ; }// ^xz_05
	public void setPayBank1PayAmount_05(Integer  payBank1PayAmount_05) { this.payBank1PayAmount_05 = payBank1PayAmount_05                 ; }// ^s1Uz_05
	public void setPayBank2PayAmount_05(Integer  payBank2PayAmount_05) { this.payBank2PayAmount_05 = payBank2PayAmount_05                 ; }// ^s2Uz_05
	public void setPayCashPayAmount_05 (Integer  payCashPayAmount_05 ) { this.payCashPayAmount_05  = payCashPayAmount_05                  ; }// ^xz_05
	public void setPayAllowanceTotal_06(Integer  payAllowanceTotal_06) { this.payAllowanceTotal_06 = payAllowanceTotal_06                 ; }// ^xz_06
	public void setPayDeductionTotal_06(Integer  payDeductionTotal_06) { this.payDeductionTotal_06 = payDeductionTotal_06                 ; }// ^Tz_06
	public void setPayPaymentTotal_06  (Integer  payPaymentTotal_06  ) { this.payPaymentTotal_06   = payPaymentTotal_06                   ; }// ^xz_06
	public void setPayBank1PayAmount_06(Integer  payBank1PayAmount_06) { this.payBank1PayAmount_06 = payBank1PayAmount_06                 ; }// ^s1Uz_06
	public void setPayBank2PayAmount_06(Integer  payBank2PayAmount_06) { this.payBank2PayAmount_06 = payBank2PayAmount_06                 ; }// ^s2Uz_06
	public void setPayCashPayAmount_06 (Integer  payCashPayAmount_06 ) { this.payCashPayAmount_06  = payCashPayAmount_06                  ; }// ^xz_06
	public void setPayAllowanceTotal_07(Integer  payAllowanceTotal_07) { this.payAllowanceTotal_07 = payAllowanceTotal_07                 ; }// ^xz_07
	public void setPayDeductionTotal_07(Integer  payDeductionTotal_07) { this.payDeductionTotal_07 = payDeductionTotal_07                 ; }// ^Tz_07
	public void setPayPaymentTotal_07  (Integer  payPaymentTotal_07  ) { this.payPaymentTotal_07   = payPaymentTotal_07                   ; }// ^xz_07
	public void setPayBank1PayAmount_07(Integer  payBank1PayAmount_07) { this.payBank1PayAmount_07 = payBank1PayAmount_07                 ; }// ^s1Uz_07
	public void setPayBank2PayAmount_07(Integer  payBank2PayAmount_07) { this.payBank2PayAmount_07 = payBank2PayAmount_07                 ; }// ^s2Uz_07
	public void setPayCashPayAmount_07 (Integer  payCashPayAmount_07 ) { this.payCashPayAmount_07  = payCashPayAmount_07                  ; }// ^xz_07
	public void setPayAllowanceTotal_08(Integer  payAllowanceTotal_08) { this.payAllowanceTotal_08 = payAllowanceTotal_08                 ; }// ^xz_08
	public void setPayDeductionTotal_08(Integer  payDeductionTotal_08) { this.payDeductionTotal_08 = payDeductionTotal_08                 ; }// ^Tz_08
	public void setPayPaymentTotal_08  (Integer  payPaymentTotal_08  ) { this.payPaymentTotal_08   = payPaymentTotal_08                   ; }// ^xz_08
	public void setPayBank1PayAmount_08(Integer  payBank1PayAmount_08) { this.payBank1PayAmount_08 = payBank1PayAmount_08                 ; }// ^s1Uz_08
	public void setPayBank2PayAmount_08(Integer  payBank2PayAmount_08) { this.payBank2PayAmount_08 = payBank2PayAmount_08                 ; }// ^s2Uz_08
	public void setPayCashPayAmount_08 (Integer  payCashPayAmount_08 ) { this.payCashPayAmount_08  = payCashPayAmount_08                  ; }// ^xz_08
	public void setPayAllowanceTotal_09(Integer  payAllowanceTotal_09) { this.payAllowanceTotal_09 = payAllowanceTotal_09                 ; }// ^xz_09
	public void setPayDeductionTotal_09(Integer  payDeductionTotal_09) { this.payDeductionTotal_09 = payDeductionTotal_09                 ; }// ^Tz_09
	public void setPayPaymentTotal_09  (Integer  payPaymentTotal_09  ) { this.payPaymentTotal_09   = payPaymentTotal_09                   ; }// ^xz_09
	public void setPayBank1PayAmount_09(Integer  payBank1PayAmount_09) { this.payBank1PayAmount_09 = payBank1PayAmount_09                 ; }// ^s1Uz_09
	public void setPayBank2PayAmount_09(Integer  payBank2PayAmount_09) { this.payBank2PayAmount_09 = payBank2PayAmount_09                 ; }// ^s2Uz_09
	public void setPayCashPayAmount_09 (Integer  payCashPayAmount_09 ) { this.payCashPayAmount_09  = payCashPayAmount_09                  ; }// ^xz_09
	public void setPayAllowanceTotal_10(Integer  payAllowanceTotal_10) { this.payAllowanceTotal_10 = payAllowanceTotal_10                 ; }// ^xz_10
	public void setPayDeductionTotal_10(Integer  payDeductionTotal_10) { this.payDeductionTotal_10 = payDeductionTotal_10                 ; }// ^Tz_10
	public void setPayPaymentTotal_10  (Integer  payPaymentTotal_10  ) { this.payPaymentTotal_10   = payPaymentTotal_10                   ; }// ^xz_10
	public void setPayBank1PayAmount_10(Integer  payBank1PayAmount_10) { this.payBank1PayAmount_10 = payBank1PayAmount_10                 ; }// ^s1Uz_10
	public void setPayBank2PayAmount_10(Integer  payBank2PayAmount_10) { this.payBank2PayAmount_10 = payBank2PayAmount_10                 ; }// ^s2Uz_10
	public void setPayCashPayAmount_10 (Integer  payCashPayAmount_10 ) { this.payCashPayAmount_10  = payCashPayAmount_10                  ; }// ^xz_10
	public void setPayAllowanceTotal_11(Integer  payAllowanceTotal_11) { this.payAllowanceTotal_11 = payAllowanceTotal_11                 ; }// ^xz_11
	public void setPayDeductionTotal_11(Integer  payDeductionTotal_11) { this.payDeductionTotal_11 = payDeductionTotal_11                 ; }// ^Tz_11
	public void setPayPaymentTotal_11  (Integer  payPaymentTotal_11  ) { this.payPaymentTotal_11   = payPaymentTotal_11                   ; }// ^xz_11
	public void setPayBank1PayAmount_11(Integer  payBank1PayAmount_11) { this.payBank1PayAmount_11 = payBank1PayAmount_11                 ; }// ^s1Uz_11
	public void setPayBank2PayAmount_11(Integer  payBank2PayAmount_11) { this.payBank2PayAmount_11 = payBank2PayAmount_11                 ; }// ^s2Uz_11
	public void setPayCashPayAmount_11 (Integer  payCashPayAmount_11 ) { this.payCashPayAmount_11  = payCashPayAmount_11                  ; }// ^xz_11
	public void setPayAllowanceTotal_12(Integer  payAllowanceTotal_12) { this.payAllowanceTotal_12 = payAllowanceTotal_12                 ; }// ^xz_12
	public void setPayDeductionTotal_12(Integer  payDeductionTotal_12) { this.payDeductionTotal_12 = payDeductionTotal_12                 ; }// ^Tz_12
	public void setPayPaymentTotal_12  (Integer  payPaymentTotal_12  ) { this.payPaymentTotal_12   = payPaymentTotal_12                   ; }// ^xz_12
	public void setPayBank1PayAmount_12(Integer  payBank1PayAmount_12) { this.payBank1PayAmount_12 = payBank1PayAmount_12                 ; }// ^s1Uz_12
	public void setPayBank2PayAmount_12(Integer  payBank2PayAmount_12) { this.payBank2PayAmount_12 = payBank2PayAmount_12                 ; }// ^s2Uz_12
	public void setPayCashPayAmount_12 (Integer  payCashPayAmount_12 ) { this.payCashPayAmount_12  = payCashPayAmount_12                  ; }// ^xz_12
	public void setBonAllowanceTotal_01(Integer  bonAllowanceTotal_01) { this.bonAllowanceTotal_01 = bonAllowanceTotal_01                 ; }// ܗ^xz_01
	public void setBonDeductionTotal_01(Integer  bonDeductionTotal_01) { this.bonDeductionTotal_01 = bonDeductionTotal_01                 ; }// ܗ^Tz_01
	public void setBonPaymentTotal_01  (Integer  bonPaymentTotal_01  ) { this.bonPaymentTotal_01   = bonPaymentTotal_01                   ; }// ܗ^xz_01
	public void setBonBank1PayAmount_01(Integer  bonBank1PayAmount_01) { this.bonBank1PayAmount_01 = bonBank1PayAmount_01                 ; }// ܗ^s1Uz_01
	public void setBonBank2PayAmount_01(Integer  bonBank2PayAmount_01) { this.bonBank2PayAmount_01 = bonBank2PayAmount_01                 ; }// ܗ^s2Uz_01
	public void setBonCashPayAmount_01 (Integer  bonCashPayAmount_01 ) { this.bonCashPayAmount_01  = bonCashPayAmount_01                  ; }// ܗ^xz_01
	public void setBonAllowanceTotal_02(Integer  bonAllowanceTotal_02) { this.bonAllowanceTotal_02 = bonAllowanceTotal_02                 ; }// ܗ^xz_02
	public void setBonDeductionTotal_02(Integer  bonDeductionTotal_02) { this.bonDeductionTotal_02 = bonDeductionTotal_02                 ; }// ܗ^Tz_02
	public void setBonPaymentTotal_02  (Integer  bonPaymentTotal_02  ) { this.bonPaymentTotal_02   = bonPaymentTotal_02                   ; }// ܗ^xz_02
	public void setBonBank1PayAmount_02(Integer  bonBank1PayAmount_02) { this.bonBank1PayAmount_02 = bonBank1PayAmount_02                 ; }// ܗ^s1Uz_02
	public void setBonBank2PayAmount_02(Integer  bonBank2PayAmount_02) { this.bonBank2PayAmount_02 = bonBank2PayAmount_02                 ; }// ܗ^s2Uz_02
	public void setBonCashPayAmount_02 (Integer  bonCashPayAmount_02 ) { this.bonCashPayAmount_02  = bonCashPayAmount_02                  ; }// ܗ^xz_02
	public void setBonAllowanceTotal_03(Integer  bonAllowanceTotal_03) { this.bonAllowanceTotal_03 = bonAllowanceTotal_03                 ; }// ܗ^xz_03
	public void setBonDeductionTotal_03(Integer  bonDeductionTotal_03) { this.bonDeductionTotal_03 = bonDeductionTotal_03                 ; }// ܗ^Tz_03
	public void setBonPaymentTotal_03  (Integer  bonPaymentTotal_03  ) { this.bonPaymentTotal_03   = bonPaymentTotal_03                   ; }// ܗ^xz_03
	public void setBonBank1PayAmount_03(Integer  bonBank1PayAmount_03) { this.bonBank1PayAmount_03 = bonBank1PayAmount_03                 ; }// ܗ^s1Uz_03
	public void setBonBank2PayAmount_03(Integer  bonBank2PayAmount_03) { this.bonBank2PayAmount_03 = bonBank2PayAmount_03                 ; }// ܗ^s2Uz_03
	public void setBonCashPayAmount_03 (Integer  bonCashPayAmount_03 ) { this.bonCashPayAmount_03  = bonCashPayAmount_03                  ; }// ܗ^xz_03
	public void setBonAllowanceTotal_04(Integer  bonAllowanceTotal_04) { this.bonAllowanceTotal_04 = bonAllowanceTotal_04                 ; }// ܗ^xz_04
	public void setBonDeductionTotal_04(Integer  bonDeductionTotal_04) { this.bonDeductionTotal_04 = bonDeductionTotal_04                 ; }// ܗ^Tz_04
	public void setBonPaymentTotal_04  (Integer  bonPaymentTotal_04  ) { this.bonPaymentTotal_04   = bonPaymentTotal_04                   ; }// ܗ^xz_04
	public void setBonBank1PayAmount_04(Integer  bonBank1PayAmount_04) { this.bonBank1PayAmount_04 = bonBank1PayAmount_04                 ; }// ܗ^s1Uz_04
	public void setBonBank2PayAmount_04(Integer  bonBank2PayAmount_04) { this.bonBank2PayAmount_04 = bonBank2PayAmount_04                 ; }// ܗ^s2Uz_04
	public void setBonCashPayAmount_04 (Integer  bonCashPayAmount_04 ) { this.bonCashPayAmount_04  = bonCashPayAmount_04                  ; }// ܗ^xz_04
	public void setBonAllowanceTotal_05(Integer  bonAllowanceTotal_05) { this.bonAllowanceTotal_05 = bonAllowanceTotal_05                 ; }// ܗ^xz_05
	public void setBonDeductionTotal_05(Integer  bonDeductionTotal_05) { this.bonDeductionTotal_05 = bonDeductionTotal_05                 ; }// ܗ^Tz_05
	public void setBonPaymentTotal_05  (Integer  bonPaymentTotal_05  ) { this.bonPaymentTotal_05   = bonPaymentTotal_05                   ; }// ܗ^xz_05
	public void setBonBank1PayAmount_05(Integer  bonBank1PayAmount_05) { this.bonBank1PayAmount_05 = bonBank1PayAmount_05                 ; }// ܗ^s1Uz_05
	public void setBonBank2PayAmount_05(Integer  bonBank2PayAmount_05) { this.bonBank2PayAmount_05 = bonBank2PayAmount_05                 ; }// ܗ^s2Uz_05
	public void setBonCashPayAmount_05 (Integer  bonCashPayAmount_05 ) { this.bonCashPayAmount_05  = bonCashPayAmount_05                  ; }// ܗ^xz_05
	public void setBonAllowanceTotal_06(Integer  bonAllowanceTotal_06) { this.bonAllowanceTotal_06 = bonAllowanceTotal_06                 ; }// ܗ^xz_06
	public void setBonDeductionTotal_06(Integer  bonDeductionTotal_06) { this.bonDeductionTotal_06 = bonDeductionTotal_06                 ; }// ܗ^Tz_06
	public void setBonPaymentTotal_06  (Integer  bonPaymentTotal_06  ) { this.bonPaymentTotal_06   = bonPaymentTotal_06                   ; }// ܗ^xz_06
	public void setBonBank1PayAmount_06(Integer  bonBank1PayAmount_06) { this.bonBank1PayAmount_06 = bonBank1PayAmount_06                 ; }// ܗ^s1Uz_06
	public void setBonBank2PayAmount_06(Integer  bonBank2PayAmount_06) { this.bonBank2PayAmount_06 = bonBank2PayAmount_06                 ; }// ܗ^s2Uz_06
	public void setBonCashPayAmount_06 (Integer  bonCashPayAmount_06 ) { this.bonCashPayAmount_06  = bonCashPayAmount_06                  ; }// ܗ^xz_06


	public void setPayTotalAllowanceTotal(Integer  payTotalAllowanceTotal ) { this.payTotalAllowanceTotal  = payTotalAllowanceTotal                 ; }	// ^xz(v)
	public void setPayTotalDeductionTotal(Integer  payTotalDeductionTotal ) { this.payTotalDeductionTotal  = payTotalDeductionTotal                 ; }	// ^Tz(v)
	public void setPayTotalPaymentTotal  (Integer  payTotalPaymentTotal   ) { this.payTotalPaymentTotal    = payTotalPaymentTotal                   ; }	// ^xz(v)
	public void setPayTotalBank1PayAmount(Integer  payTotalBank1PayAmount ) { this.payTotalBank1PayAmount  = payTotalBank1PayAmount                 ; }	// ^s1Uz(v)
	public void setPayTotalBank2PayAmount(Integer  payTotalBank2PayAmount ) { this.payTotalBank2PayAmount  = payTotalBank2PayAmount                 ; }	// ^s2Uz(v)
	public void setPayTotalCashPayAmount (Integer  payTotalCashPayAmount  ) { this.payTotalCashPayAmount   = payTotalCashPayAmount                  ; }	// ^xz(v)
                                                                                                              
	public void setBonTotalAllowanceTotal(Integer  bonTotalAllowanceTotal ) { this.bonTotalAllowanceTotal  = bonTotalAllowanceTotal                 ; }	// ܗ^xz(v)
	public void setBonTotalDeductionTotal(Integer  bonTotalDeductionTotal ) { this.bonTotalDeductionTotal  = bonTotalDeductionTotal                 ; }	// ܗ^Tz(v)
	public void setBonTotalPaymentTotal  (Integer  bonTotalPaymentTotal   ) { this.bonTotalPaymentTotal    = bonTotalPaymentTotal                   ; }	// ܗ^xz(v)
	public void setBonTotalBank1PayAmount(Integer  bonTotalBank1PayAmount ) { this.bonTotalBank1PayAmount  = bonTotalBank1PayAmount                 ; }	// ܗ^s1Uz(v)
	public void setBonTotalBank2PayAmount(Integer  bonTotalBank2PayAmount ) { this.bonTotalBank2PayAmount  = bonTotalBank2PayAmount                 ; }	// ܗ^s2Uz(v)
	public void setBonTotalCashPayAmount (Integer  bonTotalCashPayAmount  ) { this.bonTotalCashPayAmount   = bonTotalCashPayAmount                  ; }	// ܗ^xz(v)
                                                                                                             
	public void setPayTotalAllowance_01(Integer payTotalAllowance_01) { this.payTotalAllowance_01 = payTotalAllowance_01                 ; } 	// ^x01(v)
	public void setPayTotalAllowance_02(Integer payTotalAllowance_02) { this.payTotalAllowance_02 = payTotalAllowance_02                 ; } 	// ^x02(v)
	public void setPayTotalAllowance_03(Integer payTotalAllowance_03) { this.payTotalAllowance_03 = payTotalAllowance_03                 ; } 	// ^x03(v)
	public void setPayTotalAllowance_04(Integer payTotalAllowance_04) { this.payTotalAllowance_04 = payTotalAllowance_04                 ; } 	// ^x04(v)
	public void setPayTotalAllowance_05(Integer payTotalAllowance_05) { this.payTotalAllowance_05 = payTotalAllowance_05                 ; } 	// ^x05(v)
	public void setPayTotalAllowance_06(Integer payTotalAllowance_06) { this.payTotalAllowance_06 = payTotalAllowance_06                 ; } 	// ^x06(v)
	public void setPayTotalAllowance_07(Integer payTotalAllowance_07) { this.payTotalAllowance_07 = payTotalAllowance_07                 ; } 	// ^x07(v)
	public void setPayTotalAllowance_08(Integer payTotalAllowance_08) { this.payTotalAllowance_08 = payTotalAllowance_08                 ; } 	// ^x08(v)
	public void setPayTotalAllowance_09(Integer payTotalAllowance_09) { this.payTotalAllowance_09 = payTotalAllowance_09                 ; } 	// ^x09(v)
	public void setPayTotalAllowance_10(Integer payTotalAllowance_10) { this.payTotalAllowance_10 = payTotalAllowance_10                 ; } 	// ^x10(v)
	public void setPayTotalAllowance_11(Integer payTotalAllowance_11) { this.payTotalAllowance_11 = payTotalAllowance_11                 ; } 	// ^x11(v)
	public void setPayTotalAllowance_12(Integer payTotalAllowance_12) { this.payTotalAllowance_12 = payTotalAllowance_12                 ; } 	// ^x12(v)
	public void setPayTotalAllowance_13(Integer payTotalAllowance_13) { this.payTotalAllowance_13 = payTotalAllowance_13                 ; } 	// ^x13(v)
	public void setPayTotalAllowance_14(Integer payTotalAllowance_14) { this.payTotalAllowance_14 = payTotalAllowance_14                 ; } 	// ^x14(v)
	public void setPayTotalAllowance_15(Integer payTotalAllowance_15) { this.payTotalAllowance_15 = payTotalAllowance_15                 ; } 	// ^x15(v)
	public void setPayTotalAllowance_16(Integer payTotalAllowance_16) { this.payTotalAllowance_16 = payTotalAllowance_16                 ; } 	// ^x16(v)
	public void setPayTotalAllowance_17(Integer payTotalAllowance_17) { this.payTotalAllowance_17 = payTotalAllowance_17                 ; } 	// ^x17(v)
	public void setPayTotalAllowance_18(Integer payTotalAllowance_18) { this.payTotalAllowance_18 = payTotalAllowance_18                 ; } 	// ^x18(v)
	public void setPayTotalAllowance_19(Integer payTotalAllowance_19) { this.payTotalAllowance_19 = payTotalAllowance_19                 ; } 	// ^x19(v)
	public void setPayTotalAllowance_20(Integer payTotalAllowance_20) { this.payTotalAllowance_20 = payTotalAllowance_20                 ; } 	// ^x20(v)
	public void setPayTotalAllowance_21(Integer payTotalAllowance_21) { this.payTotalAllowance_21 = payTotalAllowance_21                 ; } 	// ^x21(v)
	public void setPayTotalAllowance_22(Integer payTotalAllowance_22) { this.payTotalAllowance_22 = payTotalAllowance_22                 ; } 	// ^x22(v)
	public void setPayTotalAllowance_23(Integer payTotalAllowance_23) { this.payTotalAllowance_23 = payTotalAllowance_23                 ; } 	// ^x23(v)
	public void setPayTotalAllowance_24(Integer payTotalAllowance_24) { this.payTotalAllowance_24 = payTotalAllowance_24                 ; } 	// ^x24(v)
	public void setPayTotalAllowance_25(Integer payTotalAllowance_25) { this.payTotalAllowance_25 = payTotalAllowance_25                 ; } 	// ^x25(v)
	public void setPayTotalAllowance_26(Integer payTotalAllowance_26) { this.payTotalAllowance_26 = payTotalAllowance_26                 ; } 	// ^x26(v)
	public void setPayTotalAllowance_27(Integer payTotalAllowance_27) { this.payTotalAllowance_27 = payTotalAllowance_27                 ; } 	// ^x27(v)
	public void setPayTotalAllowance_28(Integer payTotalAllowance_28) { this.payTotalAllowance_28 = payTotalAllowance_28                 ; } 	// ^x28(v)
	public void setPayTotalAllowance_29(Integer payTotalAllowance_29) { this.payTotalAllowance_29 = payTotalAllowance_29                 ; } 	// ^x29(v)
	public void setPayTotalAllowance_30(Integer payTotalAllowance_30) { this.payTotalAllowance_30 = payTotalAllowance_30                 ; } 	// ^x30(v)
	public void setPayTotalDeduction_01(Integer payTotalDeduction_01) { this.payTotalDeduction_01 = payTotalDeduction_01                 ; } 	// ^T01(v)
	public void setPayTotalDeduction_02(Integer payTotalDeduction_02) { this.payTotalDeduction_02 = payTotalDeduction_02                 ; } 	// ^T02(v)
	public void setPayTotalDeduction_03(Integer payTotalDeduction_03) { this.payTotalDeduction_03 = payTotalDeduction_03                 ; } 	// ^T03(v)
	public void setPayTotalDeduction_04(Integer payTotalDeduction_04) { this.payTotalDeduction_04 = payTotalDeduction_04                 ; } 	// ^T04(v)
	public void setPayTotalDeduction_05(Integer payTotalDeduction_05) { this.payTotalDeduction_05 = payTotalDeduction_05                 ; } 	// ^T05(v)
	public void setPayTotalDeduction_06(Integer payTotalDeduction_06) { this.payTotalDeduction_06 = payTotalDeduction_06                 ; } 	// ^T06(v)
	public void setPayTotalDeduction_07(Integer payTotalDeduction_07) { this.payTotalDeduction_07 = payTotalDeduction_07                 ; } 	// ^T07(v)
	public void setPayTotalDeduction_08(Integer payTotalDeduction_08) { this.payTotalDeduction_08 = payTotalDeduction_08                 ; } 	// ^T08(v)
	public void setPayTotalDeduction_09(Integer payTotalDeduction_09) { this.payTotalDeduction_09 = payTotalDeduction_09                 ; } 	// ^T09(v)
	public void setPayTotalDeduction_10(Integer payTotalDeduction_10) { this.payTotalDeduction_10 = payTotalDeduction_10                 ; } 	// ^T10(v)
	public void setPayTotalDeduction_11(Integer payTotalDeduction_11) { this.payTotalDeduction_11 = payTotalDeduction_11                 ; } 	// ^T11(v)
	public void setPayTotalDeduction_12(Integer payTotalDeduction_12) { this.payTotalDeduction_12 = payTotalDeduction_12                 ; } 	// ^T12(v)
	public void setPayTotalDeduction_13(Integer payTotalDeduction_13) { this.payTotalDeduction_13 = payTotalDeduction_13                 ; } 	// ^T13(v)
	public void setPayTotalDeduction_14(Integer payTotalDeduction_14) { this.payTotalDeduction_14 = payTotalDeduction_14                 ; } 	// ^T14(v)
	public void setPayTotalDeduction_15(Integer payTotalDeduction_15) { this.payTotalDeduction_15 = payTotalDeduction_15                 ; } 	// ^T15(v)
	public void setPayTotalDeduction_16(Integer payTotalDeduction_16) { this.payTotalDeduction_16 = payTotalDeduction_16                 ; } 	// ^T16(v)
	public void setPayTotalDeduction_17(Integer payTotalDeduction_17) { this.payTotalDeduction_17 = payTotalDeduction_17                 ; } 	// ^T17(v)
	public void setPayTotalDeduction_18(Integer payTotalDeduction_18) { this.payTotalDeduction_18 = payTotalDeduction_18                 ; } 	// ^T18(v)
	public void setPayTotalDeduction_19(Integer payTotalDeduction_19) { this.payTotalDeduction_19 = payTotalDeduction_19                 ; } 	// ^T19(v)
	public void setPayTotalDeduction_20(Integer payTotalDeduction_20) { this.payTotalDeduction_20 = payTotalDeduction_20                 ; } 	// ^T20(v)
	public void setPayTotalDeduction_21(Integer payTotalDeduction_21) { this.payTotalDeduction_21 = payTotalDeduction_21                 ; } 	// ^T21(v)
	public void setPayTotalDeduction_22(Integer payTotalDeduction_22) { this.payTotalDeduction_22 = payTotalDeduction_22                 ; } 	// ^T22(v)
	public void setPayTotalDeduction_23(Integer payTotalDeduction_23) { this.payTotalDeduction_23 = payTotalDeduction_23                 ; } 	// ^T23(v)
	public void setPayTotalDeduction_24(Integer payTotalDeduction_24) { this.payTotalDeduction_24 = payTotalDeduction_24                 ; } 	// ^T24(v)
	public void setPayTotalDeduction_25(Integer payTotalDeduction_25) { this.payTotalDeduction_25 = payTotalDeduction_25                 ; } 	// ^T25(v)
	public void setPayTotalDeduction_26(Integer payTotalDeduction_26) { this.payTotalDeduction_26 = payTotalDeduction_26                 ; } 	// ^T26(v)
	public void setPayTotalDeduction_27(Integer payTotalDeduction_27) { this.payTotalDeduction_27 = payTotalDeduction_27                 ; } 	// ^T27(v)
	public void setTotalAttendance_01(Float  totalAttendance_01) { this.totalAttendance_01 = totalAttendance_01                 ; } 	// ΑӍ01(v)
	public void setTotalAttendance_02(Float  totalAttendance_02) { this.totalAttendance_02 = totalAttendance_02                 ; } 	// ΑӍ02(v)
	public void setTotalAttendance_03(Float  totalAttendance_03) { this.totalAttendance_03 = totalAttendance_03                 ; } 	// ΑӍ03(v)
	public void setTotalAttendance_04(Float  totalAttendance_04) { this.totalAttendance_04 = totalAttendance_04                 ; } 	// ΑӍ04(v)
	public void setTotalAttendance_05(Float  totalAttendance_05) { this.totalAttendance_05 = totalAttendance_05                 ; } 	// ΑӍ05(v)
	public void setTotalAttendance_06(Integer totalAttendance_06) { this.totalAttendance_06 = totalAttendance_06                 ; } 	// ΑӍ06(v)
	public void setTotalAttendance_07(Integer totalAttendance_07) { this.totalAttendance_07 = totalAttendance_07                 ; } 	// ΑӍ07(v)
	public void setTotalAttendance_08(Float  totalAttendance_08) { this.totalAttendance_08 = totalAttendance_08                 ; } 	// ΑӍ08(v)
	public void setTotalAttendance_09(Float  totalAttendance_09) { this.totalAttendance_09 = totalAttendance_09                 ; } 	// ΑӍ09(v)
	public void setTotalAttendance_10(Float  totalAttendance_10) { this.totalAttendance_10 = totalAttendance_10                 ; } 	// ΑӍ10(v)
	public void setTotalAttendance_11(Float  totalAttendance_11) { this.totalAttendance_11 = totalAttendance_11                 ; } 	// ΑӍ11(v)
	public void setTotalAttendance_12(Float  totalAttendance_12) { this.totalAttendance_12 = totalAttendance_12                 ; } 	// ΑӍ12(v)
	public void setTotalAttendance_13(Integer totalAttendance_13) { this.totalAttendance_13 = totalAttendance_13                 ; } 	// ΑӍ13(v)
	public void setTotalAttendance_14(Integer totalAttendance_14) { this.totalAttendance_14 = totalAttendance_14                 ; } 	// ΑӍ14(v)
	public void setBonTotalAllowance_01(Integer bonTotalAllowance_01) { this.bonTotalAllowance_01 = bonTotalAllowance_01                 ; } 	// ܗ^x01(v)
	public void setBonTotalAllowance_02(Integer bonTotalAllowance_02) { this.bonTotalAllowance_02 = bonTotalAllowance_02                 ; } 	// ܗ^x02(v)
	public void setBonTotalAllowance_03(Integer bonTotalAllowance_03) { this.bonTotalAllowance_03 = bonTotalAllowance_03                 ; } 	// ܗ^x03(v)
	public void setBonTotalAllowance_04(Integer bonTotalAllowance_04) { this.bonTotalAllowance_04 = bonTotalAllowance_04                 ; } 	// ܗ^x04(v)
	public void setBonTotalAllowance_05(Integer bonTotalAllowance_05) { this.bonTotalAllowance_05 = bonTotalAllowance_05                 ; } 	// ܗ^x05(v)
	public void setBonTotalAllowance_06(Integer bonTotalAllowance_06) { this.bonTotalAllowance_06 = bonTotalAllowance_06                 ; } 	// ܗ^x06(v)
	public void setBonTotalAllowance_07(Integer bonTotalAllowance_07) { this.bonTotalAllowance_07 = bonTotalAllowance_07                 ; } 	// ܗ^x07(v)
	public void setBonTotalAllowance_08(Integer bonTotalAllowance_08) { this.bonTotalAllowance_08 = bonTotalAllowance_08                 ; } 	// ܗ^x08(v)
	public void setBonTotalAllowance_09(Integer bonTotalAllowance_09) { this.bonTotalAllowance_09 = bonTotalAllowance_09                 ; } 	// ܗ^x09(v)
	public void setBonTotalAllowance_10(Integer bonTotalAllowance_10) { this.bonTotalAllowance_10 = bonTotalAllowance_10                 ; } 	// ܗ^x10(v)
	public void setBonTotalDeduction_01(Integer bonTotalDeduction_01) { this.bonTotalDeduction_01 = bonTotalDeduction_01                 ; } 	// ܗ^T01(v)
	public void setBonTotalDeduction_02(Integer bonTotalDeduction_02) { this.bonTotalDeduction_02 = bonTotalDeduction_02                 ; } 	// ܗ^T02(v)
	public void setBonTotalDeduction_03(Integer bonTotalDeduction_03) { this.bonTotalDeduction_03 = bonTotalDeduction_03                 ; } 	// ܗ^T03(v)
	public void setBonTotalDeduction_04(Integer bonTotalDeduction_04) { this.bonTotalDeduction_04 = bonTotalDeduction_04                 ; } 	// ܗ^T04(v)
	public void setBonTotalDeduction_05(Integer bonTotalDeduction_05) { this.bonTotalDeduction_05 = bonTotalDeduction_05                 ; } 	// ܗ^T05(v)
	public void setBonTotalDeduction_06(Integer bonTotalDeduction_06) { this.bonTotalDeduction_06 = bonTotalDeduction_06                 ; } 	// ܗ^T06(v)
	public void setBonTotalDeduction_07(Integer bonTotalDeduction_07) { this.bonTotalDeduction_07 = bonTotalDeduction_07                 ; } 	// ܗ^T07(v)
	public void setBonTotalDeduction_08(Integer bonTotalDeduction_08) { this.bonTotalDeduction_08 = bonTotalDeduction_08                 ; } 	// ܗ^T08(v)
	public void setBonTotalDeduction_09(Integer bonTotalDeduction_09) { this.bonTotalDeduction_09 = bonTotalDeduction_09                 ; } 	// ܗ^T09(v)
	public void setBonTotalDeduction_10(Integer bonTotalDeduction_10) { this.bonTotalDeduction_10 = bonTotalDeduction_10                 ; } 	// ܗ^T10(v)
	public void setBonTotalDeduction_11(Integer bonTotalDeduction_11) { this.bonTotalDeduction_11 = bonTotalDeduction_11                 ; } 	// ܗ^T11(v)
	public void setBonTotalDeduction_12(Integer bonTotalDeduction_12) { this.bonTotalDeduction_12 = bonTotalDeduction_12                 ; } 	// ܗ^T12(v)
	public void setBonTotalDeduction_13(Integer bonTotalDeduction_13) { this.bonTotalDeduction_13 = bonTotalDeduction_13                 ; } 	// ܗ^T13(v)
	public void setBonTotalDeduction_14(Integer bonTotalDeduction_14) { this.bonTotalDeduction_14 = bonTotalDeduction_14                 ; } 	// ܗ^T14(v)
	public void setBonTotalDeduction_15(Integer bonTotalDeduction_15) { this.bonTotalDeduction_15 = bonTotalDeduction_15                 ; } 	// ܗ^T15(v)
	public void setBonTotalDeduction_16(Integer bonTotalDeduction_16) { this.bonTotalDeduction_16 = bonTotalDeduction_16                 ; } 	// ܗ^T16(v)
	public void setBonTotalDeduction_17(Integer bonTotalDeduction_17) { this.bonTotalDeduction_17 = bonTotalDeduction_17                 ; } 	// ܗ^T17(v)

	
	public void setPayAllowance_01_01(Integer payAllowance_01_01 ) { this.payAllowance_01_01 = payAllowance_01_01; } 	// ^x01_01
	public void setPayAllowance_02_01(Integer payAllowance_02_01 ) { this.payAllowance_02_01 = payAllowance_02_01; } 	// ^x02_01
	public void setPayAllowance_03_01(Integer payAllowance_03_01 ) { this.payAllowance_03_01 = payAllowance_03_01; } 	// ^x03_01
	public void setPayAllowance_04_01(Integer payAllowance_04_01 ) { this.payAllowance_04_01 = payAllowance_04_01; } 	// ^x04_01
	public void setPayAllowance_05_01(Integer payAllowance_05_01 ) { this.payAllowance_05_01 = payAllowance_05_01; } 	// ^x05_01
	public void setPayAllowance_06_01(Integer payAllowance_06_01 ) { this.payAllowance_06_01 = payAllowance_06_01; } 	// ^x06_01
	public void setPayAllowance_07_01(Integer payAllowance_07_01 ) { this.payAllowance_07_01 = payAllowance_07_01; } 	// ^x07_01
	public void setPayAllowance_08_01(Integer payAllowance_08_01 ) { this.payAllowance_08_01 = payAllowance_08_01; } 	// ^x08_01
	public void setPayAllowance_09_01(Integer payAllowance_09_01 ) { this.payAllowance_09_01 = payAllowance_09_01; } 	// ^x09_01
	public void setPayAllowance_10_01(Integer payAllowance_10_01 ) { this.payAllowance_10_01 = payAllowance_10_01; } 	// ^x10_01
	public void setPayAllowance_11_01(Integer payAllowance_11_01 ) { this.payAllowance_11_01 = payAllowance_11_01; } 	// ^x11_01
	public void setPayAllowance_12_01(Integer payAllowance_12_01 ) { this.payAllowance_12_01 = payAllowance_12_01; } 	// ^x12_01
	public void setPayAllowance_13_01(Integer payAllowance_13_01 ) { this.payAllowance_13_01 = payAllowance_13_01; } 	// ^x13_01
	public void setPayAllowance_14_01(Integer payAllowance_14_01 ) { this.payAllowance_14_01 = payAllowance_14_01; } 	// ^x14_01
	public void setPayAllowance_15_01(Integer payAllowance_15_01 ) { this.payAllowance_15_01 = payAllowance_15_01; } 	// ^x15_01
	public void setPayAllowance_16_01(Integer payAllowance_16_01 ) { this.payAllowance_16_01 = payAllowance_16_01; } 	// ^x16_01
	public void setPayAllowance_17_01(Integer payAllowance_17_01 ) { this.payAllowance_17_01 = payAllowance_17_01; } 	// ^x17_01
	public void setPayAllowance_18_01(Integer payAllowance_18_01 ) { this.payAllowance_18_01 = payAllowance_18_01; } 	// ^x18_01
	public void setPayAllowance_19_01(Integer payAllowance_19_01 ) { this.payAllowance_19_01 = payAllowance_19_01; } 	// ^x19_01
	public void setPayAllowance_20_01(Integer payAllowance_20_01 ) { this.payAllowance_20_01 = payAllowance_20_01; } 	// ^x20_01
	public void setPayAllowance_21_01(Integer payAllowance_21_01 ) { this.payAllowance_21_01 = payAllowance_21_01; } 	// ^x21_01
	public void setPayAllowance_22_01(Integer payAllowance_22_01 ) { this.payAllowance_22_01 = payAllowance_22_01; } 	// ^x22_01
	public void setPayAllowance_23_01(Integer payAllowance_23_01 ) { this.payAllowance_23_01 = payAllowance_23_01; } 	// ^x23_01
	public void setPayAllowance_24_01(Integer payAllowance_24_01 ) { this.payAllowance_24_01 = payAllowance_24_01; } 	// ^x24_01
	public void setPayAllowance_25_01(Integer payAllowance_25_01 ) { this.payAllowance_25_01 = payAllowance_25_01; } 	// ^x25_01
	public void setPayAllowance_26_01(Integer payAllowance_26_01 ) { this.payAllowance_26_01 = payAllowance_26_01; } 	// ^x26_01
	public void setPayAllowance_27_01(Integer payAllowance_27_01 ) { this.payAllowance_27_01 = payAllowance_27_01; } 	// ^x27_01
	public void setPayAllowance_28_01(Integer payAllowance_28_01 ) { this.payAllowance_28_01 = payAllowance_28_01; } 	// ^x28_01
	public void setPayAllowance_29_01(Integer payAllowance_29_01 ) { this.payAllowance_29_01 = payAllowance_29_01; } 	// ^x29_01
	public void setPayAllowance_30_01(Integer payAllowance_30_01 ) { this.payAllowance_30_01 = payAllowance_30_01; } 	// ^x30_01
	public void setPayDeduction_01_01(Integer payDeduction_01_01 ) { this.payDeduction_01_01 = payDeduction_01_01; } 	// ^T01_01
	public void setPayDeduction_02_01(Integer payDeduction_02_01 ) { this.payDeduction_02_01 = payDeduction_02_01; } 	// ^T02_01
	public void setPayDeduction_03_01(Integer payDeduction_03_01 ) { this.payDeduction_03_01 = payDeduction_03_01; } 	// ^T03_01
	public void setPayDeduction_04_01(Integer payDeduction_04_01 ) { this.payDeduction_04_01 = payDeduction_04_01; } 	// ^T04_01
	public void setPayDeduction_05_01(Integer payDeduction_05_01 ) { this.payDeduction_05_01 = payDeduction_05_01; } 	// ^T05_01
	public void setPayDeduction_06_01(Integer payDeduction_06_01 ) { this.payDeduction_06_01 = payDeduction_06_01; } 	// ^T06_01
	public void setPayDeduction_07_01(Integer payDeduction_07_01 ) { this.payDeduction_07_01 = payDeduction_07_01; } 	// ^T07_01
	public void setPayDeduction_08_01(Integer payDeduction_08_01 ) { this.payDeduction_08_01 = payDeduction_08_01; } 	// ^T08_01
	public void setPayDeduction_09_01(Integer payDeduction_09_01 ) { this.payDeduction_09_01 = payDeduction_09_01; } 	// ^T09_01
	public void setPayDeduction_10_01(Integer payDeduction_10_01 ) { this.payDeduction_10_01 = payDeduction_10_01; } 	// ^T10_01
	public void setPayDeduction_11_01(Integer payDeduction_11_01 ) { this.payDeduction_11_01 = payDeduction_11_01; } 	// ^T11_01
	public void setPayDeduction_12_01(Integer payDeduction_12_01 ) { this.payDeduction_12_01 = payDeduction_12_01; } 	// ^T12_01
	public void setPayDeduction_13_01(Integer payDeduction_13_01 ) { this.payDeduction_13_01 = payDeduction_13_01; } 	// ^T13_01
	public void setPayDeduction_14_01(Integer payDeduction_14_01 ) { this.payDeduction_14_01 = payDeduction_14_01; } 	// ^T14_01
	public void setPayDeduction_15_01(Integer payDeduction_15_01 ) { this.payDeduction_15_01 = payDeduction_15_01; } 	// ^T15_01
	public void setPayDeduction_16_01(Integer payDeduction_16_01 ) { this.payDeduction_16_01 = payDeduction_16_01; } 	// ^T16_01
	public void setPayDeduction_17_01(Integer payDeduction_17_01 ) { this.payDeduction_17_01 = payDeduction_17_01; } 	// ^T17_01
	public void setPayDeduction_18_01(Integer payDeduction_18_01 ) { this.payDeduction_18_01 = payDeduction_18_01; } 	// ^T18_01
	public void setPayDeduction_19_01(Integer payDeduction_19_01 ) { this.payDeduction_19_01 = payDeduction_19_01; } 	// ^T19_01
	public void setPayDeduction_20_01(Integer payDeduction_20_01 ) { this.payDeduction_20_01 = payDeduction_20_01; } 	// ^T20_01
	public void setPayDeduction_21_01(Integer payDeduction_21_01 ) { this.payDeduction_21_01 = payDeduction_21_01; } 	// ^T21_01
	public void setPayDeduction_22_01(Integer payDeduction_22_01 ) { this.payDeduction_22_01 = payDeduction_22_01; } 	// ^T22_01
	public void setPayDeduction_23_01(Integer payDeduction_23_01 ) { this.payDeduction_23_01 = payDeduction_23_01; } 	// ^T23_01
	public void setPayDeduction_24_01(Integer payDeduction_24_01 ) { this.payDeduction_24_01 = payDeduction_24_01; } 	// ^T24_01
	public void setPayDeduction_25_01(Integer payDeduction_25_01 ) { this.payDeduction_25_01 = payDeduction_25_01; } 	// ^T25_01
	public void setPayDeduction_26_01(Integer payDeduction_26_01 ) { this.payDeduction_26_01 = payDeduction_26_01; } 	// ^T26_01
	public void setPayDeduction_27_01(Integer payDeduction_27_01 ) { this.payDeduction_27_01 = payDeduction_27_01; } 	// ^T27_01
	public void setAttendance_01_01(Float attendance_01_01 ) { this.attendance_01_01 = attendance_01_01; } 	// ΑӍ01_01
	public void setAttendance_02_01(Float attendance_02_01 ) { this.attendance_02_01 = attendance_02_01; } 	// ΑӍ02_01
	public void setAttendance_03_01(Float attendance_03_01 ) { this.attendance_03_01 = attendance_03_01; } 	// ΑӍ03_01
	public void setAttendance_04_01(Float attendance_04_01 ) { this.attendance_04_01 = attendance_04_01; } 	// ΑӍ04_01
	public void setAttendance_05_01(Float attendance_05_01 ) { this.attendance_05_01 = attendance_05_01; } 	// ΑӍ05_01
	public void setAttendance_06_01(Integer attendance_06_01 ) { this.attendance_06_01 = attendance_06_01; } 	// ΑӍ06_01
	public void setAttendance_07_01(Integer  attendance_07_01 ) { this.attendance_07_01 = attendance_07_01; } 	// ΑӍ07_01
	public void setAttendance_08_01(Float attendance_08_01 ) { this.attendance_08_01 = attendance_08_01; } 	// ΑӍ08_01
	public void setAttendance_09_01(Float attendance_09_01 ) { this.attendance_09_01 = attendance_09_01; } 	// ΑӍ09_01
	public void setAttendance_10_01(Float attendance_10_01 ) { this.attendance_10_01 = attendance_10_01; } 	// ΑӍ10_01
	public void setAttendance_11_01(Float attendance_11_01 ) { this.attendance_11_01 = attendance_11_01; } 	// ΑӍ11_01
	public void setAttendance_12_01(Float attendance_12_01 ) { this.attendance_12_01 = attendance_12_01; } 	// ΑӍ12_01
	public void setAttendance_13_01(Integer  attendance_13_01 ) { this.attendance_13_01 = attendance_13_01; } 	// ΑӍ13_01
	public void setAttendance_14_01(Integer  attendance_14_01 ) { this.attendance_14_01 = attendance_14_01; } 	// ΑӍ14_01
	public void setBonAllowance_01_01(Integer bonAllowance_01_01 ) { this.bonAllowance_01_01 = bonAllowance_01_01; } 	// ܗ^x01_01
	public void setBonAllowance_02_01(Integer bonAllowance_02_01 ) { this.bonAllowance_02_01 = bonAllowance_02_01; } 	// ܗ^x02_01
	public void setBonAllowance_03_01(Integer bonAllowance_03_01 ) { this.bonAllowance_03_01 = bonAllowance_03_01; } 	// ܗ^x03_01
	public void setBonAllowance_04_01(Integer bonAllowance_04_01 ) { this.bonAllowance_04_01 = bonAllowance_04_01; } 	// ܗ^x04_01
	public void setBonAllowance_05_01(Integer bonAllowance_05_01 ) { this.bonAllowance_05_01 = bonAllowance_05_01; } 	// ܗ^x05_01
	public void setBonAllowance_06_01(Integer bonAllowance_06_01 ) { this.bonAllowance_06_01 = bonAllowance_06_01; } 	// ܗ^x06_01
	public void setBonAllowance_07_01(Integer bonAllowance_07_01 ) { this.bonAllowance_07_01 = bonAllowance_07_01; } 	// ܗ^x07_01
	public void setBonAllowance_08_01(Integer bonAllowance_08_01 ) { this.bonAllowance_08_01 = bonAllowance_08_01; } 	// ܗ^x08_01
	public void setBonAllowance_09_01(Integer bonAllowance_09_01 ) { this.bonAllowance_09_01 = bonAllowance_09_01; } 	// ܗ^x09_01
	public void setBonAllowance_10_01(Integer bonAllowance_10_01 ) { this.bonAllowance_10_01 = bonAllowance_10_01; } 	// ܗ^x10_01
	public void setBonDeduction_01_01(Integer bonDeduction_01_01 ) { this.bonDeduction_01_01 = bonDeduction_01_01; } 	// ܗ^T01_01
	public void setBonDeduction_02_01(Integer bonDeduction_02_01 ) { this.bonDeduction_02_01 = bonDeduction_02_01; } 	// ܗ^T02_01
	public void setBonDeduction_03_01(Integer bonDeduction_03_01 ) { this.bonDeduction_03_01 = bonDeduction_03_01; } 	// ܗ^T03_01
	public void setBonDeduction_04_01(Integer bonDeduction_04_01 ) { this.bonDeduction_04_01 = bonDeduction_04_01; } 	// ܗ^T04_01
	public void setBonDeduction_05_01(Integer bonDeduction_05_01 ) { this.bonDeduction_05_01 = bonDeduction_05_01; } 	// ܗ^T05_01
	public void setBonDeduction_06_01(Integer bonDeduction_06_01 ) { this.bonDeduction_06_01 = bonDeduction_06_01; } 	// ܗ^T06_01
	public void setBonDeduction_07_01(Integer bonDeduction_07_01 ) { this.bonDeduction_07_01 = bonDeduction_07_01; } 	// ܗ^T07_01
	public void setBonDeduction_08_01(Integer bonDeduction_08_01 ) { this.bonDeduction_08_01 = bonDeduction_08_01; } 	// ܗ^T08_01
	public void setBonDeduction_09_01(Integer bonDeduction_09_01 ) { this.bonDeduction_09_01 = bonDeduction_09_01; } 	// ܗ^T09_01
	public void setBonDeduction_10_01(Integer bonDeduction_10_01 ) { this.bonDeduction_10_01 = bonDeduction_10_01; } 	// ܗ^T10_01
	public void setBonDeduction_11_01(Integer bonDeduction_11_01 ) { this.bonDeduction_11_01 = bonDeduction_11_01; } 	// ܗ^T11_01
	public void setBonDeduction_12_01(Integer bonDeduction_12_01 ) { this.bonDeduction_12_01 = bonDeduction_12_01; } 	// ܗ^T12_01
	public void setBonDeduction_13_01(Integer bonDeduction_13_01 ) { this.bonDeduction_13_01 = bonDeduction_13_01; } 	// ܗ^T13_01
	public void setBonDeduction_14_01(Integer bonDeduction_14_01 ) { this.bonDeduction_14_01 = bonDeduction_14_01; } 	// ܗ^T14_01
	public void setBonDeduction_15_01(Integer bonDeduction_15_01 ) { this.bonDeduction_15_01 = bonDeduction_15_01; } 	// ܗ^T15_01
	public void setBonDeduction_16_01(Integer bonDeduction_16_01 ) { this.bonDeduction_16_01 = bonDeduction_16_01; } 	// ܗ^T16_01
	public void setBonDeduction_17_01(Integer bonDeduction_17_01 ) { this.bonDeduction_17_01 = bonDeduction_17_01; } 	// ܗ^T17_01
	public void setPayAllowance_01_02(Integer payAllowance_01_02 ) { this.payAllowance_01_02 = payAllowance_01_02; } 	// ^x01_02
	public void setPayAllowance_02_02(Integer payAllowance_02_02 ) { this.payAllowance_02_02 = payAllowance_02_02; } 	// ^x02_02
	public void setPayAllowance_03_02(Integer payAllowance_03_02 ) { this.payAllowance_03_02 = payAllowance_03_02; } 	// ^x03_02
	public void setPayAllowance_04_02(Integer payAllowance_04_02 ) { this.payAllowance_04_02 = payAllowance_04_02; } 	// ^x04_02
	public void setPayAllowance_05_02(Integer payAllowance_05_02 ) { this.payAllowance_05_02 = payAllowance_05_02; } 	// ^x05_02
	public void setPayAllowance_06_02(Integer payAllowance_06_02 ) { this.payAllowance_06_02 = payAllowance_06_02; } 	// ^x06_02
	public void setPayAllowance_07_02(Integer payAllowance_07_02 ) { this.payAllowance_07_02 = payAllowance_07_02; } 	// ^x07_02
	public void setPayAllowance_08_02(Integer payAllowance_08_02 ) { this.payAllowance_08_02 = payAllowance_08_02; } 	// ^x08_02
	public void setPayAllowance_09_02(Integer payAllowance_09_02 ) { this.payAllowance_09_02 = payAllowance_09_02; } 	// ^x09_02
	public void setPayAllowance_10_02(Integer payAllowance_10_02 ) { this.payAllowance_10_02 = payAllowance_10_02; } 	// ^x10_02
	public void setPayAllowance_11_02(Integer payAllowance_11_02 ) { this.payAllowance_11_02 = payAllowance_11_02; } 	// ^x11_02
	public void setPayAllowance_12_02(Integer payAllowance_12_02 ) { this.payAllowance_12_02 = payAllowance_12_02; } 	// ^x12_02
	public void setPayAllowance_13_02(Integer payAllowance_13_02 ) { this.payAllowance_13_02 = payAllowance_13_02; } 	// ^x13_02
	public void setPayAllowance_14_02(Integer payAllowance_14_02 ) { this.payAllowance_14_02 = payAllowance_14_02; } 	// ^x14_02
	public void setPayAllowance_15_02(Integer payAllowance_15_02 ) { this.payAllowance_15_02 = payAllowance_15_02; } 	// ^x15_02
	public void setPayAllowance_16_02(Integer payAllowance_16_02 ) { this.payAllowance_16_02 = payAllowance_16_02; } 	// ^x16_02
	public void setPayAllowance_17_02(Integer payAllowance_17_02 ) { this.payAllowance_17_02 = payAllowance_17_02; } 	// ^x17_02
	public void setPayAllowance_18_02(Integer payAllowance_18_02 ) { this.payAllowance_18_02 = payAllowance_18_02; } 	// ^x18_02
	public void setPayAllowance_19_02(Integer payAllowance_19_02 ) { this.payAllowance_19_02 = payAllowance_19_02; } 	// ^x19_02
	public void setPayAllowance_20_02(Integer payAllowance_20_02 ) { this.payAllowance_20_02 = payAllowance_20_02; } 	// ^x20_02
	public void setPayAllowance_21_02(Integer payAllowance_21_02 ) { this.payAllowance_21_02 = payAllowance_21_02; } 	// ^x21_02
	public void setPayAllowance_22_02(Integer payAllowance_22_02 ) { this.payAllowance_22_02 = payAllowance_22_02; } 	// ^x22_02
	public void setPayAllowance_23_02(Integer payAllowance_23_02 ) { this.payAllowance_23_02 = payAllowance_23_02; } 	// ^x23_02
	public void setPayAllowance_24_02(Integer payAllowance_24_02 ) { this.payAllowance_24_02 = payAllowance_24_02; } 	// ^x24_02
	public void setPayAllowance_25_02(Integer payAllowance_25_02 ) { this.payAllowance_25_02 = payAllowance_25_02; } 	// ^x25_02
	public void setPayAllowance_26_02(Integer payAllowance_26_02 ) { this.payAllowance_26_02 = payAllowance_26_02; } 	// ^x26_02
	public void setPayAllowance_27_02(Integer payAllowance_27_02 ) { this.payAllowance_27_02 = payAllowance_27_02; } 	// ^x27_02
	public void setPayAllowance_28_02(Integer payAllowance_28_02 ) { this.payAllowance_28_02 = payAllowance_28_02; } 	// ^x28_02
	public void setPayAllowance_29_02(Integer payAllowance_29_02 ) { this.payAllowance_29_02 = payAllowance_29_02; } 	// ^x29_02
	public void setPayAllowance_30_02(Integer payAllowance_30_02 ) { this.payAllowance_30_02 = payAllowance_30_02; } 	// ^x30_02
	public void setPayDeduction_01_02(Integer payDeduction_01_02 ) { this.payDeduction_01_02 = payDeduction_01_02; } 	// ^T01_02
	public void setPayDeduction_02_02(Integer payDeduction_02_02 ) { this.payDeduction_02_02 = payDeduction_02_02; } 	// ^T02_02
	public void setPayDeduction_03_02(Integer payDeduction_03_02 ) { this.payDeduction_03_02 = payDeduction_03_02; } 	// ^T03_02
	public void setPayDeduction_04_02(Integer payDeduction_04_02 ) { this.payDeduction_04_02 = payDeduction_04_02; } 	// ^T04_02
	public void setPayDeduction_05_02(Integer payDeduction_05_02 ) { this.payDeduction_05_02 = payDeduction_05_02; } 	// ^T05_02
	public void setPayDeduction_06_02(Integer payDeduction_06_02 ) { this.payDeduction_06_02 = payDeduction_06_02; } 	// ^T06_02
	public void setPayDeduction_07_02(Integer payDeduction_07_02 ) { this.payDeduction_07_02 = payDeduction_07_02; } 	// ^T07_02
	public void setPayDeduction_08_02(Integer payDeduction_08_02 ) { this.payDeduction_08_02 = payDeduction_08_02; } 	// ^T08_02
	public void setPayDeduction_09_02(Integer payDeduction_09_02 ) { this.payDeduction_09_02 = payDeduction_09_02; } 	// ^T09_02
	public void setPayDeduction_10_02(Integer payDeduction_10_02 ) { this.payDeduction_10_02 = payDeduction_10_02; } 	// ^T10_02
	public void setPayDeduction_11_02(Integer payDeduction_11_02 ) { this.payDeduction_11_02 = payDeduction_11_02; } 	// ^T11_02
	public void setPayDeduction_12_02(Integer payDeduction_12_02 ) { this.payDeduction_12_02 = payDeduction_12_02; } 	// ^T12_02
	public void setPayDeduction_13_02(Integer payDeduction_13_02 ) { this.payDeduction_13_02 = payDeduction_13_02; } 	// ^T13_02
	public void setPayDeduction_14_02(Integer payDeduction_14_02 ) { this.payDeduction_14_02 = payDeduction_14_02; } 	// ^T14_02
	public void setPayDeduction_15_02(Integer payDeduction_15_02 ) { this.payDeduction_15_02 = payDeduction_15_02; } 	// ^T15_02
	public void setPayDeduction_16_02(Integer payDeduction_16_02 ) { this.payDeduction_16_02 = payDeduction_16_02; } 	// ^T16_02
	public void setPayDeduction_17_02(Integer payDeduction_17_02 ) { this.payDeduction_17_02 = payDeduction_17_02; } 	// ^T17_02
	public void setPayDeduction_18_02(Integer payDeduction_18_02 ) { this.payDeduction_18_02 = payDeduction_18_02; } 	// ^T18_02
	public void setPayDeduction_19_02(Integer payDeduction_19_02 ) { this.payDeduction_19_02 = payDeduction_19_02; } 	// ^T19_02
	public void setPayDeduction_20_02(Integer payDeduction_20_02 ) { this.payDeduction_20_02 = payDeduction_20_02; } 	// ^T20_02
	public void setPayDeduction_21_02(Integer payDeduction_21_02 ) { this.payDeduction_21_02 = payDeduction_21_02; } 	// ^T21_02
	public void setPayDeduction_22_02(Integer payDeduction_22_02 ) { this.payDeduction_22_02 = payDeduction_22_02; } 	// ^T22_02
	public void setPayDeduction_23_02(Integer payDeduction_23_02 ) { this.payDeduction_23_02 = payDeduction_23_02; } 	// ^T23_02
	public void setPayDeduction_24_02(Integer payDeduction_24_02 ) { this.payDeduction_24_02 = payDeduction_24_02; } 	// ^T24_02
	public void setPayDeduction_25_02(Integer payDeduction_25_02 ) { this.payDeduction_25_02 = payDeduction_25_02; } 	// ^T25_02
	public void setPayDeduction_26_02(Integer payDeduction_26_02 ) { this.payDeduction_26_02 = payDeduction_26_02; } 	// ^T26_02
	public void setPayDeduction_27_02(Integer payDeduction_27_02 ) { this.payDeduction_27_02 = payDeduction_27_02; } 	// ^T27_02
	public void setAttendance_01_02(Float attendance_01_02 ) { this.attendance_01_02 = attendance_01_02; } 	// ΑӍ01_02
	public void setAttendance_02_02(Float attendance_02_02 ) { this.attendance_02_02 = attendance_02_02; } 	// ΑӍ02_02
	public void setAttendance_03_02(Float attendance_03_02 ) { this.attendance_03_02 = attendance_03_02; } 	// ΑӍ03_02
	public void setAttendance_04_02(Float attendance_04_02 ) { this.attendance_04_02 = attendance_04_02; } 	// ΑӍ04_02
	public void setAttendance_05_02(Float attendance_05_02 ) { this.attendance_05_02 = attendance_05_02; } 	// ΑӍ05_02
	public void setAttendance_06_02(Integer  attendance_06_02 ) { this.attendance_06_02 = attendance_06_02; } 	// ΑӍ06_02
	public void setAttendance_07_02(Integer  attendance_07_02 ) { this.attendance_07_02 = attendance_07_02; } 	// ΑӍ07_02
	public void setAttendance_08_02(Float attendance_08_02 ) { this.attendance_08_02 = attendance_08_02; } 	// ΑӍ08_02
	public void setAttendance_09_02(Float attendance_09_02 ) { this.attendance_09_02 = attendance_09_02; } 	// ΑӍ09_02
	public void setAttendance_10_02(Float attendance_10_02 ) { this.attendance_10_02 = attendance_10_02; } 	// ΑӍ10_02
	public void setAttendance_11_02(Float attendance_11_02 ) { this.attendance_11_02 = attendance_11_02; } 	// ΑӍ11_02
	public void setAttendance_12_02(Float attendance_12_02 ) { this.attendance_12_02 = attendance_12_02; } 	// ΑӍ12_02
	public void setAttendance_13_02(Integer  attendance_13_02 ) { this.attendance_13_02 = attendance_13_02; } 	// ΑӍ13_02
	public void setAttendance_14_02(Integer  attendance_14_02 ) { this.attendance_14_02 = attendance_14_02; } 	// ΑӍ14_02
	public void setBonAllowance_01_02(Integer bonAllowance_01_02 ) { this.bonAllowance_01_02 = bonAllowance_01_02; } 	// ܗ^x01_02
	public void setBonAllowance_02_02(Integer bonAllowance_02_02 ) { this.bonAllowance_02_02 = bonAllowance_02_02; } 	// ܗ^x02_02
	public void setBonAllowance_03_02(Integer bonAllowance_03_02 ) { this.bonAllowance_03_02 = bonAllowance_03_02; } 	// ܗ^x03_02
	public void setBonAllowance_04_02(Integer bonAllowance_04_02 ) { this.bonAllowance_04_02 = bonAllowance_04_02; } 	// ܗ^x04_02
	public void setBonAllowance_05_02(Integer bonAllowance_05_02 ) { this.bonAllowance_05_02 = bonAllowance_05_02; } 	// ܗ^x05_02
	public void setBonAllowance_06_02(Integer bonAllowance_06_02 ) { this.bonAllowance_06_02 = bonAllowance_06_02; } 	// ܗ^x06_02
	public void setBonAllowance_07_02(Integer bonAllowance_07_02 ) { this.bonAllowance_07_02 = bonAllowance_07_02; } 	// ܗ^x07_02
	public void setBonAllowance_08_02(Integer bonAllowance_08_02 ) { this.bonAllowance_08_02 = bonAllowance_08_02; } 	// ܗ^x08_02
	public void setBonAllowance_09_02(Integer bonAllowance_09_02 ) { this.bonAllowance_09_02 = bonAllowance_09_02; } 	// ܗ^x09_02
	public void setBonAllowance_10_02(Integer bonAllowance_10_02 ) { this.bonAllowance_10_02 = bonAllowance_10_02; } 	// ܗ^x10_02
	public void setBonDeduction_01_02(Integer bonDeduction_01_02 ) { this.bonDeduction_01_02 = bonDeduction_01_02; } 	// ܗ^T01_02
	public void setBonDeduction_02_02(Integer bonDeduction_02_02 ) { this.bonDeduction_02_02 = bonDeduction_02_02; } 	// ܗ^T02_02
	public void setBonDeduction_03_02(Integer bonDeduction_03_02 ) { this.bonDeduction_03_02 = bonDeduction_03_02; } 	// ܗ^T03_02
	public void setBonDeduction_04_02(Integer bonDeduction_04_02 ) { this.bonDeduction_04_02 = bonDeduction_04_02; } 	// ܗ^T04_02
	public void setBonDeduction_05_02(Integer bonDeduction_05_02 ) { this.bonDeduction_05_02 = bonDeduction_05_02; } 	// ܗ^T05_02
	public void setBonDeduction_06_02(Integer bonDeduction_06_02 ) { this.bonDeduction_06_02 = bonDeduction_06_02; } 	// ܗ^T06_02
	public void setBonDeduction_07_02(Integer bonDeduction_07_02 ) { this.bonDeduction_07_02 = bonDeduction_07_02; } 	// ܗ^T07_02
	public void setBonDeduction_08_02(Integer bonDeduction_08_02 ) { this.bonDeduction_08_02 = bonDeduction_08_02; } 	// ܗ^T08_02
	public void setBonDeduction_09_02(Integer bonDeduction_09_02 ) { this.bonDeduction_09_02 = bonDeduction_09_02; } 	// ܗ^T09_02
	public void setBonDeduction_10_02(Integer bonDeduction_10_02 ) { this.bonDeduction_10_02 = bonDeduction_10_02; } 	// ܗ^T10_02
	public void setBonDeduction_11_02(Integer bonDeduction_11_02 ) { this.bonDeduction_11_02 = bonDeduction_11_02; } 	// ܗ^T11_02
	public void setBonDeduction_12_02(Integer bonDeduction_12_02 ) { this.bonDeduction_12_02 = bonDeduction_12_02; } 	// ܗ^T12_02
	public void setBonDeduction_13_02(Integer bonDeduction_13_02 ) { this.bonDeduction_13_02 = bonDeduction_13_02; } 	// ܗ^T13_02
	public void setBonDeduction_14_02(Integer bonDeduction_14_02 ) { this.bonDeduction_14_02 = bonDeduction_14_02; } 	// ܗ^T14_02
	public void setBonDeduction_15_02(Integer bonDeduction_15_02 ) { this.bonDeduction_15_02 = bonDeduction_15_02; } 	// ܗ^T15_02
	public void setBonDeduction_16_02(Integer bonDeduction_16_02 ) { this.bonDeduction_16_02 = bonDeduction_16_02; } 	// ܗ^T16_02
	public void setBonDeduction_17_02(Integer bonDeduction_17_02 ) { this.bonDeduction_17_02 = bonDeduction_17_02; } 	// ܗ^T17_02
	public void setPayAllowance_01_03(Integer payAllowance_01_03 ) { this.payAllowance_01_03 = payAllowance_01_03; } 	// ^x01_03
	public void setPayAllowance_02_03(Integer payAllowance_02_03 ) { this.payAllowance_02_03 = payAllowance_02_03; } 	// ^x02_03
	public void setPayAllowance_03_03(Integer payAllowance_03_03 ) { this.payAllowance_03_03 = payAllowance_03_03; } 	// ^x03_03
	public void setPayAllowance_04_03(Integer payAllowance_04_03 ) { this.payAllowance_04_03 = payAllowance_04_03; } 	// ^x04_03
	public void setPayAllowance_05_03(Integer payAllowance_05_03 ) { this.payAllowance_05_03 = payAllowance_05_03; } 	// ^x05_03
	public void setPayAllowance_06_03(Integer payAllowance_06_03 ) { this.payAllowance_06_03 = payAllowance_06_03; } 	// ^x06_03
	public void setPayAllowance_07_03(Integer payAllowance_07_03 ) { this.payAllowance_07_03 = payAllowance_07_03; } 	// ^x07_03
	public void setPayAllowance_08_03(Integer payAllowance_08_03 ) { this.payAllowance_08_03 = payAllowance_08_03; } 	// ^x08_03
	public void setPayAllowance_09_03(Integer payAllowance_09_03 ) { this.payAllowance_09_03 = payAllowance_09_03; } 	// ^x09_03
	public void setPayAllowance_10_03(Integer payAllowance_10_03 ) { this.payAllowance_10_03 = payAllowance_10_03; } 	// ^x10_03
	public void setPayAllowance_11_03(Integer payAllowance_11_03 ) { this.payAllowance_11_03 = payAllowance_11_03; } 	// ^x11_03
	public void setPayAllowance_12_03(Integer payAllowance_12_03 ) { this.payAllowance_12_03 = payAllowance_12_03; } 	// ^x12_03
	public void setPayAllowance_13_03(Integer payAllowance_13_03 ) { this.payAllowance_13_03 = payAllowance_13_03; } 	// ^x13_03
	public void setPayAllowance_14_03(Integer payAllowance_14_03 ) { this.payAllowance_14_03 = payAllowance_14_03; } 	// ^x14_03
	public void setPayAllowance_15_03(Integer payAllowance_15_03 ) { this.payAllowance_15_03 = payAllowance_15_03; } 	// ^x15_03
	public void setPayAllowance_16_03(Integer payAllowance_16_03 ) { this.payAllowance_16_03 = payAllowance_16_03; } 	// ^x16_03
	public void setPayAllowance_17_03(Integer payAllowance_17_03 ) { this.payAllowance_17_03 = payAllowance_17_03; } 	// ^x17_03
	public void setPayAllowance_18_03(Integer payAllowance_18_03 ) { this.payAllowance_18_03 = payAllowance_18_03; } 	// ^x18_03
	public void setPayAllowance_19_03(Integer payAllowance_19_03 ) { this.payAllowance_19_03 = payAllowance_19_03; } 	// ^x19_03
	public void setPayAllowance_20_03(Integer payAllowance_20_03 ) { this.payAllowance_20_03 = payAllowance_20_03; } 	// ^x20_03
	public void setPayAllowance_21_03(Integer payAllowance_21_03 ) { this.payAllowance_21_03 = payAllowance_21_03; } 	// ^x21_03
	public void setPayAllowance_22_03(Integer payAllowance_22_03 ) { this.payAllowance_22_03 = payAllowance_22_03; } 	// ^x22_03
	public void setPayAllowance_23_03(Integer payAllowance_23_03 ) { this.payAllowance_23_03 = payAllowance_23_03; } 	// ^x23_03
	public void setPayAllowance_24_03(Integer payAllowance_24_03 ) { this.payAllowance_24_03 = payAllowance_24_03; } 	// ^x24_03
	public void setPayAllowance_25_03(Integer payAllowance_25_03 ) { this.payAllowance_25_03 = payAllowance_25_03; } 	// ^x25_03
	public void setPayAllowance_26_03(Integer payAllowance_26_03 ) { this.payAllowance_26_03 = payAllowance_26_03; } 	// ^x26_03
	public void setPayAllowance_27_03(Integer payAllowance_27_03 ) { this.payAllowance_27_03 = payAllowance_27_03; } 	// ^x27_03
	public void setPayAllowance_28_03(Integer payAllowance_28_03 ) { this.payAllowance_28_03 = payAllowance_28_03; } 	// ^x28_03
	public void setPayAllowance_29_03(Integer payAllowance_29_03 ) { this.payAllowance_29_03 = payAllowance_29_03; } 	// ^x29_03
	public void setPayAllowance_30_03(Integer payAllowance_30_03 ) { this.payAllowance_30_03 = payAllowance_30_03; } 	// ^x30_03
	public void setPayDeduction_01_03(Integer payDeduction_01_03 ) { this.payDeduction_01_03 = payDeduction_01_03; } 	// ^T01_03
	public void setPayDeduction_02_03(Integer payDeduction_02_03 ) { this.payDeduction_02_03 = payDeduction_02_03; } 	// ^T02_03
	public void setPayDeduction_03_03(Integer payDeduction_03_03 ) { this.payDeduction_03_03 = payDeduction_03_03; } 	// ^T03_03
	public void setPayDeduction_04_03(Integer payDeduction_04_03 ) { this.payDeduction_04_03 = payDeduction_04_03; } 	// ^T04_03
	public void setPayDeduction_05_03(Integer payDeduction_05_03 ) { this.payDeduction_05_03 = payDeduction_05_03; } 	// ^T05_03
	public void setPayDeduction_06_03(Integer payDeduction_06_03 ) { this.payDeduction_06_03 = payDeduction_06_03; } 	// ^T06_03
	public void setPayDeduction_07_03(Integer payDeduction_07_03 ) { this.payDeduction_07_03 = payDeduction_07_03; } 	// ^T07_03
	public void setPayDeduction_08_03(Integer payDeduction_08_03 ) { this.payDeduction_08_03 = payDeduction_08_03; } 	// ^T08_03
	public void setPayDeduction_09_03(Integer payDeduction_09_03 ) { this.payDeduction_09_03 = payDeduction_09_03; } 	// ^T09_03
	public void setPayDeduction_10_03(Integer payDeduction_10_03 ) { this.payDeduction_10_03 = payDeduction_10_03; } 	// ^T10_03
	public void setPayDeduction_11_03(Integer payDeduction_11_03 ) { this.payDeduction_11_03 = payDeduction_11_03; } 	// ^T11_03
	public void setPayDeduction_12_03(Integer payDeduction_12_03 ) { this.payDeduction_12_03 = payDeduction_12_03; } 	// ^T12_03
	public void setPayDeduction_13_03(Integer payDeduction_13_03 ) { this.payDeduction_13_03 = payDeduction_13_03; } 	// ^T13_03
	public void setPayDeduction_14_03(Integer payDeduction_14_03 ) { this.payDeduction_14_03 = payDeduction_14_03; } 	// ^T14_03
	public void setPayDeduction_15_03(Integer payDeduction_15_03 ) { this.payDeduction_15_03 = payDeduction_15_03; } 	// ^T15_03
	public void setPayDeduction_16_03(Integer payDeduction_16_03 ) { this.payDeduction_16_03 = payDeduction_16_03; } 	// ^T16_03
	public void setPayDeduction_17_03(Integer payDeduction_17_03 ) { this.payDeduction_17_03 = payDeduction_17_03; } 	// ^T17_03
	public void setPayDeduction_18_03(Integer payDeduction_18_03 ) { this.payDeduction_18_03 = payDeduction_18_03; } 	// ^T18_03
	public void setPayDeduction_19_03(Integer payDeduction_19_03 ) { this.payDeduction_19_03 = payDeduction_19_03; } 	// ^T19_03
	public void setPayDeduction_20_03(Integer payDeduction_20_03 ) { this.payDeduction_20_03 = payDeduction_20_03; } 	// ^T20_03
	public void setPayDeduction_21_03(Integer payDeduction_21_03 ) { this.payDeduction_21_03 = payDeduction_21_03; } 	// ^T21_03
	public void setPayDeduction_22_03(Integer payDeduction_22_03 ) { this.payDeduction_22_03 = payDeduction_22_03; } 	// ^T22_03
	public void setPayDeduction_23_03(Integer payDeduction_23_03 ) { this.payDeduction_23_03 = payDeduction_23_03; } 	// ^T23_03
	public void setPayDeduction_24_03(Integer payDeduction_24_03 ) { this.payDeduction_24_03 = payDeduction_24_03; } 	// ^T24_03
	public void setPayDeduction_25_03(Integer payDeduction_25_03 ) { this.payDeduction_25_03 = payDeduction_25_03; } 	// ^T25_03
	public void setPayDeduction_26_03(Integer payDeduction_26_03 ) { this.payDeduction_26_03 = payDeduction_26_03; } 	// ^T26_03
	public void setPayDeduction_27_03(Integer payDeduction_27_03 ) { this.payDeduction_27_03 = payDeduction_27_03; } 	// ^T27_03
	public void setAttendance_01_03(Float attendance_01_03 ) { this.attendance_01_03 = attendance_01_03; } 	// ΑӍ01_03
	public void setAttendance_02_03(Float attendance_02_03 ) { this.attendance_02_03 = attendance_02_03; } 	// ΑӍ02_03
	public void setAttendance_03_03(Float attendance_03_03 ) { this.attendance_03_03 = attendance_03_03; } 	// ΑӍ03_03
	public void setAttendance_04_03(Float attendance_04_03 ) { this.attendance_04_03 = attendance_04_03; } 	// ΑӍ04_03
	public void setAttendance_05_03(Float attendance_05_03 ) { this.attendance_05_03 = attendance_05_03; } 	// ΑӍ05_03
	public void setAttendance_06_03(Integer  attendance_06_03 ) { this.attendance_06_03 = attendance_06_03; } 	// ΑӍ06_03
	public void setAttendance_07_03(Integer  attendance_07_03 ) { this.attendance_07_03 = attendance_07_03; } 	// ΑӍ07_03
	public void setAttendance_08_03(Float attendance_08_03 ) { this.attendance_08_03 = attendance_08_03; } 	// ΑӍ08_03
	public void setAttendance_09_03(Float attendance_09_03 ) { this.attendance_09_03 = attendance_09_03; } 	// ΑӍ09_03
	public void setAttendance_10_03(Float attendance_10_03 ) { this.attendance_10_03 = attendance_10_03; } 	// ΑӍ10_03
	public void setAttendance_11_03(Float attendance_11_03 ) { this.attendance_11_03 = attendance_11_03; } 	// ΑӍ11_03
	public void setAttendance_12_03(Float attendance_12_03 ) { this.attendance_12_03 = attendance_12_03; } 	// ΑӍ12_03
	public void setAttendance_13_03(Integer  attendance_13_03 ) { this.attendance_13_03 = attendance_13_03; } 	// ΑӍ13_03
	public void setAttendance_14_03(Integer  attendance_14_03 ) { this.attendance_14_03 = attendance_14_03; } 	// ΑӍ14_03
	public void setBonAllowance_01_03(Integer bonAllowance_01_03 ) { this.bonAllowance_01_03 = bonAllowance_01_03; } 	// ܗ^x01_03
	public void setBonAllowance_02_03(Integer bonAllowance_02_03 ) { this.bonAllowance_02_03 = bonAllowance_02_03; } 	// ܗ^x02_03
	public void setBonAllowance_03_03(Integer bonAllowance_03_03 ) { this.bonAllowance_03_03 = bonAllowance_03_03; } 	// ܗ^x03_03
	public void setBonAllowance_04_03(Integer bonAllowance_04_03 ) { this.bonAllowance_04_03 = bonAllowance_04_03; } 	// ܗ^x04_03
	public void setBonAllowance_05_03(Integer bonAllowance_05_03 ) { this.bonAllowance_05_03 = bonAllowance_05_03; } 	// ܗ^x05_03
	public void setBonAllowance_06_03(Integer bonAllowance_06_03 ) { this.bonAllowance_06_03 = bonAllowance_06_03; } 	// ܗ^x06_03
	public void setBonAllowance_07_03(Integer bonAllowance_07_03 ) { this.bonAllowance_07_03 = bonAllowance_07_03; } 	// ܗ^x07_03
	public void setBonAllowance_08_03(Integer bonAllowance_08_03 ) { this.bonAllowance_08_03 = bonAllowance_08_03; } 	// ܗ^x08_03
	public void setBonAllowance_09_03(Integer bonAllowance_09_03 ) { this.bonAllowance_09_03 = bonAllowance_09_03; } 	// ܗ^x09_03
	public void setBonAllowance_10_03(Integer bonAllowance_10_03 ) { this.bonAllowance_10_03 = bonAllowance_10_03; } 	// ܗ^x10_03
	public void setBonDeduction_01_03(Integer bonDeduction_01_03 ) { this.bonDeduction_01_03 = bonDeduction_01_03; } 	// ܗ^T01_03
	public void setBonDeduction_02_03(Integer bonDeduction_02_03 ) { this.bonDeduction_02_03 = bonDeduction_02_03; } 	// ܗ^T02_03
	public void setBonDeduction_03_03(Integer bonDeduction_03_03 ) { this.bonDeduction_03_03 = bonDeduction_03_03; } 	// ܗ^T03_03
	public void setBonDeduction_04_03(Integer bonDeduction_04_03 ) { this.bonDeduction_04_03 = bonDeduction_04_03; } 	// ܗ^T04_03
	public void setBonDeduction_05_03(Integer bonDeduction_05_03 ) { this.bonDeduction_05_03 = bonDeduction_05_03; } 	// ܗ^T05_03
	public void setBonDeduction_06_03(Integer bonDeduction_06_03 ) { this.bonDeduction_06_03 = bonDeduction_06_03; } 	// ܗ^T06_03
	public void setBonDeduction_07_03(Integer bonDeduction_07_03 ) { this.bonDeduction_07_03 = bonDeduction_07_03; } 	// ܗ^T07_03
	public void setBonDeduction_08_03(Integer bonDeduction_08_03 ) { this.bonDeduction_08_03 = bonDeduction_08_03; } 	// ܗ^T08_03
	public void setBonDeduction_09_03(Integer bonDeduction_09_03 ) { this.bonDeduction_09_03 = bonDeduction_09_03; } 	// ܗ^T09_03
	public void setBonDeduction_10_03(Integer bonDeduction_10_03 ) { this.bonDeduction_10_03 = bonDeduction_10_03; } 	// ܗ^T10_03
	public void setBonDeduction_11_03(Integer bonDeduction_11_03 ) { this.bonDeduction_11_03 = bonDeduction_11_03; } 	// ܗ^T11_03
	public void setBonDeduction_12_03(Integer bonDeduction_12_03 ) { this.bonDeduction_12_03 = bonDeduction_12_03; } 	// ܗ^T12_03
	public void setBonDeduction_13_03(Integer bonDeduction_13_03 ) { this.bonDeduction_13_03 = bonDeduction_13_03; } 	// ܗ^T13_03
	public void setBonDeduction_14_03(Integer bonDeduction_14_03 ) { this.bonDeduction_14_03 = bonDeduction_14_03; } 	// ܗ^T14_03
	public void setBonDeduction_15_03(Integer bonDeduction_15_03 ) { this.bonDeduction_15_03 = bonDeduction_15_03; } 	// ܗ^T15_03
	public void setBonDeduction_16_03(Integer bonDeduction_16_03 ) { this.bonDeduction_16_03 = bonDeduction_16_03; } 	// ܗ^T16_03
	public void setBonDeduction_17_03(Integer bonDeduction_17_03 ) { this.bonDeduction_17_03 = bonDeduction_17_03; } 	// ܗ^T17_03
	public void setPayAllowance_01_04(Integer payAllowance_01_04 ) { this.payAllowance_01_04 = payAllowance_01_04; } 	// ^x01_04
	public void setPayAllowance_02_04(Integer payAllowance_02_04 ) { this.payAllowance_02_04 = payAllowance_02_04; } 	// ^x02_04
	public void setPayAllowance_03_04(Integer payAllowance_03_04 ) { this.payAllowance_03_04 = payAllowance_03_04; } 	// ^x03_04
	public void setPayAllowance_04_04(Integer payAllowance_04_04 ) { this.payAllowance_04_04 = payAllowance_04_04; } 	// ^x04_04
	public void setPayAllowance_05_04(Integer payAllowance_05_04 ) { this.payAllowance_05_04 = payAllowance_05_04; } 	// ^x05_04
	public void setPayAllowance_06_04(Integer payAllowance_06_04 ) { this.payAllowance_06_04 = payAllowance_06_04; } 	// ^x06_04
	public void setPayAllowance_07_04(Integer payAllowance_07_04 ) { this.payAllowance_07_04 = payAllowance_07_04; } 	// ^x07_04
	public void setPayAllowance_08_04(Integer payAllowance_08_04 ) { this.payAllowance_08_04 = payAllowance_08_04; } 	// ^x08_04
	public void setPayAllowance_09_04(Integer payAllowance_09_04 ) { this.payAllowance_09_04 = payAllowance_09_04; } 	// ^x09_04
	public void setPayAllowance_10_04(Integer payAllowance_10_04 ) { this.payAllowance_10_04 = payAllowance_10_04; } 	// ^x10_04
	public void setPayAllowance_11_04(Integer payAllowance_11_04 ) { this.payAllowance_11_04 = payAllowance_11_04; } 	// ^x11_04
	public void setPayAllowance_12_04(Integer payAllowance_12_04 ) { this.payAllowance_12_04 = payAllowance_12_04; } 	// ^x12_04
	public void setPayAllowance_13_04(Integer payAllowance_13_04 ) { this.payAllowance_13_04 = payAllowance_13_04; } 	// ^x13_04
	public void setPayAllowance_14_04(Integer payAllowance_14_04 ) { this.payAllowance_14_04 = payAllowance_14_04; } 	// ^x14_04
	public void setPayAllowance_15_04(Integer payAllowance_15_04 ) { this.payAllowance_15_04 = payAllowance_15_04; } 	// ^x15_04
	public void setPayAllowance_16_04(Integer payAllowance_16_04 ) { this.payAllowance_16_04 = payAllowance_16_04; } 	// ^x16_04
	public void setPayAllowance_17_04(Integer payAllowance_17_04 ) { this.payAllowance_17_04 = payAllowance_17_04; } 	// ^x17_04
	public void setPayAllowance_18_04(Integer payAllowance_18_04 ) { this.payAllowance_18_04 = payAllowance_18_04; } 	// ^x18_04
	public void setPayAllowance_19_04(Integer payAllowance_19_04 ) { this.payAllowance_19_04 = payAllowance_19_04; } 	// ^x19_04
	public void setPayAllowance_20_04(Integer payAllowance_20_04 ) { this.payAllowance_20_04 = payAllowance_20_04; } 	// ^x20_04
	public void setPayAllowance_21_04(Integer payAllowance_21_04 ) { this.payAllowance_21_04 = payAllowance_21_04; } 	// ^x21_04
	public void setPayAllowance_22_04(Integer payAllowance_22_04 ) { this.payAllowance_22_04 = payAllowance_22_04; } 	// ^x22_04
	public void setPayAllowance_23_04(Integer payAllowance_23_04 ) { this.payAllowance_23_04 = payAllowance_23_04; } 	// ^x23_04
	public void setPayAllowance_24_04(Integer payAllowance_24_04 ) { this.payAllowance_24_04 = payAllowance_24_04; } 	// ^x24_04
	public void setPayAllowance_25_04(Integer payAllowance_25_04 ) { this.payAllowance_25_04 = payAllowance_25_04; } 	// ^x25_04
	public void setPayAllowance_26_04(Integer payAllowance_26_04 ) { this.payAllowance_26_04 = payAllowance_26_04; } 	// ^x26_04
	public void setPayAllowance_27_04(Integer payAllowance_27_04 ) { this.payAllowance_27_04 = payAllowance_27_04; } 	// ^x27_04
	public void setPayAllowance_28_04(Integer payAllowance_28_04 ) { this.payAllowance_28_04 = payAllowance_28_04; } 	// ^x28_04
	public void setPayAllowance_29_04(Integer payAllowance_29_04 ) { this.payAllowance_29_04 = payAllowance_29_04; } 	// ^x29_04
	public void setPayAllowance_30_04(Integer payAllowance_30_04 ) { this.payAllowance_30_04 = payAllowance_30_04; } 	// ^x30_04
	public void setPayDeduction_01_04(Integer payDeduction_01_04 ) { this.payDeduction_01_04 = payDeduction_01_04; } 	// ^T01_04
	public void setPayDeduction_02_04(Integer payDeduction_02_04 ) { this.payDeduction_02_04 = payDeduction_02_04; } 	// ^T02_04
	public void setPayDeduction_03_04(Integer payDeduction_03_04 ) { this.payDeduction_03_04 = payDeduction_03_04; } 	// ^T03_04
	public void setPayDeduction_04_04(Integer payDeduction_04_04 ) { this.payDeduction_04_04 = payDeduction_04_04; } 	// ^T04_04
	public void setPayDeduction_05_04(Integer payDeduction_05_04 ) { this.payDeduction_05_04 = payDeduction_05_04; } 	// ^T05_04
	public void setPayDeduction_06_04(Integer payDeduction_06_04 ) { this.payDeduction_06_04 = payDeduction_06_04; } 	// ^T06_04
	public void setPayDeduction_07_04(Integer payDeduction_07_04 ) { this.payDeduction_07_04 = payDeduction_07_04; } 	// ^T07_04
	public void setPayDeduction_08_04(Integer payDeduction_08_04 ) { this.payDeduction_08_04 = payDeduction_08_04; } 	// ^T08_04
	public void setPayDeduction_09_04(Integer payDeduction_09_04 ) { this.payDeduction_09_04 = payDeduction_09_04; } 	// ^T09_04
	public void setPayDeduction_10_04(Integer payDeduction_10_04 ) { this.payDeduction_10_04 = payDeduction_10_04; } 	// ^T10_04
	public void setPayDeduction_11_04(Integer payDeduction_11_04 ) { this.payDeduction_11_04 = payDeduction_11_04; } 	// ^T11_04
	public void setPayDeduction_12_04(Integer payDeduction_12_04 ) { this.payDeduction_12_04 = payDeduction_12_04; } 	// ^T12_04
	public void setPayDeduction_13_04(Integer payDeduction_13_04 ) { this.payDeduction_13_04 = payDeduction_13_04; } 	// ^T13_04
	public void setPayDeduction_14_04(Integer payDeduction_14_04 ) { this.payDeduction_14_04 = payDeduction_14_04; } 	// ^T14_04
	public void setPayDeduction_15_04(Integer payDeduction_15_04 ) { this.payDeduction_15_04 = payDeduction_15_04; } 	// ^T15_04
	public void setPayDeduction_16_04(Integer payDeduction_16_04 ) { this.payDeduction_16_04 = payDeduction_16_04; } 	// ^T16_04
	public void setPayDeduction_17_04(Integer payDeduction_17_04 ) { this.payDeduction_17_04 = payDeduction_17_04; } 	// ^T17_04
	public void setPayDeduction_18_04(Integer payDeduction_18_04 ) { this.payDeduction_18_04 = payDeduction_18_04; } 	// ^T18_04
	public void setPayDeduction_19_04(Integer payDeduction_19_04 ) { this.payDeduction_19_04 = payDeduction_19_04; } 	// ^T19_04
	public void setPayDeduction_20_04(Integer payDeduction_20_04 ) { this.payDeduction_20_04 = payDeduction_20_04; } 	// ^T20_04
	public void setPayDeduction_21_04(Integer payDeduction_21_04 ) { this.payDeduction_21_04 = payDeduction_21_04; } 	// ^T21_04
	public void setPayDeduction_22_04(Integer payDeduction_22_04 ) { this.payDeduction_22_04 = payDeduction_22_04; } 	// ^T22_04
	public void setPayDeduction_23_04(Integer payDeduction_23_04 ) { this.payDeduction_23_04 = payDeduction_23_04; } 	// ^T23_04
	public void setPayDeduction_24_04(Integer payDeduction_24_04 ) { this.payDeduction_24_04 = payDeduction_24_04; } 	// ^T24_04
	public void setPayDeduction_25_04(Integer payDeduction_25_04 ) { this.payDeduction_25_04 = payDeduction_25_04; } 	// ^T25_04
	public void setPayDeduction_26_04(Integer payDeduction_26_04 ) { this.payDeduction_26_04 = payDeduction_26_04; } 	// ^T26_04
	public void setPayDeduction_27_04(Integer payDeduction_27_04 ) { this.payDeduction_27_04 = payDeduction_27_04; } 	// ^T27_04
	public void setAttendance_01_04(Float attendance_01_04 ) { this.attendance_01_04 = attendance_01_04; } 	// ΑӍ01_04
	public void setAttendance_02_04(Float attendance_02_04 ) { this.attendance_02_04 = attendance_02_04; } 	// ΑӍ02_04
	public void setAttendance_03_04(Float attendance_03_04 ) { this.attendance_03_04 = attendance_03_04; } 	// ΑӍ03_04
	public void setAttendance_04_04(Float attendance_04_04 ) { this.attendance_04_04 = attendance_04_04; } 	// ΑӍ04_04
	public void setAttendance_05_04(Float attendance_05_04 ) { this.attendance_05_04 = attendance_05_04; } 	// ΑӍ05_04
	public void setAttendance_06_04(Integer  attendance_06_04 ) { this.attendance_06_04 = attendance_06_04; } 	// ΑӍ06_04
	public void setAttendance_07_04(Integer  attendance_07_04 ) { this.attendance_07_04 = attendance_07_04; } 	// ΑӍ07_04
	public void setAttendance_08_04(Float attendance_08_04 ) { this.attendance_08_04 = attendance_08_04; } 	// ΑӍ08_04
	public void setAttendance_09_04(Float attendance_09_04 ) { this.attendance_09_04 = attendance_09_04; } 	// ΑӍ09_04
	public void setAttendance_10_04(Float attendance_10_04 ) { this.attendance_10_04 = attendance_10_04; } 	// ΑӍ10_04
	public void setAttendance_11_04(Float attendance_11_04 ) { this.attendance_11_04 = attendance_11_04; } 	// ΑӍ11_04
	public void setAttendance_12_04(Float attendance_12_04 ) { this.attendance_12_04 = attendance_12_04; } 	// ΑӍ12_04
	public void setAttendance_13_04(Integer  attendance_13_04 ) { this.attendance_13_04 = attendance_13_04; } 	// ΑӍ13_04
	public void setAttendance_14_04(Integer  attendance_14_04 ) { this.attendance_14_04 = attendance_14_04; } 	// ΑӍ14_04
	public void setBonAllowance_01_04(Integer bonAllowance_01_04 ) { this.bonAllowance_01_04 = bonAllowance_01_04; } 	// ܗ^x01_04
	public void setBonAllowance_02_04(Integer bonAllowance_02_04 ) { this.bonAllowance_02_04 = bonAllowance_02_04; } 	// ܗ^x02_04
	public void setBonAllowance_03_04(Integer bonAllowance_03_04 ) { this.bonAllowance_03_04 = bonAllowance_03_04; } 	// ܗ^x03_04
	public void setBonAllowance_04_04(Integer bonAllowance_04_04 ) { this.bonAllowance_04_04 = bonAllowance_04_04; } 	// ܗ^x04_04
	public void setBonAllowance_05_04(Integer bonAllowance_05_04 ) { this.bonAllowance_05_04 = bonAllowance_05_04; } 	// ܗ^x05_04
	public void setBonAllowance_06_04(Integer bonAllowance_06_04 ) { this.bonAllowance_06_04 = bonAllowance_06_04; } 	// ܗ^x06_04
	public void setBonAllowance_07_04(Integer bonAllowance_07_04 ) { this.bonAllowance_07_04 = bonAllowance_07_04; } 	// ܗ^x07_04
	public void setBonAllowance_08_04(Integer bonAllowance_08_04 ) { this.bonAllowance_08_04 = bonAllowance_08_04; } 	// ܗ^x08_04
	public void setBonAllowance_09_04(Integer bonAllowance_09_04 ) { this.bonAllowance_09_04 = bonAllowance_09_04; } 	// ܗ^x09_04
	public void setBonAllowance_10_04(Integer bonAllowance_10_04 ) { this.bonAllowance_10_04 = bonAllowance_10_04; } 	// ܗ^x10_04
	public void setBonDeduction_01_04(Integer bonDeduction_01_04 ) { this.bonDeduction_01_04 = bonDeduction_01_04; } 	// ܗ^T01_04
	public void setBonDeduction_02_04(Integer bonDeduction_02_04 ) { this.bonDeduction_02_04 = bonDeduction_02_04; } 	// ܗ^T02_04
	public void setBonDeduction_03_04(Integer bonDeduction_03_04 ) { this.bonDeduction_03_04 = bonDeduction_03_04; } 	// ܗ^T03_04
	public void setBonDeduction_04_04(Integer bonDeduction_04_04 ) { this.bonDeduction_04_04 = bonDeduction_04_04; } 	// ܗ^T04_04
	public void setBonDeduction_05_04(Integer bonDeduction_05_04 ) { this.bonDeduction_05_04 = bonDeduction_05_04; } 	// ܗ^T05_04
	public void setBonDeduction_06_04(Integer bonDeduction_06_04 ) { this.bonDeduction_06_04 = bonDeduction_06_04; } 	// ܗ^T06_04
	public void setBonDeduction_07_04(Integer bonDeduction_07_04 ) { this.bonDeduction_07_04 = bonDeduction_07_04; } 	// ܗ^T07_04
	public void setBonDeduction_08_04(Integer bonDeduction_08_04 ) { this.bonDeduction_08_04 = bonDeduction_08_04; } 	// ܗ^T08_04
	public void setBonDeduction_09_04(Integer bonDeduction_09_04 ) { this.bonDeduction_09_04 = bonDeduction_09_04; } 	// ܗ^T09_04
	public void setBonDeduction_10_04(Integer bonDeduction_10_04 ) { this.bonDeduction_10_04 = bonDeduction_10_04; } 	// ܗ^T10_04
	public void setBonDeduction_11_04(Integer bonDeduction_11_04 ) { this.bonDeduction_11_04 = bonDeduction_11_04; } 	// ܗ^T11_04
	public void setBonDeduction_12_04(Integer bonDeduction_12_04 ) { this.bonDeduction_12_04 = bonDeduction_12_04; } 	// ܗ^T12_04
	public void setBonDeduction_13_04(Integer bonDeduction_13_04 ) { this.bonDeduction_13_04 = bonDeduction_13_04; } 	// ܗ^T13_04
	public void setBonDeduction_14_04(Integer bonDeduction_14_04 ) { this.bonDeduction_14_04 = bonDeduction_14_04; } 	// ܗ^T14_04
	public void setBonDeduction_15_04(Integer bonDeduction_15_04 ) { this.bonDeduction_15_04 = bonDeduction_15_04; } 	// ܗ^T15_04
	public void setBonDeduction_16_04(Integer bonDeduction_16_04 ) { this.bonDeduction_16_04 = bonDeduction_16_04; } 	// ܗ^T16_04
	public void setBonDeduction_17_04(Integer bonDeduction_17_04 ) { this.bonDeduction_17_04 = bonDeduction_17_04; } 	// ܗ^T17_04
	
	public void setPayAllowance_01_05(Integer payAllowance_01_05 ) { this.payAllowance_01_05 = payAllowance_01_05; } 	// ^x01_05
	public void setPayAllowance_02_05(Integer payAllowance_02_05 ) { this.payAllowance_02_05 = payAllowance_02_05; } 	// ^x02_05
	public void setPayAllowance_03_05(Integer payAllowance_03_05 ) { this.payAllowance_03_05 = payAllowance_03_05; } 	// ^x03_05
	public void setPayAllowance_04_05(Integer payAllowance_04_05 ) { this.payAllowance_04_05 = payAllowance_04_05; } 	// ^x04_05
	public void setPayAllowance_05_05(Integer payAllowance_05_05 ) { this.payAllowance_05_05 = payAllowance_05_05; } 	// ^x05_05
	public void setPayAllowance_06_05(Integer payAllowance_06_05 ) { this.payAllowance_06_05 = payAllowance_06_05; } 	// ^x06_05
	public void setPayAllowance_07_05(Integer payAllowance_07_05 ) { this.payAllowance_07_05 = payAllowance_07_05; } 	// ^x07_05
	public void setPayAllowance_08_05(Integer payAllowance_08_05 ) { this.payAllowance_08_05 = payAllowance_08_05; } 	// ^x08_05
	public void setPayAllowance_09_05(Integer payAllowance_09_05 ) { this.payAllowance_09_05 = payAllowance_09_05; } 	// ^x09_05
	public void setPayAllowance_10_05(Integer payAllowance_10_05 ) { this.payAllowance_10_05 = payAllowance_10_05; } 	// ^x10_05
	public void setPayAllowance_11_05(Integer payAllowance_11_05 ) { this.payAllowance_11_05 = payAllowance_11_05; } 	// ^x11_05
	public void setPayAllowance_12_05(Integer payAllowance_12_05 ) { this.payAllowance_12_05 = payAllowance_12_05; } 	// ^x12_05
	public void setPayAllowance_13_05(Integer payAllowance_13_05 ) { this.payAllowance_13_05 = payAllowance_13_05; } 	// ^x13_05
	public void setPayAllowance_14_05(Integer payAllowance_14_05 ) { this.payAllowance_14_05 = payAllowance_14_05; } 	// ^x14_05
	public void setPayAllowance_15_05(Integer payAllowance_15_05 ) { this.payAllowance_15_05 = payAllowance_15_05; } 	// ^x15_05
	public void setPayAllowance_16_05(Integer payAllowance_16_05 ) { this.payAllowance_16_05 = payAllowance_16_05; } 	// ^x16_05
	public void setPayAllowance_17_05(Integer payAllowance_17_05 ) { this.payAllowance_17_05 = payAllowance_17_05; } 	// ^x17_05
	public void setPayAllowance_18_05(Integer payAllowance_18_05 ) { this.payAllowance_18_05 = payAllowance_18_05; } 	// ^x18_05
	public void setPayAllowance_19_05(Integer payAllowance_19_05 ) { this.payAllowance_19_05 = payAllowance_19_05; } 	// ^x19_05
	public void setPayAllowance_20_05(Integer payAllowance_20_05 ) { this.payAllowance_20_05 = payAllowance_20_05; } 	// ^x20_05
	public void setPayAllowance_21_05(Integer payAllowance_21_05 ) { this.payAllowance_21_05 = payAllowance_21_05; } 	// ^x21_05
	public void setPayAllowance_22_05(Integer payAllowance_22_05 ) { this.payAllowance_22_05 = payAllowance_22_05; } 	// ^x22_05
	public void setPayAllowance_23_05(Integer payAllowance_23_05 ) { this.payAllowance_23_05 = payAllowance_23_05; } 	// ^x23_05
	public void setPayAllowance_24_05(Integer payAllowance_24_05 ) { this.payAllowance_24_05 = payAllowance_24_05; } 	// ^x24_05
	public void setPayAllowance_25_05(Integer payAllowance_25_05 ) { this.payAllowance_25_05 = payAllowance_25_05; } 	// ^x25_05
	public void setPayAllowance_26_05(Integer payAllowance_26_05 ) { this.payAllowance_26_05 = payAllowance_26_05; } 	// ^x26_05
	public void setPayAllowance_27_05(Integer payAllowance_27_05 ) { this.payAllowance_27_05 = payAllowance_27_05; } 	// ^x27_05
	public void setPayAllowance_28_05(Integer payAllowance_28_05 ) { this.payAllowance_28_05 = payAllowance_28_05; } 	// ^x28_05
	public void setPayAllowance_29_05(Integer payAllowance_29_05 ) { this.payAllowance_29_05 = payAllowance_29_05; } 	// ^x29_05
	public void setPayAllowance_30_05(Integer payAllowance_30_05 ) { this.payAllowance_30_05 = payAllowance_30_05; } 	// ^x30_05
	public void setPayDeduction_01_05(Integer payDeduction_01_05 ) { this.payDeduction_01_05 = payDeduction_01_05; } 	// ^T01_05
	public void setPayDeduction_02_05(Integer payDeduction_02_05 ) { this.payDeduction_02_05 = payDeduction_02_05; } 	// ^T02_05
	public void setPayDeduction_03_05(Integer payDeduction_03_05 ) { this.payDeduction_03_05 = payDeduction_03_05; } 	// ^T03_05
	public void setPayDeduction_04_05(Integer payDeduction_04_05 ) { this.payDeduction_04_05 = payDeduction_04_05; } 	// ^T04_05
	public void setPayDeduction_05_05(Integer payDeduction_05_05 ) { this.payDeduction_05_05 = payDeduction_05_05; } 	// ^T05_05
	public void setPayDeduction_06_05(Integer payDeduction_06_05 ) { this.payDeduction_06_05 = payDeduction_06_05; } 	// ^T06_05
	public void setPayDeduction_07_05(Integer payDeduction_07_05 ) { this.payDeduction_07_05 = payDeduction_07_05; } 	// ^T07_05
	public void setPayDeduction_08_05(Integer payDeduction_08_05 ) { this.payDeduction_08_05 = payDeduction_08_05; } 	// ^T08_05
	public void setPayDeduction_09_05(Integer payDeduction_09_05 ) { this.payDeduction_09_05 = payDeduction_09_05; } 	// ^T09_05
	public void setPayDeduction_10_05(Integer payDeduction_10_05 ) { this.payDeduction_10_05 = payDeduction_10_05; } 	// ^T10_05
	public void setPayDeduction_11_05(Integer payDeduction_11_05 ) { this.payDeduction_11_05 = payDeduction_11_05; } 	// ^T11_05
	public void setPayDeduction_12_05(Integer payDeduction_12_05 ) { this.payDeduction_12_05 = payDeduction_12_05; } 	// ^T12_05
	public void setPayDeduction_13_05(Integer payDeduction_13_05 ) { this.payDeduction_13_05 = payDeduction_13_05; } 	// ^T13_05
	public void setPayDeduction_14_05(Integer payDeduction_14_05 ) { this.payDeduction_14_05 = payDeduction_14_05; } 	// ^T14_05
	public void setPayDeduction_15_05(Integer payDeduction_15_05 ) { this.payDeduction_15_05 = payDeduction_15_05; } 	// ^T15_05
	public void setPayDeduction_16_05(Integer payDeduction_16_05 ) { this.payDeduction_16_05 = payDeduction_16_05; } 	// ^T16_05
	public void setPayDeduction_17_05(Integer payDeduction_17_05 ) { this.payDeduction_17_05 = payDeduction_17_05; } 	// ^T17_05
	public void setPayDeduction_18_05(Integer payDeduction_18_05 ) { this.payDeduction_18_05 = payDeduction_18_05; } 	// ^T18_05
	public void setPayDeduction_19_05(Integer payDeduction_19_05 ) { this.payDeduction_19_05 = payDeduction_19_05; } 	// ^T19_05
	public void setPayDeduction_20_05(Integer payDeduction_20_05 ) { this.payDeduction_20_05 = payDeduction_20_05; } 	// ^T20_05
	public void setPayDeduction_21_05(Integer payDeduction_21_05 ) { this.payDeduction_21_05 = payDeduction_21_05; } 	// ^T21_05
	public void setPayDeduction_22_05(Integer payDeduction_22_05 ) { this.payDeduction_22_05 = payDeduction_22_05; } 	// ^T22_05
	public void setPayDeduction_23_05(Integer payDeduction_23_05 ) { this.payDeduction_23_05 = payDeduction_23_05; } 	// ^T23_05
	public void setPayDeduction_24_05(Integer payDeduction_24_05 ) { this.payDeduction_24_05 = payDeduction_24_05; } 	// ^T24_05
	public void setPayDeduction_25_05(Integer payDeduction_25_05 ) { this.payDeduction_25_05 = payDeduction_25_05; } 	// ^T25_05
	public void setPayDeduction_26_05(Integer payDeduction_26_05 ) { this.payDeduction_26_05 = payDeduction_26_05; } 	// ^T26_05
	public void setPayDeduction_27_05(Integer payDeduction_27_05 ) { this.payDeduction_27_05 = payDeduction_27_05; } 	// ^T27_05
	public void setAttendance_01_05(Float attendance_01_05 ) { this.attendance_01_05 = attendance_01_05; } 	// ΑӍ01_05
	public void setAttendance_02_05(Float attendance_02_05 ) { this.attendance_02_05 = attendance_02_05; } 	// ΑӍ02_05
	public void setAttendance_03_05(Float attendance_03_05 ) { this.attendance_03_05 = attendance_03_05; } 	// ΑӍ03_05
	public void setAttendance_04_05(Float attendance_04_05 ) { this.attendance_04_05 = attendance_04_05; } 	// ΑӍ04_05
	public void setAttendance_05_05(Float attendance_05_05 ) { this.attendance_05_05 = attendance_05_05; } 	// ΑӍ05_05
	public void setAttendance_06_05(Integer  attendance_06_05 ) { this.attendance_06_05 = attendance_06_05; } 	// ΑӍ06_05
	public void setAttendance_07_05(Integer  attendance_07_05 ) { this.attendance_07_05 = attendance_07_05; } 	// ΑӍ07_05
	public void setAttendance_08_05(Float attendance_08_05 ) { this.attendance_08_05 = attendance_08_05; } 	// ΑӍ08_05
	public void setAttendance_09_05(Float attendance_09_05 ) { this.attendance_09_05 = attendance_09_05; } 	// ΑӍ09_05
	public void setAttendance_10_05(Float attendance_10_05 ) { this.attendance_10_05 = attendance_10_05; } 	// ΑӍ10_05
	public void setAttendance_11_05(Float attendance_11_05 ) { this.attendance_11_05 = attendance_11_05; } 	// ΑӍ11_05
	public void setAttendance_12_05(Float attendance_12_05 ) { this.attendance_12_05 = attendance_12_05; } 	// ΑӍ12_05
	public void setAttendance_13_05(Integer  attendance_13_05 ) { this.attendance_13_05 = attendance_13_05; } 	// ΑӍ13_05
	public void setAttendance_14_05(Integer  attendance_14_05 ) { this.attendance_14_05 = attendance_14_05; } 	// ΑӍ14_05
	public void setBonAllowance_01_05(Integer bonAllowance_01_05 ) { this.bonAllowance_01_05 = bonAllowance_01_05; } 	// ܗ^x01_05
	public void setBonAllowance_02_05(Integer bonAllowance_02_05 ) { this.bonAllowance_02_05 = bonAllowance_02_05; } 	// ܗ^x02_05
	public void setBonAllowance_03_05(Integer bonAllowance_03_05 ) { this.bonAllowance_03_05 = bonAllowance_03_05; } 	// ܗ^x03_05
	public void setBonAllowance_04_05(Integer bonAllowance_04_05 ) { this.bonAllowance_04_05 = bonAllowance_04_05; } 	// ܗ^x04_05
	public void setBonAllowance_05_05(Integer bonAllowance_05_05 ) { this.bonAllowance_05_05 = bonAllowance_05_05; } 	// ܗ^x05_05
	public void setBonAllowance_06_05(Integer bonAllowance_06_05 ) { this.bonAllowance_06_05 = bonAllowance_06_05; } 	// ܗ^x06_05
	public void setBonAllowance_07_05(Integer bonAllowance_07_05 ) { this.bonAllowance_07_05 = bonAllowance_07_05; } 	// ܗ^x07_05
	public void setBonAllowance_08_05(Integer bonAllowance_08_05 ) { this.bonAllowance_08_05 = bonAllowance_08_05; } 	// ܗ^x08_05
	public void setBonAllowance_09_05(Integer bonAllowance_09_05 ) { this.bonAllowance_09_05 = bonAllowance_09_05; } 	// ܗ^x09_05
	public void setBonAllowance_10_05(Integer bonAllowance_10_05 ) { this.bonAllowance_10_05 = bonAllowance_10_05; } 	// ܗ^x10_05
	public void setBonDeduction_01_05(Integer bonDeduction_01_05 ) { this.bonDeduction_01_05 = bonDeduction_01_05; } 	// ܗ^T01_05
	public void setBonDeduction_02_05(Integer bonDeduction_02_05 ) { this.bonDeduction_02_05 = bonDeduction_02_05; } 	// ܗ^T02_05
	public void setBonDeduction_03_05(Integer bonDeduction_03_05 ) { this.bonDeduction_03_05 = bonDeduction_03_05; } 	// ܗ^T03_05
	public void setBonDeduction_04_05(Integer bonDeduction_04_05 ) { this.bonDeduction_04_05 = bonDeduction_04_05; } 	// ܗ^T04_05
	public void setBonDeduction_05_05(Integer bonDeduction_05_05 ) { this.bonDeduction_05_05 = bonDeduction_05_05; } 	// ܗ^T05_05
	public void setBonDeduction_06_05(Integer bonDeduction_06_05 ) { this.bonDeduction_06_05 = bonDeduction_06_05; } 	// ܗ^T06_05
	public void setBonDeduction_07_05(Integer bonDeduction_07_05 ) { this.bonDeduction_07_05 = bonDeduction_07_05; } 	// ܗ^T07_05
	public void setBonDeduction_08_05(Integer bonDeduction_08_05 ) { this.bonDeduction_08_05 = bonDeduction_08_05; } 	// ܗ^T08_05
	public void setBonDeduction_09_05(Integer bonDeduction_09_05 ) { this.bonDeduction_09_05 = bonDeduction_09_05; } 	// ܗ^T09_05
	public void setBonDeduction_10_05(Integer bonDeduction_10_05 ) { this.bonDeduction_10_05 = bonDeduction_10_05; } 	// ܗ^T10_05
	public void setBonDeduction_11_05(Integer bonDeduction_11_05 ) { this.bonDeduction_11_05 = bonDeduction_11_05; } 	// ܗ^T11_05
	public void setBonDeduction_12_05(Integer bonDeduction_12_05 ) { this.bonDeduction_12_05 = bonDeduction_12_05; } 	// ܗ^T12_05
	public void setBonDeduction_13_05(Integer bonDeduction_13_05 ) { this.bonDeduction_13_05 = bonDeduction_13_05; } 	// ܗ^T13_05
	public void setBonDeduction_14_05(Integer bonDeduction_14_05 ) { this.bonDeduction_14_05 = bonDeduction_14_05; } 	// ܗ^T14_05
	public void setBonDeduction_15_05(Integer bonDeduction_15_05 ) { this.bonDeduction_15_05 = bonDeduction_15_05; } 	// ܗ^T15_05
	public void setBonDeduction_16_05(Integer bonDeduction_16_05 ) { this.bonDeduction_16_05 = bonDeduction_16_05; } 	// ܗ^T16_05
	public void setBonDeduction_17_05(Integer bonDeduction_17_05 ) { this.bonDeduction_17_05 = bonDeduction_17_05; } 	// ܗ^T17_05
	
	public void setPayAllowance_01_06(Integer payAllowance_01_06 ) { this.payAllowance_01_06 = payAllowance_01_06; } 	// ^x01_06
	public void setPayAllowance_02_06(Integer payAllowance_02_06 ) { this.payAllowance_02_06 = payAllowance_02_06; } 	// ^x02_06
	public void setPayAllowance_03_06(Integer payAllowance_03_06 ) { this.payAllowance_03_06 = payAllowance_03_06; } 	// ^x03_06
	public void setPayAllowance_04_06(Integer payAllowance_04_06 ) { this.payAllowance_04_06 = payAllowance_04_06; } 	// ^x04_06
	public void setPayAllowance_05_06(Integer payAllowance_05_06 ) { this.payAllowance_05_06 = payAllowance_05_06; } 	// ^x05_06
	public void setPayAllowance_06_06(Integer payAllowance_06_06 ) { this.payAllowance_06_06 = payAllowance_06_06; } 	// ^x06_06
	public void setPayAllowance_07_06(Integer payAllowance_07_06 ) { this.payAllowance_07_06 = payAllowance_07_06; } 	// ^x07_06
	public void setPayAllowance_08_06(Integer payAllowance_08_06 ) { this.payAllowance_08_06 = payAllowance_08_06; } 	// ^x08_06
	public void setPayAllowance_09_06(Integer payAllowance_09_06 ) { this.payAllowance_09_06 = payAllowance_09_06; } 	// ^x09_06
	public void setPayAllowance_10_06(Integer payAllowance_10_06 ) { this.payAllowance_10_06 = payAllowance_10_06; } 	// ^x10_06
	public void setPayAllowance_11_06(Integer payAllowance_11_06 ) { this.payAllowance_11_06 = payAllowance_11_06; } 	// ^x11_06
	public void setPayAllowance_12_06(Integer payAllowance_12_06 ) { this.payAllowance_12_06 = payAllowance_12_06; } 	// ^x12_06
	public void setPayAllowance_13_06(Integer payAllowance_13_06 ) { this.payAllowance_13_06 = payAllowance_13_06; } 	// ^x13_06
	public void setPayAllowance_14_06(Integer payAllowance_14_06 ) { this.payAllowance_14_06 = payAllowance_14_06; } 	// ^x14_06
	public void setPayAllowance_15_06(Integer payAllowance_15_06 ) { this.payAllowance_15_06 = payAllowance_15_06; } 	// ^x15_06
	public void setPayAllowance_16_06(Integer payAllowance_16_06 ) { this.payAllowance_16_06 = payAllowance_16_06; } 	// ^x16_06
	public void setPayAllowance_17_06(Integer payAllowance_17_06 ) { this.payAllowance_17_06 = payAllowance_17_06; } 	// ^x17_06
	public void setPayAllowance_18_06(Integer payAllowance_18_06 ) { this.payAllowance_18_06 = payAllowance_18_06; } 	// ^x18_06
	public void setPayAllowance_19_06(Integer payAllowance_19_06 ) { this.payAllowance_19_06 = payAllowance_19_06; } 	// ^x19_06
	public void setPayAllowance_20_06(Integer payAllowance_20_06 ) { this.payAllowance_20_06 = payAllowance_20_06; } 	// ^x20_06
	public void setPayAllowance_21_06(Integer payAllowance_21_06 ) { this.payAllowance_21_06 = payAllowance_21_06; } 	// ^x21_06
	public void setPayAllowance_22_06(Integer payAllowance_22_06 ) { this.payAllowance_22_06 = payAllowance_22_06; } 	// ^x22_06
	public void setPayAllowance_23_06(Integer payAllowance_23_06 ) { this.payAllowance_23_06 = payAllowance_23_06; } 	// ^x23_06
	public void setPayAllowance_24_06(Integer payAllowance_24_06 ) { this.payAllowance_24_06 = payAllowance_24_06; } 	// ^x24_06
	public void setPayAllowance_25_06(Integer payAllowance_25_06 ) { this.payAllowance_25_06 = payAllowance_25_06; } 	// ^x25_06
	public void setPayAllowance_26_06(Integer payAllowance_26_06 ) { this.payAllowance_26_06 = payAllowance_26_06; } 	// ^x26_06
	public void setPayAllowance_27_06(Integer payAllowance_27_06 ) { this.payAllowance_27_06 = payAllowance_27_06; } 	// ^x27_06
	public void setPayAllowance_28_06(Integer payAllowance_28_06 ) { this.payAllowance_28_06 = payAllowance_28_06; } 	// ^x28_06
	public void setPayAllowance_29_06(Integer payAllowance_29_06 ) { this.payAllowance_29_06 = payAllowance_29_06; } 	// ^x29_06
	public void setPayAllowance_30_06(Integer payAllowance_30_06 ) { this.payAllowance_30_06 = payAllowance_30_06; } 	// ^x30_06
	public void setPayDeduction_01_06(Integer payDeduction_01_06 ) { this.payDeduction_01_06 = payDeduction_01_06; } 	// ^T01_06
	public void setPayDeduction_02_06(Integer payDeduction_02_06 ) { this.payDeduction_02_06 = payDeduction_02_06; } 	// ^T02_06
	public void setPayDeduction_03_06(Integer payDeduction_03_06 ) { this.payDeduction_03_06 = payDeduction_03_06; } 	// ^T03_06
	public void setPayDeduction_04_06(Integer payDeduction_04_06 ) { this.payDeduction_04_06 = payDeduction_04_06; } 	// ^T04_06
	public void setPayDeduction_05_06(Integer payDeduction_05_06 ) { this.payDeduction_05_06 = payDeduction_05_06; } 	// ^T05_06
	public void setPayDeduction_06_06(Integer payDeduction_06_06 ) { this.payDeduction_06_06 = payDeduction_06_06; } 	// ^T06_06
	public void setPayDeduction_07_06(Integer payDeduction_07_06 ) { this.payDeduction_07_06 = payDeduction_07_06; } 	// ^T07_06
	public void setPayDeduction_08_06(Integer payDeduction_08_06 ) { this.payDeduction_08_06 = payDeduction_08_06; } 	// ^T08_06
	public void setPayDeduction_09_06(Integer payDeduction_09_06 ) { this.payDeduction_09_06 = payDeduction_09_06; } 	// ^T09_06
	public void setPayDeduction_10_06(Integer payDeduction_10_06 ) { this.payDeduction_10_06 = payDeduction_10_06; } 	// ^T10_06
	public void setPayDeduction_11_06(Integer payDeduction_11_06 ) { this.payDeduction_11_06 = payDeduction_11_06; } 	// ^T11_06
	public void setPayDeduction_12_06(Integer payDeduction_12_06 ) { this.payDeduction_12_06 = payDeduction_12_06; } 	// ^T12_06
	public void setPayDeduction_13_06(Integer payDeduction_13_06 ) { this.payDeduction_13_06 = payDeduction_13_06; } 	// ^T13_06
	public void setPayDeduction_14_06(Integer payDeduction_14_06 ) { this.payDeduction_14_06 = payDeduction_14_06; } 	// ^T14_06
	public void setPayDeduction_15_06(Integer payDeduction_15_06 ) { this.payDeduction_15_06 = payDeduction_15_06; } 	// ^T15_06
	public void setPayDeduction_16_06(Integer payDeduction_16_06 ) { this.payDeduction_16_06 = payDeduction_16_06; } 	// ^T16_06
	public void setPayDeduction_17_06(Integer payDeduction_17_06 ) { this.payDeduction_17_06 = payDeduction_17_06; } 	// ^T17_06
	public void setPayDeduction_18_06(Integer payDeduction_18_06 ) { this.payDeduction_18_06 = payDeduction_18_06; } 	// ^T18_06
	public void setPayDeduction_19_06(Integer payDeduction_19_06 ) { this.payDeduction_19_06 = payDeduction_19_06; } 	// ^T19_06
	public void setPayDeduction_20_06(Integer payDeduction_20_06 ) { this.payDeduction_20_06 = payDeduction_20_06; } 	// ^T20_06
	public void setPayDeduction_21_06(Integer payDeduction_21_06 ) { this.payDeduction_21_06 = payDeduction_21_06; } 	// ^T21_06
	public void setPayDeduction_22_06(Integer payDeduction_22_06 ) { this.payDeduction_22_06 = payDeduction_22_06; } 	// ^T22_06
	public void setPayDeduction_23_06(Integer payDeduction_23_06 ) { this.payDeduction_23_06 = payDeduction_23_06; } 	// ^T23_06
	public void setPayDeduction_24_06(Integer payDeduction_24_06 ) { this.payDeduction_24_06 = payDeduction_24_06; } 	// ^T24_06
	public void setPayDeduction_25_06(Integer payDeduction_25_06 ) { this.payDeduction_25_06 = payDeduction_25_06; } 	// ^T25_06
	public void setPayDeduction_26_06(Integer payDeduction_26_06 ) { this.payDeduction_26_06 = payDeduction_26_06; } 	// ^T26_06
	public void setPayDeduction_27_06(Integer payDeduction_27_06 ) { this.payDeduction_27_06 = payDeduction_27_06; } 	// ^T27_06
	public void setAttendance_01_06(Float attendance_01_06 ) { this.attendance_01_06 = attendance_01_06; } 	// ΑӍ01_06
	public void setAttendance_02_06(Float attendance_02_06 ) { this.attendance_02_06 = attendance_02_06; } 	// ΑӍ02_06
	public void setAttendance_03_06(Float attendance_03_06 ) { this.attendance_03_06 = attendance_03_06; } 	// ΑӍ03_06
	public void setAttendance_04_06(Float attendance_04_06 ) { this.attendance_04_06 = attendance_04_06; } 	// ΑӍ04_06
	public void setAttendance_05_06(Float attendance_05_06 ) { this.attendance_05_06 = attendance_05_06; } 	// ΑӍ05_06
	public void setAttendance_06_06(Integer  attendance_06_06 ) { this.attendance_06_06 = attendance_06_06; } 	// ΑӍ06_06
	public void setAttendance_07_06(Integer  attendance_07_06 ) { this.attendance_07_06 = attendance_07_06; } 	// ΑӍ07_06
	public void setAttendance_08_06(Float attendance_08_06 ) { this.attendance_08_06 = attendance_08_06; } 	// ΑӍ08_06
	public void setAttendance_09_06(Float  attendance_09_06 ) { this.attendance_09_06 = attendance_09_06; } 	// ΑӍ09_06
	public void setAttendance_10_06(Float  attendance_10_06 ) { this.attendance_10_06 = attendance_10_06; } 	// ΑӍ10_06
	public void setAttendance_11_06(Float  attendance_11_06 ) { this.attendance_11_06 = attendance_11_06; } 	// ΑӍ11_06
	public void setAttendance_12_06(Float  attendance_12_06 ) { this.attendance_12_06 = attendance_12_06; } 	// ΑӍ12_06
	public void setAttendance_13_06(Integer  attendance_13_06 ) { this.attendance_13_06 = attendance_13_06; } 	// ΑӍ13_06
	public void setAttendance_14_06(Integer  attendance_14_06 ) { this.attendance_14_06 = attendance_14_06; } 	// ΑӍ14_06
	
	public void setBonAllowance_01_06(Integer bonAllowance_01_06 ) { this.bonAllowance_01_06 = bonAllowance_01_06; } 	// ܗ^x01_06
	public void setBonAllowance_02_06(Integer bonAllowance_02_06 ) { this.bonAllowance_02_06 = bonAllowance_02_06; } 	// ܗ^x02_06
	public void setBonAllowance_03_06(Integer bonAllowance_03_06 ) { this.bonAllowance_03_06 = bonAllowance_03_06; } 	// ܗ^x03_06
	public void setBonAllowance_04_06(Integer bonAllowance_04_06 ) { this.bonAllowance_04_06 = bonAllowance_04_06; } 	// ܗ^x04_06
	public void setBonAllowance_05_06(Integer bonAllowance_05_06 ) { this.bonAllowance_05_06 = bonAllowance_05_06; } 	// ܗ^x05_06
	public void setBonAllowance_06_06(Integer bonAllowance_06_06 ) { this.bonAllowance_06_06 = bonAllowance_06_06; } 	// ܗ^x06_06
	public void setBonAllowance_07_06(Integer bonAllowance_07_06 ) { this.bonAllowance_07_06 = bonAllowance_07_06; } 	// ܗ^x07_06
	public void setBonAllowance_08_06(Integer bonAllowance_08_06 ) { this.bonAllowance_08_06 = bonAllowance_08_06; } 	// ܗ^x08_06
	public void setBonAllowance_09_06(Integer bonAllowance_09_06 ) { this.bonAllowance_09_06 = bonAllowance_09_06; } 	// ܗ^x09_06
	public void setBonAllowance_10_06(Integer bonAllowance_10_06 ) { this.bonAllowance_10_06 = bonAllowance_10_06; } 	// ܗ^x10_06
	public void setBonDeduction_01_06(Integer bonDeduction_01_06 ) { this.bonDeduction_01_06 = bonDeduction_01_06; } 	// ܗ^T01_06
	public void setBonDeduction_02_06(Integer bonDeduction_02_06 ) { this.bonDeduction_02_06 = bonDeduction_02_06; } 	// ܗ^T02_06
	public void setBonDeduction_03_06(Integer bonDeduction_03_06 ) { this.bonDeduction_03_06 = bonDeduction_03_06; } 	// ܗ^T03_06
	public void setBonDeduction_04_06(Integer bonDeduction_04_06 ) { this.bonDeduction_04_06 = bonDeduction_04_06; } 	// ܗ^T04_06
	public void setBonDeduction_05_06(Integer bonDeduction_05_06 ) { this.bonDeduction_05_06 = bonDeduction_05_06; } 	// ܗ^T05_06
	public void setBonDeduction_06_06(Integer bonDeduction_06_06 ) { this.bonDeduction_06_06 = bonDeduction_06_06; } 	// ܗ^T06_06
	public void setBonDeduction_07_06(Integer bonDeduction_07_06 ) { this.bonDeduction_07_06 = bonDeduction_07_06; } 	// ܗ^T07_06
	public void setBonDeduction_08_06(Integer bonDeduction_08_06 ) { this.bonDeduction_08_06 = bonDeduction_08_06; } 	// ܗ^T08_06
	public void setBonDeduction_09_06(Integer bonDeduction_09_06 ) { this.bonDeduction_09_06 = bonDeduction_09_06; } 	// ܗ^T09_06
	public void setBonDeduction_10_06(Integer bonDeduction_10_06 ) { this.bonDeduction_10_06 = bonDeduction_10_06; } 	// ܗ^T10_06
	public void setBonDeduction_11_06(Integer bonDeduction_11_06 ) { this.bonDeduction_11_06 = bonDeduction_11_06; } 	// ܗ^T11_06
	public void setBonDeduction_12_06(Integer bonDeduction_12_06 ) { this.bonDeduction_12_06 = bonDeduction_12_06; } 	// ܗ^T12_06
	public void setBonDeduction_13_06(Integer bonDeduction_13_06 ) { this.bonDeduction_13_06 = bonDeduction_13_06; } 	// ܗ^T13_06
	public void setBonDeduction_14_06(Integer bonDeduction_14_06 ) { this.bonDeduction_14_06 = bonDeduction_14_06; } 	// ܗ^T14_06
	public void setBonDeduction_15_06(Integer bonDeduction_15_06 ) { this.bonDeduction_15_06 = bonDeduction_15_06; } 	// ܗ^T15_06
	public void setBonDeduction_16_06(Integer bonDeduction_16_06 ) { this.bonDeduction_16_06 = bonDeduction_16_06; } 	// ܗ^T16_06
	public void setBonDeduction_17_06(Integer bonDeduction_17_06 ) { this.bonDeduction_17_06 = bonDeduction_17_06; } 	// ܗ^T17_06
	
	public void setPayAllowance_01_07(Integer payAllowance_01_07 ) { this.payAllowance_01_07 = payAllowance_01_07; } 	// ^x01_07
	public void setPayAllowance_02_07(Integer payAllowance_02_07 ) { this.payAllowance_02_07 = payAllowance_02_07; } 	// ^x02_07
	public void setPayAllowance_03_07(Integer payAllowance_03_07 ) { this.payAllowance_03_07 = payAllowance_03_07; } 	// ^x03_07
	public void setPayAllowance_04_07(Integer payAllowance_04_07 ) { this.payAllowance_04_07 = payAllowance_04_07; } 	// ^x04_07
	public void setPayAllowance_05_07(Integer payAllowance_05_07 ) { this.payAllowance_05_07 = payAllowance_05_07; } 	// ^x05_07
	public void setPayAllowance_06_07(Integer payAllowance_06_07 ) { this.payAllowance_06_07 = payAllowance_06_07; } 	// ^x06_07
	public void setPayAllowance_07_07(Integer payAllowance_07_07 ) { this.payAllowance_07_07 = payAllowance_07_07; } 	// ^x07_07
	public void setPayAllowance_08_07(Integer payAllowance_08_07 ) { this.payAllowance_08_07 = payAllowance_08_07; } 	// ^x08_07
	public void setPayAllowance_09_07(Integer payAllowance_09_07 ) { this.payAllowance_09_07 = payAllowance_09_07; } 	// ^x09_07
	public void setPayAllowance_10_07(Integer payAllowance_10_07 ) { this.payAllowance_10_07 = payAllowance_10_07; } 	// ^x10_07
	public void setPayAllowance_11_07(Integer payAllowance_11_07 ) { this.payAllowance_11_07 = payAllowance_11_07; } 	// ^x11_07
	public void setPayAllowance_12_07(Integer payAllowance_12_07 ) { this.payAllowance_12_07 = payAllowance_12_07; } 	// ^x12_07
	public void setPayAllowance_13_07(Integer payAllowance_13_07 ) { this.payAllowance_13_07 = payAllowance_13_07; } 	// ^x13_07
	public void setPayAllowance_14_07(Integer payAllowance_14_07 ) { this.payAllowance_14_07 = payAllowance_14_07; } 	// ^x14_07
	public void setPayAllowance_15_07(Integer payAllowance_15_07 ) { this.payAllowance_15_07 = payAllowance_15_07; } 	// ^x15_07
	public void setPayAllowance_16_07(Integer payAllowance_16_07 ) { this.payAllowance_16_07 = payAllowance_16_07; } 	// ^x16_07
	public void setPayAllowance_17_07(Integer payAllowance_17_07 ) { this.payAllowance_17_07 = payAllowance_17_07; } 	// ^x17_07
	public void setPayAllowance_18_07(Integer payAllowance_18_07 ) { this.payAllowance_18_07 = payAllowance_18_07; } 	// ^x18_07
	public void setPayAllowance_19_07(Integer payAllowance_19_07 ) { this.payAllowance_19_07 = payAllowance_19_07; } 	// ^x19_07
	public void setPayAllowance_20_07(Integer payAllowance_20_07 ) { this.payAllowance_20_07 = payAllowance_20_07; } 	// ^x20_07
	public void setPayAllowance_21_07(Integer payAllowance_21_07 ) { this.payAllowance_21_07 = payAllowance_21_07; } 	// ^x21_07
	public void setPayAllowance_22_07(Integer payAllowance_22_07 ) { this.payAllowance_22_07 = payAllowance_22_07; } 	// ^x22_07
	public void setPayAllowance_23_07(Integer payAllowance_23_07 ) { this.payAllowance_23_07 = payAllowance_23_07; } 	// ^x23_07
	public void setPayAllowance_24_07(Integer payAllowance_24_07 ) { this.payAllowance_24_07 = payAllowance_24_07; } 	// ^x24_07
	public void setPayAllowance_25_07(Integer payAllowance_25_07 ) { this.payAllowance_25_07 = payAllowance_25_07; } 	// ^x25_07
	public void setPayAllowance_26_07(Integer payAllowance_26_07 ) { this.payAllowance_26_07 = payAllowance_26_07; } 	// ^x26_07
	public void setPayAllowance_27_07(Integer payAllowance_27_07 ) { this.payAllowance_27_07 = payAllowance_27_07; } 	// ^x27_07
	public void setPayAllowance_28_07(Integer payAllowance_28_07 ) { this.payAllowance_28_07 = payAllowance_28_07; } 	// ^x28_07
	public void setPayAllowance_29_07(Integer payAllowance_29_07 ) { this.payAllowance_29_07 = payAllowance_29_07; } 	// ^x29_07
	public void setPayAllowance_30_07(Integer payAllowance_30_07 ) { this.payAllowance_30_07 = payAllowance_30_07; } 	// ^x30_07
	public void setPayDeduction_01_07(Integer payDeduction_01_07 ) { this.payDeduction_01_07 = payDeduction_01_07; } 	// ^T01_07
	public void setPayDeduction_02_07(Integer payDeduction_02_07 ) { this.payDeduction_02_07 = payDeduction_02_07; } 	// ^T02_07
	public void setPayDeduction_03_07(Integer payDeduction_03_07 ) { this.payDeduction_03_07 = payDeduction_03_07; } 	// ^T03_07
	public void setPayDeduction_04_07(Integer payDeduction_04_07 ) { this.payDeduction_04_07 = payDeduction_04_07; } 	// ^T04_07
	public void setPayDeduction_05_07(Integer payDeduction_05_07 ) { this.payDeduction_05_07 = payDeduction_05_07; } 	// ^T05_07
	public void setPayDeduction_06_07(Integer payDeduction_06_07 ) { this.payDeduction_06_07 = payDeduction_06_07; } 	// ^T06_07
	public void setPayDeduction_07_07(Integer payDeduction_07_07 ) { this.payDeduction_07_07 = payDeduction_07_07; } 	// ^T07_07
	public void setPayDeduction_08_07(Integer payDeduction_08_07 ) { this.payDeduction_08_07 = payDeduction_08_07; } 	// ^T08_07
	public void setPayDeduction_09_07(Integer payDeduction_09_07 ) { this.payDeduction_09_07 = payDeduction_09_07; } 	// ^T09_07
	public void setPayDeduction_10_07(Integer payDeduction_10_07 ) { this.payDeduction_10_07 = payDeduction_10_07; } 	// ^T10_07
	public void setPayDeduction_11_07(Integer payDeduction_11_07 ) { this.payDeduction_11_07 = payDeduction_11_07; } 	// ^T11_07
	public void setPayDeduction_12_07(Integer payDeduction_12_07 ) { this.payDeduction_12_07 = payDeduction_12_07; } 	// ^T12_07
	public void setPayDeduction_13_07(Integer payDeduction_13_07 ) { this.payDeduction_13_07 = payDeduction_13_07; } 	// ^T13_07
	public void setPayDeduction_14_07(Integer payDeduction_14_07 ) { this.payDeduction_14_07 = payDeduction_14_07; } 	// ^T14_07
	public void setPayDeduction_15_07(Integer payDeduction_15_07 ) { this.payDeduction_15_07 = payDeduction_15_07; } 	// ^T15_07
	public void setPayDeduction_16_07(Integer payDeduction_16_07 ) { this.payDeduction_16_07 = payDeduction_16_07; } 	// ^T16_07
	public void setPayDeduction_17_07(Integer payDeduction_17_07 ) { this.payDeduction_17_07 = payDeduction_17_07; } 	// ^T17_07
	public void setPayDeduction_18_07(Integer payDeduction_18_07 ) { this.payDeduction_18_07 = payDeduction_18_07; } 	// ^T18_07
	public void setPayDeduction_19_07(Integer payDeduction_19_07 ) { this.payDeduction_19_07 = payDeduction_19_07; } 	// ^T19_07
	public void setPayDeduction_20_07(Integer payDeduction_20_07 ) { this.payDeduction_20_07 = payDeduction_20_07; } 	// ^T20_07
	public void setPayDeduction_21_07(Integer payDeduction_21_07 ) { this.payDeduction_21_07 = payDeduction_21_07; } 	// ^T21_07
	public void setPayDeduction_22_07(Integer payDeduction_22_07 ) { this.payDeduction_22_07 = payDeduction_22_07; } 	// ^T22_07
	public void setPayDeduction_23_07(Integer payDeduction_23_07 ) { this.payDeduction_23_07 = payDeduction_23_07; } 	// ^T23_07
	public void setPayDeduction_24_07(Integer payDeduction_24_07 ) { this.payDeduction_24_07 = payDeduction_24_07; } 	// ^T24_07
	public void setPayDeduction_25_07(Integer payDeduction_25_07 ) { this.payDeduction_25_07 = payDeduction_25_07; } 	// ^T25_07
	public void setPayDeduction_26_07(Integer payDeduction_26_07 ) { this.payDeduction_26_07 = payDeduction_26_07; } 	// ^T26_07
	public void setPayDeduction_27_07(Integer payDeduction_27_07 ) { this.payDeduction_27_07 = payDeduction_27_07; } 	// ^T27_07
	public void setAttendance_01_07(Float attendance_01_07 ) { this.attendance_01_07 = attendance_01_07; } 	// ΑӍ01_07
	public void setAttendance_02_07(Float attendance_02_07 ) { this.attendance_02_07 = attendance_02_07; } 	// ΑӍ02_07
	public void setAttendance_03_07(Float attendance_03_07 ) { this.attendance_03_07 = attendance_03_07; } 	// ΑӍ03_07
	public void setAttendance_04_07(Float attendance_04_07 ) { this.attendance_04_07 = attendance_04_07; } 	// ΑӍ04_07
	public void setAttendance_05_07(Float attendance_05_07 ) { this.attendance_05_07 = attendance_05_07; } 	// ΑӍ05_07
	public void setAttendance_06_07(Integer attendance_06_07 ) { this.attendance_06_07 = attendance_06_07; } 	// ΑӍ06_07
	public void setAttendance_07_07(Integer  attendance_07_07 ) { this.attendance_07_07 = attendance_07_07; } 	// ΑӍ07_07
	public void setAttendance_08_07(Float attendance_08_07 ) { this.attendance_08_07 = attendance_08_07; } 	// ΑӍ08_07
	public void setAttendance_09_07(Float  attendance_09_07 ) { this.attendance_09_07 = attendance_09_07; } 	// ΑӍ09_07
	public void setAttendance_10_07(Float  attendance_10_07 ) { this.attendance_10_07 = attendance_10_07; } 	// ΑӍ10_07
	public void setAttendance_11_07(Float  attendance_11_07 ) { this.attendance_11_07 = attendance_11_07; } 	// ΑӍ11_07
	public void setAttendance_12_07(Float  attendance_12_07 ) { this.attendance_12_07 = attendance_12_07; } 	// ΑӍ12_07
	public void setAttendance_13_07(Integer  attendance_13_07 ) { this.attendance_13_07 = attendance_13_07; } 	// ΑӍ13_07
	public void setAttendance_14_07(Integer  attendance_14_07 ) { this.attendance_14_07 = attendance_14_07; } 	// ΑӍ14_07
	public void setPayAllowance_01_08(Integer payAllowance_01_08 ) { this.payAllowance_01_08 = payAllowance_01_08; } 	// ^x01_08
	public void setPayAllowance_02_08(Integer payAllowance_02_08 ) { this.payAllowance_02_08 = payAllowance_02_08; } 	// ^x02_08
	public void setPayAllowance_03_08(Integer payAllowance_03_08 ) { this.payAllowance_03_08 = payAllowance_03_08; } 	// ^x03_08
	public void setPayAllowance_04_08(Integer payAllowance_04_08 ) { this.payAllowance_04_08 = payAllowance_04_08; } 	// ^x04_08
	public void setPayAllowance_05_08(Integer payAllowance_05_08 ) { this.payAllowance_05_08 = payAllowance_05_08; } 	// ^x05_08
	public void setPayAllowance_06_08(Integer payAllowance_06_08 ) { this.payAllowance_06_08 = payAllowance_06_08; } 	// ^x06_08
	public void setPayAllowance_07_08(Integer payAllowance_07_08 ) { this.payAllowance_07_08 = payAllowance_07_08; } 	// ^x07_08
	public void setPayAllowance_08_08(Integer payAllowance_08_08 ) { this.payAllowance_08_08 = payAllowance_08_08; } 	// ^x08_08
	public void setPayAllowance_09_08(Integer payAllowance_09_08 ) { this.payAllowance_09_08 = payAllowance_09_08; } 	// ^x09_08
	public void setPayAllowance_10_08(Integer payAllowance_10_08 ) { this.payAllowance_10_08 = payAllowance_10_08; } 	// ^x10_08
	public void setPayAllowance_11_08(Integer payAllowance_11_08 ) { this.payAllowance_11_08 = payAllowance_11_08; } 	// ^x11_08
	public void setPayAllowance_12_08(Integer payAllowance_12_08 ) { this.payAllowance_12_08 = payAllowance_12_08; } 	// ^x12_08
	public void setPayAllowance_13_08(Integer payAllowance_13_08 ) { this.payAllowance_13_08 = payAllowance_13_08; } 	// ^x13_08
	public void setPayAllowance_14_08(Integer payAllowance_14_08 ) { this.payAllowance_14_08 = payAllowance_14_08; } 	// ^x14_08
	public void setPayAllowance_15_08(Integer payAllowance_15_08 ) { this.payAllowance_15_08 = payAllowance_15_08; } 	// ^x15_08
	public void setPayAllowance_16_08(Integer payAllowance_16_08 ) { this.payAllowance_16_08 = payAllowance_16_08; } 	// ^x16_08
	public void setPayAllowance_17_08(Integer payAllowance_17_08 ) { this.payAllowance_17_08 = payAllowance_17_08; } 	// ^x17_08
	public void setPayAllowance_18_08(Integer payAllowance_18_08 ) { this.payAllowance_18_08 = payAllowance_18_08; } 	// ^x18_08
	public void setPayAllowance_19_08(Integer payAllowance_19_08 ) { this.payAllowance_19_08 = payAllowance_19_08; } 	// ^x19_08
	public void setPayAllowance_20_08(Integer payAllowance_20_08 ) { this.payAllowance_20_08 = payAllowance_20_08; } 	// ^x20_08
	public void setPayAllowance_21_08(Integer payAllowance_21_08 ) { this.payAllowance_21_08 = payAllowance_21_08; } 	// ^x21_08
	public void setPayAllowance_22_08(Integer payAllowance_22_08 ) { this.payAllowance_22_08 = payAllowance_22_08; } 	// ^x22_08
	public void setPayAllowance_23_08(Integer payAllowance_23_08 ) { this.payAllowance_23_08 = payAllowance_23_08; } 	// ^x23_08
	public void setPayAllowance_24_08(Integer payAllowance_24_08 ) { this.payAllowance_24_08 = payAllowance_24_08; } 	// ^x24_08
	public void setPayAllowance_25_08(Integer payAllowance_25_08 ) { this.payAllowance_25_08 = payAllowance_25_08; } 	// ^x25_08
	public void setPayAllowance_26_08(Integer payAllowance_26_08 ) { this.payAllowance_26_08 = payAllowance_26_08; } 	// ^x26_08
	public void setPayAllowance_27_08(Integer payAllowance_27_08 ) { this.payAllowance_27_08 = payAllowance_27_08; } 	// ^x27_08
	public void setPayAllowance_28_08(Integer payAllowance_28_08 ) { this.payAllowance_28_08 = payAllowance_28_08; } 	// ^x28_08
	public void setPayAllowance_29_08(Integer payAllowance_29_08 ) { this.payAllowance_29_08 = payAllowance_29_08; } 	// ^x29_08
	public void setPayAllowance_30_08(Integer payAllowance_30_08 ) { this.payAllowance_30_08 = payAllowance_30_08; } 	// ^x30_08
	public void setPayDeduction_01_08(Integer payDeduction_01_08 ) { this.payDeduction_01_08 = payDeduction_01_08; } 	// ^T01_08
	public void setPayDeduction_02_08(Integer payDeduction_02_08 ) { this.payDeduction_02_08 = payDeduction_02_08; } 	// ^T02_08
	public void setPayDeduction_03_08(Integer payDeduction_03_08 ) { this.payDeduction_03_08 = payDeduction_03_08; } 	// ^T03_08
	public void setPayDeduction_04_08(Integer payDeduction_04_08 ) { this.payDeduction_04_08 = payDeduction_04_08; } 	// ^T04_08
	public void setPayDeduction_05_08(Integer payDeduction_05_08 ) { this.payDeduction_05_08 = payDeduction_05_08; } 	// ^T05_08
	public void setPayDeduction_06_08(Integer payDeduction_06_08 ) { this.payDeduction_06_08 = payDeduction_06_08; } 	// ^T06_08
	public void setPayDeduction_07_08(Integer payDeduction_07_08 ) { this.payDeduction_07_08 = payDeduction_07_08; } 	// ^T07_08
	public void setPayDeduction_08_08(Integer payDeduction_08_08 ) { this.payDeduction_08_08 = payDeduction_08_08; } 	// ^T08_08
	public void setPayDeduction_09_08(Integer payDeduction_09_08 ) { this.payDeduction_09_08 = payDeduction_09_08; } 	// ^T09_08
	public void setPayDeduction_10_08(Integer payDeduction_10_08 ) { this.payDeduction_10_08 = payDeduction_10_08; } 	// ^T10_08
	public void setPayDeduction_11_08(Integer payDeduction_11_08 ) { this.payDeduction_11_08 = payDeduction_11_08; } 	// ^T11_08
	public void setPayDeduction_12_08(Integer payDeduction_12_08 ) { this.payDeduction_12_08 = payDeduction_12_08; } 	// ^T12_08
	public void setPayDeduction_13_08(Integer payDeduction_13_08 ) { this.payDeduction_13_08 = payDeduction_13_08; } 	// ^T13_08
	public void setPayDeduction_14_08(Integer payDeduction_14_08 ) { this.payDeduction_14_08 = payDeduction_14_08; } 	// ^T14_08
	public void setPayDeduction_15_08(Integer payDeduction_15_08 ) { this.payDeduction_15_08 = payDeduction_15_08; } 	// ^T15_08
	public void setPayDeduction_16_08(Integer payDeduction_16_08 ) { this.payDeduction_16_08 = payDeduction_16_08; } 	// ^T16_08
	public void setPayDeduction_17_08(Integer payDeduction_17_08 ) { this.payDeduction_17_08 = payDeduction_17_08; } 	// ^T17_08
	public void setPayDeduction_18_08(Integer payDeduction_18_08 ) { this.payDeduction_18_08 = payDeduction_18_08; } 	// ^T18_08
	public void setPayDeduction_19_08(Integer payDeduction_19_08 ) { this.payDeduction_19_08 = payDeduction_19_08; } 	// ^T19_08
	public void setPayDeduction_20_08(Integer payDeduction_20_08 ) { this.payDeduction_20_08 = payDeduction_20_08; } 	// ^T20_08
	public void setPayDeduction_21_08(Integer payDeduction_21_08 ) { this.payDeduction_21_08 = payDeduction_21_08; } 	// ^T21_08
	public void setPayDeduction_22_08(Integer payDeduction_22_08 ) { this.payDeduction_22_08 = payDeduction_22_08; } 	// ^T22_08
	public void setPayDeduction_23_08(Integer payDeduction_23_08 ) { this.payDeduction_23_08 = payDeduction_23_08; } 	// ^T23_08
	public void setPayDeduction_24_08(Integer payDeduction_24_08 ) { this.payDeduction_24_08 = payDeduction_24_08; } 	// ^T24_08
	public void setPayDeduction_25_08(Integer payDeduction_25_08 ) { this.payDeduction_25_08 = payDeduction_25_08; } 	// ^T25_08
	public void setPayDeduction_26_08(Integer payDeduction_26_08 ) { this.payDeduction_26_08 = payDeduction_26_08; } 	// ^T26_08
	public void setPayDeduction_27_08(Integer payDeduction_27_08 ) { this.payDeduction_27_08 = payDeduction_27_08; } 	// ^T27_08
	public void setAttendance_01_08(Float attendance_01_08 ) { this.attendance_01_08 = attendance_01_08; } 	// ΑӍ01_08
	public void setAttendance_02_08(Float attendance_02_08 ) { this.attendance_02_08 = attendance_02_08; } 	// ΑӍ02_08
	public void setAttendance_03_08(Float attendance_03_08 ) { this.attendance_03_08 = attendance_03_08; } 	// ΑӍ03_08
	public void setAttendance_04_08(Float attendance_04_08 ) { this.attendance_04_08 = attendance_04_08; } 	// ΑӍ04_08
	public void setAttendance_05_08(Float attendance_05_08 ) { this.attendance_05_08 = attendance_05_08; } 	// ΑӍ05_08
	public void setAttendance_06_08(Integer attendance_06_08 ) { this.attendance_06_08 = attendance_06_08; } 	// ΑӍ06_08
	public void setAttendance_07_08(Integer  attendance_07_08 ) { this.attendance_07_08 = attendance_07_08; } 	// ΑӍ07_08
	public void setAttendance_08_08(Float attendance_08_08 ) { this.attendance_08_08 = attendance_08_08; } 	// ΑӍ08_08
	public void setAttendance_09_08(Float  attendance_09_08 ) { this.attendance_09_08 = attendance_09_08; } 	// ΑӍ09_08
	public void setAttendance_10_08(Float  attendance_10_08 ) { this.attendance_10_08 = attendance_10_08; } 	// ΑӍ10_08
	public void setAttendance_11_08(Float  attendance_11_08 ) { this.attendance_11_08 = attendance_11_08; } 	// ΑӍ11_08
	public void setAttendance_12_08(Float  attendance_12_08 ) { this.attendance_12_08 = attendance_12_08; } 	// ΑӍ12_08
	public void setAttendance_13_08(Integer  attendance_13_08 ) { this.attendance_13_08 = attendance_13_08; } 	// ΑӍ13_08
	public void setAttendance_14_08(Integer  attendance_14_08 ) { this.attendance_14_08 = attendance_14_08; } 	// ΑӍ14_08
	public void setPayAllowance_01_09(Integer payAllowance_01_09 ) { this.payAllowance_01_09 = payAllowance_01_09; } 	// ^x01_09
	public void setPayAllowance_02_09(Integer payAllowance_02_09 ) { this.payAllowance_02_09 = payAllowance_02_09; } 	// ^x02_09
	public void setPayAllowance_03_09(Integer payAllowance_03_09 ) { this.payAllowance_03_09 = payAllowance_03_09; } 	// ^x03_09
	public void setPayAllowance_04_09(Integer payAllowance_04_09 ) { this.payAllowance_04_09 = payAllowance_04_09; } 	// ^x04_09
	public void setPayAllowance_05_09(Integer payAllowance_05_09 ) { this.payAllowance_05_09 = payAllowance_05_09; } 	// ^x05_09
	public void setPayAllowance_06_09(Integer payAllowance_06_09 ) { this.payAllowance_06_09 = payAllowance_06_09; } 	// ^x06_09
	public void setPayAllowance_07_09(Integer payAllowance_07_09 ) { this.payAllowance_07_09 = payAllowance_07_09; } 	// ^x07_09
	public void setPayAllowance_08_09(Integer payAllowance_08_09 ) { this.payAllowance_08_09 = payAllowance_08_09; } 	// ^x08_09
	public void setPayAllowance_09_09(Integer payAllowance_09_09 ) { this.payAllowance_09_09 = payAllowance_09_09; } 	// ^x09_09
	public void setPayAllowance_10_09(Integer payAllowance_10_09 ) { this.payAllowance_10_09 = payAllowance_10_09; } 	// ^x10_09
	public void setPayAllowance_11_09(Integer payAllowance_11_09 ) { this.payAllowance_11_09 = payAllowance_11_09; } 	// ^x11_09
	public void setPayAllowance_12_09(Integer payAllowance_12_09 ) { this.payAllowance_12_09 = payAllowance_12_09; } 	// ^x12_09
	public void setPayAllowance_13_09(Integer payAllowance_13_09 ) { this.payAllowance_13_09 = payAllowance_13_09; } 	// ^x13_09
	public void setPayAllowance_14_09(Integer payAllowance_14_09 ) { this.payAllowance_14_09 = payAllowance_14_09; } 	// ^x14_09
	public void setPayAllowance_15_09(Integer payAllowance_15_09 ) { this.payAllowance_15_09 = payAllowance_15_09; } 	// ^x15_09
	public void setPayAllowance_16_09(Integer payAllowance_16_09 ) { this.payAllowance_16_09 = payAllowance_16_09; } 	// ^x16_09
	public void setPayAllowance_17_09(Integer payAllowance_17_09 ) { this.payAllowance_17_09 = payAllowance_17_09; } 	// ^x17_09
	public void setPayAllowance_18_09(Integer payAllowance_18_09 ) { this.payAllowance_18_09 = payAllowance_18_09; } 	// ^x18_09
	public void setPayAllowance_19_09(Integer payAllowance_19_09 ) { this.payAllowance_19_09 = payAllowance_19_09; } 	// ^x19_09
	public void setPayAllowance_20_09(Integer payAllowance_20_09 ) { this.payAllowance_20_09 = payAllowance_20_09; } 	// ^x20_09
	public void setPayAllowance_21_09(Integer payAllowance_21_09 ) { this.payAllowance_21_09 = payAllowance_21_09; } 	// ^x21_09
	public void setPayAllowance_22_09(Integer payAllowance_22_09 ) { this.payAllowance_22_09 = payAllowance_22_09; } 	// ^x22_09
	public void setPayAllowance_23_09(Integer payAllowance_23_09 ) { this.payAllowance_23_09 = payAllowance_23_09; } 	// ^x23_09
	public void setPayAllowance_24_09(Integer payAllowance_24_09 ) { this.payAllowance_24_09 = payAllowance_24_09; } 	// ^x24_09
	public void setPayAllowance_25_09(Integer payAllowance_25_09 ) { this.payAllowance_25_09 = payAllowance_25_09; } 	// ^x25_09
	public void setPayAllowance_26_09(Integer payAllowance_26_09 ) { this.payAllowance_26_09 = payAllowance_26_09; } 	// ^x26_09
	public void setPayAllowance_27_09(Integer payAllowance_27_09 ) { this.payAllowance_27_09 = payAllowance_27_09; } 	// ^x27_09
	public void setPayAllowance_28_09(Integer payAllowance_28_09 ) { this.payAllowance_28_09 = payAllowance_28_09; } 	// ^x28_09
	public void setPayAllowance_29_09(Integer payAllowance_29_09 ) { this.payAllowance_29_09 = payAllowance_29_09; } 	// ^x29_09
	public void setPayAllowance_30_09(Integer payAllowance_30_09 ) { this.payAllowance_30_09 = payAllowance_30_09; } 	// ^x30_09
	public void setPayDeduction_01_09(Integer payDeduction_01_09 ) { this.payDeduction_01_09 = payDeduction_01_09; } 	// ^T01_09
	public void setPayDeduction_02_09(Integer payDeduction_02_09 ) { this.payDeduction_02_09 = payDeduction_02_09; } 	// ^T02_09
	public void setPayDeduction_03_09(Integer payDeduction_03_09 ) { this.payDeduction_03_09 = payDeduction_03_09; } 	// ^T03_09
	public void setPayDeduction_04_09(Integer payDeduction_04_09 ) { this.payDeduction_04_09 = payDeduction_04_09; } 	// ^T04_09
	public void setPayDeduction_05_09(Integer payDeduction_05_09 ) { this.payDeduction_05_09 = payDeduction_05_09; } 	// ^T05_09
	public void setPayDeduction_06_09(Integer payDeduction_06_09 ) { this.payDeduction_06_09 = payDeduction_06_09; } 	// ^T06_09
	public void setPayDeduction_07_09(Integer payDeduction_07_09 ) { this.payDeduction_07_09 = payDeduction_07_09; } 	// ^T07_09
	public void setPayDeduction_08_09(Integer payDeduction_08_09 ) { this.payDeduction_08_09 = payDeduction_08_09; } 	// ^T08_09
	public void setPayDeduction_09_09(Integer payDeduction_09_09 ) { this.payDeduction_09_09 = payDeduction_09_09; } 	// ^T09_09
	public void setPayDeduction_10_09(Integer payDeduction_10_09 ) { this.payDeduction_10_09 = payDeduction_10_09; } 	// ^T10_09
	public void setPayDeduction_11_09(Integer payDeduction_11_09 ) { this.payDeduction_11_09 = payDeduction_11_09; } 	// ^T11_09
	public void setPayDeduction_12_09(Integer payDeduction_12_09 ) { this.payDeduction_12_09 = payDeduction_12_09; } 	// ^T12_09
	public void setPayDeduction_13_09(Integer payDeduction_13_09 ) { this.payDeduction_13_09 = payDeduction_13_09; } 	// ^T13_09
	public void setPayDeduction_14_09(Integer payDeduction_14_09 ) { this.payDeduction_14_09 = payDeduction_14_09; } 	// ^T14_09
	public void setPayDeduction_15_09(Integer payDeduction_15_09 ) { this.payDeduction_15_09 = payDeduction_15_09; } 	// ^T15_09
	public void setPayDeduction_16_09(Integer payDeduction_16_09 ) { this.payDeduction_16_09 = payDeduction_16_09; } 	// ^T16_09
	public void setPayDeduction_17_09(Integer payDeduction_17_09 ) { this.payDeduction_17_09 = payDeduction_17_09; } 	// ^T17_09
	public void setPayDeduction_18_09(Integer payDeduction_18_09 ) { this.payDeduction_18_09 = payDeduction_18_09; } 	// ^T18_09
	public void setPayDeduction_19_09(Integer payDeduction_19_09 ) { this.payDeduction_19_09 = payDeduction_19_09; } 	// ^T19_09
	public void setPayDeduction_20_09(Integer payDeduction_20_09 ) { this.payDeduction_20_09 = payDeduction_20_09; } 	// ^T20_09
	public void setPayDeduction_21_09(Integer payDeduction_21_09 ) { this.payDeduction_21_09 = payDeduction_21_09; } 	// ^T21_09
	public void setPayDeduction_22_09(Integer payDeduction_22_09 ) { this.payDeduction_22_09 = payDeduction_22_09; } 	// ^T22_09
	public void setPayDeduction_23_09(Integer payDeduction_23_09 ) { this.payDeduction_23_09 = payDeduction_23_09; } 	// ^T23_09
	public void setPayDeduction_24_09(Integer payDeduction_24_09 ) { this.payDeduction_24_09 = payDeduction_24_09; } 	// ^T24_09
	public void setPayDeduction_25_09(Integer payDeduction_25_09 ) { this.payDeduction_25_09 = payDeduction_25_09; } 	// ^T25_09
	public void setPayDeduction_26_09(Integer payDeduction_26_09 ) { this.payDeduction_26_09 = payDeduction_26_09; } 	// ^T26_09
	public void setPayDeduction_27_09(Integer payDeduction_27_09 ) { this.payDeduction_27_09 = payDeduction_27_09; } 	// ^T27_09
	public void setAttendance_01_09(Float attendance_01_09 ) { this.attendance_01_09 = attendance_01_09; } 	// ΑӍ01_09
	public void setAttendance_02_09(Float attendance_02_09 ) { this.attendance_02_09 = attendance_02_09; } 	// ΑӍ02_09
	public void setAttendance_03_09(Float attendance_03_09 ) { this.attendance_03_09 = attendance_03_09; } 	// ΑӍ03_09
	public void setAttendance_04_09(Float attendance_04_09 ) { this.attendance_04_09 = attendance_04_09; } 	// ΑӍ04_09
	public void setAttendance_05_09(Float attendance_05_09 ) { this.attendance_05_09 = attendance_05_09; } 	// ΑӍ05_09
	public void setAttendance_06_09(Integer attendance_06_09 ) { this.attendance_06_09 = attendance_06_09; } 	// ΑӍ06_09
	public void setAttendance_07_09(Integer  attendance_07_09 ) { this.attendance_07_09 = attendance_07_09; } 	// ΑӍ07_09
	public void setAttendance_08_09(Float attendance_08_09 ) { this.attendance_08_09 = attendance_08_09; } 	// ΑӍ08_09
	public void setAttendance_09_09(Float  attendance_09_09 ) { this.attendance_09_09 = attendance_09_09; } 	// ΑӍ09_09
	public void setAttendance_10_09(Float  attendance_10_09 ) { this.attendance_10_09 = attendance_10_09; } 	// ΑӍ10_09
	public void setAttendance_11_09(Float  attendance_11_09 ) { this.attendance_11_09 = attendance_11_09; } 	// ΑӍ11_09
	public void setAttendance_12_09(Float attendance_12_09 ) { this.attendance_12_09 = attendance_12_09; } 	// ΑӍ12_09
	public void setAttendance_13_09(Integer  attendance_13_09 ) { this.attendance_13_09 = attendance_13_09; } 	// ΑӍ13_09
	public void setAttendance_14_09(Integer  attendance_14_09 ) { this.attendance_14_09 = attendance_14_09; } 	// ΑӍ14_09
	public void setPayAllowance_01_10(Integer payAllowance_01_10 ) { this.payAllowance_01_10 = payAllowance_01_10; } 	// ^x01_10
	public void setPayAllowance_02_10(Integer payAllowance_02_10 ) { this.payAllowance_02_10 = payAllowance_02_10; } 	// ^x02_10
	public void setPayAllowance_03_10(Integer payAllowance_03_10 ) { this.payAllowance_03_10 = payAllowance_03_10; } 	// ^x03_10
	public void setPayAllowance_04_10(Integer payAllowance_04_10 ) { this.payAllowance_04_10 = payAllowance_04_10; } 	// ^x04_10
	public void setPayAllowance_05_10(Integer payAllowance_05_10 ) { this.payAllowance_05_10 = payAllowance_05_10; } 	// ^x05_10
	public void setPayAllowance_06_10(Integer payAllowance_06_10 ) { this.payAllowance_06_10 = payAllowance_06_10; } 	// ^x06_10
	public void setPayAllowance_07_10(Integer payAllowance_07_10 ) { this.payAllowance_07_10 = payAllowance_07_10; } 	// ^x07_10
	public void setPayAllowance_08_10(Integer payAllowance_08_10 ) { this.payAllowance_08_10 = payAllowance_08_10; } 	// ^x08_10
	public void setPayAllowance_09_10(Integer payAllowance_09_10 ) { this.payAllowance_09_10 = payAllowance_09_10; } 	// ^x09_10
	public void setPayAllowance_10_10(Integer payAllowance_10_10 ) { this.payAllowance_10_10 = payAllowance_10_10; } 	// ^x10_10
	public void setPayAllowance_11_10(Integer payAllowance_11_10 ) { this.payAllowance_11_10 = payAllowance_11_10; } 	// ^x11_10
	public void setPayAllowance_12_10(Integer payAllowance_12_10 ) { this.payAllowance_12_10 = payAllowance_12_10; } 	// ^x12_10
	public void setPayAllowance_13_10(Integer payAllowance_13_10 ) { this.payAllowance_13_10 = payAllowance_13_10; } 	// ^x13_10
	public void setPayAllowance_14_10(Integer payAllowance_14_10 ) { this.payAllowance_14_10 = payAllowance_14_10; } 	// ^x14_10
	public void setPayAllowance_15_10(Integer payAllowance_15_10 ) { this.payAllowance_15_10 = payAllowance_15_10; } 	// ^x15_10
	public void setPayAllowance_16_10(Integer payAllowance_16_10 ) { this.payAllowance_16_10 = payAllowance_16_10; } 	// ^x16_10
	public void setPayAllowance_17_10(Integer payAllowance_17_10 ) { this.payAllowance_17_10 = payAllowance_17_10; } 	// ^x17_10
	public void setPayAllowance_18_10(Integer payAllowance_18_10 ) { this.payAllowance_18_10 = payAllowance_18_10; } 	// ^x18_10
	public void setPayAllowance_19_10(Integer payAllowance_19_10 ) { this.payAllowance_19_10 = payAllowance_19_10; } 	// ^x19_10
	public void setPayAllowance_20_10(Integer payAllowance_20_10 ) { this.payAllowance_20_10 = payAllowance_20_10; } 	// ^x20_10
	public void setPayAllowance_21_10(Integer payAllowance_21_10 ) { this.payAllowance_21_10 = payAllowance_21_10; } 	// ^x21_10
	public void setPayAllowance_22_10(Integer payAllowance_22_10 ) { this.payAllowance_22_10 = payAllowance_22_10; } 	// ^x22_10
	public void setPayAllowance_23_10(Integer payAllowance_23_10 ) { this.payAllowance_23_10 = payAllowance_23_10; } 	// ^x23_10
	public void setPayAllowance_24_10(Integer payAllowance_24_10 ) { this.payAllowance_24_10 = payAllowance_24_10; } 	// ^x24_10
	public void setPayAllowance_25_10(Integer payAllowance_25_10 ) { this.payAllowance_25_10 = payAllowance_25_10; } 	// ^x25_10
	public void setPayAllowance_26_10(Integer payAllowance_26_10 ) { this.payAllowance_26_10 = payAllowance_26_10; } 	// ^x26_10
	public void setPayAllowance_27_10(Integer payAllowance_27_10 ) { this.payAllowance_27_10 = payAllowance_27_10; } 	// ^x27_10
	public void setPayAllowance_28_10(Integer payAllowance_28_10 ) { this.payAllowance_28_10 = payAllowance_28_10; } 	// ^x28_10
	public void setPayAllowance_29_10(Integer payAllowance_29_10 ) { this.payAllowance_29_10 = payAllowance_29_10; } 	// ^x29_10
	public void setPayAllowance_30_10(Integer payAllowance_30_10 ) { this.payAllowance_30_10 = payAllowance_30_10; } 	// ^x30_10
	public void setPayDeduction_01_10(Integer payDeduction_01_10 ) { this.payDeduction_01_10 = payDeduction_01_10; } 	// ^T01_10
	public void setPayDeduction_02_10(Integer payDeduction_02_10 ) { this.payDeduction_02_10 = payDeduction_02_10; } 	// ^T02_10
	public void setPayDeduction_03_10(Integer payDeduction_03_10 ) { this.payDeduction_03_10 = payDeduction_03_10; } 	// ^T03_10
	public void setPayDeduction_04_10(Integer payDeduction_04_10 ) { this.payDeduction_04_10 = payDeduction_04_10; } 	// ^T04_10
	public void setPayDeduction_05_10(Integer payDeduction_05_10 ) { this.payDeduction_05_10 = payDeduction_05_10; } 	// ^T05_10
	public void setPayDeduction_06_10(Integer payDeduction_06_10 ) { this.payDeduction_06_10 = payDeduction_06_10; } 	// ^T06_10
	public void setPayDeduction_07_10(Integer payDeduction_07_10 ) { this.payDeduction_07_10 = payDeduction_07_10; } 	// ^T07_10
	public void setPayDeduction_08_10(Integer payDeduction_08_10 ) { this.payDeduction_08_10 = payDeduction_08_10; } 	// ^T08_10
	public void setPayDeduction_09_10(Integer payDeduction_09_10 ) { this.payDeduction_09_10 = payDeduction_09_10; } 	// ^T09_10
	public void setPayDeduction_10_10(Integer payDeduction_10_10 ) { this.payDeduction_10_10 = payDeduction_10_10; } 	// ^T10_10
	public void setPayDeduction_11_10(Integer payDeduction_11_10 ) { this.payDeduction_11_10 = payDeduction_11_10; } 	// ^T11_10
	public void setPayDeduction_12_10(Integer payDeduction_12_10 ) { this.payDeduction_12_10 = payDeduction_12_10; } 	// ^T12_10
	public void setPayDeduction_13_10(Integer payDeduction_13_10 ) { this.payDeduction_13_10 = payDeduction_13_10; } 	// ^T13_10
	public void setPayDeduction_14_10(Integer payDeduction_14_10 ) { this.payDeduction_14_10 = payDeduction_14_10; } 	// ^T14_10
	public void setPayDeduction_15_10(Integer payDeduction_15_10 ) { this.payDeduction_15_10 = payDeduction_15_10; } 	// ^T15_10
	public void setPayDeduction_16_10(Integer payDeduction_16_10 ) { this.payDeduction_16_10 = payDeduction_16_10; } 	// ^T16_10
	public void setPayDeduction_17_10(Integer payDeduction_17_10 ) { this.payDeduction_17_10 = payDeduction_17_10; } 	// ^T17_10
	public void setPayDeduction_18_10(Integer payDeduction_18_10 ) { this.payDeduction_18_10 = payDeduction_18_10; } 	// ^T18_10
	public void setPayDeduction_19_10(Integer payDeduction_19_10 ) { this.payDeduction_19_10 = payDeduction_19_10; } 	// ^T19_10
	public void setPayDeduction_20_10(Integer payDeduction_20_10 ) { this.payDeduction_20_10 = payDeduction_20_10; } 	// ^T20_10
	public void setPayDeduction_21_10(Integer payDeduction_21_10 ) { this.payDeduction_21_10 = payDeduction_21_10; } 	// ^T21_10
	public void setPayDeduction_22_10(Integer payDeduction_22_10 ) { this.payDeduction_22_10 = payDeduction_22_10; } 	// ^T22_10
	public void setPayDeduction_23_10(Integer payDeduction_23_10 ) { this.payDeduction_23_10 = payDeduction_23_10; } 	// ^T23_10
	public void setPayDeduction_24_10(Integer payDeduction_24_10 ) { this.payDeduction_24_10 = payDeduction_24_10; } 	// ^T24_10
	public void setPayDeduction_25_10(Integer payDeduction_25_10 ) { this.payDeduction_25_10 = payDeduction_25_10; } 	// ^T25_10
	public void setPayDeduction_26_10(Integer payDeduction_26_10 ) { this.payDeduction_26_10 = payDeduction_26_10; } 	// ^T26_10
	public void setPayDeduction_27_10(Integer payDeduction_27_10 ) { this.payDeduction_27_10 = payDeduction_27_10; } 	// ^T27_10
	public void setAttendance_01_10(Float attendance_01_10 ) { this.attendance_01_10 = attendance_01_10; } 	// ΑӍ01_10
	public void setAttendance_02_10(Float attendance_02_10 ) { this.attendance_02_10 = attendance_02_10; } 	// ΑӍ02_10
	public void setAttendance_03_10(Float attendance_03_10 ) { this.attendance_03_10 = attendance_03_10; } 	// ΑӍ03_10
	public void setAttendance_04_10(Float attendance_04_10 ) { this.attendance_04_10 = attendance_04_10; } 	// ΑӍ04_10
	public void setAttendance_05_10(Float attendance_05_10 ) { this.attendance_05_10 = attendance_05_10; } 	// ΑӍ05_10
	public void setAttendance_06_10(Integer attendance_06_10 ) { this.attendance_06_10 = attendance_06_10; } 	// ΑӍ06_10
	public void setAttendance_07_10(Integer  attendance_07_10 ) { this.attendance_07_10 = attendance_07_10; } 	// ΑӍ07_10
	public void setAttendance_08_10(Float attendance_08_10 ) { this.attendance_08_10 = attendance_08_10; } 	// ΑӍ08_10
	public void setAttendance_09_10(Float   attendance_09_10 ) { this.attendance_09_10 = attendance_09_10; } 	// ΑӍ09_10
	public void setAttendance_10_10(Float   attendance_10_10 ) { this.attendance_10_10 = attendance_10_10; } 	// ΑӍ10_10
	public void setAttendance_11_10(Float   attendance_11_10 ) { this.attendance_11_10 = attendance_11_10; } 	// ΑӍ11_10
	public void setAttendance_12_10(Float   attendance_12_10 ) { this.attendance_12_10 = attendance_12_10; } 	// ΑӍ12_10
	public void setAttendance_13_10(Integer  attendance_13_10 ) { this.attendance_13_10 = attendance_13_10; } 	// ΑӍ13_10
	public void setPayAllowance_01_11(Integer payAllowance_01_11 ) { this.payAllowance_01_11 = payAllowance_01_11; } 	// ^x01_11
	public void setPayAllowance_02_11(Integer payAllowance_02_11 ) { this.payAllowance_02_11 = payAllowance_02_11; } 	// ^x02_11
	public void setPayAllowance_03_11(Integer payAllowance_03_11 ) { this.payAllowance_03_11 = payAllowance_03_11; } 	// ^x03_11
	public void setPayAllowance_04_11(Integer payAllowance_04_11 ) { this.payAllowance_04_11 = payAllowance_04_11; } 	// ^x04_11
	public void setPayAllowance_05_11(Integer payAllowance_05_11 ) { this.payAllowance_05_11 = payAllowance_05_11; } 	// ^x05_11
	public void setPayAllowance_06_11(Integer payAllowance_06_11 ) { this.payAllowance_06_11 = payAllowance_06_11; } 	// ^x06_11
	public void setPayAllowance_07_11(Integer payAllowance_07_11 ) { this.payAllowance_07_11 = payAllowance_07_11; } 	// ^x07_11
	public void setPayAllowance_08_11(Integer payAllowance_08_11 ) { this.payAllowance_08_11 = payAllowance_08_11; } 	// ^x08_11
	public void setPayAllowance_09_11(Integer payAllowance_09_11 ) { this.payAllowance_09_11 = payAllowance_09_11; } 	// ^x09_11
	public void setPayAllowance_10_11(Integer payAllowance_10_11 ) { this.payAllowance_10_11 = payAllowance_10_11; } 	// ^x10_11
	public void setPayAllowance_11_11(Integer payAllowance_11_11 ) { this.payAllowance_11_11 = payAllowance_11_11; } 	// ^x11_11
	public void setPayAllowance_12_11(Integer payAllowance_12_11 ) { this.payAllowance_12_11 = payAllowance_12_11; } 	// ^x12_11
	public void setPayAllowance_13_11(Integer payAllowance_13_11 ) { this.payAllowance_13_11 = payAllowance_13_11; } 	// ^x13_11
	public void setPayAllowance_14_11(Integer payAllowance_14_11 ) { this.payAllowance_14_11 = payAllowance_14_11; } 	// ^x14_11
	public void setPayAllowance_15_11(Integer payAllowance_15_11 ) { this.payAllowance_15_11 = payAllowance_15_11; } 	// ^x15_11
	public void setPayAllowance_16_11(Integer payAllowance_16_11 ) { this.payAllowance_16_11 = payAllowance_16_11; } 	// ^x16_11
	public void setPayAllowance_17_11(Integer payAllowance_17_11 ) { this.payAllowance_17_11 = payAllowance_17_11; } 	// ^x17_11
	public void setPayAllowance_18_11(Integer payAllowance_18_11 ) { this.payAllowance_18_11 = payAllowance_18_11; } 	// ^x18_11
	public void setPayAllowance_19_11(Integer payAllowance_19_11 ) { this.payAllowance_19_11 = payAllowance_19_11; } 	// ^x19_11
	public void setPayAllowance_20_11(Integer payAllowance_20_11 ) { this.payAllowance_20_11 = payAllowance_20_11; } 	// ^x20_11
	public void setPayAllowance_21_11(Integer payAllowance_21_11 ) { this.payAllowance_21_11 = payAllowance_21_11; } 	// ^x21_11
	public void setPayAllowance_22_11(Integer payAllowance_22_11 ) { this.payAllowance_22_11 = payAllowance_22_11; } 	// ^x22_11
	public void setPayAllowance_23_11(Integer payAllowance_23_11 ) { this.payAllowance_23_11 = payAllowance_23_11; } 	// ^x23_11
	public void setPayAllowance_24_11(Integer payAllowance_24_11 ) { this.payAllowance_24_11 = payAllowance_24_11; } 	// ^x24_11
	public void setPayAllowance_25_11(Integer payAllowance_25_11 ) { this.payAllowance_25_11 = payAllowance_25_11; } 	// ^x25_11
	public void setPayAllowance_26_11(Integer payAllowance_26_11 ) { this.payAllowance_26_11 = payAllowance_26_11; } 	// ^x26_11
	public void setPayAllowance_27_11(Integer payAllowance_27_11 ) { this.payAllowance_27_11 = payAllowance_27_11; } 	// ^x27_11
	public void setPayAllowance_28_11(Integer payAllowance_28_11 ) { this.payAllowance_28_11 = payAllowance_28_11; } 	// ^x28_11
	public void setPayAllowance_29_11(Integer payAllowance_29_11 ) { this.payAllowance_29_11 = payAllowance_29_11; } 	// ^x29_11
	public void setPayAllowance_30_11(Integer payAllowance_30_11 ) { this.payAllowance_30_11 = payAllowance_30_11; } 	// ^x30_11
	public void setPayDeduction_01_11(Integer payDeduction_01_11 ) { this.payDeduction_01_11 = payDeduction_01_11; } 	// ^T01_11
	public void setPayDeduction_02_11(Integer payDeduction_02_11 ) { this.payDeduction_02_11 = payDeduction_02_11; } 	// ^T02_11
	public void setPayDeduction_03_11(Integer payDeduction_03_11 ) { this.payDeduction_03_11 = payDeduction_03_11; } 	// ^T03_11
	public void setPayDeduction_04_11(Integer payDeduction_04_11 ) { this.payDeduction_04_11 = payDeduction_04_11; } 	// ^T04_11
	public void setPayDeduction_05_11(Integer payDeduction_05_11 ) { this.payDeduction_05_11 = payDeduction_05_11; } 	// ^T05_11
	public void setPayDeduction_06_11(Integer payDeduction_06_11 ) { this.payDeduction_06_11 = payDeduction_06_11; } 	// ^T06_11
	public void setPayDeduction_07_11(Integer payDeduction_07_11 ) { this.payDeduction_07_11 = payDeduction_07_11; } 	// ^T07_11
	public void setPayDeduction_08_11(Integer payDeduction_08_11 ) { this.payDeduction_08_11 = payDeduction_08_11; } 	// ^T08_11
	public void setPayDeduction_09_11(Integer payDeduction_09_11 ) { this.payDeduction_09_11 = payDeduction_09_11; } 	// ^T09_11
	public void setPayDeduction_10_11(Integer payDeduction_10_11 ) { this.payDeduction_10_11 = payDeduction_10_11; } 	// ^T10_11
	public void setPayDeduction_11_11(Integer payDeduction_11_11 ) { this.payDeduction_11_11 = payDeduction_11_11; } 	// ^T11_11
	public void setPayDeduction_12_11(Integer payDeduction_12_11 ) { this.payDeduction_12_11 = payDeduction_12_11; } 	// ^T12_11
	public void setPayDeduction_13_11(Integer payDeduction_13_11 ) { this.payDeduction_13_11 = payDeduction_13_11; } 	// ^T13_11
	public void setPayDeduction_14_11(Integer payDeduction_14_11 ) { this.payDeduction_14_11 = payDeduction_14_11; } 	// ^T14_11
	public void setPayDeduction_15_11(Integer payDeduction_15_11 ) { this.payDeduction_15_11 = payDeduction_15_11; } 	// ^T15_11
	public void setPayDeduction_16_11(Integer payDeduction_16_11 ) { this.payDeduction_16_11 = payDeduction_16_11; } 	// ^T16_11
	public void setPayDeduction_17_11(Integer payDeduction_17_11 ) { this.payDeduction_17_11 = payDeduction_17_11; } 	// ^T17_11
	public void setPayDeduction_18_11(Integer payDeduction_18_11 ) { this.payDeduction_18_11 = payDeduction_18_11; } 	// ^T18_11
	public void setPayDeduction_19_11(Integer payDeduction_19_11 ) { this.payDeduction_19_11 = payDeduction_19_11; } 	// ^T19_11
	public void setPayDeduction_20_11(Integer payDeduction_20_11 ) { this.payDeduction_20_11 = payDeduction_20_11; } 	// ^T20_11
	public void setPayDeduction_21_11(Integer payDeduction_21_11 ) { this.payDeduction_21_11 = payDeduction_21_11; } 	// ^T21_11
	public void setPayDeduction_22_11(Integer payDeduction_22_11 ) { this.payDeduction_22_11 = payDeduction_22_11; } 	// ^T22_11
	public void setPayDeduction_23_11(Integer payDeduction_23_11 ) { this.payDeduction_23_11 = payDeduction_23_11; } 	// ^T23_11
	public void setPayDeduction_24_11(Integer payDeduction_24_11 ) { this.payDeduction_24_11 = payDeduction_24_11; } 	// ^T24_11
	public void setPayDeduction_25_11(Integer payDeduction_25_11 ) { this.payDeduction_25_11 = payDeduction_25_11; } 	// ^T25_11
	public void setPayDeduction_26_11(Integer payDeduction_26_11 ) { this.payDeduction_26_11 = payDeduction_26_11; } 	// ^T26_11
	public void setPayDeduction_27_11(Integer payDeduction_27_11 ) { this.payDeduction_27_11 = payDeduction_27_11; } 	// ^T27_11
	public void setAttendance_01_11(Float attendance_01_11 ) { this.attendance_01_11 = attendance_01_11; } 	// ΑӍ01_11
	public void setAttendance_02_11(Float attendance_02_11 ) { this.attendance_02_11 = attendance_02_11; } 	// ΑӍ02_11
	public void setAttendance_03_11(Float attendance_03_11 ) { this.attendance_03_11 = attendance_03_11; } 	// ΑӍ03_11
	public void setAttendance_04_11(Float attendance_04_11 ) { this.attendance_04_11 = attendance_04_11; } 	// ΑӍ04_11
	public void setAttendance_05_11(Float attendance_05_11 ) { this.attendance_05_11 = attendance_05_11; } 	// ΑӍ05_11
	public void setAttendance_06_11(Integer attendance_06_11 ) { this.attendance_06_11 = attendance_06_11; } 	// ΑӍ06_11
	public void setAttendance_07_11(Integer  attendance_07_11 ) { this.attendance_07_11 = attendance_07_11; } 	// ΑӍ07_11
	public void setAttendance_08_11(Float attendance_08_11 ) { this.attendance_08_11 = attendance_08_11; } 	// ΑӍ08_11
	public void setAttendance_09_11(Float   attendance_09_11 ) { this.attendance_09_11 = attendance_09_11; } 	// ΑӍ09_11
	public void setAttendance_10_11(Float   attendance_10_11 ) { this.attendance_10_11 = attendance_10_11; } 	// ΑӍ10_11
	public void setAttendance_11_11(Float   attendance_11_11 ) { this.attendance_11_11 = attendance_11_11; } 	// ΑӍ11_11
	public void setAttendance_12_11(Float   attendance_12_11 ) { this.attendance_12_11 = attendance_12_11; } 	// ΑӍ12_11
	public void setAttendance_13_11(Integer  attendance_13_11 ) { this.attendance_13_11 = attendance_13_11; } 	// ΑӍ13_11
	public void setAttendance_14_11(Integer  attendance_14_11 ) { this.attendance_14_11 = attendance_14_11; } 	// ΑӍ14_11
	public void setBonAllowance_01_11(Integer bonAllowance_01_11 ) { this.bonAllowance_01_11 = bonAllowance_01_11; } 	// ܗ^x01_11
	public void setBonAllowance_02_11(Integer bonAllowance_02_11 ) { this.bonAllowance_02_11 = bonAllowance_02_11; } 	// ܗ^x02_11
	public void setBonAllowance_03_11(Integer bonAllowance_03_11 ) { this.bonAllowance_03_11 = bonAllowance_03_11; } 	// ܗ^x03_11
	public void setBonAllowance_04_11(Integer bonAllowance_04_11 ) { this.bonAllowance_04_11 = bonAllowance_04_11; } 	// ܗ^x04_11
	public void setBonAllowance_05_11(Integer bonAllowance_05_11 ) { this.bonAllowance_05_11 = bonAllowance_05_11; } 	// ܗ^x05_11
	public void setBonAllowance_06_11(Integer bonAllowance_06_11 ) { this.bonAllowance_06_11 = bonAllowance_06_11; } 	// ܗ^x06_11
	public void setBonAllowance_07_11(Integer bonAllowance_07_11 ) { this.bonAllowance_07_11 = bonAllowance_07_11; } 	// ܗ^x07_11
	public void setBonAllowance_08_11(Integer bonAllowance_08_11 ) { this.bonAllowance_08_11 = bonAllowance_08_11; } 	// ܗ^x08_11
	public void setBonAllowance_09_11(Integer bonAllowance_09_11 ) { this.bonAllowance_09_11 = bonAllowance_09_11; } 	// ܗ^x09_11
	public void setBonAllowance_10_11(Integer bonAllowance_10_11 ) { this.bonAllowance_10_11 = bonAllowance_10_11; } 	// ܗ^x10_11
	public void setBonDeduction_01_11(Integer bonDeduction_01_11 ) { this.bonDeduction_01_11 = bonDeduction_01_11; } 	// ܗ^T01_11
	public void setBonDeduction_02_11(Integer bonDeduction_02_11 ) { this.bonDeduction_02_11 = bonDeduction_02_11; } 	// ܗ^T02_11
	public void setBonDeduction_03_11(Integer bonDeduction_03_11 ) { this.bonDeduction_03_11 = bonDeduction_03_11; } 	// ܗ^T03_11
	public void setBonDeduction_04_11(Integer bonDeduction_04_11 ) { this.bonDeduction_04_11 = bonDeduction_04_11; } 	// ܗ^T04_11
	public void setBonDeduction_05_11(Integer bonDeduction_05_11 ) { this.bonDeduction_05_11 = bonDeduction_05_11; } 	// ܗ^T05_11
	public void setBonDeduction_06_11(Integer bonDeduction_06_11 ) { this.bonDeduction_06_11 = bonDeduction_06_11; } 	// ܗ^T06_11
	public void setBonDeduction_07_11(Integer bonDeduction_07_11 ) { this.bonDeduction_07_11 = bonDeduction_07_11; } 	// ܗ^T07_11
	public void setBonDeduction_08_11(Integer bonDeduction_08_11 ) { this.bonDeduction_08_11 = bonDeduction_08_11; } 	// ܗ^T08_11
	public void setBonDeduction_09_11(Integer bonDeduction_09_11 ) { this.bonDeduction_09_11 = bonDeduction_09_11; } 	// ܗ^T09_11
	public void setBonDeduction_10_11(Integer bonDeduction_10_11 ) { this.bonDeduction_10_11 = bonDeduction_10_11; } 	// ܗ^T10_11
	public void setBonDeduction_11_11(Integer bonDeduction_11_11 ) { this.bonDeduction_11_11 = bonDeduction_11_11; } 	// ܗ^T11_11
	public void setBonDeduction_12_11(Integer bonDeduction_12_11 ) { this.bonDeduction_12_11 = bonDeduction_12_11; } 	// ܗ^T12_11
	public void setBonDeduction_13_11(Integer bonDeduction_13_11 ) { this.bonDeduction_13_11 = bonDeduction_13_11; } 	// ܗ^T13_11
	public void setBonDeduction_14_11(Integer bonDeduction_14_11 ) { this.bonDeduction_14_11 = bonDeduction_14_11; } 	// ܗ^T14_11
	public void setBonDeduction_15_11(Integer bonDeduction_15_11 ) { this.bonDeduction_15_11 = bonDeduction_15_11; } 	// ܗ^T15_11
	public void setBonDeduction_16_11(Integer bonDeduction_16_11 ) { this.bonDeduction_16_11 = bonDeduction_16_11; } 	// ܗ^T16_11
	public void setBonDeduction_17_11(Integer bonDeduction_17_11 ) { this.bonDeduction_17_11 = bonDeduction_17_11; } 	// ܗ^T17_11
	public void setPayAllowance_01_12(Integer payAllowance_01_12 ) { this.payAllowance_01_12 = payAllowance_01_12; } 	// ^x01_12
	public void setPayAllowance_02_12(Integer payAllowance_02_12 ) { this.payAllowance_02_12 = payAllowance_02_12; } 	// ^x02_12
	public void setPayAllowance_03_12(Integer payAllowance_03_12 ) { this.payAllowance_03_12 = payAllowance_03_12; } 	// ^x03_12
	public void setPayAllowance_04_12(Integer payAllowance_04_12 ) { this.payAllowance_04_12 = payAllowance_04_12; } 	// ^x04_12
	public void setPayAllowance_05_12(Integer payAllowance_05_12 ) { this.payAllowance_05_12 = payAllowance_05_12; } 	// ^x05_12
	public void setPayAllowance_06_12(Integer payAllowance_06_12 ) { this.payAllowance_06_12 = payAllowance_06_12; } 	// ^x06_12
	public void setPayAllowance_07_12(Integer payAllowance_07_12 ) { this.payAllowance_07_12 = payAllowance_07_12; } 	// ^x07_12
	public void setPayAllowance_08_12(Integer payAllowance_08_12 ) { this.payAllowance_08_12 = payAllowance_08_12; } 	// ^x08_12
	public void setPayAllowance_09_12(Integer payAllowance_09_12 ) { this.payAllowance_09_12 = payAllowance_09_12; } 	// ^x09_12
	public void setPayAllowance_10_12(Integer payAllowance_10_12 ) { this.payAllowance_10_12 = payAllowance_10_12; } 	// ^x10_12
	public void setPayAllowance_11_12(Integer payAllowance_11_12 ) { this.payAllowance_11_12 = payAllowance_11_12; } 	// ^x11_12
	public void setPayAllowance_12_12(Integer payAllowance_12_12 ) { this.payAllowance_12_12 = payAllowance_12_12; } 	// ^x12_12
	public void setPayAllowance_13_12(Integer payAllowance_13_12 ) { this.payAllowance_13_12 = payAllowance_13_12; } 	// ^x13_12
	public void setPayAllowance_14_12(Integer payAllowance_14_12 ) { this.payAllowance_14_12 = payAllowance_14_12; } 	// ^x14_12
	public void setPayAllowance_15_12(Integer payAllowance_15_12 ) { this.payAllowance_15_12 = payAllowance_15_12; } 	// ^x15_12
	public void setPayAllowance_16_12(Integer payAllowance_16_12 ) { this.payAllowance_16_12 = payAllowance_16_12; } 	// ^x16_12
	public void setPayAllowance_17_12(Integer payAllowance_17_12 ) { this.payAllowance_17_12 = payAllowance_17_12; } 	// ^x17_12
	public void setPayAllowance_18_12(Integer payAllowance_18_12 ) { this.payAllowance_18_12 = payAllowance_18_12; } 	// ^x18_12
	public void setPayAllowance_19_12(Integer payAllowance_19_12 ) { this.payAllowance_19_12 = payAllowance_19_12; } 	// ^x19_12
	public void setPayAllowance_20_12(Integer payAllowance_20_12 ) { this.payAllowance_20_12 = payAllowance_20_12; } 	// ^x20_12
	public void setPayAllowance_21_12(Integer payAllowance_21_12 ) { this.payAllowance_21_12 = payAllowance_21_12; } 	// ^x21_12
	public void setPayAllowance_22_12(Integer payAllowance_22_12 ) { this.payAllowance_22_12 = payAllowance_22_12; } 	// ^x22_12
	public void setPayAllowance_23_12(Integer payAllowance_23_12 ) { this.payAllowance_23_12 = payAllowance_23_12; } 	// ^x23_12
	public void setPayAllowance_24_12(Integer payAllowance_24_12 ) { this.payAllowance_24_12 = payAllowance_24_12; } 	// ^x24_12
	public void setPayAllowance_25_12(Integer payAllowance_25_12 ) { this.payAllowance_25_12 = payAllowance_25_12; } 	// ^x25_12
	public void setPayAllowance_26_12(Integer payAllowance_26_12 ) { this.payAllowance_26_12 = payAllowance_26_12; } 	// ^x26_12
	public void setPayAllowance_27_12(Integer payAllowance_27_12 ) { this.payAllowance_27_12 = payAllowance_27_12; } 	// ^x27_12
	public void setPayAllowance_28_12(Integer payAllowance_28_12 ) { this.payAllowance_28_12 = payAllowance_28_12; } 	// ^x28_12
	public void setPayAllowance_29_12(Integer payAllowance_29_12 ) { this.payAllowance_29_12 = payAllowance_29_12; } 	// ^x29_12
	public void setPayAllowance_30_12(Integer payAllowance_30_12 ) { this.payAllowance_30_12 = payAllowance_30_12; } 	// ^x30_12
	public void setPayDeduction_01_12(Integer payDeduction_01_12 ) { this.payDeduction_01_12 = payDeduction_01_12; } 	// ^T01_12
	public void setPayDeduction_02_12(Integer payDeduction_02_12 ) { this.payDeduction_02_12 = payDeduction_02_12; } 	// ^T02_12
	public void setPayDeduction_03_12(Integer payDeduction_03_12 ) { this.payDeduction_03_12 = payDeduction_03_12; } 	// ^T03_12
	public void setPayDeduction_04_12(Integer payDeduction_04_12 ) { this.payDeduction_04_12 = payDeduction_04_12; } 	// ^T04_12
	public void setPayDeduction_05_12(Integer payDeduction_05_12 ) { this.payDeduction_05_12 = payDeduction_05_12; } 	// ^T05_12
	public void setPayDeduction_06_12(Integer payDeduction_06_12 ) { this.payDeduction_06_12 = payDeduction_06_12; } 	// ^T06_12
	public void setPayDeduction_07_12(Integer payDeduction_07_12 ) { this.payDeduction_07_12 = payDeduction_07_12; } 	// ^T07_12
	public void setPayDeduction_08_12(Integer payDeduction_08_12 ) { this.payDeduction_08_12 = payDeduction_08_12; } 	// ^T08_12
	public void setPayDeduction_09_12(Integer payDeduction_09_12 ) { this.payDeduction_09_12 = payDeduction_09_12; } 	// ^T09_12
	public void setPayDeduction_10_12(Integer payDeduction_10_12 ) { this.payDeduction_10_12 = payDeduction_10_12; } 	// ^T10_12
	public void setPayDeduction_11_12(Integer payDeduction_11_12 ) { this.payDeduction_11_12 = payDeduction_11_12; } 	// ^T11_12
	public void setPayDeduction_12_12(Integer payDeduction_12_12 ) { this.payDeduction_12_12 = payDeduction_12_12; } 	// ^T12_12
	public void setPayDeduction_13_12(Integer payDeduction_13_12 ) { this.payDeduction_13_12 = payDeduction_13_12; } 	// ^T13_12
	public void setPayDeduction_14_12(Integer payDeduction_14_12 ) { this.payDeduction_14_12 = payDeduction_14_12; } 	// ^T14_12
	public void setPayDeduction_15_12(Integer payDeduction_15_12 ) { this.payDeduction_15_12 = payDeduction_15_12; } 	// ^T15_12
	public void setPayDeduction_16_12(Integer payDeduction_16_12 ) { this.payDeduction_16_12 = payDeduction_16_12; } 	// ^T16_12
	public void setPayDeduction_17_12(Integer payDeduction_17_12 ) { this.payDeduction_17_12 = payDeduction_17_12; } 	// ^T17_12
	public void setPayDeduction_18_12(Integer payDeduction_18_12 ) { this.payDeduction_18_12 = payDeduction_18_12; } 	// ^T18_12
	public void setPayDeduction_19_12(Integer payDeduction_19_12 ) { this.payDeduction_19_12 = payDeduction_19_12; } 	// ^T19_12
	public void setPayDeduction_20_12(Integer payDeduction_20_12 ) { this.payDeduction_20_12 = payDeduction_20_12; } 	// ^T20_12
	public void setPayDeduction_21_12(Integer payDeduction_21_12 ) { this.payDeduction_21_12 = payDeduction_21_12; } 	// ^T21_12
	public void setPayDeduction_22_12(Integer payDeduction_22_12 ) { this.payDeduction_22_12 = payDeduction_22_12; } 	// ^T22_12
	public void setPayDeduction_23_12(Integer payDeduction_23_12 ) { this.payDeduction_23_12 = payDeduction_23_12; } 	// ^T23_12
	public void setPayDeduction_24_12(Integer payDeduction_24_12 ) { this.payDeduction_24_12 = payDeduction_24_12; } 	// ^T24_12
	public void setPayDeduction_25_12(Integer payDeduction_25_12 ) { this.payDeduction_25_12 = payDeduction_25_12; } 	// ^T25_12
	public void setPayDeduction_26_12(Integer payDeduction_26_12 ) { this.payDeduction_26_12 = payDeduction_26_12; } 	// ^T26_12
	public void setPayDeduction_27_12(Integer payDeduction_27_12 ) { this.payDeduction_27_12 = payDeduction_27_12; } 	// ^T27_12
	public void setAttendance_01_12(Float attendance_01_12 ) { this.attendance_01_12 = attendance_01_12; } 	// ΑӍ01_12
	public void setAttendance_02_12(Float attendance_02_12 ) { this.attendance_02_12 = attendance_02_12; } 	// ΑӍ02_12
	public void setAttendance_03_12(Float attendance_03_12 ) { this.attendance_03_12 = attendance_03_12; } 	// ΑӍ03_12
	public void setAttendance_04_12(Float attendance_04_12 ) { this.attendance_04_12 = attendance_04_12; } 	// ΑӍ04_12
	public void setAttendance_05_12(Float attendance_05_12 ) { this.attendance_05_12 = attendance_05_12; } 	// ΑӍ05_12
	public void setAttendance_06_12(Integer attendance_06_12 ) { this.attendance_06_12 = attendance_06_12; } 	// ΑӍ06_12
	public void setAttendance_07_12(Integer  attendance_07_12 ) { this.attendance_07_12 = attendance_07_12; } 	// ΑӍ07_12
	public void setAttendance_08_12(Float attendance_08_12 ) { this.attendance_08_12 = attendance_08_12; } 	// ΑӍ08_12
	public void setAttendance_09_12(Float  attendance_09_12 ) { this.attendance_09_12 = attendance_09_12; } 	// ΑӍ09_12
	public void setAttendance_10_12(Float  attendance_10_12 ) { this.attendance_10_12 = attendance_10_12; } 	// ΑӍ10_12
	public void setAttendance_11_12(Float  attendance_11_12 ) { this.attendance_11_12 = attendance_11_12; } 	// ΑӍ11_12
	public void setAttendance_12_12(Float  attendance_12_12 ) { this.attendance_12_12 = attendance_12_12; } 	// ΑӍ12_12
	public void setAttendance_13_12(Integer  attendance_13_12 ) { this.attendance_13_12 = attendance_13_12; } 	// ΑӍ13_12

	public void setIncomeTaxType    (String incomeTaxType     ) { this.incomeTaxType     = incomeTaxType    ; } 	// ېŋ敪
	public void setAdjustmentType   (String adjustmentType    ) { this.adjustmentType    = adjustmentType   ; } 	// N敪
	public void setSelfWidowType    (String selfWidowType     ) { this.selfWidowType     = selfWidowType    ; } 	// {lǕw敪
	public void setSelfHandicapType (String selfHandicapType  ) { this.selfHandicapType  = selfHandicapType ; } 	// {lQ敪
	public void setSelfStudentType  (String selfStudentType   ) { this.selfStudentType   = selfStudentType  ; } 	// {lw敪
	public void setSpouseIntendType (String spouseIntendType  ) { this.spouseIntendType  = spouseIntendType ; } 	// zҋ敪
	public void setGeneralDependent (String generalDependent  ) { this.generalDependent  = generalDependent ; } 	// ʕ}{e
	public void setSpecificDependent(String specificDependent ) { this.specificDependent = specificDependent; } 	// }{e
	public void setElderlyDependent (String elderlyDependent  ) { this.elderlyDependent  = elderlyDependent ; } 	// Vl}{e
	public void setLiveWithEldRel   (String liveWithEldRel    ) { this.liveWithEldRel    = liveWithEldRel   ; } 	// Ve
	public void setLiveWithHandiGe  (String liveWithHandiGe   ) { this.liveWithHandiGe   = liveWithHandiGe  ; } 	// 
	public void setLiveWithHandiSp  (String liveWithHandiSp   ) { this.liveWithHandiSp   = liveWithHandiSp  ; } 	// 
	public void setLiveWithHandiEl  (String liveWithHandiEl   ) { this.liveWithHandiEl   = liveWithHandiEl  ; } 	// Vl
	public void setLiveWithHandiEr  (String liveWithHandiEr   ) { this.liveWithHandiEr   = liveWithHandiEr  ; } 	// Ve
	public void setGeneralHandicap  (String generalHandicap   ) { this.generalHandicap   = generalHandicap  ; } 	// ʏQ
	public void setSpecificHandicap (String specificHandicap  ) { this.specificHandicap  = specificHandicap ; } 	// ʏQ
	public void setStationCode      (String stationCode       ) { this.stationCode       = stationCode      ; } 	// R[h
	public void setGender           (String gender            ) { this.gender            = gender           ; } 	// 
	public void setPostalCode       (String postalCode        ) { this.postalCode        = postalCode       ; } 	// X֔ԍ
	public void setAddress          (String address           ) { this.address           = address          ; } 	// Z
	public void setPositionCode     (String positionCode      ) { this.positionCode      = positionCode     ; } 	// E
	public void setBirthDate        (String birthDate         ) { this.birthDate         = birthDate        ; } 	// N
	public void setKCode            (String kCode             ) { this.kCode             = kCode            ; } 	// ЈR[h
	public void setEntranceDate     (String entranceDate      ) { this.entranceDate      = entranceDate     ; } 	// Г
	public void setKName            (String kName             ) { this.kName             = kName            ; } 	// Ј
	public void setRetirementDate   (String retirementDate    ) { this.retirementDate    = retirementDate   ; } 	// ގГ
	public void setPhoneNumber      (String phoneNumber       ) { this.phoneNumber       = phoneNumber      ; } 	// dbԍ
	public void setHealthNo         (String healthNo          ) { this.healthNo          = healthNo         ; } 	// Nیԍ
	public void setFundNo           (String fundNo            ) { this.fundNo            = fundNo           ; } 	// Nԍ
	public void setPensionNo        (String pensionNo         ) { this.pensionNo         = pensionNo        ; } 	// Nԍ
	public void setUnemployNo       (String unemployNo        ) { this.unemployNo        = unemployNo       ; } 	// ٗpیԍ

	
}
